(* ::Package:: *)

(* ::Title:: *)
(*ExportUtilities*)


(* ::Section:: *)
(*Reference*)


(* ::Subsection:: *)
(*Title*)


(* ::Text:: *)
(*ExportUtilities.m*)


(* ::Subsection:: *)
(*Author*)


(* ::Text:: *)
(*Simon Rochester (simonkeys@yahoo.com)*)


(* ::Subsection:: *)
(*Summary*)


(* ::Text:: *)
(**)


(* ::Subsection:: *)
(*Copyright*)


(* ::Text:: *)
(*\[Copyright] Copyright 2007, Simon Rochester*)


(* ::Subsection:: *)
(*Notebook Version*)


(* ::Text:: *)
(*1.0*)


(* ::Subsection:: *)
(*Mathematica version*)


(* ::Text:: *)
(*6.0*)


(* ::Subsection:: *)
(*History*)


(* ::Text:: *)
(*Created 2007-8-7*)


(* ::Subsection:: *)
(*Keywords*)


(* ::Text:: *)
(**)


(* ::Section:: *)
(*Interface*)


(* ::Text:: *)
(*This part declares publicly visible symbols.*)


(* ::Subsection:: *)
(*Begin package context*)


BeginPackage["Graphics`ExportUtilities`"]


(* ::Subsection:: *)
(*Usage messages*)


FixFrameLabel::usage=""


FrameLabelSpacing::usage=""


ExportScaled::usage=""


ExportBitmappedEPS::usage=""


ExportRasterizedEPS::usage=""


AntialiasFactor::usage=""


EPSToPDF::usage=""


PreserveObjects::usage=""


DeleteTemporaryFiles::usage=""


Ps2EpsOptions::usage=""


InitialFormat::usage=""


Compression::usage=""


Trim::usage=""


BackgroundRun::usage=""


RunBackground::usage=""


(* ::Subsection:: *)
(*Error messages*)


(* ::Section:: *)
(*Implementation*)


(* ::Subsection:: *)
(*Begin private context*)


Begin["`Private`"]


(* ::Subsection:: *)
(*ExportScaled*)


Options[FixFrameLabel]={FrameLabelSpacing->{15,20}};


FixFrameLabel[g_,opts___Rule]:=Module[{
fl,ep,
fls=FrameLabelSpacing/.{opts}/.Options[FixFrameLabel]
},
{fl,ep}={FrameLabel,Epilog}/.AbsoluteOptions[g];
Show[g,FrameLabel->None,Epilog->Join[{
Text[fl[[1]],Offset[{0,-fls[[1]]},Scaled[{.5,0}]],{0,1}],
Text[fl[[2]],Offset[{-fls[[2]],0},Scaled[{0,.5}]],{0,-1},{0,1}]
},ep],FilterRules[{opts},Options[Graphics]]]
]


(* ::Subsection:: *)
(*ExportScaled*)


ExportScaled[file_,g_,opts___Rule]:=Module[{s= ImageResolution/72/.{opts}/.ImageResolution->72,size=ImageSize/.{opts}/.AbsoluteOptions[g,ImageSize]},
Export[file,g/.{r:AbsoluteThickness[x_]:>(r/.x->s x),r:(FontSize->x_):>(r/.x->s x)},ImageSize->s size,opts]
]


(* ::Subsection:: *)
(*ExportBitmappedEPS*)


(* ::Input:: *)
(*(*Options[ExportBitmappedEPS]={AntialiasFactor->2,ImageResolution->72,PreserveObjects->{Text},DeleteTemporaryFiles->True,Ps2EpsOptions->"-e",InitialFormat->"tiff"};*)*)


(* ::Input:: *)
(*(*ExportBitmappedEPS[file_,g_,opts:OptionsPattern[]]:=Module[{primitives={Point,Line,Polygon,Cuboid,Text,Cylinder,Sphere,Arrow,Circle,Disk,Raster,Rectangle},*)
(*olddir,tempdir,oldstart,newstart,initialIR=OptionValue[AntialiasFactor] OptionValue[ImageResolution],*)
(*cls="\\NeedsTeXFormat{LaTeX2e}*)
(*\\ProvidesClass{empty}*)
(*\\renewcommand\\normalsize{}*)
(*\\endinput*)
(*",*)
(*latex="\\documentclass{empty}*)
(*\\usepackage{graphics}*)
(*\\usepackage[dvips,divide={0pt,*,0pt},papersize={$widthin,$heightin}]{geometry}*)
(*\\begin{document}*)
(*\\noindent\\makebox[0pt][l]{\\includegraphics{raster}}*)
(*\\includegraphics{vector}*)
(*\\end{document}*)
(*"},*)
(*olddir=Directory[];*)
(*tempdir=CreateDirectory[];*)
(*SetDirectory[tempdir];*)
(*If[MemberQ[{"tiff","Tiff","TIFF"},OptionValue[InitialFormat]],*)
(*(* export a tiff *)*)
(*Export["raster.tiff",g/.(#[___]->{}&/@OptionValue[PreserveObjects]),ImageResolution->initialIR,Sequence@@FilterRules[{opts},Options[Export]]],*)
(*(* else export an eps and convert to a tiff *)*)
(*Export["raster.eps",g/.(#[___]->{}&/@OptionValue[PreserveObjects]),Sequence@@FilterRules[{opts},Options[Export]]];*)
(*Run["convert -density",ToString[OptionValue[ImageResolution]]," raster.eps raster.tiff"]*)
(*];*)
(*If[OptionValue[PreserveObjects]=={},*)
(*(*Just convert tiff to eps*)*)
(*Run["convert raster.tiff -resample",ToString[OptionValue[ImageResolution]],"-white-threshold 99% -compress LZW eps2:combineeps.ps & ps2eps",OptionValue[Ps2EpsOptions] ,"combineeps.ps"],*)
(*(*else export eps with preserved objects and combine in latex*)*)
(*{width,height}=N[Import["raster.tiff","ImageSize"]/initialIR];*)
(*Export["vector.eps",g/.(#[___]->{}&/@Complement[primitives,OptionValue[PreserveObjects]])/.(FaceGrids->_)->(FaceGrids->None)];*)
(*Export["empty.cls",cls,"Text"];*)
(*Export["combineeps.tex",StringReplace[latex,{"$width"->ToString[width],"$height"->ToString[height]}],"Text"];*)
(*Run["convert raster.tiff -resample",ToString[OptionValue[ImageResolution]],"-white-threshold 99% -compress LZW eps2:raster.eps & latex combineeps.tex & dvips combineeps.dvi & ps2eps",OptionValue[Ps2EpsOptions] ,"combineeps.ps"]*)
(*];*)
(*If[FileNames[ToFileName[olddir,file]]=!={},DeleteFile[ToFileName[olddir,file]]];*)
(*CopyFile["combineeps.eps",ToFileName[olddir,file]];*)
(*SetDirectory[olddir];*)
(*If[OptionValue[DeleteTemporaryFiles],*)
(*DeleteDirectory[tempdir,DeleteContents->True],*)
(*Print["Temp files saved in "<>tempdir]*)
(*];*)
(*file*)
(*]*)*)


BackgroundRun[str:_String..]:=ToExpression@StringJoin[{"<<\"!",(#<>" ")&/@{str},"\""}]


Options[ExportRasterizedEPS]={AntialiasFactor->2,ImageResolution->72,PreserveObjects->{Text},DeleteTemporaryFiles->True,InitialFormat->"TIFF",RunBackground->True,Pause->False,Compression->"LZW",Trim->True};


ExportRasterizedEPS[file_,g_,opts:OptionsPattern[]]:=Module[{primitives={Point,Line,Polygon,Cuboid,Text,Cylinder,Sphere,Arrow,Circle,Disk,Raster,Rectangle},
initialIR=OptionValue[AntialiasFactor] OptionValue[ImageResolution],
name=StringReplace[file,".eps"~~EndOfString->""],tiff,raster, vector,run=If[OptionValue[RunBackground],BackgroundRun,Run],extrah,pause=If[OptionValue[Pause],"& pause",""]},
tiff=name<>"_raster.tiff";
raster=name<>"_raster.eps";
vector=name<>"_vector.eps";
If[MemberQ[{"tiff","Tiff","TIFF"},OptionValue[InitialFormat]],
(* export a tiff *)
Export[tiff,g/.(#[___]->{}&/@OptionValue[PreserveObjects])/.(Ticks->_)->(Ticks->None),ImageResolution->initialIR,Sequence@@FilterRules[{opts},Options[Export]]],
(* else export an eps and convert to a tiff *)
Export[raster,g/.(#[___]->{}&/@OptionValue[PreserveObjects]),Sequence@@FilterRules[{opts},Options[Export]]];
run["convert -density",ToString[OptionValue[ImageResolution]],raster, tiff,pause];
];
(*convert tiff to eps*)
run["convert",tiff, "-resample",ToString[OptionValue[ImageResolution]],"-white-threshold 99%",If[ OptionValue[Compression]==="LZW","-compress LZW",""],"eps2:"<>raster,pause];
(*kludge to delete padding in tiff due to Mathematica bug*)
extrah=If[OptionValue[Trim],Floor[72 Import[tiff,"ImageSize"][[2]]/initialIR-AspectRatio ImageSize /.AbsoluteOptions[g]],0];
run["ps2eps.pl -f -e -t 0,"<>ToString[-extrah]<>" -a 0,0,0,"<>ToString[-extrah],raster,pause];
run["mv",raster<>".eps",raster,pause];
If[OptionValue[PreserveObjects]=!={},
(*export eps with preserved objects and combine using overlayeps*)
Export[vector,g/.(#[___]->{}&/@Complement[primitives,OptionValue[PreserveObjects]])/.{(FaceGrids->_)->(FaceGrids->None)}];
run["overlayeps.pl",file,raster,vector,pause];
If[OptionValue[DeleteTemporaryFiles],DeleteFile[{vector,raster}]],
run["mv",raster,file,pause];
];
If[OptionValue[DeleteTemporaryFiles],DeleteFile[{tiff}]];
file
]


ExportBitmappedEPS=ExportRasterizedEPS


(* ::Subsection:: *)
(*EPSToPDF*)


(* ::Input:: *)
(*(*EPSToPDF[file_]:=Module[*)
(*{pdfFile=StringReplace[file,".eps"~~EndOfString->".pdf"],tempfile=StringReplace[file,".eps"~~EndOfString->".txt"],bbox},*)
(*Run["gswin32c -sDEVICE=pdfwrite -dCompatibilityLevel=1.3 -dMaxSubsetPct=100 -dSubsetFonts=true -dEmbedAllFonts=true -dAutoFilterColorImages=false -dAutoFilterGrayImages=false -dColorImageFilter=/FlateEncode -dGrayImageFilter=/FlateEncode -dMonoImageFilter=/FlateEncode -o",pdfFile,file,"& ps2eps -q -B -f -j -r 300",pdfFile,"2>"<>tempfile];*)
(*bbox=Import[tempfile,"Text"];*)
(*Run["pdfcrop.pl --bbox", "\""<>bbox<>"\"",pdfFile,pdfFile];*)
(*DeleteFile[tempfile];*)
(*pdfFile*)
(*]*)*)


Options[EPSToPDF]={RunBackground->True};


EPSToPDF[file_,opts:OptionsPattern[]]:=(
If[OptionValue[RunBackground],BackgroundRun,Run]["eps2pdf.pl",file];
StringReplace[file,".eps"~~EndOfString->".pdf"]
)


(* ::Subsection:: *)
(*End the private context*)


End[]


(* ::Section:: *)
(*Epilog*)


(* ::Text:: *)
(*This section protects exported symbols and ends the package.*)


(* ::Subsection:: *)
(*Protect exported symbols*)


(*Protect[Evaluate[$Context<>"*"]]*)


(* ::Subsection:: *)
(*End the package context*)


EndPackage[]
