(* ::Package:: *)

(* ::Title:: *)
(*FixTicks*)


(* ::Section:: *)
(*Reference*)


(* ::Subsection:: *)
(*Title*)


(* ::Text:: *)
(*FixTicks.m*)


(* ::Subsection:: *)
(*Author*)


(* ::Text:: *)
(*Simon Rochester (simonkeys@yahoo.com)*)


(* ::Subsection:: *)
(*Summary*)


(* ::Text:: *)
(**)


(* ::Subsection:: *)
(*Copyright*)


(* ::Text:: *)
(*\[Copyright] Copyright 2007, Simon Rochester*)


(* ::Subsection:: *)
(*Notebook Version*)


(* ::Text:: *)
(*1.0*)


(* ::Subsection:: *)
(*Mathematica version*)


(* ::Text:: *)
(*6.0*)


(* ::Subsection:: *)
(*History*)


(* ::Text:: *)
(*Created 2007-11-27*)


(* ::Subsection:: *)
(*Keywords*)


(* ::Text:: *)
(**)


(* ::Section:: *)
(*Interface*)


(* ::Text:: *)
(*This part declares publicly visible symbols.*)


(* ::Subsection:: *)
(*Begin package context*)


BeginPackage["Graphics`FixTicks`"]


(* ::Subsection:: *)
(*Usage messages*)


LinearScale::usage=""


TickSpacing::usage=""


NiceList::usage=""


TickList::usage=""


TickLabels::usage=""


FixFrameTicks::usage=""


FixTicks::usage=""


LogTickList::usage=""


FixLogLogFrameTicks::usage=""


MajorTicks::usage=""


MajorTickLength::usage=""


LabelFunction::usage=""


MinorTickLength::usage=""


LogScaleForm::usage=""


BaselineNudge::usage=""


(* ::Subsection:: *)
(*Error messages*)


(* ::Section:: *)
(*Implementation*)


(* ::Subsection:: *)
(*Begin private context*)


Begin["`Private`"]


(* ::Subsection:: *)
(*FixFrameTicks*)


(*LinearScale[min_, max_, n_Integer] :=
Module[{spacing, t, nmin=N[min], nmax=N[max]},
(spacing = TickSpacing[nmax-nmin, n, {1, 2, 2.5,4, 5, 10}];
t = N[spacing Range[Floor[nmin/spacing - 0.05],Ceiling[max/spacing + 0.05]]];Map[{#, If[Round[#]==#, Round[#], #]}&, t]
)/; nmin < nmax
    ]*)


(*TickSpacing[dx_, n_, prefs_List, method_:GreaterEqual] :=
    Module[ { dist=N[dx/n], scale, prefsdelta, min, pos } ,
        scale = 10.^Floor[Log[10., dist]] ;
        dist /= scale ;
        If[dist < 1, dist *= 10 ; scale /= 10] ;
        If[dist >= 10, dist /= 10 ; scale *= 10] ;
        scale * Switch[method,
            GreaterEqual,
            (* "nice" tick spacing is greater than or equal to
                requested tick spacing *)
            First[Select[prefs, (dist <= #)&]],
            LessEqual,
            (* "nice" tick spacing is less than or equal to
                                requested tick spacing *)
            First[Select[Reverse[prefs], (dist >= #)&]],
            Nearest,
            (* "nice" tick spacing is the taken from the
                element of "prefs" nearest to "dist" *)
            prefsdelta = Map[Abs[#-dist]&, prefs];
            min = Min[prefsdelta];
            pos = Position[prefsdelta, min][[1, 1]];
            prefs[[pos]]
        ]
    ]*)


If[$VersionNumber<7.,Needs["Developer`"]]


NiceList[min_,max_,prefs_,n_]:=Module[{},
{man,exp}=MantissaExponent[max-min];
Catch[
If[Length[list=N[# Range[Ceiling[min/#]-1,Floor[max/#]+1]]]<=n+2,Throw[list]]&/@(10^(exp-1) prefs)
]
]


Options[TickList]={MajorTicks->3,MajorTickLength->.05,MinorTickLength->.025,TickLabels->True,LabelFunction->Automatic};


TickList[{x1_,x2_},OptionsPattern[]]:=Module[{majticks,majstep,man,exp,minstep,minticks,lf},
majticks=FindDivisions[{x1,x2},OptionValue[MajorTicks]]//N;
majstep=majticks[[2]]-majticks[[1]];
{man,exp}=MantissaExponent[majstep];
minstep=Switch[Round[man,.01],0.1,0.02,0.2,0.05,0.25,0.05,0.4,0.1,0.5,0.1,1.,.2] 10^exp;
minticks=Range[First@majticks-majstep,Last@majticks+majstep,minstep];
lf=Replace[OptionValue[LabelFunction],Automatic->Identity];
Join[{#,If[OptionValue[TickLabels],lf@If[#==Round[#],Round[#],#],""],{OptionValue[MajorTickLength],0}}&/@majticks,{#,"",{OptionValue[MinorTickLength],0}}&/@minticks]
]


SetAttributes[PopRotate,HoldFirst]


PopRotate[x_]:=Last[x=RotateLeft[x]]


Options[FixFrameTicks]={MajorTicks->3,MajorTickLength->.05,MinorTickLength->.025,TickLabels->{True,True,False,False},LabelFunction->Automatic};


FixFrameTicks[g_,opts:OptionsPattern[]]:=
Module[{pr,ar,tbopts,ticklab,majticks,lf},
	{pr,ar}={PlotRange,AspectRatio}/.AbsoluteOptions[g];
	lf=PadRight[{},4,OptionValue[LabelFunction]];
	majticks=PadRight[{},4,OptionValue[MajorTicks]];
	tbopts={MajorTickLength->OptionValue[MajorTickLength]/ar,MinorTickLength->OptionValue[MinorTickLength]/ar};
	ticklab=OptionValue[TickLabels];
	Show[g,
		FrameTicks->Table[
			If[Head[ticklab[[i]]]===List,
				{#[[1]],#[[2]],{OptionValue[MajorTickLength],0}}&/@ticklab[[i]],
				TickList[pr[[Mod[i,2,1]]],
					TickLabels->ticklab[[i]],
					MajorTicks->majticks[[i]],
					LabelFunction->lf[[i]],Sequence@@tbopts]],
					{i,4}]]
]

Options[FixTicks]={MajorTicks->3,MajorTickLength->.05,MinorTickLength->.025,TickLabels->{True,True},LabelFunction->Automatic};


FixTicks[g_,opts:OptionsPattern[]]:=Module[{pr,ar,tbopts,ticklab,majticks,lf},
{pr,ar}={PlotRange,AspectRatio}/.AbsoluteOptions[g];
lf=PadRight[{},2,OptionValue[LabelFunction]];
majticks=PadRight[{},2,OptionValue[MajorTicks]];
tbopts={MajorTickLength->OptionValue[MajorTickLength]/ar,MinorTickLength->OptionValue[MinorTickLength]/ar};
ticklab=OptionValue[TickLabels];
Show[g,Ticks->
	Table[
		If[
			Head[ticklab[[i]]]===List,
				{#[[1]],#[[2]],{OptionValue[MajorTickLength],0}}&/@ticklab[[i]],
				TickList[pr[[Mod[i,2,1]]],TickLabels->ticklab[[i]],MajorTicks->majticks[[i]],LabelFunction->lf[[i]],Sequence@@tbopts]
		],{i,2}]
	]
]


Options[LogTickList]={MajorTicks->3,MajorTickLength->.05,MinorTickLength->.025,TickLabels->True};


LogTickList[{x1_,x2_},OptionsPattern[]]:=Module[{majticks,majstep,minstep,minticks,man,exp},
majticks=FindDivisions[N@Log[10,{x1,x2}],OptionValue[MajorTicks]]//N;
majstep=majticks[[2]]-majticks[[1]];
{man,exp}=MantissaExponent[majstep];
minstep=Switch[Round[man,.01],0.1,0.01,0.2,0.1,0.25,0.1,0.4,0.1,0.5,0.1,1.,.1] 10^exp;
minticks=Flatten@Table[Log[10,Range[10^m,10^(m+majstep),10^(m+1) minstep]],{m,First@majticks-majstep,Last@majticks,majstep}];
Join[{#,If[OptionValue[TickLabels],LogScaleForm[#],""],{OptionValue[MajorTickLength],0}}&/@(10^majticks),{#,"",{OptionValue[MinorTickLength],0}}&/@(10^minticks)]
]


Options[FixLogLogFrameTicks]={MajorTicks->{4,4},MajorTickLength->.05,MinorTickLength->.025,TickLabels->{True,True,False,False}};


FixLogLogFrameTicks[g_,opts:OptionsPattern[]]:=Module[{pr,ar,tbopts},
{pr,ar}={Exp[PlotRange],AspectRatio}/.Quiet[AbsoluteOptions[g],Ticks::"ticks"];
mt=RotateRight[If[Head[#]=!=List,{#},#]]&@OptionValue[MajorTicks];
tl=OptionValue[TickLabels];
tbopts={MajorTickLength->OptionValue[MajorTickLength]/ar,MinorTickLength->OptionValue[MinorTickLength]/ar};
Show[g,FrameTicks->{
MapAt[Log,#,1]&/@LogTickList[pr[[1]],MajorTicks->First[mt=RotateLeft[mt]],TickLabels->tl[[1]],Sequence@@tbopts],MapAt[Log,#,1]&/@LogTickList[pr[[2]],MajorTicks->First[mt=RotateLeft[mt]],TickLabels->tl[[2]],Sequence@@tbopts],MapAt[Log,#,1]&/@LogTickList[pr[[1]],MajorTicks->First[mt=RotateLeft[mt]],TickLabels->tl[[3]],Sequence@@tbopts],MapAt[Log,#,1]&/@LogTickList[pr[[2]],MajorTicks->First[mt=RotateLeft[mt]],TickLabels->tl[[4]],Sequence@@tbopts]}]
]


Options[LogScaleForm]={BaselineNudge->{-.4,.2}}


LogScaleForm[n_,OptionsPattern[]] :=Module[{m,e},
If[.01<=n<=100.,Return[DisplayForm@AdjustmentBox[If[n==Round[n],Round[n],n],BoxMargins->{{0,0},{0,OptionValue[BaselineNudge][[2]]}}]]];
{m,e}=MantissaExponent[n];
If[m==.1,m=1;e=e-1];
m=If[m==Round[m],Round[m],N[m]];DisplayForm[AdjustmentBox[RowBox[Append[If[m != 1, {ToString[m], "\[Times]"}, {}], SuperscriptBox["10", ToString[e]]]],BoxMargins->{{0,0},{0,OptionValue[BaselineNudge][[1]]}}]]
]


(* ::Subsection:: *)
(*End the private context*)


End[]


(* ::Section:: *)
(*Epilog*)


(* ::Text:: *)
(*This section protects exported symbols and ends the package.*)


(* ::Subsection:: *)
(*Protect exported symbols*)


(*Protect[Evaluate[$Context<>"*"]]*)


(* ::Subsection:: *)
(*End the package context*)


EndPackage[]
