(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     45760,       1311]
NotebookOptionsPosition[     40686,       1159]
NotebookOutlinePosition[     42770,       1211]
CellTagsIndexPosition[     42727,       1208]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "TutorialColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["AtomicDensityMatrix Package",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {
    StyleBox[
     GraphicsBox[RasterBox[CompressedData["
1:eJy9lulTk1cUxp+Zfu+Xfu5MO9O/oF90povj0A6dVtupdRsBqwRCg+DCqCxF
LLIIoUAIyGLayqJCFZRYVJaAaDBsQkBCEhaVoCjEBAiLTSLJ7bmX0nEBhZZ6
5mbmTebN/d3nnOec930/cN+mwLcAvEefD+jDr9nrwul0DvabbdaxuwNm++Ox
197/r8PQrY/bLwnyxYFvEL0F8TtwOiNq9IHFYDC4XK5VBGmvaXasg/QLRH6H
xABkBiFXhvw9fCVJP7LZbKsFemwdC1gP2ZdcjnwXCvag9BAuxOByHC4dQUU0
dBfzV4vV0aoL+4orOv49ckNRHo3qeDQehy4NzWnQpvCv/W2aRf+70vSeK8o/
+C0vkDIEZYdx5SfclKM9Az05MOai9wQ6FahLwJT9ObeQkaqrq3t7e1fESo+W
/LgV8t1QhfPU1Seh5WfczoY5D4Mn0V/AoSSwNkfidjnpfofDUVVVpVKpFArF
5OTkiliZMZJ4PyiCceYg/ohDUyq6stCXhzsqziIicXVyXriyVMnQoHnt2rV+
fn5paWkmk2lFIAptrfqYHzceJZBy1ZaObiUGCjirL5/nsDWdl+yXvfw8R3e8
EyYLIVBhYSEJfMW25F6HCKeI+R+npxzJOzmLEtiQhFuZvEzEouzps9CQzN1C
5s8IQroE4VvWJB2NLsqKP3U8vCI7ytypm0/syzExMaFWqxMTE2NjY0NDQ6VS
aVNTk8vpVMVLToZxq9cnclZvLsd1KDiFtFA1Y7aAtKfuflsRFXA+YSMdifzT
ks7PdjXV1/7IspS69vZ2uVyeLYKqbLFYGmursqUoO8RzRSwqUJcSJRGcsssH
gZ/zYULaC/fzapJVhn7F47MYPw/b77CVYlCFe83qpXDUFw0NDSUlJZRPo9FY
U1OTk5kWfzjsVOQ6qg7t1piMw5uw/VPs/gx7N/JhQiBy42gJZi/iaS3YdTAd
WBtYEzwaTJbj0a0lcez5TrxvGcpOOFCsiCOxOTEBcdu5HN7jm3k7kG2ou20X
4KqDpxXsNlgPmAmsD6xfXLdh5jK8Txev3cthHbHkhWLfRq6FRhY1OMmZ92db
BkbPYk4LZgS7BzYMZhHr/sIaBNPDZX6VtGeDJvDWT3iBwjZwM5yQ8ZLdSMGA
CvZyeBrE+Qn0QLCGwO6KixGwh+JHwg0vi3X6t/xtArTvayT4o/gAauLRmYVH
xXBWgmnAOsEMYunBugSXEnhHqBsRi9Cji4/NZ6MgK3Xrx7xAVB3qIz7b0/jQ
mD4PTzXYNbBWjrBW4mExZtXw1nNLcKhRyLEIgXThMC8ndTvXI3Yb0gNx+Sjv
rNHT+FMN1igo3VzIXD0myjB5DtMV8F5ZOECXcMggF2hvW+OcedUkoYcXGTvY
lzucZi+BqLlmKjB3FV6dOLlZ7Ebb3oRXAzeZrUak9IYwPN3QK264jYfmG0ql
UqfTud3uRVl1V9TkOrKcUoq6YzDlwVEBz3V42xfyc0eUhjbsAGsB04qlE/QO
oYv8b5Iw19+KZmdnl9JVVX7m0CZkSXmNqP2fXIS3UezQt+DqAZFDk/BGm8A1
i9Uivhqj2IiGzS2rrcI30OjGuUgYcmAthUcr0jK44K57mGp511r1ITdDI7xa
Pi68VKkWibs5io3pl0mZj+wjkuwf+AgdL8VcrUiLSfTmiOigHlSejLTb7XNP
HJ6pMc+4hdFkWPZweCGMHbriCJjzMX1B2NggCjQkerYLTlufv79/T0/PUuVe
UdDTpzLJl56Jzkui3D0LxuuVOMctPj4+MpksOTlZr9f/dxbFU5dztFtjPcPN
7CUnd0cxq34+URERESEhISkpKTMzM6vC+ic8bucLg3p4eDgoKIjel1YXtGjQ
e0JwcDA94N4Ai6KoqGh8fPzNsFbFgf9r/AWVRIUY
       "], {{0, 0}, {36, 32}}, {0, 255},
       ColorFunction->RGBColor],
      ImageSize->{36, 32},
      PlotRange->{{0, 36}, {0, 32}}],
     Deployed->True,
     StripOnInput->False], Cell[
    "ATOMIC DENSITY MATRIX TUTORIAL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "Specifying the Atomic System", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/tutorial/SpecifyingTheAtomicSystem", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "The Wigner-Eckart Theorem", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/tutorial/TheWignerEckartTheorem", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "The Rotating-Wave Approximation", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/tutorial/\
TheRotatingWaveApproximation", "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"Specifying the Atomic System\"\>", 
       2->"\<\"The Wigner-Eckart Theorem\"\>", 
       3->"\<\"The Rotating-Wave Approximation\"\>"}, 
       FrameBox["\<\"Related Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"Related Tutorials \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix Package", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"AtomicDensityMatrix Package\"\>"}, 
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"More About \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "Automatic", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:ref/Automatic", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "E1", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/E1", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "ElectricField", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/ElectricField", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "Hamiltonian", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/Hamiltonian", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "Internal", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/Internal", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "Magnetic", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/Magnetic", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "MagneticField", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/MagneticField", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "Polarizability", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/Polarizability", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"Automatic\"\>", 2->"\<\"E1\"\>", 
       3->"\<\"ElectricField\"\>", 4->"\<\"Hamiltonian\"\>", 
       5->"\<\"Internal\"\>", 6->"\<\"Magnetic\"\>", 
       7->"\<\"MagneticField\"\>", 8->"\<\"Polarizability\"\>"}, 
       FrameBox["\<\"Functions \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"Functions \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix/tutorial/ConstructingTheHamiltonian", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> None, 
          StringReplace[
           "Copy Mathematica url", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  StringReplace[
                  "AtomicDensityMatrix/tutorial/ConstructingTheHamiltonian", 
                   "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], Delimiter, 
          StringReplace[
           "Copy web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  BoxData[
                   MakeBoxes[
                    Hyperlink[
                    StringReplace[
                    "http://reference.wolfram.com/mathematica/\
AtomicDensityMatrix/tutorial/ConstructingTheHamiltonian.html", 
                    "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]], StandardForm]], 
                  StringReplace[
                  "Input", "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"], TextClipboardType -> 
                  StringReplace[
                   "PlainText", "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], 
          StringReplace[
           "Go to web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> FrontEndExecute[{
             NotebookLocate[{
               URL[
                StringJoin[
                 StringReplace[
                 "http://reference.wolfram.com/mathematica/", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 "AtomicDensityMatrix/tutorial/ConstructingTheHamiltonian", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 ".html", "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"]]], None}]}]}, #, 2]& , 
        Evaluator -> Automatic], {
       1->"\<\"AtomicDensityMatrix/tutorial/ConstructingTheHamiltonian\"\>", 
       2->"\<\"Copy Mathematica url\"\>", Delimiter, 
       4->"\<\"Copy web url\"\>", 5->"\<\"Go to web url\"\>"}, 
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"URL \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxAlignment->{"Columns" -> {{Left, Left, Right}}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.05], 
     Scaled[0.3], {
      Scaled[0.64]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Constructing the Hamiltonian", "Title",
 CellID->471728094],

Cell[TextData[{
 "The Hamiltonian is the operator that governs the time evolution of the \
state vector or density matrix. The eigenvalues of the Hamiltonian are the \
observable energies of the system. The Hamiltonian for an atomic system \
subject to external electromagnetic fields can be constructed using the ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["Hamiltonian", "InlineFormula"],
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/Hamiltonian"]]],
 " function."
}], "Text",
 CellID->97203088],

Cell[BoxData[GridBox[{
   {
    RowBox[{
     ButtonBox["Hamiltonian",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/Hamiltonian"], "[", 
     StyleBox["sys", "TI"], ",", 
     StyleBox["opts", "TI"], "]"}], Cell[TextData[{
     "the Hamiltonian for atomic system ",
     Cell[BoxData[
      StyleBox["sys", "TI"]], "InlineFormula"],
     " subject to interactions specified by ",
     Cell[BoxData[
      StyleBox["opts", "TI"]], "InlineFormula"],
     " "
    }], "TableText"]}
  }]], "DefinitionBox",
 CellID->1334],

Cell["The Hamiltonian.", "Caption",
 CellID->164610213],

Cell["This loads the package.", "MathCaption",
 CellID->339534619],

Cell[BoxData[
 RowBox[{"<<", "AtomicDensityMatrix`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->87034352],

Cell[TextData[{
 "If no options are specified, the electric and magnetic fields are taken to \
be zero, and ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["Hamiltonian", "InlineFormula"],
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/Hamiltonian"]]],
 " returns the Hamiltonian describing the internal energy of the system. In \
the absence of external fields, this is a diagonal matrix with the diagonal \
comprised of the unperturbed energies of the atomic states."
}], "Text",
 CellID->121057749],

Cell[TextData[{
 "An atomic system consisting of a ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"J", "=", "0"}], "InlineMath"]]],
 " state and a  ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"J", "=", "1"}], "InlineMath"]]],
 " state."
}], "MathCaption",
 CellID->70779043],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", 
       RowBox[{"J", "\[Rule]", "0"}], ",", 
       RowBox[{"L", "\[Rule]", "0"}], ",", 
       RowBox[{"S", "\[Rule]", "0"}], ",", 
       RowBox[{"Energy", "\[Rule]", "0"}]}], "]"}], ",", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"2", ",", 
       RowBox[{"J", "\[Rule]", "1"}], ",", 
       RowBox[{"L", "\[Rule]", "1"}], ",", 
       RowBox[{"S", "\[Rule]", "0"}]}], "]"}]}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->29838874],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "0"}], ",", 
     RowBox[{"L", "\[Rule]", "0"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{555, 50},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->202393276]
}, Open  ]],

Cell["\<\
The Hamiltonian for this system in the absence of external fields.\
\>", "MathCaption",
 CellID->457381827],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Hamiltonian", "[", "sys", "]"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->692860306],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", 
      RowBox[{"Energy", "[", "2", "]"}], "0", "0"},
     {"0", "0", 
      RowBox[{"Energy", "[", "2", "]"}], "0"},
     {"0", "0", "0", 
      RowBox[{"Energy", "[", "2", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{244, 57},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//MatrixForm=",
 CellID->146000192]
}, Open  ]],

Cell[TextData[{
 "By default, Hamiltonian takes into account the ",
 Cell[BoxData[
  StyleBox["E1", "InlineMath"]]],
 " and magnetic moment interactions when nonzero electric or magnetic fields \
are specified."
}], "Text",
 CellID->3417020],

Cell[BoxData[GridBox[{
   {
    ButtonBox["ElectricField",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/ElectricField"], Cell[
    "the electric field can be specified as a Cartesian vector", 
     "TableText"]},
   {
    ButtonBox["MagneticField",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/MagneticField"], Cell[
    "the magnetic field can be specified as a Cartesian vector", 
     "TableText"]}
  }]], "DefinitionBox",
 CellID->12102275],

Cell[TextData[{
 "External fields as options to ",
 Cell[BoxData[
  ButtonBox["Hamiltonian",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/Hamiltonian"]]],
 "."
}], "Caption",
 CellID->199605313],

Cell[TextData[{
 "The Hamiltonian in the presence of a ",
 Cell[BoxData[
  StyleBox["z", "InlineMath"]]],
 "-directed electric field and ",
 Cell[BoxData[
  StyleBox["y", "InlineMath"]]],
 "-directed magnetic field."
}], "MathCaption",
 CellID->592511425],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Hamiltonian", "[", 
   RowBox[{"sys", ",", 
    RowBox[{"ElectricField", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "E0"}], "}"}]}], ",", 
    RowBox[{"MagneticField", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "B", ",", "0"}], "}"}]}]}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->70769325],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", 
      FractionBox[
       RowBox[{"E0", " ", 
        RowBox[{"ReducedME", "[", 
         RowBox[{"1", ",", 
          RowBox[{"{", 
           RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}], 
       SqrtBox["3"]], "0"},
     {"0", 
      RowBox[{"Energy", "[", "2", "]"}], 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", "B", " ", "BohrMagneton"}], 
        SqrtBox["2"]]}], "0"},
     {
      FractionBox[
       RowBox[{"E0", " ", 
        RowBox[{"ReducedME", "[", 
         RowBox[{"1", ",", 
          RowBox[{"{", 
           RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}], 
       SqrtBox["3"]], 
      FractionBox[
       RowBox[{"\[ImaginaryI]", " ", "B", " ", "BohrMagneton"}], 
       SqrtBox["2"]], 
      RowBox[{"Energy", "[", "2", "]"}], 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", "B", " ", "BohrMagneton"}], 
        SqrtBox["2"]]}]},
     {"0", "0", 
      FractionBox[
       RowBox[{"\[ImaginaryI]", " ", "B", " ", "BohrMagneton"}], 
       SqrtBox["2"]], 
      RowBox[{"Energy", "[", "2", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{497, 129},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]//MatrixForm=",
 CellID->1034004531]
}, Open  ]],

Cell[TextData[{
 "The Hamiltonian can be written more cleanly in terms of the reduced Rabi \
frequency ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    SubscriptBox["\[CapitalOmega]", "R"], "=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "||", "d", "||", "2"}], ")"}], 
     SubscriptBox["E", "0"]}]}], "InlineMath"]], "InlineFormula"],
 " and the reduced Larmor frequency ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    SubscriptBox["\[CapitalOmega]", "L"], "=", 
    RowBox[{
     SubscriptBox["\[Mu]", "B"], "B"}]}], "InlineMath"]], "InlineFormula"],
 "."
}], "MathCaption",
 CellID->103026365],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"%", "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"E0", "\[Rule]", 
      RowBox[{"\[CapitalOmega]R", "/", 
       RowBox[{"ReducedME", "[", 
        RowBox[{"1", ",", 
         RowBox[{"{", 
          RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}]}], ",", 
     RowBox[{"B", "\[Rule]", 
      RowBox[{"\[CapitalOmega]L", "/", "BohrMagneton"}]}], ",", 
     RowBox[{
      RowBox[{"Energy", "[", "2", "]"}], "\[Rule]", "\[Omega]0"}]}], "}"}]}], 
  "//", "MatrixForm"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->252259222],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", 
      FractionBox["\[CapitalOmega]R", 
       SqrtBox["3"]], "0"},
     {"0", "\[Omega]0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", "\[CapitalOmega]L"}], 
        SqrtBox["2"]]}], "0"},
     {
      FractionBox["\[CapitalOmega]R", 
       SqrtBox["3"]], 
      FractionBox[
       RowBox[{"\[ImaginaryI]", " ", "\[CapitalOmega]L"}], 
       SqrtBox["2"]], "\[Omega]0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", "\[CapitalOmega]L"}], 
        SqrtBox["2"]]}]},
     {"0", "0", 
      FractionBox[
       RowBox[{"\[ImaginaryI]", " ", "\[CapitalOmega]L"}], 
       SqrtBox["2"]], "\[Omega]0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{160, 125},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]//MatrixForm=",
 CellID->443124244]
}, Open  ]],

Cell[TextData[{
 "Combinations of interactions other than the default can be selected with \
the ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["Interaction",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/Interaction"], 
   "InlineFormula"]]],
 " option."
}], "Text",
 CellID->85178770],

Cell[BoxData[GridBox[{
   {
    ButtonBox["Internal",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Internal"], Cell[
    "energies in the absence of external fields", "TableText"]},
   {
    ButtonBox["Magnetic",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Magnetic"], Cell[
    "magnetic interaction energy", "TableText"]},
   {
    ButtonBox["E1",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/E1"], Cell[TextData[{
     Cell[BoxData[
      StyleBox["E1", "InlineMath"]]],
     " electric dipole interaction energy"
    }], "TableText"]},
   {
    ButtonBox["Polarizability",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Polarizability"], Cell[
    "effective Hamiltonian due to atomic polarizability", "TableText"]},
   {
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[TextData[{
     "equivalent to ",
     Cell[BoxData[
      StyleBox[
       RowBox[{"{", 
        RowBox[{
         ButtonBox["Internal",
          BaseStyle->"Link",
          ButtonData->"paclet:AtomicDensityMatrix/ref/Internal"], ",", " ", 
         ButtonBox["E1",
          BaseStyle->"Link",
          ButtonData->"paclet:AtomicDensityMatrix/ref/E1"], ",", " ", 
         ButtonBox["Magnetic",
          BaseStyle->"Link",
          ButtonData->"paclet:AtomicDensityMatrix/ref/Magnetic"]}], "}"}], 
       "InlineFormula"]]]
    }], "TableText"]}
  }]], "DefinitionBox",
 CellID->242695712],

Cell["Interactions.", "Caption",
 CellID->390339910],

Cell[TextData[{
 "In order to take into account the polarizability of an atomic state (i.e., \
the effect of Stark-induced mixing with additional states not considered in \
the atomic system), the ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["Polarizability", "InlineFormula"],
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/Polarizability"]]],
 " interaction can be selected."
}], "Text",
 CellID->132407538],

Cell[TextData[{
 "An atomic system consisting of a ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"J", "=", "2"}], "InlineMath"]]],
 " state with specified values for scalar and tensor polarizability. (It is \
not necessary to specify values; the default symbolic values will be used if \
values are not specified.)"
}], "MathCaption",
 CellID->275041341],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"{", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", 
      RowBox[{"J", "\[Rule]", "2"}], ",", 
      RowBox[{
       RowBox[{"Polarizability", "[", "0", "]"}], "\[Rule]", "\[Alpha]0"}], 
      ",", 
      RowBox[{
       RowBox[{"Polarizability", "[", "2", "]"}], "\[Rule]", "\[Alpha]2"}]}], 
     "]"}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[6]:=",
 CellID->339582056],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "0", "]"}], "\[Rule]", "\[Alpha]0"}], 
     ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "2", "]"}], "\[Rule]", "\[Alpha]2"}], 
     ",", 
     RowBox[{"M", "\[Rule]", "2"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "0", "]"}], "\[Rule]", "\[Alpha]0"}], 
     ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "2", "]"}], "\[Rule]", "\[Alpha]2"}], 
     ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "0", "]"}], "\[Rule]", "\[Alpha]0"}], 
     ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "2", "]"}], "\[Rule]", "\[Alpha]2"}], 
     ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "0", "]"}], "\[Rule]", "\[Alpha]0"}], 
     ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "2", "]"}], "\[Rule]", "\[Alpha]2"}], 
     ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "0", "]"}], "\[Rule]", "\[Alpha]0"}], 
     ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "2", "]"}], "\[Rule]", "\[Alpha]2"}], 
     ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "2"}]}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{527, 84},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->875737503]
}, Open  ]],

Cell[TextData[{
 "The effective Hamiltonian describing the response of the state to a ",
 Cell[BoxData[
  StyleBox["y", "InlineMath"]]],
 "-directed electric field in terms of the polarizabilities."
}], "MathCaption",
 CellID->329137741],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Hamiltonian", "[", 
   RowBox[{"sys", ",", 
    RowBox[{"ElectricField", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "E0", ",", "0"}], "}"}]}], ",", 
    RowBox[{"Interaction", "\[Rule]", 
     RowBox[{"{", "Polarizability", "}"}]}]}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->620675676],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["E0", "2"], " ", "\[Alpha]0"}], "2"]}], "+", 
       FractionBox[
        RowBox[{
         SuperscriptBox["E0", "2"], " ", "\[Alpha]2"}], "4"]}], "0", 
      RowBox[{
       FractionBox["1", "4"], " ", 
       SqrtBox[
        FractionBox["3", "2"]], " ", 
       SuperscriptBox["E0", "2"], " ", "\[Alpha]2"}], "0", "0"},
     {"0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["E0", "2"], " ", "\[Alpha]0"}], "2"]}], "-", 
       FractionBox[
        RowBox[{
         SuperscriptBox["E0", "2"], " ", "\[Alpha]2"}], "8"]}], "0", 
      FractionBox[
       RowBox[{"3", " ", 
        SuperscriptBox["E0", "2"], " ", "\[Alpha]2"}], "8"], "0"},
     {
      RowBox[{
       FractionBox["1", "4"], " ", 
       SqrtBox[
        FractionBox["3", "2"]], " ", 
       SuperscriptBox["E0", "2"], " ", "\[Alpha]2"}], "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["E0", "2"], " ", "\[Alpha]0"}], "2"]}], "-", 
       FractionBox[
        RowBox[{
         SuperscriptBox["E0", "2"], " ", "\[Alpha]2"}], "4"]}], "0", 
      RowBox[{
       FractionBox["1", "4"], " ", 
       SqrtBox[
        FractionBox["3", "2"]], " ", 
       SuperscriptBox["E0", "2"], " ", "\[Alpha]2"}]},
     {"0", 
      FractionBox[
       RowBox[{"3", " ", 
        SuperscriptBox["E0", "2"], " ", "\[Alpha]2"}], "8"], "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["E0", "2"], " ", "\[Alpha]0"}], "2"]}], "-", 
       FractionBox[
        RowBox[{
         SuperscriptBox["E0", "2"], " ", "\[Alpha]2"}], "8"]}], "0"},
     {"0", "0", 
      RowBox[{
       FractionBox["1", "4"], " ", 
       SqrtBox[
        FractionBox["3", "2"]], " ", 
       SuperscriptBox["E0", "2"], " ", "\[Alpha]2"}], "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["E0", "2"], " ", "\[Alpha]0"}], "2"]}], "+", 
       FractionBox[
        RowBox[{
         SuperscriptBox["E0", "2"], " ", "\[Alpha]2"}], "4"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{476, 179},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]//MatrixForm=",
 CellID->228411739]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "TutorialMoreAboutSection",
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell["MORE ABOUT", "TutorialMoreAboutSection"], 
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "More About"}], "TutorialMoreAboutSection"]], 
    None}, {None, None}},
 CellFrameLabelMargins->0,
 "WholeCellGroupOpener" -> True,
 CellID->23220180],

Cell["", "SectionHeaderSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["AtomicDensityMatrix Package",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]], \
"TutorialMoreAbout",
 CellID->1567025153],

Cell["", "SectionFooterSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "RelatedTutorialsSection",
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell["RELATED TUTORIALS", "RelatedTutorialsSection"], 
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "Related Tutorials"}], "RelatedTutorialsSection"]], 
    None}, {None, None}},
 CellFrameLabelMargins->0,
 "WholeCellGroupOpener" -> True,
 CellID->415694126],

Cell["", "SectionHeaderSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["Specifying the Atomic System",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/tutorial/SpecifyingTheAtomicSystem"]], \
"RelatedTutorials",
 CellID->806871991],

Cell[TextData[ButtonBox["The Wigner-Eckart Theorem",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/tutorial/TheWignerEckartTheorem"]], \
"RelatedTutorials",
 CellID->216904287],

Cell[TextData[ButtonBox["The Rotating-Wave Approximation",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/tutorial/TheRotatingWaveApproximation"]], \
"RelatedTutorials",
 CellID->75292384],

Cell["", "SectionFooterSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Constructing the Hamiltonian - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2013, 7, 19, 15, 4, 18.9681185}", "context" -> 
    "AtomicDensityMatrix`", "keywords" -> {"Atomic Density Matrix", "ADM"}, 
    "index" -> True, "label" -> "Atomic Density Matrix Tutorial", "language" -> 
    "en", "paclet" -> "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "The Hamiltonian is the operator that governs the time evolution of the \
state vector or density matrix. The eigenvalues of the Hamiltonian are the \
observable energies of the system. The Hamiltonian for an atomic system \
subject to external electromagnetic fields can be constructed using the \
Hamiltonian function. The Hamiltonian. This loads the package.", 
    "synonyms" -> {}, "title" -> "Constructing the Hamiltonian", "type" -> 
    "Tutorial", "uri" -> 
    "AtomicDensityMatrix/tutorial/ConstructingTheHamiltonian"}, 
  "SearchTextTranslated" -> "", "SearchText" -> ""},
FrontEndVersion->"6.0 for Microsoft Windows (64-bit) (May 21, 2008)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "6.0 for Microsoft Windows (64-bit) (May 21, 2008)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 78, 1, 3, "TutorialColorBar"],
Cell[649, 24, 220, 5, 70, "LinkTrail"],
Cell[872, 31, 13931, 283, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[14828, 318, 65, 1, 70, "Title",
 CellID->471728094],
Cell[14896, 321, 520, 12, 70, "Text",
 CellID->97203088],
Cell[15419, 335, 547, 17, 70, "DefinitionBox",
 CellID->1334],
Cell[15969, 354, 55, 1, 70, "Caption",
 CellID->164610213],
Cell[16027, 357, 66, 1, 70, "MathCaption",
 CellID->339534619],
Cell[16096, 360, 106, 3, 70, "Input",
 CellID->87034352],
Cell[16205, 365, 518, 12, 70, "Text",
 CellID->121057749],
Cell[16726, 379, 265, 11, 70, "MathCaption",
 CellID->70779043],
Cell[CellGroupData[{
Cell[17016, 394, 607, 17, 70, "Input",
 CellID->29838874],
Cell[17626, 413, 1181, 33, 70, "Output",
 CellID->202393276]
}, Open  ]],
Cell[18822, 449, 117, 3, 70, "MathCaption",
 CellID->457381827],
Cell[CellGroupData[{
Cell[18964, 456, 142, 4, 70, "Input",
 CellID->692860306],
Cell[19109, 462, 913, 27, 70, "Output",
 CellID->146000192]
}, Open  ]],
Cell[20037, 492, 241, 7, 70, "Text",
 CellID->3417020],
Cell[20281, 501, 500, 14, 70, "DefinitionBox",
 CellID->12102275],
Cell[20784, 517, 218, 8, 70, "Caption",
 CellID->199605313],
Cell[21005, 527, 255, 9, 70, "MathCaption",
 CellID->592511425],
Cell[CellGroupData[{
Cell[21285, 540, 391, 12, 70, "Input",
 CellID->70769325],
Cell[21679, 554, 1819, 55, 70, "Output",
 CellID->1034004531]
}, Open  ]],
Cell[23513, 612, 601, 20, 70, "MathCaption",
 CellID->103026365],
Cell[CellGroupData[{
Cell[24139, 636, 571, 17, 70, "Input",
 CellID->252259222],
Cell[24713, 655, 1379, 42, 70, "Output",
 CellID->443124244]
}, Open  ]],
Cell[26107, 700, 307, 11, 70, "Text",
 CellID->85178770],
Cell[26417, 713, 1531, 45, 70, "DefinitionBox",
 CellID->242695712],
Cell[27951, 760, 52, 1, 70, "Caption",
 CellID->390339910],
Cell[28006, 763, 429, 11, 70, "Text",
 CellID->132407538],
Cell[28438, 776, 349, 9, 70, "MathCaption",
 CellID->275041341],
Cell[CellGroupData[{
Cell[28812, 789, 460, 14, 70, "Input",
 CellID->339582056],
Cell[29275, 805, 1978, 59, 70, "Output",
 CellID->875737503]
}, Open  ]],
Cell[31268, 867, 237, 6, 70, "MathCaption",
 CellID->329137741],
Cell[CellGroupData[{
Cell[31530, 877, 366, 11, 70, "Input",
 CellID->620675676],
Cell[31899, 890, 2894, 91, 70, "Output",
 CellID->228411739]
}, Open  ]],
Cell[CellGroupData[{
Cell[34830, 986, 747, 21, 70, "TutorialMoreAboutSection",
 CellID->23220180],
Cell[35580, 1009, 861, 21, 70, "SectionHeaderSpacer"],
Cell[36444, 1032, 192, 5, 70, "TutorialMoreAbout",
 CellID->1567025153],
Cell[36639, 1039, 861, 21, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[37537, 1065, 759, 21, 70, "RelatedTutorialsSection",
 CellID->415694126],
Cell[38299, 1088, 861, 21, 70, "SectionHeaderSpacer"],
Cell[39163, 1111, 200, 5, 70, "RelatedTutorials",
 CellID->806871991],
Cell[39366, 1118, 194, 5, 70, "RelatedTutorials",
 CellID->216904287],
Cell[39563, 1125, 205, 5, 70, "RelatedTutorials",
 CellID->75292384],
Cell[39771, 1132, 861, 21, 70, "SectionFooterSpacer"]
}, Open  ]]
}, Open  ]],
Cell[40659, 1157, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

