(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     32702,        936]
NotebookOptionsPosition[     27905,        786]
NotebookOutlinePosition[     29999,        840]
CellTagsIndexPosition[     29956,        837]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "TutorialColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["AtomicDensityMatrix Package",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {
    StyleBox[
     GraphicsBox[RasterBox[CompressedData["
1:eJy9lulTk1cUxp+Zfu+Xfu5MO9O/oF90povj0A6dVtupdRsBqwRCg+DCqCxF
LLIIoUAIyGLayqJCFZRYVJaAaDBsQkBCEhaVoCjEBAiLTSLJ7bmX0nEBhZZ6
5mbmTebN/d3nnOec930/cN+mwLcAvEefD+jDr9nrwul0DvabbdaxuwNm++Ox
197/r8PQrY/bLwnyxYFvEL0F8TtwOiNq9IHFYDC4XK5VBGmvaXasg/QLRH6H
xABkBiFXhvw9fCVJP7LZbKsFemwdC1gP2ZdcjnwXCvag9BAuxOByHC4dQUU0
dBfzV4vV0aoL+4orOv49ckNRHo3qeDQehy4NzWnQpvCv/W2aRf+70vSeK8o/
+C0vkDIEZYdx5SfclKM9Az05MOai9wQ6FahLwJT9ObeQkaqrq3t7e1fESo+W
/LgV8t1QhfPU1Seh5WfczoY5D4Mn0V/AoSSwNkfidjnpfofDUVVVpVKpFArF
5OTkiliZMZJ4PyiCceYg/ohDUyq6stCXhzsqziIicXVyXriyVMnQoHnt2rV+
fn5paWkmk2lFIAptrfqYHzceJZBy1ZaObiUGCjirL5/nsDWdl+yXvfw8R3e8
EyYLIVBhYSEJfMW25F6HCKeI+R+npxzJOzmLEtiQhFuZvEzEouzps9CQzN1C
5s8IQroE4VvWJB2NLsqKP3U8vCI7ytypm0/syzExMaFWqxMTE2NjY0NDQ6VS
aVNTk8vpVMVLToZxq9cnclZvLsd1KDiFtFA1Y7aAtKfuflsRFXA+YSMdifzT
ks7PdjXV1/7IspS69vZ2uVyeLYKqbLFYGmursqUoO8RzRSwqUJcSJRGcsssH
gZ/zYULaC/fzapJVhn7F47MYPw/b77CVYlCFe83qpXDUFw0NDSUlJZRPo9FY
U1OTk5kWfzjsVOQ6qg7t1piMw5uw/VPs/gx7N/JhQiBy42gJZi/iaS3YdTAd
WBtYEzwaTJbj0a0lcez5TrxvGcpOOFCsiCOxOTEBcdu5HN7jm3k7kG2ou20X
4KqDpxXsNlgPmAmsD6xfXLdh5jK8Txev3cthHbHkhWLfRq6FRhY1OMmZ92db
BkbPYk4LZgS7BzYMZhHr/sIaBNPDZX6VtGeDJvDWT3iBwjZwM5yQ8ZLdSMGA
CvZyeBrE+Qn0QLCGwO6KixGwh+JHwg0vi3X6t/xtArTvayT4o/gAauLRmYVH
xXBWgmnAOsEMYunBugSXEnhHqBsRi9Cji4/NZ6MgK3Xrx7xAVB3qIz7b0/jQ
mD4PTzXYNbBWjrBW4mExZtXw1nNLcKhRyLEIgXThMC8ndTvXI3Yb0gNx+Sjv
rNHT+FMN1igo3VzIXD0myjB5DtMV8F5ZOECXcMggF2hvW+OcedUkoYcXGTvY
lzucZi+BqLlmKjB3FV6dOLlZ7Ebb3oRXAzeZrUak9IYwPN3QK264jYfmG0ql
UqfTud3uRVl1V9TkOrKcUoq6YzDlwVEBz3V42xfyc0eUhjbsAGsB04qlE/QO
oYv8b5Iw19+KZmdnl9JVVX7m0CZkSXmNqP2fXIS3UezQt+DqAZFDk/BGm8A1
i9Uivhqj2IiGzS2rrcI30OjGuUgYcmAthUcr0jK44K57mGp511r1ITdDI7xa
Pi68VKkWibs5io3pl0mZj+wjkuwf+AgdL8VcrUiLSfTmiOigHlSejLTb7XNP
HJ6pMc+4hdFkWPZweCGMHbriCJjzMX1B2NggCjQkerYLTlufv79/T0/PUuVe
UdDTpzLJl56Jzkui3D0LxuuVOMctPj4+MpksOTlZr9f/dxbFU5dztFtjPcPN
7CUnd0cxq34+URERESEhISkpKTMzM6vC+ic8bucLg3p4eDgoKIjel1YXtGjQ
e0JwcDA94N4Ai6KoqGh8fPzNsFbFgf9r/AWVRIUY
       "], {{0, 0}, {36, 32}}, {0, 255},
       ColorFunction->RGBColor],
      ImageSize->{36, 32},
      PlotRange->{{0, 36}, {0, 32}}],
     Deployed->True,
     StripOnInput->False], Cell[
    "ATOMIC DENSITY MATRIX TUTORIAL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix Package", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"AtomicDensityMatrix Package\"\>"}, 
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"More About \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "ToCartesian", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/ToCartesian", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "ToContravariant", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/ToContravariant", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "ToCovariant", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/ToCovariant", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"ToCartesian\"\>", 2->"\<\"ToContravariant\"\>", 
       3->"\<\"ToCovariant\"\>"}, 
       FrameBox["\<\"Functions \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"Functions \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix/tutorial/\
ConversionBetweenTheCartesianAndSphericalBases", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> None, 
          StringReplace[
           "Copy Mathematica url", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  StringReplace[
                  "AtomicDensityMatrix/tutorial/\
ConversionBetweenTheCartesianAndSphericalBases", 
                   "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], Delimiter, 
          StringReplace[
           "Copy web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  BoxData[
                   MakeBoxes[
                    Hyperlink[
                    StringReplace[
                    "http://reference.wolfram.com/mathematica/\
AtomicDensityMatrix/tutorial/ConversionBetweenTheCartesianAndSphericalBases.\
html", "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]], StandardForm]], 
                  StringReplace[
                  "Input", "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"], TextClipboardType -> 
                  StringReplace[
                   "PlainText", "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], 
          StringReplace[
           "Go to web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> FrontEndExecute[{
             NotebookLocate[{
               URL[
                StringJoin[
                 StringReplace[
                 "http://reference.wolfram.com/mathematica/", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 "AtomicDensityMatrix/tutorial/\
ConversionBetweenTheCartesianAndSphericalBases", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 ".html", "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"]]], None}]}]}, #, 2]& , 
        Evaluator -> Automatic], {
       1->"\<\"AtomicDensityMatrix/tutorial/\
ConversionBetweenTheCartesianAndSphericalBases\"\>", 
       2->"\<\"Copy Mathematica url\"\>", Delimiter, 
       4->"\<\"Copy web url\"\>", 5->"\<\"Go to web url\"\>"}, 
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"URL \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxAlignment->{"Columns" -> {{Left, Left, Right}}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.05], 
     Scaled[0.3], {
      Scaled[0.64]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Conversion Between the Cartesian and Spherical Bases", "Title",
 CellID->126474626],

Cell["\<\
The spherical harmonics of a particular rank are covariant components of an \
irreducible tensor. This can be used to find the perscription for converting \
between the spherical and Cartesian bases.\
\>", "Text",
 CellID->368638997],

Cell["This loads the package with coordinate systems.", "MathCaption",
 CellID->19870820],

Cell[BoxData[
 RowBox[{"<<", "VectorAnalysis`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->3349167],

Cell["Here are the spherical harmonics of rank 1.", "MathCaption",
 CellID->588324495],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sphereh", "=", 
  RowBox[{"ExpToTrig", "@", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"SphericalHarmonicY", "[", 
      RowBox[{"1", ",", "q", ",", "\[Theta]", ",", "\[Phi]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"q", ",", "1", ",", 
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "1"}]}], "}"}]}], "]"}]}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->414842540],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     FractionBox["1", "2"]}], " ", 
    SqrtBox[
     FractionBox["3", 
      RowBox[{"2", " ", "\[Pi]"}]]], " ", 
    RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Cos", "[", "\[Phi]", "]"}], "+", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"Sin", "[", "\[Phi]", "]"}]}]}], ")"}]}], ",", 
   RowBox[{
    FractionBox["1", "2"], " ", 
    SqrtBox[
     FractionBox["3", "\[Pi]"]], " ", 
    RowBox[{"Cos", "[", "\[Theta]", "]"}]}], ",", 
   RowBox[{
    FractionBox["1", "2"], " ", 
    SqrtBox[
     FractionBox["3", 
      RowBox[{"2", " ", "\[Pi]"}]]], " ", 
    RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Cos", "[", "\[Phi]", "]"}], "-", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"Sin", "[", "\[Phi]", "]"}]}]}], ")"}]}]}], "}"}]], "Output",
 ImageSize->{583, 40},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->159864394]
}, Open  ]],

Cell["Here are rules for converting to Cartesian coordinates.", "MathCaption",
 CellID->133455718],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tocart", "=", 
  RowBox[{"MapThread", "[", 
   RowBox[{"Rule", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"CoordinatesToCartesian", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"r", ",", "\[Theta]", ",", "\[Phi]"}], "}"}], ",", 
         "Spherical"}], "]"}], "/", "r"}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "y", ",", "z"}], "}"}], "/", "r"}]}], "}"}]}], 
   "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->427805132],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Cos", "[", "\[Phi]", "]"}], " ", 
     RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "\[Rule]", 
    FractionBox["x", "r"]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
     RowBox[{"Sin", "[", "\[Phi]", "]"}]}], "\[Rule]", 
    FractionBox["y", "r"]}], ",", 
   RowBox[{
    RowBox[{"Cos", "[", "\[Theta]", "]"}], "\[Rule]", 
    FractionBox["z", "r"]}]}], "}"}]], "Output",
 ImageSize->{338, 28},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->81851296]
}, Open  ]],

Cell[TextData[{
 "The spherical harmonics in terms of Cartesian coordinates, with the ",
 Cell[BoxData[
  FormBox["r", TraditionalForm]]],
 " dependence normalized out."
}], "MathCaption",
 CellID->951095738],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{
    RowBox[{"Expand", "[", "sphereh", "]"}], "/.", "tocart"}], "]"}], "/", 
  RowBox[{"(", 
   RowBox[{
    SqrtBox[
     RowBox[{"3", "/", "\[Pi]"}]], "/", 
    RowBox[{"(", 
     RowBox[{"2", "r"}], ")"}]}], ")"}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->181541453],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"x", "+", 
      RowBox[{"\[ImaginaryI]", " ", "y"}]}], 
     SqrtBox["2"]]}], ",", "z", ",", 
   FractionBox[
    RowBox[{"x", "-", 
     RowBox[{"\[ImaginaryI]", " ", "y"}]}], 
    SqrtBox["2"]]}], "}"}]], "Output",
 ImageSize->{137, 34},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->349463250]
}, Open  ]],

Cell[BoxData[GridBox[{
   {
    RowBox[{
     ButtonBox["ToCovariant",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/ToCovariant"], "[", 
     StyleBox["expr", "TI"], "]"}], Cell[TextData[{
     "convert ",
     StyleBox["expr", "TI"],
     " to a covariant spherical tensor"
    }], "TableText"]},
   {
    RowBox[{
     ButtonBox["ToContravariant",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/ToContravariant"], "[", 
     StyleBox["expr", "TI"], "]"}], Cell[TextData[{
     "convert ",
     StyleBox["expr", "TI"],
     " to a contravariant spherical tensor"
    }], "TableText"]},
   {
    RowBox[{
     ButtonBox["ToCartesian",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/ToCartesian"], "[", 
     StyleBox["expr", "TI"], "]"}], Cell[TextData[{
     "convert ",
     StyleBox["expr", "TI"],
     " to Cartesian basis"
    }], "TableText"]}
  }]], "DefinitionBox",
 CellID->36928428],

Cell["Converting between standard and cartesian bases.", "Caption",
 CellID->34858334],

Cell["This loads the package.", "MathCaption",
 CellID->96769381],

Cell[BoxData[
 RowBox[{"<<", "AtomicDensityMatrix`"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->374867326],

Cell["\<\
This converts the Cartesian components of a vector to covariant spherical \
components.\
\>", "MathCaption",
 CellID->601841232],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ToCovariant", "[", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y", ",", "z"}], "}"}], "]"}], "//", "Simplify"}], "//",
   "MatrixForm"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->645192206],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"-", 
       FractionBox[
        RowBox[{"x", "+", 
         RowBox[{"\[ImaginaryI]", " ", "y"}]}], 
        SqrtBox["2"]]}], "z", 
      FractionBox[
       RowBox[{"x", "-", 
        RowBox[{"\[ImaginaryI]", " ", "y"}]}], 
       SqrtBox["2"]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{108, 31},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]//MatrixForm=",
 CellID->541101613]
}, Open  ]],

Cell["This converts to contravariant spherical components.", "MathCaption",
 CellID->37952416],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ToContravariant", "[", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y", ",", "z"}], "}"}], "]"}], "//", "Simplify"}], "//",
   "MatrixForm"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->24871644],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"-", 
       FractionBox[
        RowBox[{"x", "-", 
         RowBox[{"\[ImaginaryI]", " ", "y"}]}], 
        SqrtBox["2"]]}]},
     {"z"},
     {
      FractionBox[
       RowBox[{"x", "+", 
        RowBox[{"\[ImaginaryI]", " ", "y"}]}], 
       SqrtBox["2"]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{58, 79},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]//MatrixForm=",
 CellID->522851662]
}, Open  ]],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["ToCartesian",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/ToCartesian"]], 
  "InlineFormula"],
 " converts either set back to Cartesian components."
}], "MathCaption",
 CellID->359020410],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "@", 
  RowBox[{"ToCartesian", "[", "%", "]"}]}]], "Input",
 CellLabel->"In[8]:=",
 CellID->197447347],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"x", ",", "y", ",", "z"}], "}"}]], "Output",
 ImageSize->{62, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[8]=",
 CellID->302363619]
}, Open  ]],

Cell["\<\
The conversion functions also work on vectors whose components are operators.\
\
\>", "Text",
 CellID->525920805],

Cell[TextData[{
 "This gives the covariant spherical components of the angular-momentum \
operator for a ",
 Cell[BoxData[
  FormBox[
   RowBox[{"j", "=", 
    RowBox[{"1", "/", "2"}]}], TraditionalForm]]],
 " state."
}], "MathCaption",
 CellID->19678084],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"WignerEckart", "[", 
   RowBox[{
    RowBox[{"1", "/", "2"}], ",", 
    RowBox[{"{", 
     RowBox[{"J", ",", "1"}], "}"}]}], "]"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[9]:=",
 CellID->1244599],

Cell[GraphicsData["CompressedBitmap", "\<\
eJzVWj1QG0cUPnToLxJCiBg84cdCtjMpYuJJ5aFKlaTJTCZVSognGlx4onE8
GWZS4I4SdZSUlHSipKSkpFBBSUlJqejtz7t9d9+thHwiNjMS3O7e7vd9+97b
fbv8svN+98+3O+/fvN5p/vRup7P75vXfzR//ejcsCmeCIOgPPy+aAf09GP5p
vvrBYDCgSvXrX/UrH/S7W4H7s9XtB1+ruvDxzc2N+os+3+vX8rpq+/j4mKt+
02W7R0dHXLauy4bfvaBN/bZ7QVmXle7u7vj9FV328vLycu/g4EA9vdBlH/b3
97m/UA8/qx++ubq6+vns7Ew9lcDwOcNu0O8GEb+toNsfBMueugUAsa7LaDxW
ZMOA6rWVZC4Ogs3t6gBbMZKQy1tg3FLUjuQBMqBuBcyQJ7mt6Km2Q9rt4SQv
e+oagMq8LuscHh7ymC07Sq8X9CSO5vX1NeObB9hUu5xiJom0wODFSJ+Dvb09
V4swquJuSgCr1aK71WasyjqH07fsqWsAPrXIan84Pz9XT03XrIbWrvoY2gc5
VBngqYEyTXPWllHfZOrRNCZ9dQXAM/TJoUgWxyO0CrlXFxcXJcBB21UhpsPA
Pi/5qxuA0VxUxlA2zFjKedSPeh2JNAdAapHyZBu/np6e0lP99vb295OTE2sM
IuyspwqtDJIETiikTTJufoLF1LTiOEifTV1G5BgN0rSgy0gQfj8XBZCYF8jA
tZoukAi0UiARnosA+uyEDreYTln0X3AdLhbHn+r2ZDNk66l9GFtiGc1HSVaw
gjnBbQVgc2ITSz2hVMrBY7Fj2VO3mE5TjFngPpKxXkmVoy5qAFlFfZeVczkC
wSi3CtCgxXlmpDiiLI/DxWNcvBinA4VAdldhB+kHNtDm1HdoO3fdioYY2M1V
qL85RjHuVCRmNIpssQiUoLTKHZVBR/dU89UY+qRGrdY4lMgRbGAOWp8J9mrk
2Fy28dDYsV0+stYk4hzFgoHeWHzqpNKjWigIj0WGLeuByRSxb07Mg5z+sNPp
qLqS+g5pG8PtlrLkpjenMqN75IXZujexZ9BO9XpczJLME10mcsYlL7SmmTy7
ahlSX4zFBy2a0+AjEkI/H5F+mqXJT8bk7WLRqutF63h7e5vblU1rFIgyJa12
5Sj985vl5hhTlroEFDInkMzVxFYulqvNfSbU1jQHmGGZo4fAzbDmP4LXHIwa
enVrPJQxmp3ryOzJknezp4+ZVHMuIgha0mjVzJS0mWWY+xTtLDu5TzVjootG
0tiKmilHEyjFDkicDcYE9k+m2NDEfDuRRo3kvz4FoiKdCLHA43CU/v18DA9O
LK5PpkBPpBZfelGVgKv656jmvmEW1UxJtIAx+tPVMnBDfx7z8v8FLM5kYr7l
V38awEWu4Aeesr1/eMwj84KSF5I/DGcK2O500H7/u08NJNrE+0Gueej5l8Kp
EEB7IA4PE5xYoc1/YSxBkJT3FEQcNY8WBJyVpm6ENyPXpzsR9ZR+JDr6FK/m
0T/BWgDFO1ttQA1PXREwcO4CU3SjHIrjhHNfcU/dRCqGTszX/N1U0uUHdx2+
20dP4o1vPmk8jvjyAJ6uMPgOVW8w6YQ675nbr+AM6bwE3eoikuNplexGgfMZ
3sjECCtkc1SgEJkOi4esTdxB4oN/AcfseCmHZE1qTK7oUddHrgrI1QDaql/5
BX91HmB3rpTjd6qe23gCFbsxxMf7WD0aLX4BL3gWwbu+BLICmM0DqJnoJ9A7
/x3BzV391FGQaUQweNP5DFCsRe04ONUBDSRPStpZSVdcwKlO6JZ5AFlv5cjt
tGnYRsiSxNGtvUGPpVwOXl4K6oADkmUD4FsAQ1c81uWzvDzAhi4HQ6GEGPpb
08BN0J6CdrNYnRZAYA+G0SVisrgOBjN4/wDY/tFV5h+ugpn/AN7eTmA=\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{219, 45},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[9]//MatrixForm=",
 CellID->194712039]
}, Open  ]],

Cell["This converts to the Cartesian basis.", "MathCaption",
 CellID->15092995],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ToCartesian", "[", "%", "]"}], "//", "TensorForm"}]], "Input",
 CellLabel->"In[10]:=",
 CellID->470616148],

Cell[GraphicsData["CompressedBitmap", "\<\
eJzFWj1s20YUpvVP2UlsJWmaWK4pOUGMDm6AokCgqVPbpUDGolONoISCoKiQ
pIA3d/NobR49evRGjx6dzaMHDR49evTI8v4e76SPx6NlpgZE6453733fu/fe
ke/06/an4Z9/bX9693Y7+PnD9mj47u3H4Ke/PyRd1QXP8z4nn+8Cj32Pk6/y
8tmL4+TbG/6v7k3GA0//G4wn3kcx5KFlyGt+r5pcIy9knWHk/aNPM299L/qG
BwcH/Bv7NOS4KOQyeasn+lo3Nzd/HB4e8tYPFhiPhcolMY2mZIlfFX3/7u7u
0riO6Pvl5OTk66urK95qKQpR5EVyXC+dS+PkXNZm83lrHdD3Rd+r8/PzN8fH
x7y1KKCLf9XNi4sLEoHUP0spMjG6+tH+/j7RqavrZOwNEtW8P7EBs1ZfjA8u
Ly9pJZCMHjCdxLQ/Go1oXNugYCyuDcZqush7Ozs7vLWSWujH09NT3mrya03A
4H8hM8cGQLwM/GYDWFGIrLJFIDWSRTsVQUwyEHTF0J29vT02XEfAUFHfVjbS
346OjsiNAouxfOCyvoa48vrs7Gwz9WHmSLoiBpImbgHlywBkD/P2wVAdi/AB
kvwSuDZCtabTT8PbG09iFdlssRhRXYZhEmRqE5ox/KlFpQ98CalUsCfjkM/j
/Ym8MFk1DrvCUK+AmQ2L9g0QTA5EEIg2EPUgEw63cay2iaq4UpCwz32pazwI
KaB4lktShBthhFISZqamwLEQdgXbtoBFcpFh1qRGU0as2otOnBGARZWa4omn
drUKv1ZVrPERFUey9dSGLLm7OU0mL5RySjJP5uR+NqOqTE60wSYGncRxtTyi
OF7FE0hnzqDIsUDLsID4KJ/hw2q6UdiWPaAIqxWgEkb2+HYNmSZ5dpTIGXC5
xnPk1PbmljcQoscWJj7wHmUhfZMVfSrMhGnHkR5SBhz1XKbDuW8hN4/RHskl
nNqCXfPsLJgnADyyU0150piHlZaH5rLTA8xnHhM9t9oi49ntfzbDWqGUoyU5
4dl2yv0vx43wyWiSKr8RN42hygkT/EtA0hZRoggVg3lrEcwIsO52OUyV5wk/
EoYVNJuzNHkuEhkYIW/qOkMB6fks/xwpPYCoJPKbWUS1l1sEESyqy4xbEJDZ
zU7A7FNzgf0ySNSKzMggwXIyy1oaCbn/KH9vOuJH+SLFihIDwlXXOClcC/Mb
927AWYxWzHXLBDdHXKWvbbM1Ldct0Q68YdGwUSYpM9RRxkdkAgtc34GoqfVF
OQRX9TQg62KuqxUAmPY3pBbQVtLKdSngo+kHh1xifQDTvmI+0Ibe9+4wzlBl
zXXlUB2x5RR7SGtJK/hMCrrl43VuBbLoY3ZBmq6vr65J3VbALJTrLW+NBeoQ
d7kXuVYEsotnuPBY7M3EUrzMxN+1zLwHbJ9bBcQFRUnEKAXbiGQWJXOJoJka
keXr62tXIqjCIUoL+dW/RqrSifAXq0hmGrDuKMVWkboHWM8eRtAa5FTb5NbO
fI9O6FDR36Vop9M2Djq69slLwHFNRuwYhU7/3BgxLNYzIbdCLDMKBSYS48bN
cqzBVopMnx8W1sKfcQqHDrhuU1jUTuMMGtqJHum0lVlX8p3asKw0k+2UFdX7
JCxUDDI8mo/jp4hNi7SvKD+k9Td0voQOYlEdbMWiS/oKg0TnhvpRc4WFQMZz
B2ItHtaYbz0EOaOBBSHC0nzsgJO8qQNENgGIDlYjuR4Mh0NyHskVhczTLHpT
4zRUJDbIZsTYTP+ogRmZjlwRo15qjekfNSyltwjSE2mAqaqdD4Z2UidiUcVb
62q6WRBtpUMpaB4BkTWsvQ+GSg7y9Nqo+ayD4d+mCGiz6YK5r4TY97QKaQnw
d3FL/jLHW/gP4yHT+g==\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{200, 47},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[10]=",
 CellID->2806508]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "TutorialMoreAboutSection",
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell["MORE ABOUT", "TutorialMoreAboutSection"], 
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "More About"}], "TutorialMoreAboutSection"]], 
    None}, {None, None}},
 CellFrameLabelMargins->0,
 "WholeCellGroupOpener" -> True,
 CellID->23220180],

Cell["", "SectionHeaderSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["AtomicDensityMatrix Package",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]], \
"TutorialMoreAbout",
 CellID->1567025153],

Cell["", "SectionFooterSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Conversion Between the Cartesian and Spherical Bases - Wolfram \
Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2013, 7, 19, 15, 4, 20.3531977}", "context" -> 
    "AtomicDensityMatrix`", "keywords" -> {"Atomic Density Matrix", "ADM"}, 
    "index" -> True, "label" -> "Atomic Density Matrix Tutorial", "language" -> 
    "en", "paclet" -> "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "The spherical harmonics of a particular rank are covariant components of \
an irreducible tensor. This can be used to find the perscription for \
converting between the spherical and Cartesian bases. This loads the package \
with coordinate systems. Here are the spherical harmonics of rank 1.", 
    "synonyms" -> {}, "title" -> 
    "Conversion Between the Cartesian and Spherical Bases", "type" -> 
    "Tutorial", "uri" -> 
    "AtomicDensityMatrix/tutorial/\
ConversionBetweenTheCartesianAndSphericalBases"}, "SearchTextTranslated" -> 
  "", "SearchText" -> ""},
FrontEndVersion->"6.0 for Microsoft Windows (64-bit) (May 21, 2008)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "6.0 for Microsoft Windows (64-bit) (May 21, 2008)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 78, 1, 3, "TutorialColorBar"],
Cell[649, 24, 220, 5, 70, "LinkTrail"],
Cell[872, 31, 9973, 206, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[10870, 241, 89, 1, 70, "Title",
 CellID->126474626],
Cell[10962, 244, 243, 5, 70, "Text",
 CellID->368638997],
Cell[11208, 251, 89, 1, 70, "MathCaption",
 CellID->19870820],
Cell[11300, 254, 100, 3, 70, "Input",
 CellID->3349167],
Cell[11403, 259, 86, 1, 70, "MathCaption",
 CellID->588324495],
Cell[CellGroupData[{
Cell[11514, 264, 413, 12, 70, "Input",
 CellID->414842540],
Cell[11930, 278, 1061, 35, 70, "Output",
 CellID->159864394]
}, Open  ]],
Cell[13006, 316, 98, 1, 70, "MathCaption",
 CellID->133455718],
Cell[CellGroupData[{
Cell[13129, 321, 520, 17, 70, "Input",
 CellID->427805132],
Cell[13652, 340, 617, 20, 70, "Output",
 CellID->81851296]
}, Open  ]],
Cell[14284, 363, 208, 6, 70, "MathCaption",
 CellID->951095738],
Cell[CellGroupData[{
Cell[14517, 373, 339, 12, 70, "Input",
 CellID->181541453],
Cell[14859, 387, 435, 16, 70, "Output",
 CellID->349463250]
}, Open  ]],
Cell[15309, 406, 978, 32, 70, "DefinitionBox",
 CellID->36928428],
Cell[16290, 440, 86, 1, 70, "Caption",
 CellID->34858334],
Cell[16379, 443, 65, 1, 70, "MathCaption",
 CellID->96769381],
Cell[16447, 446, 107, 3, 70, "Input",
 CellID->374867326],
Cell[16557, 451, 138, 4, 70, "MathCaption",
 CellID->601841232],
Cell[CellGroupData[{
Cell[16720, 459, 236, 8, 70, "Input",
 CellID->645192206],
Cell[16959, 469, 964, 30, 70, "Output",
 CellID->541101613]
}, Open  ]],
Cell[17938, 502, 94, 1, 70, "MathCaption",
 CellID->37952416],
Cell[CellGroupData[{
Cell[18057, 507, 239, 8, 70, "Input",
 CellID->24871644],
Cell[18299, 517, 977, 32, 70, "Output",
 CellID->522851662]
}, Open  ]],
Cell[19291, 552, 256, 8, 70, "MathCaption",
 CellID->359020410],
Cell[CellGroupData[{
Cell[19572, 564, 137, 4, 70, "Input",
 CellID->197447347],
Cell[19712, 570, 213, 7, 70, "Output",
 CellID->302363619]
}, Open  ]],
Cell[19940, 580, 123, 4, 70, "Text",
 CellID->525920805],
Cell[20066, 586, 255, 9, 70, "MathCaption",
 CellID->19678084],
Cell[CellGroupData[{
Cell[20346, 599, 239, 8, 70, "Input",
 CellID->1244599],
Cell[20588, 609, 2171, 39, 70, "Output",
 Evaluatable->False,
 CellID->194712039]
}, Open  ]],
Cell[22774, 651, 79, 1, 70, "MathCaption",
 CellID->15092995],
Cell[CellGroupData[{
Cell[22878, 656, 141, 4, 70, "Input",
 CellID->470616148],
Cell[23022, 662, 2122, 39, 70, "Output",
 Evaluatable->False,
 CellID->2806508]
}, Open  ]],
Cell[CellGroupData[{
Cell[25181, 706, 747, 21, 70, "TutorialMoreAboutSection",
 CellID->23220180],
Cell[25931, 729, 861, 21, 70, "SectionHeaderSpacer"],
Cell[26795, 752, 192, 5, 70, "TutorialMoreAbout",
 CellID->1567025153],
Cell[26990, 759, 861, 21, 70, "SectionFooterSpacer"]
}, Open  ]]
}, Open  ]],
Cell[27878, 784, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

