(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     73770,       1614]
NotebookOptionsPosition[     69108,       1476]
NotebookOutlinePosition[     71279,       1529]
CellTagsIndexPosition[     71236,       1526]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "TutorialColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["AtomicDensityMatrix Package",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {
    StyleBox[
     GraphicsBox[RasterBox[CompressedData["
1:eJy9lulTk1cUxp+Zfu+Xfu5MO9O/oF90povj0A6dVtupdRsBqwRCg+DCqCxF
LLIIoUAIyGLayqJCFZRYVJaAaDBsQkBCEhaVoCjEBAiLTSLJ7bmX0nEBhZZ6
5mbmTebN/d3nnOec930/cN+mwLcAvEefD+jDr9nrwul0DvabbdaxuwNm++Ox
197/r8PQrY/bLwnyxYFvEL0F8TtwOiNq9IHFYDC4XK5VBGmvaXasg/QLRH6H
xABkBiFXhvw9fCVJP7LZbKsFemwdC1gP2ZdcjnwXCvag9BAuxOByHC4dQUU0
dBfzV4vV0aoL+4orOv49ckNRHo3qeDQehy4NzWnQpvCv/W2aRf+70vSeK8o/
+C0vkDIEZYdx5SfclKM9Az05MOai9wQ6FahLwJT9ObeQkaqrq3t7e1fESo+W
/LgV8t1QhfPU1Seh5WfczoY5D4Mn0V/AoSSwNkfidjnpfofDUVVVpVKpFArF
5OTkiliZMZJ4PyiCceYg/ohDUyq6stCXhzsqziIicXVyXriyVMnQoHnt2rV+
fn5paWkmk2lFIAptrfqYHzceJZBy1ZaObiUGCjirL5/nsDWdl+yXvfw8R3e8
EyYLIVBhYSEJfMW25F6HCKeI+R+npxzJOzmLEtiQhFuZvEzEouzps9CQzN1C
5s8IQroE4VvWJB2NLsqKP3U8vCI7ytypm0/syzExMaFWqxMTE2NjY0NDQ6VS
aVNTk8vpVMVLToZxq9cnclZvLsd1KDiFtFA1Y7aAtKfuflsRFXA+YSMdifzT
ks7PdjXV1/7IspS69vZ2uVyeLYKqbLFYGmursqUoO8RzRSwqUJcSJRGcsssH
gZ/zYULaC/fzapJVhn7F47MYPw/b77CVYlCFe83qpXDUFw0NDSUlJZRPo9FY
U1OTk5kWfzjsVOQ6qg7t1piMw5uw/VPs/gx7N/JhQiBy42gJZi/iaS3YdTAd
WBtYEzwaTJbj0a0lcez5TrxvGcpOOFCsiCOxOTEBcdu5HN7jm3k7kG2ou20X
4KqDpxXsNlgPmAmsD6xfXLdh5jK8Txev3cthHbHkhWLfRq6FRhY1OMmZ92db
BkbPYk4LZgS7BzYMZhHr/sIaBNPDZX6VtGeDJvDWT3iBwjZwM5yQ8ZLdSMGA
CvZyeBrE+Qn0QLCGwO6KixGwh+JHwg0vi3X6t/xtArTvayT4o/gAauLRmYVH
xXBWgmnAOsEMYunBugSXEnhHqBsRi9Cji4/NZ6MgK3Xrx7xAVB3qIz7b0/jQ
mD4PTzXYNbBWjrBW4mExZtXw1nNLcKhRyLEIgXThMC8ndTvXI3Yb0gNx+Sjv
rNHT+FMN1igo3VzIXD0myjB5DtMV8F5ZOECXcMggF2hvW+OcedUkoYcXGTvY
lzucZi+BqLlmKjB3FV6dOLlZ7Ebb3oRXAzeZrUak9IYwPN3QK264jYfmG0ql
UqfTud3uRVl1V9TkOrKcUoq6YzDlwVEBz3V42xfyc0eUhjbsAGsB04qlE/QO
oYv8b5Iw19+KZmdnl9JVVX7m0CZkSXmNqP2fXIS3UezQt+DqAZFDk/BGm8A1
i9Uivhqj2IiGzS2rrcI30OjGuUgYcmAthUcr0jK44K57mGp511r1ITdDI7xa
Pi68VKkWibs5io3pl0mZj+wjkuwf+AgdL8VcrUiLSfTmiOigHlSejLTb7XNP
HJ6pMc+4hdFkWPZweCGMHbriCJjzMX1B2NggCjQkerYLTlufv79/T0/PUuVe
UdDTpzLJl56Jzkui3D0LxuuVOMctPj4+MpksOTlZr9f/dxbFU5dztFtjPcPN
7CUnd0cxq34+URERESEhISkpKTMzM6vC+ic8bucLg3p4eDgoKIjel1YXtGjQ
e0JwcDA94N4Ai6KoqGh8fPzNsFbFgf9r/AWVRIUY
       "], {{0, 0}, {36, 32}}, {0, 255},
       ColorFunction->RGBColor],
      ImageSize->{36, 32},
      PlotRange->{{0, 36}, {0, 32}}],
     Deployed->True,
     StripOnInput->False], Cell[
    "ATOMIC DENSITY MATRIX TUTORIAL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "Stark Mixing", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/tutorial/StarkMixing", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "Hyperfine Structure: Breit-Rabi Diagram", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/tutorial/\
HyperfineStructureBreitRabiDiagram", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"Stark Mixing\"\>", 
       2->"\<\"Hyperfine Structure: Breit-Rabi Diagram\"\>"}, 
       FrameBox["\<\"Related Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"Related Tutorials \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix Package", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"AtomicDensityMatrix Package\"\>"}, 
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"More About \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix/tutorial/CrossedElectricAndMagneticFields", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> None, 
          StringReplace[
           "Copy Mathematica url", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  StringReplace[
                  "AtomicDensityMatrix/tutorial/\
CrossedElectricAndMagneticFields", 
                   "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], Delimiter, 
          StringReplace[
           "Copy web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  BoxData[
                   MakeBoxes[
                    Hyperlink[
                    StringReplace[
                    "http://reference.wolfram.com/mathematica/\
AtomicDensityMatrix/tutorial/CrossedElectricAndMagneticFields.html", 
                    "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]], StandardForm]], 
                  StringReplace[
                  "Input", "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"], TextClipboardType -> 
                  StringReplace[
                   "PlainText", "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], 
          StringReplace[
           "Go to web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> FrontEndExecute[{
             NotebookLocate[{
               URL[
                StringJoin[
                 StringReplace[
                 "http://reference.wolfram.com/mathematica/", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 "AtomicDensityMatrix/tutorial/\
CrossedElectricAndMagneticFields", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 ".html", "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"]]], None}]}]}, #, 2]& , 
        Evaluator -> Automatic], {
       1->"\<\"AtomicDensityMatrix/tutorial/CrossedElectricAndMagneticFields\"\
\>", 2->"\<\"Copy Mathematica url\"\>", Delimiter, 4->"\<\"Copy web url\"\>", 
       5->"\<\"Go to web url\"\>"}, 
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"URL \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxAlignment->{"Columns" -> {{Left, Left, Right}}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.05], 
     Scaled[0.3], {
      Scaled[0.64]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Crossed Electric and Magnetic Fields", "Title",
 CellID->147735377],

Cell[TextData[{
 "The effects of Stark mixing on the sublevels of a single state can be \
accounted for to second order in the electric field by writing an effective \
Hamiltonian in terms of the polarizability of the atomic state. Here we \
analyze a ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"J", "=", "1"}], "InlineMath"]]],
 " state subject to crossed electric and magnetic fields. The state is \
assumed to have a tensor polarizability but no scalar polarizability."
}], "Text",
 CellID->455402839],

Cell["This loads the package.", "MathCaption",
 CellID->159403208],

Cell[BoxData[
 RowBox[{"<<", "AtomicDensityMatrix`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->75905070],

Cell["Set graphics options.", "MathCaption",
 CellID->12875781],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"Plot", ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->147913779],

Cell["Define the atomic system.", "MathCaption",
 CellID->451740640],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"system", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"{", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", 
      RowBox[{"J", "\[Rule]", "1"}], ",", 
      RowBox[{"L", "\[Rule]", "1"}], ",", 
      RowBox[{"S", "\[Rule]", "0"}], ",", 
      RowBox[{"Energy", "\[Rule]", "0"}], ",", 
      RowBox[{
       RowBox[{"Polarizability", "[", "0", "]"}], "\[Rule]", "0"}], ",", 
      RowBox[{
       RowBox[{"Polarizability", "[", "2", "]"}], "\[Rule]", "\[Alpha]2"}]}], 
     "]"}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->162218567],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "0", "]"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "2", "]"}], "\[Rule]", "\[Alpha]2"}], 
     ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "0", "]"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "2", "]"}], "\[Rule]", "\[Alpha]2"}], 
     ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "0", "]"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "2", "]"}], "\[Rule]", "\[Alpha]2"}], 
     ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{462, 84},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->72112849]
}, Open  ]],

Cell[TextData[{
 "The Hamiltonian for the system subject to the magnetic and electric fields. \
We must explicitly specify the ",
 Cell[BoxData[
  ButtonBox["Polarizability",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/Polarizability"]], 
  "InlineFormula"],
 " interaction, because it is not included by default."
}], "MathCaption",
 CellID->106825082],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", 
  RowBox[{"h", "=", 
   RowBox[{"Hamiltonian", "[", 
    RowBox[{"system", ",", 
     RowBox[{"ElectricField", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Ex", ",", "0", ",", "0"}], "}"}]}], ",", 
     RowBox[{"MagneticField", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", 
        RowBox[{"\[CapitalOmega]L", "/", "BohrMagneton"}]}], "}"}]}], ",", 
     RowBox[{"Interaction", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Internal", ",", "Magnetic", ",", "Polarizability"}], 
       "}"}]}]}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->247023563],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       FractionBox[
        RowBox[{
         SuperscriptBox["Ex", "2"], " ", "\[Alpha]2"}], "4"], "+", 
       "\[CapitalOmega]L"}], "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"3", " ", 
         SuperscriptBox["Ex", "2"], " ", "\[Alpha]2"}], "4"]}]},
     {"0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         SuperscriptBox["Ex", "2"], " ", "\[Alpha]2"}], "2"]}], "0"},
     {
      RowBox[{"-", 
       FractionBox[
        RowBox[{"3", " ", 
         SuperscriptBox["Ex", "2"], " ", "\[Alpha]2"}], "4"]}], "0", 
      RowBox[{
       FractionBox[
        RowBox[{
         SuperscriptBox["Ex", "2"], " ", "\[Alpha]2"}], "4"], "-", 
       "\[CapitalOmega]L"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{198, 81},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]//MatrixForm=",
 CellID->458718447]
}, Open  ]],

Cell["\<\
The eigenenergies and eigenstates of the system in the presence of the \
fields.\
\>", "MathCaption",
 CellID->185247108],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"energies", ",", "states"}], "}"}], "=", 
  RowBox[{"Eigensystem", "[", "h", "]"}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->500586757],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["Ex", "2"], " ", "\[Alpha]2"}], "2"]}], ",", 
     RowBox[{
      FractionBox["1", "4"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["Ex", "2"], " ", "\[Alpha]2"}], "-", 
        SqrtBox[
         RowBox[{
          RowBox[{"9", " ", 
           SuperscriptBox["Ex", "4"], " ", 
           SuperscriptBox["\[Alpha]2", "2"]}], "+", 
          RowBox[{"16", " ", 
           SuperscriptBox["\[CapitalOmega]L", "2"]}]}]]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", "4"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["Ex", "2"], " ", "\[Alpha]2"}], "+", 
        SqrtBox[
         RowBox[{
          RowBox[{"9", " ", 
           SuperscriptBox["Ex", "4"], " ", 
           SuperscriptBox["\[Alpha]2", "2"]}], "+", 
          RowBox[{"16", " ", 
           SuperscriptBox["\[CapitalOmega]L", "2"]}]}]]}], ")"}]}]}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"4", " ", "\[CapitalOmega]L"}], "-", 
          SqrtBox[
           RowBox[{
            RowBox[{"9", " ", 
             SuperscriptBox["Ex", "4"], " ", 
             SuperscriptBox["\[Alpha]2", "2"]}], "+", 
            RowBox[{"16", " ", 
             SuperscriptBox["\[CapitalOmega]L", "2"]}]}]]}], 
         RowBox[{"3", " ", 
          SuperscriptBox["Ex", "2"], " ", "\[Alpha]2"}]]}], ",", "0", ",", 
       "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"4", " ", "\[CapitalOmega]L"}], "+", 
          SqrtBox[
           RowBox[{
            RowBox[{"9", " ", 
             SuperscriptBox["Ex", "4"], " ", 
             SuperscriptBox["\[Alpha]2", "2"]}], "+", 
            RowBox[{"16", " ", 
             SuperscriptBox["\[CapitalOmega]L", "2"]}]}]]}], 
         RowBox[{"3", " ", 
          SuperscriptBox["Ex", "2"], " ", "\[Alpha]2"}]]}], ",", "0", ",", 
       "1"}], "}"}]}], "}"}]}], "}"}]], "Output",
 ImageSize->{548, 75},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->13105493]
}, Open  ]],

Cell["\<\
An energy plot as a function of electric field for fixed magnetic field.\
\>", "MathCaption",
 CellID->994177565],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{"energies", "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[CapitalOmega]L", "\[Rule]", "1"}], ",", 
       RowBox[{"\[Alpha]2", "\[Rule]", "1"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"Ex", ",", 
     RowBox[{"-", "2"}], ",", "2"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->46048850],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{180, 118},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->302990801]
}, Open  ]],

Cell["\<\
An energy plot as a function of magnetic field for fixed electric field.\
\>", "MathCaption",
 CellID->187075318],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{"energies", "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Ex", "\[Rule]", "1"}], ",", 
       RowBox[{"\[Alpha]2", "\[Rule]", "1"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[CapitalOmega]L", ",", 
     RowBox[{"-", "4"}], ",", "4"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->813397135],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{180, 117},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]=",
 CellID->24515884]
}, Open  ]],

Cell["\<\
A three-dimensional energy plot as a function of both the electric and \
magnetic fields.\
\>", "MathCaption",
 CellID->6363395],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot3D", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{"energies", "/.", 
     RowBox[{"{", 
      RowBox[{"\[Alpha]2", "\[Rule]", "1"}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"Ex", ",", 
     RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[CapitalOmega]L", ",", 
     RowBox[{"-", "4"}], ",", "4"}], "}"}], ",", 
   RowBox[{"Mesh", "\[Rule]", "False"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"#", ",", 
         RowBox[{"Specularity", "[", 
          RowBox[{"White", ",", "20"}], "]"}], ",", 
         RowBox[{"Opacity", "[", "0.7", "]"}]}], "}"}], "&"}], "/@", 
      RowBox[{"{", 
       RowBox[{"Yellow", ",", "Green", ",", "Blue"}], "}"}]}], "]"}]}], ",", 
   RowBox[{"BoxRatios", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->209556660],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{180, 216},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[8]=",
 CellID->588321159]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "TutorialMoreAboutSection",
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell["MORE ABOUT", "TutorialMoreAboutSection"], 
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "More About"}], "TutorialMoreAboutSection"]], 
    None}, {None, None}},
 CellFrameLabelMargins->0,
 "WholeCellGroupOpener" -> True,
 CellID->23220180],

Cell["", "SectionHeaderSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["AtomicDensityMatrix Package",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]], \
"TutorialMoreAbout",
 CellID->1567025153],

Cell["", "SectionFooterSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "RelatedTutorialsSection",
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell["RELATED TUTORIALS", "RelatedTutorialsSection"], 
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "Related Tutorials"}], "RelatedTutorialsSection"]], 
    None}, {None, None}},
 CellFrameLabelMargins->0,
 "WholeCellGroupOpener" -> True,
 CellID->415694126],

Cell["", "SectionHeaderSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["Stark Mixing",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/tutorial/StarkMixing"]], "RelatedTutorials",
 CellID->806871991],

Cell[TextData[ButtonBox["Hyperfine Structure: Breit-Rabi Diagram",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/tutorial/HyperfineStructureBreitRabiDiagram"]], \
"RelatedTutorials",
 CellID->693953278],

Cell["", "SectionFooterSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Crossed Electric and Magnetic Fields - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2013, 7, 19, 15, 4, 21.7792793}", "context" -> 
    "AtomicDensityMatrix`", "keywords" -> {"Atomic Density Matrix", "ADM"}, 
    "index" -> True, "label" -> "Atomic Density Matrix Tutorial", "language" -> 
    "en", "paclet" -> "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "The effects of Stark mixing on the sublevels of a single state can be \
accounted for to second order in the electric field by writing an effective \
Hamiltonian in terms of the polarizability of the atomic state. Here we \
analyze a J=1 state subject to crossed electric and magnetic fields. The \
state is assumed to have a tensor polarizability but no scalar \
polarizability. This loads the package. Set graphics options.", 
    "synonyms" -> {}, "title" -> "Crossed Electric and Magnetic Fields", 
    "type" -> "Tutorial", "uri" -> 
    "AtomicDensityMatrix/tutorial/CrossedElectricAndMagneticFields"}, 
  "SearchTextTranslated" -> "", "SearchText" -> ""},
FrontEndVersion->"6.0 for Microsoft Windows (64-bit) (May 21, 2008)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "6.0 for Microsoft Windows (64-bit) (May 21, 2008)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 78, 1, 3, "TutorialColorBar"],
Cell[649, 24, 220, 5, 70, "LinkTrail"],
Cell[872, 31, 9623, 199, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[10520, 234, 73, 1, 70, "Title",
 CellID->147735377],
Cell[10596, 237, 502, 11, 70, "Text",
 CellID->455402839],
Cell[11101, 250, 66, 1, 70, "MathCaption",
 CellID->159403208],
Cell[11170, 253, 106, 3, 70, "Input",
 CellID->75905070],
Cell[11279, 258, 63, 1, 70, "MathCaption",
 CellID->12875781],
Cell[11345, 261, 288, 8, 70, "Input",
 CellID->147913779],
Cell[11636, 271, 68, 1, 70, "MathCaption",
 CellID->451740640],
Cell[CellGroupData[{
Cell[11729, 276, 582, 16, 70, "Input",
 CellID->162218567],
Cell[12314, 294, 1606, 44, 70, "Output",
 CellID->72112849]
}, Open  ]],
Cell[13935, 341, 378, 10, 70, "MathCaption",
 CellID->106825082],
Cell[CellGroupData[{
Cell[14338, 355, 634, 17, 70, "Input",
 CellID->247023563],
Cell[14975, 374, 1421, 45, 70, "Output",
 CellID->458718447]
}, Open  ]],
Cell[16411, 422, 131, 4, 70, "MathCaption",
 CellID->185247108],
Cell[CellGroupData[{
Cell[16567, 430, 189, 6, 70, "Input",
 CellID->500586757],
Cell[16759, 438, 2411, 76, 70, "Output",
 CellID->13105493]
}, Open  ]],
Cell[19185, 517, 123, 3, 70, "MathCaption",
 CellID->994177565],
Cell[CellGroupData[{
Cell[19333, 524, 416, 13, 70, "Input",
 CellID->46048850],
Cell[19752, 539, 4320, 75, 70, "Output",
 Evaluatable->False,
 CellID->302990801]
}, Open  ]],
Cell[24087, 617, 123, 3, 70, "MathCaption",
 CellID->187075318],
Cell[CellGroupData[{
Cell[24235, 624, 417, 13, 70, "Input",
 CellID->813397135],
Cell[24655, 639, 3392, 60, 70, "Output",
 Evaluatable->False,
 CellID->24515884]
}, Open  ]],
Cell[28062, 702, 138, 4, 70, "MathCaption",
 CellID->6363395],
Cell[CellGroupData[{
Cell[28225, 710, 995, 29, 70, "Input",
 CellID->209556660],
Cell[29223, 741, 34206, 565, 70, "Output",
 Evaluatable->False,
 CellID->588321159]
}, Open  ]],
Cell[CellGroupData[{
Cell[63466, 1311, 747, 21, 70, "TutorialMoreAboutSection",
 CellID->23220180],
Cell[64216, 1334, 861, 21, 70, "SectionHeaderSpacer"],
Cell[65080, 1357, 192, 5, 70, "TutorialMoreAbout",
 CellID->1567025153],
Cell[65275, 1364, 861, 21, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[66173, 1390, 759, 21, 70, "RelatedTutorialsSection",
 CellID->415694126],
Cell[66935, 1413, 861, 21, 70, "SectionHeaderSpacer"],
Cell[67799, 1436, 168, 4, 70, "RelatedTutorials",
 CellID->806871991],
Cell[67970, 1442, 220, 5, 70, "RelatedTutorials",
 CellID->693953278],
Cell[68193, 1449, 861, 21, 70, "SectionFooterSpacer"]
}, Open  ]]
}, Open  ]],
Cell[69081, 1474, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

