(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    136906,       3187]
NotebookOptionsPosition[    129549,       2952]
NotebookOutlinePosition[    131876,       3007]
CellTagsIndexPosition[    131833,       3004]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "TutorialColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["AtomicDensityMatrix Package",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {
    StyleBox[
     GraphicsBox[RasterBox[CompressedData["
1:eJy9lulTk1cUxp+Zfu+Xfu5MO9O/oF90povj0A6dVtupdRsBqwRCg+DCqCxF
LLIIoUAIyGLayqJCFZRYVJaAaDBsQkBCEhaVoCjEBAiLTSLJ7bmX0nEBhZZ6
5mbmTebN/d3nnOec930/cN+mwLcAvEefD+jDr9nrwul0DvabbdaxuwNm++Ox
197/r8PQrY/bLwnyxYFvEL0F8TtwOiNq9IHFYDC4XK5VBGmvaXasg/QLRH6H
xABkBiFXhvw9fCVJP7LZbKsFemwdC1gP2ZdcjnwXCvag9BAuxOByHC4dQUU0
dBfzV4vV0aoL+4orOv49ckNRHo3qeDQehy4NzWnQpvCv/W2aRf+70vSeK8o/
+C0vkDIEZYdx5SfclKM9Az05MOai9wQ6FahLwJT9ObeQkaqrq3t7e1fESo+W
/LgV8t1QhfPU1Seh5WfczoY5D4Mn0V/AoSSwNkfidjnpfofDUVVVpVKpFArF
5OTkiliZMZJ4PyiCceYg/ohDUyq6stCXhzsqziIicXVyXriyVMnQoHnt2rV+
fn5paWkmk2lFIAptrfqYHzceJZBy1ZaObiUGCjirL5/nsDWdl+yXvfw8R3e8
EyYLIVBhYSEJfMW25F6HCKeI+R+npxzJOzmLEtiQhFuZvEzEouzps9CQzN1C
5s8IQroE4VvWJB2NLsqKP3U8vCI7ytypm0/syzExMaFWqxMTE2NjY0NDQ6VS
aVNTk8vpVMVLToZxq9cnclZvLsd1KDiFtFA1Y7aAtKfuflsRFXA+YSMdifzT
ks7PdjXV1/7IspS69vZ2uVyeLYKqbLFYGmursqUoO8RzRSwqUJcSJRGcsssH
gZ/zYULaC/fzapJVhn7F47MYPw/b77CVYlCFe83qpXDUFw0NDSUlJZRPo9FY
U1OTk5kWfzjsVOQ6qg7t1piMw5uw/VPs/gx7N/JhQiBy42gJZi/iaS3YdTAd
WBtYEzwaTJbj0a0lcez5TrxvGcpOOFCsiCOxOTEBcdu5HN7jm3k7kG2ou20X
4KqDpxXsNlgPmAmsD6xfXLdh5jK8Txev3cthHbHkhWLfRq6FRhY1OMmZ92db
BkbPYk4LZgS7BzYMZhHr/sIaBNPDZX6VtGeDJvDWT3iBwjZwM5yQ8ZLdSMGA
CvZyeBrE+Qn0QLCGwO6KixGwh+JHwg0vi3X6t/xtArTvayT4o/gAauLRmYVH
xXBWgmnAOsEMYunBugSXEnhHqBsRi9Cji4/NZ6MgK3Xrx7xAVB3qIz7b0/jQ
mD4PTzXYNbBWjrBW4mExZtXw1nNLcKhRyLEIgXThMC8ndTvXI3Yb0gNx+Sjv
rNHT+FMN1igo3VzIXD0myjB5DtMV8F5ZOECXcMggF2hvW+OcedUkoYcXGTvY
lzucZi+BqLlmKjB3FV6dOLlZ7Ebb3oRXAzeZrUak9IYwPN3QK264jYfmG0ql
UqfTud3uRVl1V9TkOrKcUoq6YzDlwVEBz3V42xfyc0eUhjbsAGsB04qlE/QO
oYv8b5Iw19+KZmdnl9JVVX7m0CZkSXmNqP2fXIS3UezQt+DqAZFDk/BGm8A1
i9Uivhqj2IiGzS2rrcI30OjGuUgYcmAthUcr0jK44K57mGp511r1ITdDI7xa
Pi68VKkWibs5io3pl0mZj+wjkuwf+AgdL8VcrUiLSfTmiOigHlSejLTb7XNP
HJ6pMc+4hdFkWPZweCGMHbriCJjzMX1B2NggCjQkerYLTlufv79/T0/PUuVe
UdDTpzLJl56Jzkui3D0LxuuVOMctPj4+MpksOTlZr9f/dxbFU5dztFtjPcPN
7CUnd0cxq34+URERESEhISkpKTMzM6vC+ic8bucLg3p4eDgoKIjel1YXtGjQ
e0JwcDA94N4Ai6KoqGh8fPzNsFbFgf9r/AWVRIUY
       "], {{0, 0}, {36, 32}}, {0, 255},
       ColorFunction->RGBColor],
      ImageSize->{36, 32},
      PlotRange->{{0, 36}, {0, 32}}],
     Deployed->True,
     StripOnInput->False], Cell[
    "ATOMIC DENSITY MATRIX TUTORIAL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix Package", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"AtomicDensityMatrix Package\"\>"}, 
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"More About \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix/tutorial/NMORInAnRFField", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> None, 
          StringReplace[
           "Copy Mathematica url", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  StringReplace[
                  "AtomicDensityMatrix/tutorial/NMORInAnRFField", 
                   "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], Delimiter, 
          StringReplace[
           "Copy web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  BoxData[
                   MakeBoxes[
                    Hyperlink[
                    StringReplace[
                    "http://reference.wolfram.com/mathematica/\
AtomicDensityMatrix/tutorial/NMORInAnRFField.html", 
                    "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]], StandardForm]], 
                  StringReplace[
                  "Input", "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"], TextClipboardType -> 
                  StringReplace[
                   "PlainText", "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], 
          StringReplace[
           "Go to web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> FrontEndExecute[{
             NotebookLocate[{
               URL[
                StringJoin[
                 StringReplace[
                 "http://reference.wolfram.com/mathematica/", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 "AtomicDensityMatrix/tutorial/NMORInAnRFField", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 ".html", "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"]]], None}]}]}, #, 2]& , 
        Evaluator -> Automatic], {
       1->"\<\"AtomicDensityMatrix/tutorial/NMORInAnRFField\"\>", 
       2->"\<\"Copy Mathematica url\"\>", Delimiter, 
       4->"\<\"Copy web url\"\>", 5->"\<\"Go to web url\"\>"}, 
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"URL \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxAlignment->{"Columns" -> {{Left, Left, Right}}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.05], 
     Scaled[0.3], {
      Scaled[0.64]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["NMOR in an RF Field", "Title",
 CellID->509267359],

Cell["\<\
In this example we study atoms subject to linearly polaried light, a static \
bias magnetic field and a transverse oscillating (rf) magnetic field. The \
atoms are initially polarized by the resonant light. If the Larmor frequency \
associated with the bias field and the oscillation frequency of the rf field \
satisfy a resonance condition, the atoms are put into a polarization state \
that precesses about the bias field direction. The atoms then induce \
oscillating polarization rotation in the light field, which can be detected \
with a lock-in amplifier.\
\>", "Text",
 CellID->1534169418],

Cell["Load the package.", "MathCaption",
 CellID->836781195],

Cell[BoxData[
 RowBox[{"<<", "AtomicDensityMatrix`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->2058623809],

Cell["We first make a diagram of the experimental geometry.", "Text",
 CellID->15600200],

Cell["Load a graphics package.", "MathCaption",
 CellID->210471022],

Cell[BoxData[
 RowBox[{"<<", "Graphics`Arrow3D`"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->399354204],

Cell["Set some graphics options.", "MathCaption",
 CellID->606009605],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"Axes3D", ",", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", "Gray", "}"}]}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{
      "Italic", ",", "\"\<Times New Roman\>\"", ",", "Black", ",", "18"}], 
      "]"}]}], ",", 
    RowBox[{"LabelPosition", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1.04", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1.08", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1.04", ",", "0", ",", "0"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"ArrowShape", "\[Rule]", 
     RowBox[{".8", 
      RowBox[{"{", 
       RowBox[{"0.1`", ",", "0.03`", ",", "0.01`"}], "}"}]}]}], ",", 
    RowBox[{"Width", "\[Rule]", 
     RowBox[{".8", " ", "0.01`"}]}], ",", 
    RowBox[{"RenderStyle", "\[Rule]", "Full"}], ",", 
    RowBox[{"Scale", "\[Rule]", "Automatic"}]}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"Arrow3D", ",", 
    RowBox[{"Scale", "\[Rule]", "2"}], ",", 
    RowBox[{"ArrowShape", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{".1", ",", ".03", ",", ".01"}], "}"}]}], ",", 
    RowBox[{"Width", "\[Rule]", "0.01"}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"Black", ",", "18"}], "]"}]}]}], "]"}], ";"}]}], "Input",
 CellLabel->"In[3]:=",
 CellID->287183751],

Cell["Draw the experimental diagram.", "MathCaption",
 CellID->435355331],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics3D", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Gray", ",", 
     RowBox[{"Axes3D", "[", 
      RowBox[{"1", ",", 
       RowBox[{"Scale", "\[Rule]", "1.25"}]}], "]"}], ",", "Red", ",", 
     RowBox[{"Arrow3D", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", ".8"}], ",", 
           RowBox[{"-", ".85"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", ".8"}], ",", ".85"}], "}"}]}], "}"}], ",", 
       RowBox[{"Arrowheads", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", 
       RowBox[{"Label", "\[Rule]", 
        SubscriptBox["\"\<\!\(\*
StyleBox[\"E\",
FontSlant->\"Italic\"]\)\>\"", "light"]}], ",", 
       RowBox[{"LabelPosition", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{".88", ",", "19", ",", 
          RowBox[{
           RowBox[{"-", "\[Pi]"}], "/", "2"}]}], "}"}]}]}], "]"}], ",", 
     RowBox[{"Rotate", "[", 
      RowBox[{
       RowBox[{"Arrow3D", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", ".8", ",", 
             RowBox[{"-", ".85"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", ".8", ",", ".85"}], "}"}]}], "}"}], ",", 
         RowBox[{"Arrowheads", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "}"}]}]}], "]"}], ",", ".2", ",", 
       
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Arrow3D", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", "1.01"}], ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1.01", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"Scale", "\[Rule]", "2"}], ",", 
       RowBox[{"Arrowheads", "\[Rule]", 
        RowBox[{"{", "1", "}"}]}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"ColorData", "[", 
       RowBox[{"35", ",", "\"\<ColorList\>\""}], "]"}], "[", 
      RowBox[{"[", "6", "]"}], "]"}], ",", 
     RowBox[{"Arrow3D", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", ".8"}], ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{".8", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"Label", "\[Rule]", 
        SubscriptBox["B", "rf"]}], ",", 
       RowBox[{"LabelPosition", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{".88", ",", "10", ",", "0"}], "}"}]}], ",", 
       RowBox[{"Arrowheads", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1"}], "}"}]}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"ColorData", "[", 
       RowBox[{"1", ",", "\"\<ColorList\>\""}], "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", 
     RowBox[{"Arrow3D", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", ".85"}], "}"}]}], "}"}], ",", 
       RowBox[{"Label", "\[Rule]", 
        SubscriptBox["B", "0"]}], ",", 
       RowBox[{"LabelPosition", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{".88", ",", "9", ",", "0"}], "}"}]}]}], "]"}], ",", "Black", 
     ",", 
     RowBox[{"Translate", "[", 
      RowBox[{
       RowBox[{"Rotate", "[", 
        RowBox[{
         RowBox[{"Circle3D", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", ".85", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"-", ".1"}], " ", "\[Pi]"}], "+", 
              RowBox[{"\[Pi]", "/", "2"}]}], ",", 
             RowBox[{
              RowBox[{".1", " ", "\[Pi]"}], "+", 
              RowBox[{"\[Pi]", "/", "2"}]}]}], "}"}], ",", 
           RowBox[{"Arrowheads", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "1"}], "}"}]}]}], "]"}], ",", 
         RowBox[{"\[Pi]", "/", "2"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "0"}], "}"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", ".8", ",", "0"}], "}"}]}], "]"}]}], 
    "\[IndentingNewLine]", "}"}], ",", 
   RowBox[{"Boxed", "\[Rule]", "False"}], ",", 
   RowBox[{"Lighting", "\[Rule]", "\"\<Neutral\>\""}], ",", 
   RowBox[{"ImageSize", "\[Rule]", 
    RowBox[{"4", " ", "72"}]}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->162359029],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{288, 315},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->138947816]
}, Open  ]],

Cell["\<\
We now generate the evolution equations for the system. Under the \
approximations that we will employ, all explicit time dependence can be \
removed from the equations. \
\>", "Text",
 CellID->612747630],

Cell["\<\
Remove explicit time dependence from the density matrix variables.\
\>", "MathCaption",
 CellID->108772237],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"DensityMatrix", ",", 
    RowBox[{"TimeDependence", "\[Rule]", "False"}], ",", 
    RowBox[{"ComplexExpandVariables", "\[Rule]", "Subscript"}]}], "]"}], 
  ";"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->19801112],

Cell["Generate a 1\[Rule]0 atomic system.", "MathCaption",
 CellID->627164436],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", 
       RowBox[{"J", "\[Rule]", "1"}], ",", 
       RowBox[{"L", "\[Rule]", "1"}], ",", 
       RowBox[{"S", "\[Rule]", "0"}], ",", 
       RowBox[{"Energy", "\[Rule]", "0"}], ",", 
       RowBox[{"NaturalWidth", "\[Rule]", "0"}]}], "]"}], ",", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"2", ",", 
       RowBox[{"J", "\[Rule]", "0"}], ",", 
       RowBox[{"L", "\[Rule]", "0"}], ",", 
       RowBox[{"S", "\[Rule]", "0"}], ",", 
       RowBox[{"Energy", "\[Rule]", "\[Omega]0"}], ",", 
       RowBox[{"NaturalWidth", "\[Rule]", "\[CapitalGamma]"}], ",", 
       RowBox[{
        RowBox[{"BranchingRatio", "[", "1", "]"}], "\[Rule]", "1"}]}], 
      "]"}]}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[6]:=",
 CellID->4674794],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", "0"}], ",", 
     RowBox[{"L", "\[Rule]", "0"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "\[Omega]0"}], ",", 
     RowBox[{"NaturalWidth", "\[Rule]", "\[CapitalGamma]"}], ",", 
     RowBox[{
      RowBox[{"BranchingRatio", "[", "1", "]"}], "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{585, 67},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->40279893]
}, Open  ]],

Cell[TextData[{
 "Set the default optical field to propagate along ",
 Cell[BoxData[
  FormBox["z", TraditionalForm]], "InlineMath"],
 " and be polarized along ",
 Cell[BoxData[
  FormBox["y", TraditionalForm]], "InlineMath"],
 ". This setting also determines the default field for the ",
 Cell[BoxData[
  ButtonBox["Observables",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/Observables"]], 
  "InlineFormula"],
 " function."
}], "MathCaption",
 CellID->531992379],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"OpticalField", ",", 
    RowBox[{"PropagationVector", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], ",", 
    RowBox[{"PolarizationVector", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1"}], "}"}]}]}], "]"}], ";"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->313420400],

Cell["\<\
Generate the Hamiltonian for a z-polarized light field, a z-directed static \
magnetic field, and a y-directed oscillating field.\
\>", "MathCaption",
 CellID->201724876],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"h", "=", 
    RowBox[{"Hamiltonian", "[", 
     RowBox[{"sys", ",", 
      RowBox[{"MagneticField", "\[Rule]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"\[CapitalOmega]rf", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"\[Omega]rf", " ", "t"}], "]"}]}], ",", "0", ",", 
          "\[CapitalOmega]L"}], "}"}], "/", "BohrMagneton"}]}], ",", 
      RowBox[{"ElectricField", "\[Rule]", 
       RowBox[{"OpticalField", "[", 
        RowBox[{"\[Omega]", ",", 
         RowBox[{"\[CapitalOmega]R", "/", 
          RowBox[{"ReducedME", "[", 
           RowBox[{"1", ",", 
            RowBox[{"{", 
             RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}]}], 
        "]"}]}]}], "]"}]}], ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->262558261],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"\[CapitalOmega]L", 
      FractionBox[
       RowBox[{"\[CapitalOmega]rf", " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", "\[Omega]rf"}], "]"}]}], 
       SqrtBox["2"]], "0", "0"},
     {
      FractionBox[
       RowBox[{"\[CapitalOmega]rf", " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", "\[Omega]rf"}], "]"}]}], 
       SqrtBox["2"]], "0", 
      FractionBox[
       RowBox[{"\[CapitalOmega]rf", " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", "\[Omega]rf"}], "]"}]}], 
       SqrtBox["2"]], 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[CapitalOmega]R", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
        SqrtBox["3"]]}]},
     {"0", 
      FractionBox[
       RowBox[{"\[CapitalOmega]rf", " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", "\[Omega]rf"}], "]"}]}], 
       SqrtBox["2"]], 
      RowBox[{"-", "\[CapitalOmega]L"}], "0"},
     {"0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[CapitalOmega]R", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
        SqrtBox["3"]]}], "0", "\[Omega]0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{316, 125},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[8]//MatrixForm=",
 CellID->709394457]
}, Open  ]],

Cell["\<\
Apply the rotating-wave approximation for the optical field. (This is almost \
always an excellent approximation.)\
\>", "MathCaption",
 CellID->46602588],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"hrwa", "=", 
    RowBox[{
     RowBox[{"RotatingWaveApproximation", "[", 
      RowBox[{"sys", ",", "h", ",", "\[Omega]"}], "]"}], "/.", 
     RowBox[{"\[Omega]", "\[Rule]", 
      RowBox[{"\[Omega]0", "+", "\[CapitalDelta]"}]}]}]}], ")"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[9]:=",
 CellID->367378843],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"\[CapitalOmega]L", 
      RowBox[{
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]rf"}]], 
         " ", "\[CapitalOmega]rf"}], 
        RowBox[{"2", " ", 
         SqrtBox["2"]}]], "+", 
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]rf"}]], " ", 
         "\[CapitalOmega]rf"}], 
        RowBox[{"2", " ", 
         SqrtBox["2"]}]]}], "0", "0"},
     {
      RowBox[{
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]rf"}]], 
         " ", "\[CapitalOmega]rf"}], 
        RowBox[{"2", " ", 
         SqrtBox["2"]}]], "+", 
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]rf"}]], " ", 
         "\[CapitalOmega]rf"}], 
        RowBox[{"2", " ", 
         SqrtBox["2"]}]]}], "0", 
      RowBox[{
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]rf"}]], 
         " ", "\[CapitalOmega]rf"}], 
        RowBox[{"2", " ", 
         SqrtBox["2"]}]], "+", 
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]rf"}]], " ", 
         "\[CapitalOmega]rf"}], 
        RowBox[{"2", " ", 
         SqrtBox["2"]}]]}], 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"2", " ", 
         SqrtBox["3"]}]]}]},
     {"0", 
      RowBox[{
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]rf"}]], 
         " ", "\[CapitalOmega]rf"}], 
        RowBox[{"2", " ", 
         SqrtBox["2"]}]], "+", 
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]rf"}]], " ", 
         "\[CapitalOmega]rf"}], 
        RowBox[{"2", " ", 
         SqrtBox["2"]}]]}], 
      RowBox[{"-", "\[CapitalOmega]L"}], "0"},
     {"0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"2", " ", 
         SqrtBox["3"]}]]}], "0", 
      RowBox[{"-", "\[CapitalDelta]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{474, 137},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[9]//MatrixForm=",
 CellID->151833558]
}, Open  ]],

Cell["Energy-level diagram for the system.", "MathCaption",
 CellID->279260831],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LevelDiagram", "[", 
  RowBox[{"sys", ",", 
   RowBox[{"hrwa", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\[Omega]0", "\[Rule]", "1"}], ",", 
      RowBox[{"\[CapitalOmega]L", "\[Rule]", ".1"}], ",", 
      RowBox[{"\[CapitalDelta]", "\[Rule]", 
       RowBox[{"-", "1"}]}]}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[10]:=",
 CellID->240274671],

Cell[GraphicsData["CompressedBitmap", "\<\
eJztlj9oU1EUxm9N8owWamqtpho1Nf6J1aEELaEtbRRtgyAEKlJxSShCSimm
f4YOhQoOWcQUETo6ZilkKh2rqBQH6SQZMzgUXLIIxSnmd857eUnN6tZCcvPu
Off7zvnOuef1cWY5+2I+szw7kwlPLmZy2dmZpfDEy8X6lqfDGLNe/0yGDb9r
9Z/217qp1WoYm5fbLFZiZ2fHeKLlcll2+TxX+w1ZfMH9/f30h/pfOp3eDwaD
gmjtJBIJ4ytHo1GeecqvrKwM7u3tmWd6/Jos1nSxWCylUimOAgEUkCfUDP1K
Pp/fGxwcBI3fgWq1+lRBrmgM/oODg1yhUKiEw+Hi9PR0qlQqmYDaCB1ubK/W
1tbwNU/0+CVZjsMXrlQqPGU3NjZwLeRyOdk7Iz5eSDlOEMnt7e0pRbioYQK6
G4/HX6+uruKxkc1mQQ3qYYC2k8kkCQJ0QbY9nCJBcjY+0I0HbNEcj1vNJF4y
Q81fvb29j7a2tkKKwmm4pUbnXNnIANkO/H4/BYBcSSxi4QgmxCdp4ooqnwJb
qFaze4QP/IRs88IHiETbo0dIFF4UhJOiUPSTrkzUBnkoOIiYryuvyuKjJeAj
eAAQ0lxWG1ESvUhW30Eu06U2yEkScs5J+QJuh4ALJhmL7arSet1q0F4iUY9W
483S0tLH8fHx93Nzc+aU7hFC4y50u/BQv5ufnycxaTK7heO7u7toRRqONoR/
VmnRw+lsE9GIfG5l4RTeiLKTWIP9tCsKyH8sy0I48fG7ojhSQyO2Pm0ooqTI
Tvf0K/s9PQl7NRAIgNjIyXLzRUpsvzs7O6c2NzfttvGQL4hyCcMKeV8JkQCZ
OEY6imZREKfJYCKXpkYjPVxEIe0D80BNlB89pUW0jl4yIm6I6M1+d5st55Ir
uLnjFp++krnVJd/+z6Ojo99jsRhPn8bGxli/Dg8P/xgYGOBZ3TwcE20A0nvg
RbsvIyMjXDBi0842d5WMlicyuTkBnbBvFxYWDu/JuDxUa9BQ19ELreyLY5IK
j4SNJtWr5QPKOeYEZc7rsUm3bpilbjd1D8lxF5ZWd+rXCGDAHQmIIuh9Le5s
O5fajtdD5Zw8TES+PVSuEfwxhZhw27x5HonbwxYXAnDGB6vMxIct6ugbzxb1
yHRkOjL9d1PTBWZSOi7yEv7XhRHwMxQKMcdkENouOkm8zWMMtBZrYywxlW1Q
xwRW4/XYagIHPJm4Ey35OO+M5nzavTS69W3wbWhoiF/yFGjzhogpRLtXQaTN
2Lfd2/6Hbi+m4y9iuqNf\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{144, 71},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[10]=",
 CellID->325743924]
}, Open  ]],

Cell["\<\
We will assume that the rf amplitude is low enough that the rotating-wave \
approximation can be applied to the rf field. This will allow analytic \
solutions to be obtained, while retaining a number of interesting effects.\
\>", "Text",
 CellID->419861567],

Cell["\<\
Unitary matrix for transformation into the frame rotating with the rf field.\
\>", "MathCaption",
 CellID->232477107],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"tm", "=", 
    RowBox[{"MatrixExp", "[", 
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", 
      RowBox[{"DiagonalMatrix", "[", 
       RowBox[{"{", 
        RowBox[{"\[Omega]rf", ",", "0", ",", 
         RowBox[{"-", "\[Omega]rf"}], ",", "0"}], "}"}], "]"}]}], "]"}]}], 
   ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[11]:=",
 CellID->530451512],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]rf"}]], "0", 
      "0", "0"},
     {"0", "1", "0", "0"},
     {"0", "0", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]rf"}]], "0"},
     {"0", "0", "0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{141, 65},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[11]//MatrixForm=",
 CellID->776459134]
}, Open  ]],

Cell["\<\
The Hamiltonian in the rotating frame, with far-off-resonant terms neglected. \
The Hamiltonian is now time-independent.\
\>", "MathCaption",
 CellID->250696079],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"hrwa1", "=", 
    RowBox[{
     RowBox[{"RotatingWaveApproximation", "[", 
      RowBox[{"sys", ",", "hrwa", ",", "\[Omega]rf", ",", 
       RowBox[{"TransformMatrix", "\[Rule]", "tm"}]}], "]"}], "/.", 
     RowBox[{"\[Omega]rf", "\[Rule]", 
      RowBox[{"\[CapitalOmega]L", "+", "\[CapitalDelta]rf"}]}]}]}], ")"}], "//",
   "MatrixForm"}]], "Input",
 CellLabel->"In[12]:=",
 CellID->872908440],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"-", "\[CapitalDelta]rf"}], 
      FractionBox["\[CapitalOmega]rf", 
       RowBox[{"2", " ", 
        SqrtBox["2"]}]], "0", "0"},
     {
      FractionBox["\[CapitalOmega]rf", 
       RowBox[{"2", " ", 
        SqrtBox["2"]}]], "0", 
      FractionBox["\[CapitalOmega]rf", 
       RowBox[{"2", " ", 
        SqrtBox["2"]}]], 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"2", " ", 
         SqrtBox["3"]}]]}]},
     {"0", 
      FractionBox["\[CapitalOmega]rf", 
       RowBox[{"2", " ", 
        SqrtBox["2"]}]], "\[CapitalDelta]rf", "0"},
     {"0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"2", " ", 
         SqrtBox["3"]}]]}], "0", 
      RowBox[{"-", "\[CapitalDelta]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{188, 121},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[12]//MatrixForm=",
 CellID->220658746]
}, Open  ]],

Cell["\<\
Matrix describing relaxation (spontaneous and transit) in the system.\
\>", "MathCaption",
 CellID->26724115],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"rel", "=", 
    RowBox[{
     RowBox[{"IntrinsicRelaxation", "[", "sys", "]"}], "+", 
     RowBox[{"TransitRelaxation", "[", 
      RowBox[{"sys", ",", "\[Gamma]t"}], "]"}]}]}], ")"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[13]:=",
 CellID->431704731],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"\[Gamma]t", "0", "0", "0"},
     {"0", "\[Gamma]t", "0", "0"},
     {"0", "0", "\[Gamma]t", "0"},
     {"0", "0", "0", 
      RowBox[{"\[CapitalGamma]", "+", "\[Gamma]t"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{124, 57},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[13]//MatrixForm=",
 CellID->73950923]
}, Open  ]],

Cell["\<\
Matrix describing repopulation due to atomic motion and spontaneous decay.\
\>", "MathCaption",
 CellID->403563780],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"rep", "=", 
    RowBox[{
     RowBox[{"TransitRepopulation", "[", 
      RowBox[{"sys", ",", "\[Gamma]t"}], "]"}], "+", 
     RowBox[{"OpticalRepopulation", "[", "sys", "]"}]}]}], ")"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[14]:=",
 CellID->661359577],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       FractionBox["\[Gamma]t", "3"], "+", 
       RowBox[{
        FractionBox["1", "3"], " ", "\[CapitalGamma]", " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "0"}], "}"}]}]]}]}], "0", "0", "0"},
     {"0", 
      RowBox[{
       FractionBox["\[Gamma]t", "3"], "+", 
       RowBox[{
        FractionBox["1", "3"], " ", "\[CapitalGamma]", " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "0"}], "}"}]}]]}]}], "0", "0"},
     {"0", "0", 
      RowBox[{
       FractionBox["\[Gamma]t", "3"], "+", 
       RowBox[{
        FractionBox["1", "3"], " ", "\[CapitalGamma]", " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "0"}], "}"}]}]]}]}], "0"},
     {"0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{439, 85},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[14]//MatrixForm=",
 CellID->69128610]
}, Open  ]],

Cell["\<\
The evolution equations for the rotating frame. For simplicity, we assume \
that the light field is on resonance.\
\>", "MathCaption",
 CellID->44892595],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"eqs", "=", 
    RowBox[{
     RowBox[{"LiouvilleEquation", "[", 
      RowBox[{"sys", ",", "hrwa1", ",", "rel", ",", "rep"}], "]"}], "/.", 
     RowBox[{"\[CapitalDelta]", "\[Rule]", "0"}]}]}], ")"}], "//", 
  "TableForm"}]], "Input",
 CellLabel->"In[15]:=",
 CellID->135215867],

Cell[GraphicsData["CompressedBitmap", "\<\
eJztXQuQHkdxXu7XnWRZEOkkUQZjZCQ/ZIPNw4aYA0uy5TchvCydJEs6y8Kn
s54OMX4AthweMZiADyqEhEB4OMFJJYEEkktISExCHpWqREC5HEgOS5RDTFUq
MVQlKRIqyeX+eW33/j27szu9s7N7d2Wv7mZ3e3p6emZ3e75v+rX77pi69ci+
O27bv+/sa9+y7/ap2/b/9NnXHHvLfFHvGUky9JX5/y86O+n/Ppck+jA3/588
/Hn/kCTXiX96Z3zve99L1JkkveguedG18qKXfO1rX7v7gQceyFx0N7ro5k9+
8pNTH/3oR+mLrun/M9QXlPTSq6g6xZXJktsfeuih/m9bHn300Y3f/OY3h2Vx
MjOZqJ/JZGYOtOuYvP1q8c9wv12v//znP9//a+X3v//9HY888sj83eJcMtcX
Mjkj/pK/Qj2UoKtks/pCTNuH0qaaBvTMcSYRuvUFG2G3I62W/fCHP0xbPjcn
BC1VAmYmx5Lp2axVjkoB18uLRDO0gCHdnNnpZEyaIxWSbc71aVf2zYlV10Yd
mx5UXd3YV10bFFx0p7zoBkK9PUr67PSYkDw7/9ePmXpnE1k8m5zmeN0rmeVB
96T0H1f3TI9J00KLzUxLuf2/RojrlsL6pmeg87DJe1nk+sFBfUM6mIx9rzb9
NJ2pb1k6mBLVV8bFRfmQOLFEDlw1iOcvW6LnCKDtvBf01NVCUHq1aVtakbEB
ZRd1G9CTu6ZV0HPVgF6xaKViv+rPaA/dfvvt9x8/fjxZJo69/qxvfG3MzHTT
Zo5doj13vkKpSt9qcvrUrVhC9EhPjQLYKjD5y9PPRLeIS/qdox46s9OT6VTf
b9qkFDUUtjrtb0L0fJP7jrJi0VJEddDn1AQoB5v+EcZ4pzgxrGpA7ynJsB6z
87dNz6TjVj+hhMiZSTlme2hs9DJlaZfI9uvxjQZQ/1Fuqh0GXTdn7jGDC5wb
qUnuSuhW4n/dBvhKB+anBWsp+FqlKkFeOW+VSW2kkUS/0KQ2mun/nTVO//87
jIrzl6BGrFLDJDMmtL2BcukzH/SLus+8x4Lhl75hzhjZpn8Jg5hxNz1zGq+4
Udj6MXlaTxi6tXDCmD/fWzDGga/Cyifg251o0Nh0asLU56SjDeMJVX61JePi
07P36JYtW4wT9qwyekhG+uDPOiv12rE0fVyh/pCPqBXKCOi5ACZ9dQ+cobU3
oG8yaHouaSOO9hgGs41un7ERqL2LNkLe2UPeSX2zDPFMjUvVcWYSeTZ6LJme
0u2a//903fZJ/MjKBC5GlHjzrmBEKK3n/z6NT9Song7k40M/UigX6lbDSzrP
q8E44wgyoMcO8qwR/NRPXX+b+OM0GZUxjZ81QxUOpmX5osQfX04K5vXLCDvE
FEhYZa5ObZg65JyODMK37nlb3JidWefNhZ8+87XOm20J4cpLaJHi5J8gc4or
8Kz2IvHHszIfCPNXTau/5/tUyJ3vT6lX6tzm9Xd4cO5MrF/08X2jW7tMfmVO
EtOOuOBvpHGHtFJ4vF+spgXoMPptRpRJcfZvQ+x/Q0pVPCTm2vA9uhJVJ3/S
1wYqjiyjhclFhB2WWMza73sx6cwIhZaCOrMfPPDWqD6kxEGGsJMXiH9WKq8y
YbL5CiaTHekoR/F0Wcn8M1N7ou43YC44ztWYnr9smdXjKHM18sYvDq+Bxlme
pB87aYyHiPsMgc7QorOdAVv5TDW7U2+E+roRrXrwl8tBQ4wMfHQL8TrscDp6
2oKHkRnk08aR0pGZ9oF+W1pqecWBH41hX5Uon8ATmJrlBz98jU/AwJl630xl
T2PZRGyD+kDRjymzVJVd/kNiMy//wiwgJI4f9qmMX5Ay0oI/Zy74nBwZaNH1
EFH2GXDPb8vzaA32EFH28OA9aEn2EFEG7/mt/oFaob3NdgJq+bDqexz6hKFh
1xXd8RxJw7SkXs4tvzygJF6qVU+V0uvF44SskRxZ1DLxJ4Buv6bOwyeemkgr
LUHvIuT1SsqD90I7flZfBZ47avA7r3DvJGT0cmSMENd/TOq0Pqf7xYXv0P04
+JTQujkvrI/nyJKP/NOQrLk58umk7bme6Dpx03F6dCxNR37uMv5O+vZlxO2W
l22l4DmELwgF3ytPIFzAIaLs01LOuUT/na/K4Ef0GtMkHoSAj7wtzPI2E752
iCj7FPZryn2031T5xl4BVYsQnBBCv1dGrt+mcq6ygR7D2gkheEA+1EKGJ2T7
lg3WiD9J4FOn3ugE/nq24ywWTQWmaF74SbutokYngjMdIsrU6HyFFgEwFfpj
lzWWtbw4lgX7Zhh9xWbD4hGEt4qAKYtGzDHi+YTB/JA8XbaWGtKFSLKbHa/7
iBz6drDQeWoetIOFRmwQmIEI5JxXwHYFURYyUGtelV2xQQvFMM9CQ0D+aIiT
+FBUXpV9mqkhYS410BZdTRBwVUyWFJJeh4YkD6jqDKNiFqeyNMnDDel+YFpE
WKEqzs7F9SwerIKNLoOl6rBNVkKbIIDOCHoCy9EkngAQ06OlybL6MGfNG0r8
8QY0FBmwZsMSayZ+n8sq6YQhG+wmpdazlOvmLV2dri2Ay6lvh2XqGBY/Bifq
avixbttHLyFQS13pA2gs8yJNjV3Kdi7Yu0gNOOxoQGWQ/gDsD0UxHHcSANAh
Znk/rWaSHppJmHCB1NNdByNoeJx5alVd810Br0ETXS1rvquAXznhArvV8GG8
bq9+dx3wI0blKkjJqMyBnsrFY8ms5rjDGuWCJAus8SYz3aaz3uy8vWfnwEQu
kT1o0oUhBdyH1qreAW7JW9qhloCopaIxD3nUdYWg/ecBP8/GTk3bSwErd2bU
YABWaqqwfEpKZYa0v5g3W/X9njq2ajP9pWup6i7Cm30WanwWfqiFpEsi0o+S
h0lwBPz1+YQgq6PJ2O4hXQ942twG6p6ZnAYvQXj83qnmwGCLEa5rBHawbR1r
HxvbZwbuRRnlmRY4A+WW8ANc/1AoWg2zmJlJZ7Lllnm1r/xb9ehhi7LXDVIO
Gtnf2Drz1LLioPxVA2xQC/rHA9bmjgAYZAKHi0+IlhO2XSX0u769zfWJTCum
73qtPP6+F/XsFufO9MWtSxMxxw490OsVQpGr9WgcsMR08uXpMf2oMnM3/CId
RV+kHrYJYBqP8Kr6INgAXVP7ROpMJXH+y0mcPxHLcglllYL5s0XFRnWtVLvT
RhnLgwm817ANuEJ5yjVE2TvVSMplOSxHM6u+BLMcPm6D1fMSHPyDJauVkcgW
qx6dl293gJHmWs8S4hnsfhZmx241cdtEiel5DKgFJ+VlGQ8bEP9lQmk/yshu
1RZKilktAJ2/hBYzqFgp0skt0KLoFj05LEnQs2dy5qugRnFgZKc8KhteSEwR
xw/Je/5Uni8kpoh7PozuKSSmwHsE4bYUMQVq+UXT3c50kkHsiejxnTmSLBSX
JTm3CCXfB5XsJeDLwoFMQhNTdhKyikku+Hqh2/ulbr+vzsOXXDVJFhJJhgjZ
uwl5rkSXJcS90I5mui5JKoEPy5sIGS7kFni9OL4XO2BpwkiGeLIzR04hiSVz
/Y8X+eVrpe6/R48EO4ukh0goN9G32zksA5f+uM05FZbnK/J8IQlFMzkGHEc1
VG1yyc0cKYTvbzFWS53nPGZdLmOWd6802VZ1KlYGxWbHLrg8Z5y8IPI2vjRy
/eTqWfIS41mL3IpBDy1kEWyi50aK3NPTbVyw1AxXbs+ipTKDc5FXofuwIG6v
hi0bU+AaogMWeRq+1KBFC9osqMa9nZkyivSRPyy0g4XC29DbCcLOO65k2Ok+
C46UUZr3s+As9HY0VHkYKylUi4Go0GFCx52EuPsJ29W9hXLzlqhM9+myUe5F
Q5MAXq5Ww6QeRkE72Rg+ZIJdzGQCbnk9bwZSi1ki4WhILTaSnjJ6aMpgoqqY
vcq8+QxdYXi4PsD99ruOqsml2TydaLX7uDKkn/qJI/eBW/JWU1yJI8sJb77Y
ow7qunXW0WFtplyVZGH1/JXqRusblTFL/SyRewjn8VkI4WaJXBqRfpQ8/fLL
xzrakfFXBtbRXyOHI6gscBzmcVAksqpdO77XsXZxQQvtwL2qspYYIQX0p4Na
DHg8PyZ900Jm0ZW4ElLuVv3Hup7TKU7KhW20UC3LA5QDuxKlxFF+Tie/Qpgl
4kwDXJSViJvoE4leQ+gmjgpAJbGaHcqtEJidsjSXnRKPWTwipmv0xQTF6Seh
F7UnCUU87JQOZOIwLzVZyhJyjpYl5oiAt7K0YRPw7U8yiWcJBvLKHjWv10Ne
ESd+EyvtR17Zo9riSV4ZVKwUeWU/tKgbeUXc+AVZo/hdHBgZLOJ3hWVDlJWD
RNkUUXaAKPsJIPvF8jyithwkyqaIsgNE2WsHZSMKzEGibIooO0CUQdkiSEix
ZKZsJyZtJ261nYB2Ose4qDPhppdzS4V0MBb+zjZexfLElct4c9WA9XoJ+Jgr
nVaGYgBVZRNtY9CHSpVTNe0OtJUmSsDvGlV/pRQ3Oz3kUUynHcz6jRNlrswp
ql+uBrZMNwuvno6nakof+C44zqAHJcOFwQX12Cptsz5nkP+PdtOyxK7MtZUz
CmUIYtuY9MmTUzZb0lXQjNj75M0+GYp2lJXQQ+y0cW8FttPFrjma1PizZlhS
S36IyHaQKJsiyg4QZSqrn2smJp+VRCoTk4+8rYTfHSTKpoiyA0TZDXh4U66u
fTbWJTafDEsh9Luyni7bQI+5ODIdxbccFW+qo/hspTwWce8OEmVTRNkBokx5
7Ct0VXUTrFq53NRoqp9WWky5aSGvbMLxuj2O1+12vG6zdPs2ZL6JZXUt2gw4
sRhISHo9MY7vQ87WqZwuzazStSO3SzO2EX+8sdALCehiy9KZNLL+15JUJm2w
DSKm7GUmutwYIKtHz1Fez1G/dWqA9tAAZaJeNJAlJPDqazxZQppYds6b8Ysd
qkKqDBmBZQHVUzQEn82fXu54nas87nwYGp4N+4o7uHmO6vuAOTduzM6H/uh3
H4pDiL2jLmaWx61f7Ik6YrffBjSKCPZFhUQik7oe8ECSfr6QN3paH9oC/qHd
Wqo7P7Qd9EdvpzyBW6dw8X0141gWc30SxDypZ7lBjLJp18LcbGoDu2WaoB3x
1Mmf92Zprl49yzWtdYdaVGrEAmTWn3+x9nMtGXCa3tzqrLDNrYssVlYuRRqr
sdlLibKO9bKPenU1W/ayLa3TP+r5pQJTLHgeo7D7akm6y4JIduUorlVJr3Rk
c2E5i0cTmC2iYpMb4BSmFP9HLSGKDFiN7cK1WrelCwnQHEWtTmLqekMR62LX
c+nKu36spgVR9gx1SzyJ0ALvF6YfqN3IfeciJ97cdx3rchZlGds9OO7r4jrr
vKIMpOzxWhUd51N0asC63sxsbUY/mvg4jzLjLMpQVirBHN+vJyB3fvqe8rXs
LV/LUdAucWBks6t8ZIiMfpQoS2+ULwLJdfIixDQ/SpSlN46gGxGN/ChRNnDj
tf1/KFL4YduJAaU3GXd1plLnZVbclXOuAtFbaPq/UNNeAoLBpZMr7ibKylKq
UxMmZG47V1owlVCRStDYc5RHhc6g/a7QV3kkV9xNlPVyZFAUYXH8H+x9lfiu
met35Zwrw8G9rMgfZeJDxbXwybB4E11cggV7mRGf8U81l0kaFKaiHiXKrDka
VVtfQ/TFUaLMNaeiDwSMyqnoI+9H5ZpYV87CELgfn5yFIfT7b9QViNB3lCiL
OTlffBCMaLPzxWcq7IeFrLv9jtddY2bHOnOltZJY2VxquVaaSzmoned5H9He
42po2rmfwZN8xbJkHH86tFgs9V/I83hIn8cIZ40l3VfLmKALwTg/Qi5IcEAU
yQYx0yYWU1jNRUmvdM1LBvHAunHlqKctNZB29x5ydyb+pOvUW2fKotgJlZ1o
tbsXUbRAH9pipNmTJK2Phegp/ticFDyV9F5EsZL+Fl5eozdlPImB2SlObkGu
QNDrZMaTkDt+RUeM2xjcBNExwiqkK7pVi4FvE/2j2gXaskzwItV01g28ukKT
qiX9UOvYQd6ph74oPfCFhEmY8/I0TZ6hWCTMTWyaOWJNOaTWA5+rHbECLj5o
up0mCBQtMEtYqkBe9qE/gw4VTRKehhHy0dihMbi4NSFRxl8iy8zTCJo6OisE
BhiLG/8B+kVd+NUAKYvEYR1sjDeUlDNxEaVeCajnm8vfklYrgUQ1pjC6SBqj
MF2ROJ4PbpTfV8W5iMTFGwdvLEw0NHCjeM0ulUBoQOn1xi1YkJ835pwrlyxI
aHf2gKYY5VYW+bmdKKuamGdAQSqNhA8MdDtR1nOUN0Q0VJx5AVCYykNRFgu6
nSjr5cigUs7A6STPH3+ke4MBJ3pjzrkyOV+gF1Ae+r+0d5fAh26ji12TrMBe
tyY6UeoUJjWBM3Abs5hsIbwkJ/0FW70PYuemnE47T6yB99iznWx27Np9kbfj
fdJVNtCjPo4sK9EF0eNNshKdqdQ4Kcyn8jrCfDr+tHD371OjU6/i1p4fpXUr
CI1mk2mdtdRgZMsQcxVhaX6wdOvMrEZtGxLiNL3mE20inKYN821iOOBhI380
vBtE/pLsQ0e5tbnU4HjTNC2BgeVNW/e9aIR2KotQ2FW2dmQPCmuTkzlDFzpH
uisizk2jYj0QCKFrkGVh8fZhjfcgGpkEorGVmZUaWMxsVXal+O1TmMHIh4fh
k2FJrxlQy4Ppo3Is835OTStU33LRFxroYD2T9NBMwkRhaDAFVKAF7vhSQAVq
OPX4Nu+XELigfncdZCOmGZSVeHgdgUzkPrTiS4bls67CnQyLYqkYVwMT4+y8
e8zOgble4vvQvAxjHNjlrOY5obpx4ea1WszLNJeYF2rxoJedOaTHoPluUAGU
dJ5QPkOHFSxd9TXkcARHpa0poFzj+eF2E1kf2gTeaye1GBx+Lc5MyqUlnTIQ
zpRyr2wblSWuVEGt3DxkA7sZ6lwWqM/sq7X8mfTBtlw7VGbo9G3yLemYEaSP
iWUzkMBpZDhC1T5mVJsWrtdK48/oViUWaWbnjlhyRjDFVj0M+3/SlTbAQagU
jitXRCNbXsSSJ6JEqIzFisorRFl8qQIC71gRV6qA4nCOv/EGu78FG7GLm7cO
aB7JBuhW7UowUCrsTy6O14NqxYGRr3KtNKQbVUUcJN1P70HpRlURh2ehG92o
KvDGq/v/lKeqQKVfZVzKmVvSy7lle845C/NFx9Ay81iq6TDUtJeAT7XSG4zv
IMqK6S45VBWo4OVKOHztV0pU2mF8B1HmSn2hGp8qrPa4N9u+e2w5voMoc6G7
DFBVxGEJdsrSPJLMtdtz5BRyWzKclF/P8Wxxt5xVk1fT7lxi5/FxutjObukh
bspv2Lp+p1RQpUQopKX8LuF+sKHXEwakuAG3KTlcywlrTZvbsxH6h8qZbL8S
EWswfVXOuFrcqN1P3jRylUJGweuNBy4SMgYi4nHuXx+dsaLdvj46S+HBycYw
uFpXtcjlyFR3LmGZRe5Fg3v6t85UasjaaSr3EG09gnSUPywchIVC7Ej3V7Fx
fxYcGyP+RAhNW+ghNFR5+CoHc0Y3C02hwxSPswg7NZEooiVkny4b5UNoaBIg
SioxBHcih23REgjaSQ5xzQ8Rd1KN+Fk1HqyjFhtJTxk9NGUwMVOox/pRPUi9
6QtdIXlQD/AQiTcCNS+ydCOBWu0+rqh0I9xEjguY6xjVg7h+Ysgt1tERIrPJ
46oba0lqEmKh4sWR6xeQ8bFDOy0bg6iG/Cl/jxyOoKWET53iGnYPRyjZENwG
7WaU6KwpJahMVKIVSR+xASJqybHSSn7JuXVYYmFQTChMRaksLDdIHw2QhSVm
DkqE2Vh8TPcAIUMcFcipNdlYmmSdrPRlnTDbIizf5AFtMBxgEdfsgF4UWeqR
NhBPGk65wmLG98KZWI8BwjkizTQSEyXldPQhrS9pLseKvwXFXf8EHaEuXsoO
Nf64eCnicAHU3JuXolVk4KVQ2pXgpUwobyzLSxEHGRiph5xys7SmhYgi1U7k
PzbSyc3oIgvBRF0k+Dn5PJIJcGW5tCapDPWypbLp5DAxegn4kAICFLR9t7yo
UmIQmzbOSTtSAZJ2oF6fB75mqXQJiHiQAVR/kRYjbpRNSswONjODNJUtqTMU
JcX4Qo4YWB1cVtB9cYUsQwyCP7L12aeknHWmG9KHJmUdvdgDY8euabOp69YQ
9XIn2RBSr8p0D0EruYJo75uVvCqRUO501pS8lTntWe9RV4iosDizNePHgD1z
ZTqFmP7YCvs8Jny03pIuTOzQsbZRwqqrarIWd/g3XKAZ+qFaiCqEiWtWUnjU
bwMJqYOqwQ8zryX8GzjaDH3Ujp/WtoMKvA3aM0qsK0emax950FqaTtcwWNon
VFxXCFpIuhK5IA8u+Nl5Xhs38rNC4u0KYqhg6yg0UCBAsEd0mjnYDV/pywFh
l4rjCAJLGsFjZqAWYS4nCPwrBgVIY1JQRLjU1RQUsXTqbzZxSxyt1BzSlSvM
zhu0Ry7fQy7PBOS0z8ON4/rcM477y3Gdbf3ayxKp504v7u5eeslfflnK8mcS
htN7EVeJ5VDxIlkvC+pve6l+tooRf+D0PsSjyOyU0XeOSTkDDUJshMCYEpHa
Q06seDgZ4qZBe8b8pUB74hqcFo2A2T0bjB+4NGWmXzklyy1N2oXGqyOc9Fxi
1j9q9UIr6kz88WHZNxaY2VowY/XbBTtId86FSulWQdGChlIeJPpmBKkmf6w4
K4Vvfw4xEaeeN2/xHVgOHErriGZHjNGqEkd4H3GdOH5Smu9sYCpt3lVKky6D
mSp86b5P+wcB4FErVZdqhVoI4GH7iNIuNwBkyRiptUAW/9d4USIOF0Ob1IXp
SKu7G1bnDcSwyi0BoUhlHJcy0gJGPMRfyEYhPMQxouxJouwwUXaJFPtVeQoh
KI4RZU8SZYeJskuRWIS5OEaUPUmUHSbKlFhhCwqlccR24ju2EwdtJ5Rh/tA4
2CCeo8J2oXtyzpXbLvQEr2K7yiuWB3V5IbQeBkSU3cJ0giiruoXpCQZ9dlfS
B19/kTSPxovABQNVZaUNVCeIsqGS8qCa32DWb7eHfhSESXnZH+sKPbZ1nSDK
hnJkUNu6fp1Bj90V9YDXX4inLgpjVWZT2T05cspuKnuCSaddPjplrlde9KWE
nGdL7GO7ly523cf2694K3FRWgYFLlS3+Ul6DwG3HiLInibLDRJmMtultBNni
lFcTPX2MKKPwdD71Upi9w0SZ3HrVwKlijTVe5WhGH5heiHZsLtcteuPeIpRb
+N1l4wxMqtGGkILHiLI3EjbU8ZIWpe6rw4RbCHMdJsoyHlqEf6tl69ROBWnV
FFeIOHyz43XXEr3Aj0LsVBdsdjTtPsfr5HpRDk7vTNhHLpi8UHuVNh1K1/mT
YedT+0thZ5U/LJvCBgc/Nm1xCgT5LeS/PCC/9K2oJKAv6KaeYVc77i/p7Syb
pIYFSIY1KNXN2JkJaAbcXyUPkAYfVtVgewxbU4ZeaHLdl1JNQQitt98DI0mh
/3ZGu+co19aQoXvXB4vp0xuUvL2EvGeosVsL3HEFsJMTtLH2rShDLIu6PnPM
ewlcBp6tsoNnvTs9hrBZ3mOl2DXPEEcWyOI7gZHzooCu0cLTiYZt9KjDdadK
41xgLqppZ8k3ENVf5Ki6axN9NvekTKtyAtpfWc7IzrP+EMx7Cc/1iXhyR1B9
trjk1q/hLS7fwaw6tykuiUg/quuH0fAiYME6uAlfAeT4WOiE8nNaZ4V6stnJ
srzdON8e2lKBlxVcqzs/tB1gHC+acaOe6JbF8c/oqY8tPN/1TQLO6YLFRurY
KKDsXqxvY7dkE0tDPHVuZLdF6P18a/Ni9c70sLXmEQBcTuDDtY07Qzy/fc2E
4MOya0q/FLa5dS15lZW7PmyzufdXdvUaqV/yYSW8CuNoNJdxJMrd1o3i2ldD
xl7OJExSasvkMgaoc2cREwEqv5/Gg21yDuY1RUdxq9tkIqZttwuccATOLB6M
vOUkI49YSot7Z5NK22o323auzUkejMoFGBdTHUWtjrD9TQyBYTwjVKafarxb
+s0yPf3x9Lsl7g1k1qgm5O6fvhy9Q+pLGmkxy/4xegaIp8u5Vohd5KyOtvUh
HB69B9RFsL5FzZMMm+Y/Vqui47VKfx20tTe7XBvVb5v/x3iUGecRk7FQCZ78
bXooDtxiTTXwD+Vr2Vv+FrlVVT20fcUXQNT7p4gycfygvOcaeR7x6p8iysQ9
D6F7EGn+KaIM3iN4PRQF/ru2E1DLVxl/GmSBW3jogyD8jIM7S+rl3CKUfAAq
2UtA+N+B901zyB+rJAtfL3RTG2ddrs7D2KK6p5AUPUTI/nsPeVScE9pxk76q
JMMZvsw/XlHGQOqJn8UOWJpSrJ6zWrfHqsrJBheAvV5Ne7qd0ttDjODHy95O
J81Qylwnb0PE3KeIMnHPB+Q9irGLGn5IacoFxNpK1HErcx1P25tDZfSMCUhz
JaHzROQ6/xsydyE7dJFhK6vcSthrk7FXusQYRS6OOE2IB3olHucim7b/f946
9ZWO1r0EqjYTMn9Hp8ytZlM70/V+pKf8YSFqLhRGLMXPvAc6apQpPZq22r8i
v+RhsP6U0YqBhdlhViul1T3QdvGm8whrqKeRkxI0Dyp/xa5oSZAtZLf68B8n
PDoihgwgzVhcvzD0kM8zMTrfoo3rzVnsBNXTPhE3ns8jpBn0NFvsci8H/pAX
snHlBY6awV47zVHHLurMvSGbw0JkFX9clhQ8/15K9JFP7KfFnL/7mFXnDqtl
/YqBkSpOvhL5CMHVkykPQwboWktJuze4qaLkYplsFnCFpH+Uuwja1is0kY01
9rZQWUf31mHMzpBtxBUyJ5LaS67W/ClN008+Vn8Tm+JeiDMTsidl9qSVvmyD
gfimX2woLM/g/XoKqgCiD5r2JgyAXvyxD7pHSfQ4by6bxuDj7zcyI8rp0wR+
Gs78z1W+kwsjPt0BRjybeXEqH7UIjCXW7hBp9qIQkFpqZmBAvj6uZqV6sKni
xG9ipf2QpY+rtnAkUUKKlQJ5zkKLuiE2xY1fkDWK38WBEbb5Z7L1CKL5NFEm
jtLjkq/I8wii+TRRJu55JroHQTSfJsrgPY/2/6HQmf9qOwG11EwSCjlZId/P
LK84oekSqCnGOJbNt/MEgwyhkwLh67xG8IVcPWkqJbJ5glketN+XdFs8Mso8
wSBDHHvY+yj8ZNn0LbOMsqDd/kBZN/NoLZFM5dveEqA+ckrCUM2niTJxj3zS
sidcobCIdzHXsZmoQxxlqCP6bCpXEPr/VOQ6byqwebypUqIMfqphgnCcE4S5
gmM2o7TWZsJalPMVoQhrwW12JtyppqVCzOaNhGX58ZmdMesmR7P+n/TlFmYr
aSqqq9FsZI4GYL+iLAL6p52ZS5qyPoWIFccrkCMvpLQlYaLVbyfEDBsxiQmZ
jECb+QJlwwJAwxiS6lbCgwlETKtylTS3AUmxgdQEVJiBoucojwp1KOptTXBb
LgRoE73EnXdkVo2bWlCl8eUJCbEAQU328L1sYLHfG3NbL9I0hM0K5/Vi/6w5
WYhP9ItKFrIM3Kt702S5rx/1GiK5x3dU37UlGUeIoNxaUyYsACYC/XW+oBNg
nEIuQ4BWo0gw4QovDcuSXq0kS6PNGav1tYNvq1HlXggbvHTtOOWGFjzrZ7T7
skXOOsVsTrkb8GtSmsd8TTa2x37oICVP1yqHfNhaTau2G3eNV/1q2OZyh+XK
mu+k7ORWbTcelvf7kTaZhiki5mjh70DniWs73dBM2Z+P0AZssSJHk2bcIb7d
VUPwVz8Sbet9YyouVkQuUBdw9WSt0sWJc2E7vAGtJ3nEUJqVALn+c/lbRI0v
kjWK38WBERercGUIA/sDokwcZYhMbz+IMLA/IMrEPe9C9yAM7A+IMniP2NKL
gr8+bTsBtdxk+pwFyPoErzih6dugpr3EB9N6ikGG0EkGi5It6jwXjvUUszxo
vyt0WzwwracYZIjjPdj7OLCsTzDKgnbbrKxbHdV60lsC1OcGeSHCwP6AKBP3
/Iy85zVE++9WFXJF8rcQdexnruO79ua8RV0eQ/iWim5vJnTeE7nO/4TMXQjv
XETDitq2EOZ6NXTwHECxxrJ1NMjsaEE8zCtBOBfBsXlx6M2Oln0pVC0HirwI
mLWaWs2hdiDse/RNTWE8uw6svdeUxbqxaVOWeRL5Jg+29S5Td1IPdrODGNjj
0D7xbmQaxhjfRU5JQGOoDUwnPPbNDI+ybCkM1gdg6bPDbDwbmzZhdf0CUQzz
qwBDvQeYlh982QnM6nHQVRFsbhqiyXoKLna5sYz/+AZ41oLrGoB+vsujOfa9
Wvk2N704KXg2voLoo5giSmmfN4LxjGnDU0peXRuevhj5DYEdvVD8sZiRSAP0
fICiXd8R1bXnDIQdLrD0jzKDnQ1C+iLVGNbIXadQpKvMtOmPIu3Enqk8vStK
tkvffCFRF/PuoTEiSCPfILWsycRd22SP6h3aquAjg24S2h7YaBv3TnW0rvhj
HHpOZPuItg44GvVmqo42pbwi0u1EW4EhjXtHVRdTDnpEXXjPU7VKFyc+Dtvh
DQM9xSOG0qwENPSp8reIGh+WNYrfxYERTSq3YsbI0cNE2RRRJo7vlnIm5HmE
Jj1MlE0RZULOe5AchDA9TJRNEWVQzt7+PxTg9KDtxKTtBGzmXtlNZXCjt+Td
MvDFOVG+AqGfAoFKFJc7gHR/zvXwWannG/nrnLJDSaCqjHglu+X5SiDSmx3v
HSJ02OtRL2FjZ5DpzTnXm62ewAO+rHxxlIzg5Czaqyg8ZB7mVOZlPw3vSTmn
35vlI0mrfEtJ2Y/QKn5dNuB5OU63JZ07ikCqtxKXwq8yPfXudxf52RzNvg6t
j71OQZ0RHPYwUTZFlH2OkPcNWdU6wnGoXj5MlE0RZQeUPK7VhrWEfucx13Fn
xmUI56Q2hHU1yT5VZawB+lU57X5B5Lq/NTNgwJC8UpYhyOphomyKKNMciOig
rYFXGFyrGyXsv7Ime3EnhbObirsm5azqQVcIVN3neN0ex+t00s7wwNcmVip4
6jyX3T4jdWSVs5umluqUI9vxv79EdMskUXYHNG+UMNa6VjSqyoXW0w9u/DEn
6xgOZy74fcNpLh+5dyAP5UEBP1jWqeNGvjKvyTiKo5ZGRqHBkGPUZxETwC2f
mo8509+dyFUdscFLxXGkX2b808gcM0O4CME64b+RK5K3zR+y3EGELcu6lqMo
1219KWv35BE5VeoN2bFZ1WJcqRBPY5WmR2EPjUImRHK5J0c0sFzf9TYXOa7P
A7/2siRbZMzb6O5tOl+0/LKW5XrXCC6AMrVf7QUedVDXLSfquJi5DkZk8k+U
ckurmD9S/Wx9tpv9YftuPCmnzkEMoZD1MsI7mgrFUTDol0SkHyXv0sj1qwEn
LRfxB0GS/TdQwxoA3pxOqIqrOCDxj5FDE6DrZ4NJEoIczCNXPoZlCH8Rm31u
C+3AHRbdGNwG7cGW30pMHtaRK2O6fyGHqAWJvlbNP/qrCI5TPUYvVOZZRKvb
0OrntdFCtYSCa/GVdmLt7yfG6jDSQ/6kn+Ppa+lX5aB9DvQ19VabTsTzVt2B
RcAn7DqieR2D9z+/XU30CWCvr7+pTTMZjhMyFADmbODzeois0pNY7Kj+sGQH
+UG/kjDLZLLDvHDAJXbSCPHYwCOUvrotLhKW+HFc2xCHlBUC7FItJCYWRGgq
iPSc5bQRBtf5h5puOFfYe3WMnR+aAqNf3GDsOjM4IqWDhGDErFFzFWkCjSA4
HX066UuaazZLlF4Pjkg7P6/TWLlA2+BYqIuts1fNwDbpmYV+MwMPSpp/7alT
UXHiY9Ak3nwg3XZKDLGQ2qOl7OBRhmpfCabRrWq6GLwFRFpw9Hpv+VrEjZ+W
SorfxYGRzyRXbjBP6QhRdoooO0CUXSvFfkmeQrSlI0TZKaLsAFF2HRKLWExH
iLJTRNkBokyJ/cP+PxSV6ZDtxBO2E7faTijDfM447yAxSa1FZLlMvZxbdvGK
+1tecdtyzlkyCuj1mMxjbDO0Xi+BBA+13V8OJQtfv5tBxgkGGeNEWXE+A5pP
o8zzO0okDMioqgtZXFQwZzezvBPM8saJsqGS8qD5Jfgq+V19CnyZKzfPJaXB
63czyDjBIGOcKBvKkWEwhODzYROeuiiSmvxKsRDgMtfuYpLzt0xytuXIKUw+
keERqYH4eXoWU2ETgmU3cOlN3hL+zlvCdrrYnvuil75jzY9GNZrkUjom6h0h
yk4RZQeIsmukWJXWhw1UQ5EBjxBlhwPUe4Aou1o2e6sSESu6Y7OjGSdb2I6c
btH8wSIiXdfTbLhiAJR5ERnxCFF2I2FDHaPuaJ4NHxMeIMoyHlrEiutE8g2e
hW5l4ULCoSvR8XrC3O3PvhHW1rsdr5ObG+dQ986EneFCyWtrqo1qlDLc08eI
MuyV8oclp0nrU3hwcB6/h/yXh9iXoplLEvbamLbDcc34zpLezpIGpZWpPzyI
j9iZCXpASjnIZ3PBJ1M1rltM6Tscl21HHI2jpiJEddvJTHzc60FUJN+FlcnS
l96qeVmiSxMSgMhI9a4PDfVGQt5z1djtobHLRBhcAUzuRASMPiuJy2Kz6zOH
L5lL3GlNqvIn9WOl2DUl5YCFMXcvMDJH/I8iJV7kUQdFfKRIica5wLRWU2YW
imTo00Tqupczy1unfMv6ynJG5iYGGpvO6hxrTDQmZiHFzEx356o9Gc1dEZmC
kndx5Po9Hw0vgl+pw5XwFUCOj8Vd6DaGtkPYALgjpXQ1sExeSp87u20tx9o2
tM4K3PRbNeVY1ro/oacqtjh8ezcDvIDdFp3JCK4nHdcUTW9tvSn969vQKhuM
1MEeVnPPr1hbNALQyQmc4bqwp+OGsM3mXs5xZe3+fLub6SrvrPY1E+JDyzqv
bG7yAT05VKBcjuZSLkW525JP3FtermmTiZgWxQpIy+9ZgCYpECPfoM705XGX
MUCdK6Um5Feexb0Oziwe1NTlJDWVWAWLcyfPNRG2n20RsAQ1+91dtkMJcaO6
MWUo6s22nYulnpkRKvNxNVQt/YaZnv64jZUY206pa6Jtve86pwsL/T2dbb2L
HL2xSS4Hfzn6jtCXNNJiFvo9GvV1sbnr5YqfqFX6uJriGSjz+6GtvSnkTEz0
EzxitJn82PUZC5Xgqk+Uv+Xx8rfs1bOcO+/+Ntkk8Yc4MPLn3yD7B3HgTxJl
4vhz8p7Xy/OI4H6SKBP3fADdg9jrJ4kyeM/r+v9QXPRv205ALa82XsnCBc+j
lpfjggsl3w2V7CUgTstC5q5KxIa6XavkwuiTqp+NPe3DdhZnVPrX6/R5Zrpy
WaqxOL4LO2CdPOGy/F7Yv9fQ7ulP0XUl2MIOfKM8j5iyJ4kycc/75T1vIhqv
SHhsOKpNRB37mOv4T3tzFCEuWhzM5YTON0Wu838gcxfSNRcpr6irkb3GoIej
r8RFymuh51XiWy7SW02dlzua8cVQj5mQ+TTbaVflpXbq6c8hpeQPC3NyoVBU
qfWcY+a6WFNsNm21f0d+yUMpvddox0CL7DDNlBJ3DNou3vyZYQ31n8hJS1FF
h/FMLeMIyT4PBqT+EqyHsdhhKip3zsx4clyGtrgeDz00Hpjol/dp43oTDDvB
y7RP0tGkqgxhBneXuwL4Q9lADsVTHDWDvXZO4k8Sfc2dC5IxT6P4A+9pQzwb
Lyf6qKnIUcMEvbdGZApKXg1ZEMXJVyEfIYh1LxV/dDccx8weu6N95uImTlH5
+oRstaW1ZXHjEtWOVkfaoiES3dE2a47UwaMRJbdIt3sZ0azIM4e5Mkk+1I6m
+dAqhCS5EKi2phyphJJvYzqrAtKAXMWPLdNZWGy8+GM/dI+u5m4qgRD/2UQ/
JRpO3tUANJpyiI7mK3KBCT+gRmNEyaoCoWUHHaEu2Ok31HBjgJ2Km38dKu2N
9tTa+aE9KcVKgDG/pdywBBhTHGUqiXoQmRIgSqAv4SvHHnnRINwSvmGqiwbx
lfAisSGxFUsJ65RbF5cCTaYyZNIMhQ1yxzamAmTtKvlGNQCiTRtnhGAqYKcU
cJZyq8w8IEFjbui+R2gR0M2epx2bAGxuSh2hCK332RwxsDpNkIb9sFmWISje
b9v6S55OE10PpGKhMW5cYcs1RL3nM9chpL4p0z0E3nIz0V4NH4w1tLcypz3r
I9ddnHljxo8B5HRLOn2Y/tgC+3zhgtgcaxslrLqqJmtxRwKHrJbirgn64c3y
fCFOTW8B2X2cmn9957LbpZZ4XxPhReV1dvjeJ6DtFgTSrKw82DWr1EyKX2+l
nOFw5vGJVdYaA30DcjceVN4HjYoLAVlWIIYKcI5CA6Fers8CHtHQOoKrb0J+
R4AJ1GcAwnAtFccRAaxLzTynfdOszxdAwXZ5YPI6CwVzErfE0UqU1XvyiDoP
xgymM9NdNctxBXxPY5WGXL4Y2FQBS/dB0IkdAorlyXGdWf3ayxI15g5Au7uS
AZqIqmT5JjCHcURTZB0sQDNqr357n+bj1T6aFDxi1oLB0X8H7+s6GHwTAl9G
mDamwMnK7MTsj+faLooH4SD9p7kxP+iSdEjNDdMSxTW/iHqFQIg9G4wVuBhk
plU51Z4nCluFjKqFlPgcYoZ/s9VriC6ToQrxx6dl31gC0GvB7NRvGOwg3TkX
Khu1BidUHw/vfqITRpAe8id9f8rsQ/Ap2Rumg8GMm0bC5k27A8uBY2Yd0cYI
kTw+tLLjhAxxVMshZwNTafOuUhotFMSPI/npuPYP/CEgrlGLQpdqSZ0EwziS
YvTIRi+nhJE6ChBxIXGIu8ThEmiTurASaXV3w+q8UQ5WuSVACqkMOb4GIQPJ
M/4ftd5NIw==\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{704, 557},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[15]//TableForm=",
 CellID->54720361]
}, Open  ]],

Cell[TextData[{
 "Solve the evolution equations to third order in the optical field. (Note \
that this operation takes a very long time in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " version 6.)"
}], "MathCaption",
 CellID->97985673],

Cell[BoxData[
 RowBox[{
  RowBox[{"sol", "=", 
   RowBox[{"NestList", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"FullSimplify", "[", 
       RowBox[{
        RowBox[{"Solve", "[", 
         RowBox[{
          RowBox[{"eqs", "/.", 
           RowBox[{
            RowBox[{"x", ":", 
             RowBox[{"(", 
              RowBox[{"\[CapitalOmega]R", " ", 
               RowBox[{"DMElementPattern", "[", "]"}]}], ")"}]}], 
            "\[RuleDelayed]", 
            RowBox[{"(", 
             RowBox[{"x", "/.", "#"}], ")"}]}]}], ",", 
          RowBox[{"DMVariables", "[", "sys", "]"}]}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], "]"}], "&"}], ",", 
     RowBox[{
      RowBox[{"Solve", "[", 
       RowBox[{
        RowBox[{"eqs", "/.", 
         RowBox[{"\[CapitalOmega]R", "\[Rule]", "0"}]}], ",", 
        RowBox[{"DMVariables", "[", "sys", "]"}]}], "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", "3"}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[16]:=",
 CellID->1937353],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"roty", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Observables", "[", 
      RowBox[{"sys", ",", "\[Omega]0", ",", 
       RowBox[{"\[CapitalOmega]R", "/", 
        RowBox[{"ReducedME", "[", 
         RowBox[{"1", ",", 
          RowBox[{"{", 
           RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}]}], "]"}], 
     "[", 
     RowBox[{"[", 
      RowBox[{"2", ",", "1"}], "]"}], "]"}], "/.", 
    RowBox[{"\[Omega]0", "\[Rule]", 
     RowBox[{"2", 
      RowBox[{"\[Pi]", " ", "/", "\[Lambda]"}]}]}]}], "//", 
   "Simplify"}]}]], "Input",
 CellLabel->"In[17]:=",
 CellID->24895147],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SqrtBox[
    FractionBox["3", "2"]], " ", "\[CapitalGamma]", " ", 
   SuperscriptBox["\[Lambda]", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{"Im", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "0"}], "}"}]}]], "-", 
     SubscriptBox["\[Rho]", 
      RowBox[{"Im", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "0"}], "}"}]}]]}], ")"}]}], 
  RowBox[{"4", " ", "\[Pi]", " ", "\[CapitalOmega]R"}]]], "Output",
 ImageSize->{255, 56},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[17]=",
 CellID->255987138]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rotx", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Observables", "[", 
      RowBox[{"sys", ",", "\[Omega]0", ",", 
       RowBox[{"\[CapitalOmega]R", "/", 
        RowBox[{"ReducedME", "[", 
         RowBox[{"1", ",", 
          RowBox[{"{", 
           RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}], ",", 
       RowBox[{"PropagationVector", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}]}]}], "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"2", ",", "1"}], "]"}], "]"}], "/.", 
    RowBox[{"\[Omega]0", "\[Rule]", 
     RowBox[{"2", 
      RowBox[{"\[Pi]", " ", "/", "\[Lambda]"}]}]}]}], "//", 
   "Simplify"}]}]], "Input",
 CellLabel->"In[18]:=",
 CellID->945266666],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{
    SqrtBox[
     FractionBox["3", "2"]], " ", "\[CapitalGamma]", " ", 
    SuperscriptBox["\[Lambda]", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["\[Rho]", 
       RowBox[{"Re", ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", 
          RowBox[{"-", "1"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"2", ",", "0"}], "}"}]}]], "+", 
      SubscriptBox["\[Rho]", 
       RowBox[{"Re", ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"2", ",", "0"}], "}"}]}]]}], ")"}]}], 
   RowBox[{"4", " ", "\[Pi]", " ", "\[CapitalOmega]R"}]]}]], "Output",
 ImageSize->{260, 56},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[18]=",
 CellID->134300382]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sig", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{"FullSimplify", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"roty", ",", "rotx"}], "}"}], "/.", "sol"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"\[CapitalGamma]", ",", "\[Infinity]", ",", "1"}], "}"}]}], 
     "]"}], "//", "Normal"}], "//", "Simplify"}]}]], "Input",
 CellLabel->"In[19]:=",
 CellID->215859820],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     FractionBox[
      RowBox[{
       SuperscriptBox["\[Lambda]", "2"], " ", "\[CapitalOmega]rf"}], 
      RowBox[{"12", " ", "\[Pi]", " ", "\[CapitalGamma]"}]]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     FractionBox[
      RowBox[{
       SuperscriptBox["\[Lambda]", "2"], " ", "\[CapitalOmega]rf"}], 
      RowBox[{"12", " ", "\[Pi]", " ", "\[CapitalGamma]"}]]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"\[CapitalDelta]rf", " ", 
        SuperscriptBox["\[Lambda]", "2"], " ", 
        SuperscriptBox["\[CapitalOmega]R", "2"], " ", "\[CapitalOmega]rf", 
        " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", 
           SuperscriptBox["\[Gamma]t", "2"]}], "+", 
          RowBox[{"8", " ", 
           SuperscriptBox["\[CapitalDelta]rf", "2"]}], "-", 
          SuperscriptBox["\[CapitalOmega]rf", "2"]}], ")"}]}], 
       RowBox[{
       "36", " ", "\[Pi]", " ", "\[CapitalGamma]", " ", "\[Gamma]t", " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["\[Gamma]t", "2"], "+", 
          RowBox[{"4", " ", 
           SuperscriptBox["\[CapitalDelta]rf", "2"]}], "+", 
          SuperscriptBox["\[CapitalOmega]rf", "2"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"4", " ", 
           SuperscriptBox["\[Gamma]t", "2"]}], "+", 
          RowBox[{"4", " ", 
           SuperscriptBox["\[CapitalDelta]rf", "2"]}], "+", 
          SuperscriptBox["\[CapitalOmega]rf", "2"]}], ")"}]}]]}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[Lambda]", "2"], " ", "\[CapitalOmega]rf", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"24", " ", 
           SuperscriptBox["\[Gamma]t", "4"]}], "+", 
          RowBox[{"96", " ", 
           SuperscriptBox["\[CapitalDelta]rf", "4"]}], "-", 
          RowBox[{
           SuperscriptBox["\[CapitalOmega]R", "2"], " ", 
           SuperscriptBox["\[CapitalOmega]rf", "2"]}], "+", 
          RowBox[{"6", " ", 
           SuperscriptBox["\[CapitalOmega]rf", "4"]}], "-", 
          RowBox[{"16", " ", 
           SuperscriptBox["\[CapitalDelta]rf", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[CapitalOmega]R", "2"], "-", 
             RowBox[{"3", " ", 
              SuperscriptBox["\[CapitalOmega]rf", "2"]}]}], ")"}]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["\[Gamma]t", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"60", " ", 
              SuperscriptBox["\[CapitalDelta]rf", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["\[CapitalOmega]R", "2"]}], "+", 
             RowBox[{"15", " ", 
              SuperscriptBox["\[CapitalOmega]rf", "2"]}]}], ")"}]}]}], 
         ")"}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"72", " ", "\[Pi]", " ", "\[CapitalGamma]", " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["\[Gamma]t", "2"], "+", 
          RowBox[{"4", " ", 
           SuperscriptBox["\[CapitalDelta]rf", "2"]}], "+", 
          SuperscriptBox["\[CapitalOmega]rf", "2"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"4", " ", 
           SuperscriptBox["\[Gamma]t", "2"]}], "+", 
          RowBox[{"4", " ", 
           SuperscriptBox["\[CapitalDelta]rf", "2"]}], "+", 
          SuperscriptBox["\[CapitalOmega]rf", "2"]}], ")"}]}], ")"}]}]}], 
    "}"}]}], "}"}]], "Output",
 ImageSize->{588, 83},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[19]=",
 CellID->566888926]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sig1", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"sig", "[", 
     RowBox[{"[", "4", "]"}], "]"}], "-", 
    RowBox[{"sig", "[", 
     RowBox[{"[", "3", "]"}], "]"}]}], "//", "FullSimplify"}]}]], "Input",
 CellLabel->"In[20]:=",
 CellID->79059378],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    RowBox[{"\[CapitalDelta]rf", " ", 
     SuperscriptBox["\[Lambda]", "2"], " ", 
     SuperscriptBox["\[CapitalOmega]R", "2"], " ", "\[CapitalOmega]rf", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        SuperscriptBox["\[Gamma]t", "2"]}], "-", 
       RowBox[{"8", " ", 
        SuperscriptBox["\[CapitalDelta]rf", "2"]}], "+", 
       SuperscriptBox["\[CapitalOmega]rf", "2"]}], ")"}]}], 
    RowBox[{
    "36", " ", "\[Pi]", " ", "\[CapitalGamma]", " ", "\[Gamma]t", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["\[Gamma]t", "2"], "+", 
       RowBox[{"4", " ", 
        SuperscriptBox["\[CapitalDelta]rf", "2"]}], "+", 
       SuperscriptBox["\[CapitalOmega]rf", "2"]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"4", " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["\[Gamma]t", "2"], "+", 
          SuperscriptBox["\[CapitalDelta]rf", "2"]}], ")"}]}], "+", 
       SuperscriptBox["\[CapitalOmega]rf", "2"]}], ")"}]}]], ",", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{
      SuperscriptBox["\[Lambda]", "2"], " ", 
      SuperscriptBox["\[CapitalOmega]R", "2"], " ", "\[CapitalOmega]rf", " ", 
      
      RowBox[{"(", 
       RowBox[{
        RowBox[{"4", " ", 
         SuperscriptBox["\[Gamma]t", "2"]}], "+", 
        RowBox[{"16", " ", 
         SuperscriptBox["\[CapitalDelta]rf", "2"]}], "+", 
        SuperscriptBox["\[CapitalOmega]rf", "2"]}], ")"}]}], 
     RowBox[{"72", " ", "\[Pi]", " ", "\[CapitalGamma]", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[Gamma]t", "2"], "+", 
        RowBox[{"4", " ", 
         SuperscriptBox["\[CapitalDelta]rf", "2"]}], "+", 
        SuperscriptBox["\[CapitalOmega]rf", "2"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["\[Gamma]t", "2"], "+", 
           SuperscriptBox["\[CapitalDelta]rf", "2"]}], ")"}]}], "+", 
        SuperscriptBox["\[CapitalOmega]rf", "2"]}], ")"}]}]]}]}], 
  "}"}]], "Output",
 ImageSize->{337, 83},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[20]=",
 CellID->254382841]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"Plot", ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}], ";"}]], "Input",
 CellLabel->"In[21]:=",
 CellID->110448346],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{"sig1", "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[CapitalGamma]", "\[Rule]", 
        RowBox[{"1.", " ", 
         SuperscriptBox["10", "5"]}]}], ",", 
       RowBox[{"\[Gamma]t", "\[Rule]", "1."}], ",", 
       RowBox[{"\[CapitalOmega]rf", "\[Rule]", ".5"}], ",", 
       RowBox[{"\[CapitalOmega]R", "\[Rule]", 
        SuperscriptBox["10", "3"]}], ",", 
       RowBox[{"\[Lambda]", "\[Rule]", "1"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[CapitalDelta]rf", ",", 
     RowBox[{"-", "20"}], ",", "20"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[22]:=",
 CellID->231252382],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{180, 108},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[22]=",
 CellID->158340335]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{"sig1", "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[CapitalGamma]", "\[Rule]", 
        RowBox[{"1.", " ", 
         SuperscriptBox["10", "5"]}]}], ",", 
       RowBox[{"\[Gamma]t", "\[Rule]", "1."}], ",", 
       RowBox[{"\[CapitalOmega]rf", "\[Rule]", "100"}], ",", 
       RowBox[{"\[CapitalOmega]R", "\[Rule]", 
        SuperscriptBox["10", "3"]}], ",", 
       RowBox[{"\[Lambda]", "\[Rule]", "1"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[CapitalDelta]rf", ",", 
     RowBox[{"-", "500"}], ",", "500"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[23]:=",
 CellID->334428964],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{180, 109},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[23]=",
 CellID->577930429]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"AMPSPlot", ",", 
    RowBox[{"Boxed", "\[Rule]", "False"}], ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
    RowBox[{"Mesh", "\[Rule]", "False"}]}], "]"}], ";"}]], "Input",
 CellLabel->"In[24]:=",
 CellID->31523307],

Cell[BoxData[
 RowBox[{
  RowBox[{"rfplot", "[", 
   RowBox[{"params_", ",", "range_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"gdm", ",", "rot"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"gdm", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"DensityMatrix", "@", 
         RowBox[{"SelectStates", "[", 
          RowBox[{"sys", ",", "1"}], "]"}]}], "/.", 
        RowBox[{"sol", "[", 
         RowBox[{"[", 
          RowBox[{"-", "1"}], "]"}], "]"}]}], "/.", "params"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"rot", "=", 
      RowBox[{
       RowBox[{"20", 
        RowBox[{"sig1", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], "/.", "params"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Show", "[", 
      RowBox[{
       RowBox[{"AMPSPlot", "[", 
        RowBox[{"gdm", ",", 
         RowBox[{"PlotRegion", "\[Rule]", 
          RowBox[{"Crop", "@", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{".22", ",", ".79"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{".26", ",", ".92"}], "}"}]}], "}"}]}]}], ",", 
         RowBox[{"ImageSize", "\[Rule]", 
          RowBox[{"4", " ", "72"}]}], ",", 
         RowBox[{"ViewPoint", "->", 
          RowBox[{"{", 
           RowBox[{"2", ",", 
            RowBox[{"-", "2.4`"}], ",", "1.5"}], "}"}]}], ",", 
         RowBox[{"PlotRange", "\[Rule]", 
          RowBox[{"1.15", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}]}], ",", 
         RowBox[{"ColorFunction", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Directive", "[", 
             RowBox[{"RGBColor", "[", 
              RowBox[{"1.", ",", "0.725", ",", "0.094"}], "]"}], "]"}], "&"}],
            ")"}]}], ",", 
         RowBox[{"Lighting", "\[Rule]", "\"\<Neutral\>\""}]}], "]"}], ",", 
       RowBox[{"Graphics3D", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Axes3D", "[", "1", "]"}], ",", 
          RowBox[{
           RowBox[{"ColorData", "[", 
            RowBox[{"1", ",", "\"\<ColorList\>\""}], "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}], ",", 
          RowBox[{"Arrow3D", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", "0", ",", " ", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1.01", ",", "0", ",", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "\[CapitalDelta]rf"}], "/", 
                  "\[CapitalOmega]rf"}], " ", "2", " ", "1.01"}], "/.", 
                "params"}]}], "}"}]}], "}"}], "]"}], ",", "Red", ",", 
          RowBox[{"Arrow3D", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", 
               RowBox[{"-", "1.01"}], ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "1.01", ",", "0"}], "}"}]}], "}"}], "]"}], 
          ",", 
          RowBox[{"Arrow3D", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0", ",", 
                RowBox[{"-", ".8"}], ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", 
                RowBox[{"-", ".8"}], ",", ".6"}], "}"}]}], "}"}], ",", 
            RowBox[{"Scale", "\[Rule]", "1.5"}]}], "]"}], ",", 
          RowBox[{"Rotate", "[", 
           RowBox[{
            RowBox[{"Arrow3D", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", ".8", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", ".8", ",", ".7"}], "}"}]}], "}"}], ",", 
              RowBox[{"Scale", "\[Rule]", "1.5"}]}], "]"}], ",", "rot", ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], "]"}], ",", 
          "\[IndentingNewLine]", "Black", ",", 
          RowBox[{"Line", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", ".8", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", ".8", ",", ".8"}], "}"}]}], "}"}], "]"}], ",",
           
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"rot", "\[NotEqual]", "0."}], ",", 
            RowBox[{"Rotate", "[", 
             RowBox[{
              RowBox[{"Circle3D", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", ".8"}], "}"}], ",", ".7", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "\[Pi]"}], "/", "2"}], ",", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "\[Pi]"}], "/", "2"}], "+", "rot"}]}], 
                 "}"}]}], "]"}], ",", 
              RowBox[{
               RowBox[{"-", "\[Pi]"}], "/", "2"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "0"}], "}"}]}], "]"}], ",", 
            RowBox[{"{", "}"}]}], "]"}]}], "\[IndentingNewLine]", "}"}], 
        "]"}], ",", 
       RowBox[{"Prolog", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Inset", "[", 
          RowBox[{
           RowBox[{"Plot", "[", 
            RowBox[{
             RowBox[{"Evaluate", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"sig1", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "/.", 
                RowBox[{"\[CapitalDelta]rf", "\[Rule]", "drf"}]}], "/.", 
               "params"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"drf", ",", 
               RowBox[{"range", "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{"range", "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ",", 
             RowBox[{"Frame", "\[Rule]", "False"}], ",", 
             RowBox[{"Ticks", "\[Rule]", "False"}], ",", 
             RowBox[{"Epilog", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"Red", ",", 
                RowBox[{"Line", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[CapitalDelta]rf", "/.", "params"}], ",", 
                    RowBox[{"-", "1"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[CapitalDelta]rf", "/.", "params"}], ",", "1"}],
                     "}"}]}], "}"}], "]"}]}], "}"}]}]}], "]"}], ",", 
           RowBox[{"ImageScaled", "@", 
            RowBox[{"{", 
             RowBox[{".225", ",", ".69"}], "}"}]}], ",", 
           RowBox[{"ImageScaled", "@", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0"}], "}"}]}], ",", ".3"}], "]"}], "}"}]}]}], 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 CellLabel->"In[25]:=",
 CellID->181111389],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rfplot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\[CapitalGamma]", "\[Rule]", 
      RowBox[{"1.", " ", 
       SuperscriptBox["10", "5"]}]}], ",", 
     RowBox[{"\[Gamma]t", "\[Rule]", "1."}], ",", 
     RowBox[{"\[CapitalOmega]rf", "\[Rule]", ".5"}], ",", 
     RowBox[{"\[CapitalOmega]R", "\[Rule]", 
      SuperscriptBox["10", "3"]}], ",", 
     RowBox[{"\[CapitalDelta]rf", "\[Rule]", "5"}], ",", 
     RowBox[{"\[Lambda]", "\[Rule]", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "500"}], ",", "500"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[26]:=",
 CellID->306014737],

Cell[GraphicsData["CompressedBitmap", "\<\
eJztvXeYFVXyPn4+984gM8wwZJghuu6u7q45izm7rnnVNSOCARBUghgwIyoK
Eg2omNYsJlBBJJsIYiCICAgCApJzmPSrt0L36b49AXf3eX5/fH3sO5eZG/rU
W+lU1ak6u233G67t3LZ7h3ZtW53ete3NN3Ro163VaTd1pV+l/8+5/2tF14Wt
HJ6XO2cP5fR/+Z54wG/+O8+f5B9pd8WfTnF3HXyFG3J0F9dH/vQE/8h2JxUd
5K7806nu7oOvdEOP6eJeOOFW92D0JSc3Pci1+fNp7p5DrnJPHHNT8ksOdlfv
fbq775A27snkl5xCL7lm7zPc/Yde7Z469uakl5za9BDXfp+/uwcObVvhS5od
4q7d5x+u92Ft3dPH3uKez3zJac0Oddf/5Sz34GHX6Et6xF9yOr3khr+e7foc
3s4NO66re/744CVD+UcNd0Sjv7gzmh/mOv71HPfQ4e35ZcOP7xF71VGN/+rO
bH646/S3c93Dh1/rnuFXdY+9qnXjv7l/tDjCdf7bee6RI651zx7XzT2X8aqj
6VVntTzSddn3fNf3iOsqeNUxTfZ157Q8yt203wXu0SOvxyvwyoxX7efObdXa
3bLfP91j+iq6t9irjqVXndfqaNd1/wtdvyNv4FcRxWKvOq5wf3f+nse4bvtf
5Pof1QHrAzoJr/rnnse6Hgdc7B7nV/UAs8RedTy96sI/HOduPeBfbkDrjvyq
IUd3znjVAe7iPxzveh54iRvYuhPDM6j1jbFXnVB0gPvXXie42w+8VF5FONP9
6asG8o9cd8YZZ7gbbrjB9erVi3+Dd12y14nujoMuw2cyAz18xLX6rgH6rkMP
PTTyzjvvvNOdWHSgu+yPJ7k7D7rcDT76RnBnn+q96/I/nux6sfh1rua7RCoh
tFey0FbzXSSoV/35VBLUQJar8S6I99V/Pt3dG4p3Nd4FcW5L4uxJfDXf1W7v
v/tKoBrvgtC33+dMXy9U412n0buu+wtUhemB6rzr9EztUcW7jmi0D2uKDoFC
uQUcW8W7jiTN8XfSHDH9UsW7WkPfkCa5MaJvqnoXa5YWR7rO+4r+eYY0C0lx
Fe+CpjmbNE1MH1XjXee0bO1ujuqnKt5lmiimr6p413GF+7nzWx0T0V/DqvGu
/d0FpKm6e/qMkK7iXay59jxO9ZtoriePvbnKdx3gLiJN5us7kswq3nUC678T
3G2e/iONU9W7VLP5+nBA605VvAv66VLSar4+JNwi78pJfNdlpNU8Xegeqvwt
J9Fb4Id4irDqt4S+iWrBqt7i+yrmzlT5loPj+q+qt5gvc9+hobujb3lc6Xz5
iTXdFSfXdFedUtO1PS3Htf97jrv+Hzmuw1k57gZc/8h1Hc/KTbkbz8klD+26
M3P4jbjul0/qyz8K3KUn1HSX0addfhJ9Gn3i1afWdO1Oz3HX/V0+pdPZufwh
Xc7LdTefn+tuuaCW6/bPWq77hbVcyvW4qFbK3XpRLfqOHhfm0h/kule+g286
xV9RxF9wZXDL9CVn2JfkuI70JZ3pS26Kfwl98q0X13K3/auWu/2SWu4OXJfW
cnfS1euyWu4uuu6+XH7id10vyL1LvvrB+FeDWlfq+q45vaZQ7EyhWCes71z5
avoI/uoesa8OvvLyPPpKuq7Ic/fQde+Vee4+XFflpfhJmn91D124kTvkdh4I
b6dJQO4rlCJXKzWuVRA7np0TkPyWKm4Hqw9u46o8dz9u44E2eS7L9b46zz0Y
Xmn+RZr/aLzQU+7uPvxIK7H47k6UuwvYC1idKawFhuhMxLrpfLm77oR7ZXeG
u8J3BrfTNs/1aUt3+dA1ecT8D7fLc4/oJc/z3SPt811fuh6m53iL3uY9+JHF
t9nSXXZCwm0yAXNdhxjPdiWWBAF7Xpx5i0Y4u0W6Nb6z4L7a59G95LlHr813
j+G6Lp/4vh897uH6XZ/v+tP1+A1y4d+4b3xGD7nnu8N7bsb3fJnec5tTwIcC
OkurkTUGek8ja8L9Pqj3+/A1cq+Ptg/vke4wxTeX5lsb0CHfDeyAWx/Ukf4w
uFM++bhD6HHIjfn4Fb8I7yUG6ia33iu49TTf9Z4sQ21Ozan8vi/MvO+79L7v
9++ZaZvPdAU1jY4DvJvFfeFOcZ9Db6ztnuhcmxbwZJfarqZ7ih6fuqm2e5qu
YXTht0PoNXgf0aGrrOHOOMtgIbiujC3l+mouRSCoBTIxu4BV4svAEgYFt0+3
1Qm3jQXkuCdpCbj1YTfXds/guqW2exZX19ruObqGd8Vrh3erTQKM32N5WDYt
6xZZEmuUbCwpxSvZS9jpVGGn9oEOIRGoZC29KloLwQI24HV4azDy4/5BaqwB
94Y14N5xx893x72/0L0g5V7sQQ8v3VpATPYyPb7UowC/p1cV0IoL8Ck3y2pu
z1jN5TG9I0paBDppNXdUtJq2KhTeagZ3lJUYCsw8igSoPbxrAa2iALfPd59y
/+5JC3nltgKyua/S46u3F7jX6Hr9DvmJv9BLggXSh9wkC7sNP2ow5x0aaPwr
T4G2zxHbp8YnoulpXbCmt1Wyrj7BuvJc/+uU2zqKgAAZCMOzROPnaC28HqL5
i91lPbhV3LIt4Y07C9ybfNVxb/aq497CdVcd9zZdI+6Sf79Bf3vt9jq0/Dr8
fvq8LrLEnuES9w7MRlywYN5hMkwXQ69Ve4mkd/vFl9hZYGO4bGlEfbDZK4qQ
LQ23j6Wk3Dt310m7d++pk3Lv3VuHtMf799XhZ/SryELfuKMOCNVZFngrfuzB
C9zH0xrEmzFJ63yuLU4MTebiQoUNZd2XF5bHCg+aAgousrCusjAs6lXGqw4t
qg7jhFvFLdOS+Pbfp2V8cB8tb+T9tLxRD9QlVv2QHj/sXdd9RBd+88F9dSPL
xecQljfKMnuEy/yL2Cdbppl+eJamUDx7imXClla8RNLp14dLfKJzqDSwxBe6
h7hheYbXCF3ae1geIUUro2XUoeXUcR8/WJfwHE2PWW50n7pujF0P1U25Tx6q
S+DSU36Zv3qiEH80fVUnWXX3cNV/DazyVQkC2kkFFJ6hv2o4N2bRHuIVi+XF
igf6K+5iK64dXfHtAgQACYGsS6utywDi9rFOrG4sLenTh+um3bhHsPDxfevS
Vc+ulJvwaD1a+LhH6rmxD9dlMow2Atwv9CSR75ix8L9FFn0NfFDz8ipb9FUq
olUs+DldMDTPKz2Fi/0FA5NRulDgBThx61gC1olVYmGTHqvnJtOVcpP71aPV
T6HHKf2DK+U+649f4494Kd5ClEiBYOT9gJT4Nqy9g1Cgm08BXy8nUoCZPTeZ
Au3E6rNt6SQW8qn46ntEV/+2B/cogvrj3hGIGcQJhOtEXTlWiwV+8Tgo8OWA
ei7bfTmwnvuKr/pyDapPf5tKjzn0ivru88flPVGSyHdBDygduoZ02DdQ3lef
KuxfNR1qJdIB3s6TAQ1IyLsJDf7dU+wO1OzbvUR/GQ0+Uhpg/eO9tU/WtWM9
XwyQ9WKV0wfXT7sZQ+oTvF/T49dD5UrzYy7/ZdpgIQtI9YWS4/P+IK0wGqnV
G4QKt4RU2D+kQoISuKm6VLghSoXhcQrc4VNABN4oMNajAJDnldMF3KfS6qfJ
6nnZM2mx3zxR3333ZP2U++6p+lnu+6capNz3TzcgGnz3VAP+Iyhi9ADpwDYg
5cRHWdh8GtRQGkAZXpVAgxt/Dw06R2kAxfeGqnqsH9w48j5ReFBZkAJIgL9+
3LKte4a37m+frI9lu1m04NnDGqTd3Gca1HA/PNvA1cJT/A4U4dfh9TOVFNMH
Cz3BYTAr1wsNbg5pcGBg7SEN7f9bNOgapQE0AUycv/5PvPVPjq0fmPvr/v7p
+m42rX0OrRPrnUcr//G5Bu6n4Q2y3U/PEysseL6By6PHhvin+3F4A6bOHHrt
LNDmaeYd9+0TQhd8D9HcJ4dsnQ6OBAXanJIjESIiSUcjyfmZJLk7QpK8yknS
M0YSTzFCKUAhAi5WhBCFQfXcjMECKZYwC6QYVp+XhiXOIzLMp+Vi2QtfaOAW
vdjQ/fxSw2y3+KWGWW7xyw2JRfC7BS805Nfh9UYafA5IDJJMHShm5jqhyU1x
mlgIBzSBt2QeL2hyc4Qmuf81mhiLTDAW6S/sDBaZoSzy/VNCD58tsM4FSo+f
ae1ECvfLyw1TbukrDUl1LqPHZa82dMvpyubHPP7LkpeZdG7hi8JF+Bh8HLgO
XAgFAzhIkq/1qCTBrtYRzhFKRbd2tjcQR8Oj1OWgVC0OF/0nlBrvKZMvVJhY
gQ4VlME5c4hSoJJxzALmmAa8bCz/l383ZPKAKL++Rtfr9Pz1RvSzkVtB18o3
GqXcqjcaudruN3r87c1G/C+8FBTF2xcbFV+QrwEwAAkMTDKulOsSUu6ICH9d
5VHOorMdz5KNxy3nSxAug3JXxymXv9uUm6wyx+ZnUKh+TeawDFY5AV81IL5q
wFRbqlQDGVYQxYhKbhWRZiVdKbfyrUbEZqvo8Tdcbzdyq+la8zb+tpYe89ya
t4SMoDAoD2YEKSG3PgmBJln19h4J3ZFBXPsKL+zsU9DiVyyp58nWrefFubxt
i1PwMdqqZVKwdrUpCAn9akBUiZuE/qB8t0Cpt+TlBrzKpR6/rSTqrXqjITPW
6reYUim3ekQj18D9Ro+r35FrDV1r6Vr3biO3nq51eE5/BzlBTLx9pfIlwPlZ
JXrus2ILiA+ViJ0rICIIePWpUSJef2ZuhhDf/i/Z+95L6q737yJiHY+IdQMi
wgOarmo/EF5VcSAiWBDsZwL7KxFwhRLwtzcbMvHAYmtHMKVSIBWx23uNSP+t
oce17zV2695vTCy4/v3GKbeBnua7DfTLODnxQStea8QoQaxBRiCpvOja+XRs
LcHqSmmYKc4IVvvijHgWYj6g4WCmYX4CDQsqpOGkgIb1xEyoGM+OiTEU32Ji
wqWvxJmvIXMRlg8yrH9HuGwD0W0jEWrjB6AYHtaPbEz03ECPG0fJlXKbRoGU
G0fy65iw698LuRTkXElivswjJwQE3k+7KEsGMSaV5WtiZPRDhbC+iDUF7Hhl
KNMInSGm9MR/SMZvVZbnVCDLWBJYECRcTSRc+3bDgHwbaPkbmXyN3KYPGrnN
I4l6W4hSWW7zh43dJr02fkS/3vRRY1fHbabHLR/TRT/xks304k1KVIAAMMDc
QtCGSlABl3hTaSlxn2NYvC0X0VZjdnFasmhXxpbXIGAsbDmU2BLxneeYlrV/
Fy3NqkCkyZF1i1SkobCgD02UQcf1tNINRMeNRMdNtPLNRMfNRMctRJGtRJlt
RKHtRKntRLFtHxMRt45u7Oq7LfS4ma4tY+hldG0b04SuxvxXn7iblLjroRVi
RMUtwfuJUPT4cOuk1Gx/RlTAO3kphm7GnZdEubMvuPN6BKtFyJ+9GYGE2rx9
/D3U/IGoOf858f18roRwr3pduHIdUROUNCpuISpuHdkoQsUdRJqdRKJdRKpd
n9DzT5q4HXRtxzW2CQn5Nnqsy8+3f0p/Gyt/Y/LS+7Z+LOQFD0MRQK9GeJXQ
nSd86q4RsnZS/Rkyak4YlIQBt925n7kxd8hj1AfahIyKSNXQG/M5Tm5Cj135
W70Kqibr4ChZf/JtDrk8y1XYf3sDulIYFMy5hUi6lUi6jUi6fRRdRNIdRIad
RI5dRJpiImnJ2CZpV0J0y3bF45q4XXrtHE+UpCvNz2q7nfS7HZ8KxYW6wrjM
sEbVd8SrWvmGSD8xaoSgRzNBrzw5R4I95g1VQEyfT5Fov8/4tH0eh/7Apwh6
IXANPjWpx/YeIT5EbUNi1s0k5lMi8eBR34BXSkzmzUaZvEl8WTy2MdOxlChV
Ph58WT6hidvDldFjKa6JTVwJXcV07ZpEPyfhNfhXvts1QSnuUZnVwoehKjDq
gl+h8WOkhQrw+TQoMjg7J6hxuEULDXpcmBsJooNPETzvd61EVJ+4UfI5zxOf
ImwMPkXkCHz64QN1eHs8Tsn6mTqZiG7AtsMozSWjBNW/8HmPrK9WTlaQdNtH
rDDddlr6jjEQdSItkQOMWULkASnLJ4Ipy4l4Wa58Mv17cqErn1LoyqYUpl0p
PSlwJfSrkklKaVDWo+620U08qorjuuKNhux+QLG2jVIVZj/CrP9IpihXI1wk
2RdjVmy2jVnhfYJZnyNmRYbl1Z6SAQOzjrxPJB8xOITHsGWUjXW9YNNjW0VT
phGzRLe/lhgDFN2kFN2mFN2u1NxO1NxO1IRy3EkU3UXkKFamLJskVEyDjsS1
nxEhyz/Hsy8KSSuUfV7oSj8rZNqWTDa+3UVvrMkfF6co9lRLXmEeVWJ2VLtv
wS2fRS2S49fBCDGjQS7keJhFr5O8DlgU/tPz3chC3YqshlgohHbBop/0URde
998gJvZA36rr+YPZ+RdVhfo2PoGY25WYYMsdTMjGLKngKfAX6AGeKyUKEStG
qUjPvsSzr/DwZSEJfBmR1ghbMoWIOllZFOoVBFVjhb3Vstcasmun1Pwb/0i7
7lxfX660jSqBa2LsmkjdizPZ9VGPXZ9WdoWhQjIQ7Pru3WKoEDL8VNkVznKi
7VcvCnty2P3Qg4pTt7EYJqXuTqIsWHSnWiGW3olCopIpQjKQjimbCihLNJ7K
PDytiK5C/pdH8lwmeSm9j7UCPtcjNW273Arapv78ckOl8l+lNglETrvRHqlb
e6S+OsbInf1agX8amWVz30sZuXebMDwCRrY9KfIVYGSYsBHKyB89ICYMWzto
hUDPqvNv+ycxXw0Dp3/1m7JfgrOfROadSmY29uNFSe5Ss7SLNEExuBLcCS79
UukIfTsVdC1SGhcRsacXkYYon1HEz/hS8qfwYnlfTVEdEwsDskNlYH+2ithg
yatG8r9IlFNIjuMjC+kaRZeRHK5YEmebt9BD9wm3q94AZ2OvYJxtYQBwduCC
3Sb5eqTGRilnj1P3y/QGK2Hda80zj1b3Br+ySRNymye7lci9PUbuXUpuKF1w
ILQoOLp4ipC7mEhdQqQuJYKVEYlToGQKJE2BvkSQr4tAlplF/AwX/4F0iZC+
ULiePgJqu0wpXqwUhwO8hjhhOQkhBPTqOMmF4mn3Iz2+p+x+hNIdMax2MTa/
+byo4fNpfo8XfrH9bsDm3cO97jt3macmCRiwObsTAz1drftbCxGYK7HqDQkL
BDSnnShoviNCc3EdQHPo5hLVICXK3iWgOdG7hNi6lPi2bLoSNQX6pkBsIss3
ReD8b4v4GV8zgxcQ/XNFKkD3z4XupUp3bEDW020h5EhL8EnOiiVbSV5Cj3Pp
epuuw5XkKGUBm3dAUN9j8+4VlLEECjy2JfZ3GubBgc3Ng5usbG5axbbB89U0
LvFM4xozi0buUUJu3k145C5RcpeSXWPHQTVJqbI3SF1KpC4l6pUJHzNFv8HD
t6xQvm3qyr/T63v5yX+zV81kuoPvoY2U9uVKexgPxC9gO2kdF0hwW7SKPtsj
jsUeisVOepxF16t0HaKmFRE0uCzXxdi/W0J5p7H/A1d57oqyv2xUhP3N9/sg
5vt9ppuUr4dWouFfFw2/To0osNgxytvZEd8Ve1iUMhbEmzCcqtHLWM3QBbZX
HEqJqmUCQtMUaJ4G8enZrKbAZHZTfsZ4MCZFgomrJVIxQ5V/DJGSCYXs0yNE
BI66kKlawznPptpz+q+GZ35VHZXrVVMx2kaP39L1Il0HKUZwK2EaOAl2dmiF
US5uJuGOS6NlX6aiAodH5SWy47k33PGYO/nlAEnlwNmZXYVJkB2O4LPzIwtk
CD4lHj7QG3BqoLthM1mnTFOTOkN1PlG5jCSj7DuAosikAAyhM6cp2NswmsXy
QijVYpzYahg+XxXJtxA3lE8q5HDKZlKciLteFAiI1O27fRWGRQkwbKbHGXQ9
Q9cBCgMsBRwibDwrKk5jMbk8mro26zz0Rs9K3BbbIgU+p6Snp6plhphUZiHg
BG1+TxygnaqudhIEGepqcigiEQiM/DNV/X+rAqDET4H49DAXMPzAMMxtyoDg
4pcABsDyTQVQ0DcjagB/AcJ9sVLdFxHVWPvrn5YmALKeHqc6nAd1bj9+3bFc
Tgc7AlcplIlMNwkJYpYJ3WY95nmnz97i2ZBgi6WRqr7hfnWGmuw5tvuHzno5
U2dt9HSWgQEfhd2j8RIkwRa+1PSVgTE9AYzvAjCE+4XkcxkGAqP8h2aufF4z
6K8fm8GOz2uqv2+KVzF2MCX4mG+aykf76EAs4SCT2BIvVQLMgfqnlQnArKHH
LxxO0dju7TgOKsCg3HhOTlRKLo4adkjJfZaPbq8R2piysqiXvzPj8KHnv/pS
8rNKya+aHzDfdbP6rTAku8hF30WqYZcFCxQU+E62LcgAhaUjBsqcpiIPAkaK
0UgzGuXz5aJ//YQ/0NMC+cO8ZiFQc/RzfIRsnwEGgQKl+8T9Z6ivgxWUtQmg
rKLHyXQ94tQPIK8LoMCCQHVV5txCUhCQQGwXdd6Pq+pCTffzgYW3eFndyB6O
JWVw6NyapPjbZEiKbZG3fSAbCUhKMS20+FOREtlEFIpD+7l4V2U+IDMTAJkd
AsJIpEBvIX0WUHDlC/Ra2CzNTwrk1woVozO3aWhovlOtZqjABSYXrBTxyw8U
EU9gnACAZ4fqnzYlYPMrPU6g61669lbTgtwlzIqlMGyzFy/mxiEVvwSB45mq
xVBf/6qnxeB5VWRS5mqc3aJtv2rskq36O+GemoXF87h4g0e4FCsuvKmDp5WE
S0xzMcPPaxaAkmLipw0Rvuhfi/AHAyhPAJrnAfO9B8wM8cbK1MSQzv1ngj+s
Xtfhisn2BExgccYqjH8K5KUmh+1v5p1JNGgnsqKnw0hW+qBUWWUF5yE4GtpV
qnRRhD1CzTwUWNzTws4EQTuOgL4gqaT4rmSz7Uo+tJB86GGVeHKCTZ/tQsp8
PL6L4THXw4NYP6VaaoEQX3Bw5T835yvFj/S7n5vJ7xfxK+h1tURwMvBRoSEj
w3tGkuitxE26STxSgShOAGIxPX6sQOxlwnFaTY6iYosYREFiBwHslMPD7cS8
c9HsjVIZj8ManOe7UyMhGkGN78i/Y8GoH2wPIRgc1Odcnpp2CIZtR8aIwkLw
HluzUjXrpR4IvA1MAsG3HGYuREUJAtlK6eYBCuWLGYklzVP8NK1/aMZXil9e
Sz7jR7UwPiQzZfMCHxD5GmR0z1QcDjrooMDg1xeIWlcCEQJXIxWiPdUTQ6yQ
6ywuCMsVTXeJkZeDDJI1kLNDgzpKbbe5xK9qsAq7ko901+gHqmwHb5kC5F6Q
zvKDJSwnFpwaLbt2yAkyARnwTNWd+te8Mwzh8ewIk9HgMT2luLBUCBZZgMWV
/xJc6RCnfMFpoX7A/AR8vhGLzyFzulFULhwi2mu//fYDJxCN999//+A64IAD
6NsPPPDAFGOXdocccog7+OCD+WfKHXHEEeS4HXXUUe744493J510kjv77LPd
5Zdf7nr06OGefPJJ10hQPkZRLklAeb4XKmupsWHECbqo9xDxHOyokR73fMgX
wk61g0Sm72d/oJuecZ42jPvYtuGRqG/DICaARDqEcPvHnhBOQK6nMNhrchxg
qoS9yhThMiCcYZEU4Z8ChENgTdx+aU4ILwWqv8jvYJgWxVENHG8xf/hixOAI
0XXvNTpIAAVe2YwVDqgbZocffjjhdthhh6UZtjx37LHHMngnnniiO/XUU92Z
Z57pLrjgAnfZZZe59u3bu65du7revXu7wYMHu6effrqx4Hkc/8iO4IkLHmI8
HvcWXS3U0gHXm84LcQ28Dk9yzUXHcdyBHcXrGKY16HE3neMJqlwjG1lSrj+p
5MIbRKHE2rjkfhRKbvF4zeFN0YjLlxqhn+7tk771pHauh+n8CKYZGpSBXMpq
dBn9Zblc/C/+A78EMON9i/QzfopB/X3ogyDLsEZhJvkiLBlVwHn00Ufzz2OO
OcadcMIJ7rjjjmNgTznlFHfaaae5v//97yyhF154IQN89dVXu+uvv97dcsst
7q677nKPPPKIGzhwoHv22WcLBejj+UcWuyz30zWJrnWZcb5X6Gqmsov40U1B
SaYfqBAvxs6qmsc/uJNfgBD3+iVzYwkyi6+yFxN4/A24UhBe5XpfbjXViMjM
LosRTdaIjQUnpnne5LcxrZyE76IA3xDZFAObrdASq/9qFzPB8uaCfD5zATgj
8G4WGNL6bbPUfJI3g6IRZBoE5oYROYWi9SE966yz3Hnnnef++c9/Mqxt2rRx
7dq1cx06dGD5veOOO9wDDzzgHnvsMTdkyBD3zDPPuOeee84VCcYnqHLuTSBO
oWu97PwiQcLn6WqqAJubGtaS5QXnww1cKGUI71A9M2gB9Fc1IMhpud51dI9d
V5VyPUnSq2dkW4aVr0mpg+2tUR+GEgck5DngocGO0oqE10zurJi5zQC2mcAD
y6qwMn4pwEn4rmjh6gbImiAzqL8kAeuBqnZ3K90pTIuA2oABROuQf/zjH+6c
c85x559/Psvmv/71L3fVVVe5tm3bumuvvdZ17NiRgbz99tvd3Xff7fr06eP6
9evnBg0a5J544gkGkxR0U19ma7irCLM+dH1O1wZV0GUhtBZ4HEZXoUILue2u
VS29Lot2gHiwbej0ciy+i5x/f16L23BsN7774GzrQNHLszh0Uj/qUb3eMIjv
cunfKK1c+USS17ssqFgdmfWd3IphjaIKPUywlq+Ui363qkUKT+X3+QL1Mn0n
XK/F+ommpX2IieG2kaaReEk9lseLLrrIXXLJJewUQd1CLq+77jp34403MqS3
3nort5a6//773cMPP8ywQgU/9dRTUMOAtrkPa03XlvB6mK4v6dpotpf+8l0U
3g0axhxCV2N1nuFS9bhQYsh3XRbdz/RJgBeVoC/2CGPISXsac5ijQZhQJdt+
BhWyqG9BLeF21CaM02qPyZLaikCbJLW+Og5MrUK7JIBWZBKgQU5XMKQrWxiu
vwHXVXggsPPktcuUNQzcRQrsPGUr9bC2j20iuNZl/XrNNdewfwQsO3fuzFh2
796dRfSee+5xDz74IJvTxx9/nH0nOMPkP7nhw4ezyLbwQc127Rx6+jj3FV0W
ykmrXp6b4DSvVbnuR1dDFd7Oii6cZfS5uc/TyX200YUl0p5SdF+61SufVJ3M
2yEyuJbQNEfZdqu+o8w1vORQoWoJFSCoZ0T1KNfyIFes26AgxunHN33B9Z3j
ypFNMawCIWHJV01A62rLv1eq+Y2Aqx+5IAYsMdyOT5pI3qWO23fffXkjBE+5
U6dOrkuXLuwbdevWzd12223sI0FQoX8fffRRBhc6WJ3jFCviNP/atrnNozhf
S3g9Rtc0urYoptmK808JOP+m4dWH6JId85EcoTDnGbbXV9B2kr3f9Zk4m4KW
DVEdTVx7tlejEhyuU8fZQkMo89+AOvdRUgW8lRT09nFSUbQL9QAaOuXiiYhy
jknwj54Em3KOYpyEbxr4ktO5mkH+Tf+wwrPEgRWOg9yUNcuuMU32lX0RMK7P
uyN4y3Cjzj33XBZdIIwGXvfeey+7S1DHQLl///6skiHCw4YNY/cJYox/gxta
RSG+TlMUsK1bRSdrdkOCTnGIV9DjeIfOMA7uBUOMPBNE2Yc4UNLXhF1RfIhf
9iDmFEafqA3+2ktfBDbYEnxvy7mjDaSkkfNHff1WUtLbxyvEUzTiFxdjf58b
d6sWxmyvifCK5qyTEcsAir8FVxoAkzSsgapezdbX5HlF86gljsP8jQTNi0c3
kSyE4FwXoQveEVlsAqYYahuS3bNnT3ffffcFqhpYDxgwgKV56NChrKaBt4k1
/m1iHcP8eod+cM7N9DDPUcyXVxAF/kTtdh0tEoLfZe50BO92+cFeaVAQ8Q3x
TtwLm88V2SfJiSo+CTQixHtjgHcTxnsHqtc+04h7kjjPjomz72st9sTZDLH5
VSLFjCwuxjgNtOlhLSBfw5CvbhFKuEFvqjwO+9eSW9yHSdiYMUfYCvth7H8R
zLj44ovZj4bDhagUdDgCGkC8b9++7HBBYUPCocvheNkGCVIOTgCH7BVF/AZC
bzBd39C1TRGvpYj/VkG4+SNFvLZKOXbIPuLSiiSfT6A/FuyOwxh/EuIVuWHx
sDIjjjNbI/lEktuMgwdkqLeRod5BCnwXpAexSlTAVbVp8t2vJZ50K9oq1ukA
4CwADOW2rgU/C64krH+NY91MsIbamVSoSZPaga1GdAtxjtNPP50dbjhn2PjC
ZvuONTa/JOEpxQ9CDoEG3Lh8QYefBhYJUwMB7B0cegw7draR3imlK19hX19F
CDtPBR3Br/AMlvXcyc9ow1GZoAN2nMSYFvPPfLuNUw58qJTs9noc5cPpHbLb
W1C/T0p9xxRS7qTUi1G3lyTkc2NCvtAT8l88IQdqqskzhXod0F/XEky/xkM8
QF3fb4gvVMTBdtjDT2jyh1Cf53IcE3YboUqEPK644oogggXXG/r8oYceSgHq
bC0sAJyAV7dTge2Gvv9zFN6ODn3RJaa1Q+EtUHi3JMCL2PW7Cm+uwovMRHgM
OYS3r7rfAzVhtDvwzrV4pmXscKITB1lJh68lHb4e5wxJh28im71lvMFLbs8X
UpbJGbqqNlRxd8zT36a3Y8ji3wRt+Xq50vyYL6K9Ji7enmgvUaDh8CPDSpam
VYhyfsRqIy5y6aWXchzkpptuYi8NGyz44NDfkGvo55oKIVAGwkAayEOv7x1F
uRMh9jRds+naqSjXVZR3eihblLNUI9lv0CUoH85b6DjCj1q+qYP0qbPDlJUh
PN1DGF4ZW2mc2yWdjbruOMKbURJACG/3rHTZNNXZceFN8saWNIvqaxPe1S0C
TZ1WqV3fkp5tEERbZiJqynppTHTVF2vuI4pEErJFsMqIdiHChS00rDJCIIhq
mR8GRKGxTa9CPZvflYDkM4oOkCsOtknRjKIhuUtl+2VnBRSHcxjzrjiS12rr
M80cDqsKycczkbTSIDRMwDn/tQnWdzsOZeCkwOeSKWQjNzNBTndDBTNOCiJJ
6foW6QBJ+udGPJDM5kXxXFkBnnPFySqe0KRpzO4i7wC7i/glYpYIbiFOiZ0U
dlHYQRmaJKetfeDS7kYC4Dm65tGVAiwNEzKEhtp29bOGOyuxOJxrJHpdFkXt
Ma8u4knLGu0mapC/FZ7xXEfGcwNOEuP4Kw5s6qYXdSmRwIahFpe9ampW1pnr
GCtWqxtasOjhSuExG9BBJKBr18Wk0YzocvXFLNKhblNh3IIiPwQLinjzlVde
ya2rLVEAf8ks6LFRaetM9H+Brh9V0nYGocVk3LboLvipIMhxKDs+CExZo0GT
NHZ4OoeH0ULMCoJK++pghoOIGz6Qk/c4KY5Dzcil7JootStcljpVw4zfeEGo
uJQl6soWvq4EDikzfIYXgZSFR3rYxE7PBrWPvk1cVQFm4Jfv2fFpFDeHrVu3
dieffDKbQ+R4EHe8+eab2RwiYGEhKYgbnKDjM6F7iS7EmErUd22i0L2jJtB3
bCx6PMhZHPJQdmruvUKh037FdtL9KSvMrwy6mLn7yaB7TVp7YEOKTgg4C711
tBzi49zOJKko5rzOtKLQ1PkK0he1qpSjuCwsVlgcQQascKXxSKy6ORG6RFdG
k7Y/SKxp/buN6sft3pFHHslpO6TpEH9ACgAhY8QfLFRsngxgPCkKXReC4N90
LVCYsNssUujGJ0BnoeFHWbXidQdzHieQOMAWP07kHf9Mgg27yyTYuGpMYUNw
f/sYORdbbLlWDuwXVa4hF1ZTOyZAtpmlbTOs25aW8NQ3iwjyZdAl+SwGHaR9
jmRd63kGDkEEGDhkXJFhRRYHQQQEheNBBMBGP0+NonYTUf81J4fvgBB0YTNF
7SuNF4SoHcoxAyTXkYRFPMAqyG3XMEjrL+OHdYFWUiwApyrmBGg1YLTWKlqb
CK2tHwlaKExGSRnCKJJh89GqTDdWpReTkNrCv9vakp/hSuGR3RJ4JHFhi3sl
P+uegXRkyWeFBaGg5XHIHjlypFRRv4L0aUVhABK2M6Jo3aze/c+KFvJqLRSt
mRloHR7EbHE+6SEPJelOoaf+TRXejpOoBZwXTURpWBQlrjDjfKikuXdo3VHp
BA+l6liwxc0yIzNReQpMlkLEaGQDIMNlE+OyUV+5rhJszFucWZTvuxsItMN2
WaAdeVBs2GG74hv2f0RBucVJ8dBiBWUdXa0UlFkZm/GD3DInQVXrXTxAW4VE
DvDdhvqDAvfBvZqkjoXPGIzhmsFUMDYqGFu51E9OvKCYhFsmJIHhO+1xm2Rg
ZNojJnPKzNBmlZGt/K9t8Ce2tmTzhDBjRWAsV7U2XzbWKE/LrcgcIRyOjbUf
Do9vrKHjzo6i0pUoDI/hFxWL1XT9QVGZl4HKwW6Jk8Dn4zeEx8OswxAXYt4p
jVtQiDlO0xVTY2gs1nwyMo58UvV96W1j5T2oiy03c1MRGvMT0PC9g8AJzxAL
lYWtAGGbPEupuNALckM4zNqs8uBYqH74jKKcmIFBlBoGxqLUSfthA4JE5Lwo
Dt2clE0uVRxwYuaPisPCDBz25d99AGdcS61e1F4vltfHAQtkfnGU1Uo2Zg8L
K3GWaQHsOj26alU4O7VAHCWRgbmP039eAv3j3pmvljYqbbMigmAIsES0kj9t
ZpnZzFKxSZFbnwDFYs0aoDiTOKVGku3wQ8iVbGX/GQWiuxJ2mQIBwfizAvFL
BhB/45jhCOykvKZQsjOty4UVOEVhqffvNF+H/A3iCSsj9TLS3IntAwCYqLVt
ZsENgLkxAOK+1oqYKvKYP+UZbkZgW0sVge14IBDE84pCkaP+lwfDSlV9P+kO
ZxqfBo+aCcvHWlwXu1LEdW1XSuabzcTFUfrf6qS9wa9Kf/jJ+yj9V2TsSv/G
r0G86HVc2iUCjdutZQEEAClxCICF1ZEr/fW1mAJSc1Dse1BfxqIBPvPH/Vzf
JifQXukZukxCe/xreysmu5iJ3JDaa5Thf1WG1+hN2cQmlUVXsZ30o6vx7SSM
wiVRmt+mSt3oi3IGO2u8NoPmf+FowSzdglrXcMtXQuHD/CI3PU95fakqm+Cc
/Cip1QWty6z++jOtvZ6uBx8Q+ZxbiQ8UVzSV0rqVcff2VvDbPZc14HdTNwGP
txBcYXyxPf2qMCMhaaFP2wJC1SdsAS/3qZ3FlQHonbJKqLqfEnpTBqH3DkJl
z9LlH5nzGfonj6HNv8F5xV1kTXHirEy7b5Vq4V2pEpkVyixVKL42T1ImlRJY
iAvSppSZib6No5S1HZy5OMvF/4+n/fzwI3Zn0Nnx3Rn8/quiJO2lvqKmag9Q
km7PIOleQRQL54FhIH1+Nd281DsGivrjXaQbysYQOdEZzk5QgZyf6+lCC2GY
3x7fBxu//tYi4qtnWkUmJVMRimBHKzOUycQUVjW7Fw8F2p4JocCEPVPbKAnv
Jnp8qg5geXhyF1siC72bycN2CptelMV8oX2OsPVBovpnbVgK84ZENcQdR5qL
ybco+RjkayznniZr8G5abHM6T8V9UQWkW5fJiaFDEXKi0UxMWDqkG5NdrJRp
TgvEYTNjgbj4ZqZ9lFr36o5xjZDmIKVWn6slBIqYnFRu1uJ9DgI4OFL7WT+c
GKvHgZcftTepUQon8lNsjhrwkT3IL581Hq+JhSmFUUdgljLbIs/7hWFeo1Sy
DeEmcW8hAYHdb5XBVLJrF3fW0jt+mKuyfQVx1nVR+uBwwUTnzHocrL9+WLtp
YlNdYiSqzzyHaAl4kJvJD6nPJWz4iROnIBMiw1aQiugwtxpFA0B0ryXmQhat
VBpgkcfUSmRyTlOvZlid1KhjmslE2/Sn0iWeIPHjR1aEkuDed4jSA3Ggybrp
DehRg4N44Bebp4SQUECXIrbH4+AP3S8HEOFX+g0fbCYBDiHiDIUIoOgusBML
Hvk0ZeN0QzVNBc0qQCBoy5pzES1C+huUHFtCMsSVix+QgVONgEyCU63DjI5T
B6ONk9r1z5wL6ioO0Xw+wmL9dWgNYs/YVX6gMQIhRHN2xvF3f34Rgp021gUn
NdEqDLWv72ksAHYS2ulr7DxJsS8hOeN0AuodUSYD7fO91qkuah7avd9aeFoi
Gq5HyMOvUfB8WfavwADYLXWJLv8aJzXeaHdgpfty0rumhDds3F6HcMTeZCGB
6Nw/BWX8KCO0qV29LvMnX9YKDkqi3dHjWk6I3vJo5o3tCCgCUzeH2GQeXDIS
HfSSKyaBKf1ePQCiQFJYIcmjZMWoB3ptN3ZTdOVWCO1Xtx/Gf8vh9iY8HPF6
mVwEJsD5dCxhmnr/cvqsbsYMuqA/t84m7aEdbe68xDo/aSl8G4mQy7RFiFdj
3i5jp4BpRxgngYkl0CjLiRybEZWjZfib+Io8OzxnxbtAEwb0vpujy7f6YORe
NuvyD9fykke4EFAOx0EPAD2g2vm8XD509Y2QIMVv+qs2ibWRqd7Es7PCBrFd
tbdPxhnLK8LMKijcVykPnkME2jq+Q88gfAbThJil7ZqTPDDZmbSQrNoC3Z18
U3RLlAConu1P13QXFkgf4Qk+oq3AC3cMbK2/fZYOQLPRujyg87ToELvOXvtG
4G9zT+Oz3mzlwQxCje5CRIZ2khg8Qlc4nYYdDHbpnp9kWjI8ELa4WZhpIMy7
RpdsxaNfu7B41E6u40gzQEGb/mxv2pnNxI2M4/X6pwezUz2A/RGv1lbAn/v2
kJ4A6atzSG08IWaMIpWOYDbObsGYoKgUhQwl8C/mezpxflNbZrfoKlEwiWzi
zIRVguA4zI31ZcVXeVKUjeOA+n2OTajjoPIxJjsN4U0xtWJLf8XW6AJxSlgK
HCHG5IeVZAlwzj7Y0s/izXX36CpRH4gTNzgzZ2WhR+kqbYW4UhWsss2pmXNl
k/u6eqv0OkGZGovMww1mzMpKbRZuMN+vo/SBRT9HCDY2OKtImIMo3rTCHtFV
dtTt0PdOMsnBKoNZrSfWjEyM9pfFI35jzdTDTp9e6x5jU9VHvoYOATT9lB+M
z5XxvjkMJpYXLjGf0wCI75SPl9D9rdF1oZzoKRct/2MelenKf4iMLZa15UTn
0EIEdey239u4oraadwdrE337gLe+ELZQJHlGLUYDY1F7sHQOvEF4dqBO2UTq
aQvtmXpmLg0n/ea4sObtiHBpe0e1ysk53P/W74PvD/v2NUxFS7sntrQIbJGl
ycjafip/WNkAHcPLU4Q7YAgy/Lx0MPEBS4pBZwVFP+j6SsxvEJb8Y2yajMCG
9UUa0svc9QyJY71iJtI3FsqWD1TIluFU59h44SwsKcWOW5Z48uzNszsXWVqa
azeed16t1KEhbtkxlszhtaUYvVYZ03KS1tbdW5uJnawtL2Ntcdwi05+vD6c+
o5iH1pMFlzvFK8sKhvbiolXHNAqKHNCIEMFxKy06JFxmOqIoUwzin5hNsdy2
p2bOYokus1bECAbLvCw0DRUt89H2wUDuYMj1QPW6/YG2w3QWcZq9gxr8fNhN
3kX/pvd0z1w2ajusLAdK5+CMZevSU7z4vQMONum89ozMeR/SV9ZbdkSp5mUs
u4+37L46dtlcbdtoBMjaEOyb5ACwjSrGEOkU0t42AXu4TsVG+2taf2ztqJBA
f1CrkNgWWbvMk94nWDxPOrXRHJ7IdjBXwOsZHXR3vdjHOrro+PD1vgnDzAd2
jOL8lOKI+czoRmGzssnYvKQjp3lcNl+S4USW7cUewiIxhwg1B8hBLNL1wyni
sJA3T3tvb2COrvt0TxXbsJygeXO4rwlFueJ1920XVU+Pe1PD4fQZ0E97QNs8
6pej87Wzg9na+PmqztVO8cvS/AFWwRvb8CDJ/6YLKy8Q1OZQYg2baHxCzYyp
QdEpN9KqNC7sGfbIiBAT8gw9FhPwgNMThozbLOAUxsOmeI+YE07l7iVjrG3Y
OH7CvQIxYpse5NSRElyiRMCWn0PSNuU2MuDYM8rib1QiAbGOexkE8A2wccAN
Jur5GRNxZU58OGEdIL+qw5DR9Ap9O1LorZRivzmLDyOOuBteNJ8xTjFl0vwe
Y4pYAAB5bRypsPoCBAStf6qF1kCUYADwicmKwRcQf3p5UnfI+PRynyz9/VBL
R6koMaX/zC02F7p2wA/RIe3h0OARNsk8xZG5HA47IRdmk715IvjdMlsVvAJN
E6MNUs3vuzDnj+yFd9wxHWSyQRrZaOynfJOTIDieufCdAWt6dmno5KD9e+82
nubwiDPAExj42CwwKiyogTJtYbxiM3T9aeg2LtxokuJDyjnB6HD8/OD+OsHg
9/e8SegxGiEdjBNXy5VG+PnnkEZZQapZsx45TKaDvAHxHh8lufOxHZjfhxcd
RjEEJjyJLUOL+ntiFeEfGzTdrXYwYljEScoC3tRhyzYwnieqY+SwzhkfpbPG
bVh8ioO9e/Ap/g97C+kQpAAxjbVikUZkcj90YfYceviPGmm0yL6fLLb6ra5d
uxrlLvdMc6K36W+CrGVbJNBUKyJ5j3qz5wPGilGMGauHjHpgit0hSjeTWrL6
YCq7DSzX6ew2gz7NmdI9+Dl+Dzp+rPPX8Tlg2M5RyiEriwaC1qoWNQV7aqgu
nvf1cyIIimqyKNcb4x4ZjuXxXRev/7PPc6a3mN+0684jCfwGQx4M9L4lpFw4
xz6kXJxqo7xZ9h/rLPsUF6kUyKh3Hnpejy/MtMXETJRQfPqIpBxsKDoois9B
1R3MRiTYL8nYMS7Ib7f0C0Msz2tZFIuv+lmlRx99NFfHoEek2IykxlHCOXjR
gKc1/rdouGn/ftflRXgQkgsXUBRb6AaZtn/TG40OKgoF6wQUHK0UZMo9rFPu
QbI0zwyfoFcKmZoUNyRMc9IGv0SYMcW0zWb6gzeB0nJlwo5RiiIvNtYF6e1m
fvkH9J+fmEG1k9U1x/NSSNIIR8tc7ctPqpkZWfciq5xo8JpmWkfGoAVJO0k2
9E/wM/iMlfYAY7J689bfyiBrlKTGaMyEfWW4sj+FfrL8TCG2leKIdT7XtePZ
FP07v/YxGTGPz8NnQ5WUq2MGo6Lz1o9VfwTBhhW6deGwu9Tl5zOl/WSxpYFQ
0pSUAHvooYfkmIUQ+oDIEPdICuMcj9AX+YQOO/kEluc6L0+m/BsMte8qhvnf
t0aJbMb4/RiRP/EIPKFvlLhTlJA87H4AGBhZtDQ9r+++1CvlvhpYnwy6/FsK
3AwA5LjxeeMelu+zGSqLXHi4Vicst9Y06EAnPecmqN79VUDg5E8DDwPoYMtL
+4kpJOz9VJxF7vmUku8RXH5SOEjepqb7M0orwsEOW1gt8uNxp1q9x+e7hXNL
4US/daeHwb1itz56IIrBeI/+YF6f9qAvKI1pz9MG1ycqInZdm5+jBTBaZiNJ
juf4Hf6KagxUfGIsEjDB56JxCAlalnfO+Q2FQmdmHqVJmXs1YfOiqpzZCgfi
wlxC45Xp5wTq3NJlKIRCkYBlCSEInCWsGe4BD8kMu/qI/F1sZTg1tlZkamwc
Ed7reRtdkwp4F892le3Ny+pV8FDjXuI7GRrQ5rCFn+hse5tQPtlDIoLCIKX8
EJlannIzn6ifRjFWimuca3ElDJ6hPguvCPAZVJ9xgazg01F8VEMBAdO/rIC0
jQJyl5MUIqKhqNGbofoLgNjby1zYed8rEK8VZO2tFBZlVRXVJOcGwQp3WCJE
fgjZnMJw1nStYJyFzPSKdoe0JkYDPAfQdhaWxH+5Z2h4R9hY1fsUot5qGXyI
dBw6BMXgCaDR0egAAiedkNNL8VztLK70+v6pBnalOQGcy//Ey/Byww/yNVUx
w1cRpxjNSzVhAlyujkIGVxLVPjiUjkqGqR5k2R5kuxS2miFkeUG5gZXO4kAn
qrj8PKyXgc7zUYvkaE4JA+IZiFnH5Qt9BzQBseuiiAWbZHPXe8qmmE3N3bKX
G6lmxuy4mRhWb/2FlEBr2qBQiGZCZJ6UmY5AB31uZg9rwNPE05iInoUyoBTX
5+VyRdAc+utsgg2vBGgAjMEaJNW+9G12gA5URi4djSCuigKFzSXKUp5QfwBp
vmUxoIrVIRBLVbEtsp0UykJQbef7A7BJtcPsxRGRKNhVMaDanZ7pjJmf6/fo
RPAnA6wbomCJBpR+Ya/ovsqcLyvc5fG6fcTzN1sEOwTbAc1nYsVj3p/wQWoQ
gISh9cgho3CAzMvzDbK5zjqfT0LhGSqTgJ5hN0sxg5yiJAVcAXcYUuVPNELd
AJLpV0QdBpSXoV3POypdiKDsiGJm+jDtYWZ1XDimgdrdhD0cmywr5akbi18f
EY3aIQJzRuZYad97ttitNfDr3SYBsI4eYJ7HLCZLtnLvqqccmCuVrIgeVMkC
WKDrNwqWDxQwQFU28AAuwAfVdQtfBHCLXiRJW/RiQzLyKCPDM/zRQJynIELo
vlXw8GXgFhB5jAYd/FlIX6ouvCwK4D2KKyLmqPxbIFKXBKD5GrBlCIZZiTAK
8OJbR/Y16sdQOzJArY2KWTtFDO4famjMBfRdcRkCKiUVjFrbKGqDtB1usIVU
C4aAOeLEb98VRQ0u39iHxHpNMhF73GbaivZiEVPxAmI2ej0JLbQGQqHtkpcb
plHbls2FpHl8lhcz0QDgwhdCAPFZDNyT8j1wDyc+WjelQvKlC49F2oF/VOqh
gzBckEui+N2pXslrCvEvIoDiYBYEStM2TjBoflkyCouSNqgQQGkdIUFP6ElA
6PvuAYinhyD68amI12jT3K8IxwhwOy7Ph+esgPnvKnqZbkidwKjBSzSD9ll/
AXBqTOwYwKdDAH3wMP2Vq6QJJIAF2HBAAhOsa3A7oNp8Og7P8Dv8Da8xYCGV
+DxMk0XRJ0QchpTuJUvB/Npldm9Yo/srvOLiKJg9VUbh83+u2nSngSnl3ygH
tJih7XxRV56w820s3gzgOyaS8LSUz9WneWUISeCpL+m7/A9cVQl41rm4mwde
xCOJgyengj7XGd3miXyjU6Vn8VBTUXWQPACHqmMQPgk0VNuifnDl6w1TaOWU
hXMDeNaIiLfi9Ub8guWvRdFcaCg+G6JInmYNRXBWAoIrXThrRuYFuqM1eAkn
BmdEUMD/k3qWAl8OJ6Ir2ygDOgl0HC8y50EWmLsYZKY0regn7kz6uzS//R0a
8ASQ6RAA+CavqryFfkmdwC+BW2ADwO20ge+PJMnawhekEDoC1SvSMBGHsnHw
Doc7UHe/+i3pR56N0zMpbl2Rz71HVr3ZiEEEtgYhPhB8gEM3+DIcwMGN4Mas
K+i8BOwssIdXXBDF7j71TYHdQsUurZ1kS1SPZuynuRuTOy4RLFaQp4dWLg6W
75uYMxlsqQ2s6ysAKxh7rWAhsBTxSeoGDqSBBcsWyBYmqQ5ToHRC5CKd4gmg
ANLyCkDCSUkcV10/gmBa/04jPiyhz9DQNp/Lu1ePkGHrqzwEIXgo/2bknpdv
B9ugH5v19VyUgJrFCYNNGtqGOmnTDJE7NapHYe16qWcKQV3suPpFwMxiML1T
Ey09mbOttl836DsqfoIvVJOxvsG6H7CGV37rsgDCrgVBB3AkeEfcHQ4uDB2U
uuygmG2zGfFm18DyP+gA1p8CWZMmIksNPh86AoF7DuuEcz648a4cBMzC+I4U
Py1wG9+T5tPr35PmMUBzTQxRQxLCDd7BjUjYRdBZloDiIt0oSCxdoILf+ZJu
0eGHoiEzCeIpAuiRCRkzGEkceMLZVMTPSsLp0Ni0WINJ6WhwYqT+zrbkgRY1
r+WsaP2djWa1dv3wWmTDEDajG0iIot3gk0HwJIaoN4pytAVMYt4KDN7XNpf+
KU8gh6tAqneCY3DLdXg60DQk1yYgicFvPOMKozpG4gQiTjPhWT0ez7JFLwxV
RXdxtJhBB+o42BBXKNpfGGThMNjHGUPq5SnGqzIwzmNEXleMP1C8X1OMn1WR
7CsYw3c9WXCWkwi1gr2hn9+zrkx4F4o55gjmWo8vARyLC+ypohwtSozW6oun
k5NRAmw5FhNjG/4a9iCpzWVaGYBrzT67qPeKFrYxl3BPfQ9n+iCxUtDAIKaJ
74Lhpn0buF9eDk0ktxt9U1uFj5BhsQz0uzJvZ4sCDZB3jGrEA2RTOCWZ4qf1
eAA2RmlhKA+6CuBwNYZBbB6Vif7qtzNRBzfSRqW2Ir4+A/FaHDIFum8r8qg9
e0Zl9AEnZ8mQDUeRhbZgOtiPs/mZSDvD68cBcGLrLXWnykLYS1y4MzXYLZJz
pZZGm/E1yDucneM6neMd0/Bm//bSuQ29PeM7QBsFW9M7QI6ggIXb3jbI7zfI
JUVmx8EsCBCHHAZ3YSDfDQKDy20NVVuvUSO7QeUaE1q2qkwb1LtwUoCu0o8B
e+noxqALjnPrleLJsAU8cBDHvNHXI4kLIPeCvtwD9A30DyxMHYXeb9NaQ6GH
6H2vcAN2VNPiLMKDItwMOQrRcNzqRIH+AD9r4adM7bAxouIZkQT6/ruVzea5
UN/74fZWvhU/yeMBPcUROmBRHvB1ve8xJw26k3aVMR4IxtaL8zXWxL6aPCDn
dMWYLsVuk0R+BeEAI8s88I7ywPsyymXrSJ1f+KGM7C7GWd7RciyajOonjV19
V0aPZWNx6pz+xlcTHs66C+NfxmTywsb3hQfwfXDVYGdwX1BN9RT/XRn45wYR
3aHqiiGY1EMxR3U1nO2PbBCSnq/Py0jiIrhusQgE12OxCBvXcat6CV97DLAt
gQEiNX0A//SakaJGzADwD7h09ya1op7PuijaDjc6Ay8E/7XbJd7+rmZHsLOV
mdOq86sJPvT9LyT8S19T8N8U8OFtwRhDNW8k4GGw0a9hm6pzTNyFeJfgPDwB
Wz4W4l/+aWNCZ1wTknocNi3FYD1Ff+cnaGoi850g/eAotC2DFwGPIpD6Z+on
NnutoftYBOURDr6dLhTb4ogAzuegtnyBagM5bqu9KyqP01v0wj/XBsGvodsy
KJRvvduA0O/lYx0cYqoZc+hy3I3nRg9UxFPKkSnJ10uH0/hcvFdvrxPsstDP
BGnjMX0k6jvJbHsGzg0CnBd4OMMlh3ldDkVLOK98W3rYYiIZd0T9QEeBfKij
uD7WabFj5MA+BJoQZoDJEI5vkoNO3kRgTAFHb4mST2XULyR9x8fCMGhoAw0C
awLJhsWBZCe1hq2hph0RY5xGwrHBa114dmBxiO0+njjDhlvLJYvlVxDiyFFY
H60EVq49PUUhPcN32WQiuX8Kr4c31Jcrjrxoh9867mnV3ajOqMhHt+Pcn2nG
pbqQwk2D7Vz5lkC66h1tMP2+tCZmSD/SEVyjRQcDoWLoaIKTj4Wj19YEhnUi
YJ0EWMsnyi9xGcTF6AUJ5Y0PRUfWdz3xfSGE9d9qMAGv1Rs4j+ApPhOczXOv
sHHapRDDzzrOhziHs9bxIjGLgliKJk9xhcv3mfc1UNHSx+wEts1ck3dqkk3O
CVxxqwUNkza1ghOV0RGHtYPKGws6Bn5Zgk3mYIjuu+K4/lgBrqvflC6qUMer
get72jgc3jNGfMCGwp7Crn6iYy+100uZYsowTmpC0E5uku3KpzRBfmWKtpWa
otdkxp5grxXAjo4xaHOCDhSw9+hGsd6TYlQxNFC6D9cNFq5hCmlK/TQf9jYO
aXLHU+zKlT1MumHLj/Whz4pUsJFWZm+sQP+Gnfj48KP3UpStxgqeV6bhzYke
TLw4N1LUdn9sxPDAjjHp7RGOGa7I8HK4S3fW1UV4nXpa61QRryOE15GAbfhQ
W1Sj5TF06qfS2hONwTAUuyxElxEkJFOANRs921I4C5ni7m1pD2vGmV6bIzIP
XiGMiz9uwj795vcau9VvSAQHKXkru0K4a4j616gLwnYYovu4cwG+lzrk95Ck
NREvY+EvVpyB8RibGiwV7nRnfs7HvL0xHscYroHkklY2IxtimhNgaho5wPSq
sLex7ar8ocLmUGET/Y7O0QqNbN2IkZ2h0RKLM1eF6UZuTtKIJzJvJM954yhp
FM8zO8boMCbMVRsvzXV5CHEUT0FO0cxCK7I0elCl8Ix/B9X3uSfME5sEwJaj
RxFaLo8MBXfW0/UbqF4FdkjeIedjW2Uo5cEepilGNYdxNTtZ7sL2xCa7E51F
soMDjv/Wl2z3QLxSBRNmNdGk6rHT2/6VGzGpfoGDTcjyPSUbeGdDSD/0oiAT
vSAmTOo3Fu5KAvCVTAA50oExhyNl1CFMKQQSx3F5utI4BXCidIMqY+Ai4ElD
UQbsK4A4FQ/TClFEN1VnJH6lbea+0DdMToDyoyZ8M5i/GHpQNTlEca+TUWNd
1WN6IsSQIfRLxAyzGF4DTejKbT5Oa+m3oALX8SzFKnZovefFuZ6ZrBWYSSuS
DCajeHUNr2ju4F2baqZB5yQzycHmamBlU6C32XRvnRQM04jJoxA0YLVjgo2o
xHDZJsBItGSWwSRoTC1KoVNOmrst0eMMHZpFV4ofC6QP0zSdjzfVQ/EzQ7Aw
QLCMHCf0Y8OtIvLS0CvsQ4AKu9ZO6vMOU/Q86LIjolemEGqVH/23fxTM2z0w
xf+RJCy2Ku3PqJnZayGiPXM17lzLy5aHrUIGdwpbjAd+z+0FgT8bWsS6iRYR
SdV5AZgNqwRz5yiJNdhWZBdpTVhBdMTapRMpiyfrONmYsAG4qTIREmAxcGl0
eMjmdmMF0h9KYS2f7kH5RRzGQjaU6AEHnxcBs0YKoQ8dGmI8p/Bdyu5PKHg7
XTSH5PTf+E/CE8EkDXtpGF88hi3gNRpOgEcTb0XA55fUo5EhNrXCrv7Xhi0T
/CE2L3qJPJ4Dq03Ho5avnmf5pD3eTxVgtzYBuxKNEXHPN+w51HvBaHbuRjjF
GwUcSF8hS58T8bPxsSmglkb/imzutFcgrSxm6mVYTpc+jXEMEY7gvQs5skhk
NFFPEk4pQggvCmz5Xj7HajNzY5DhkvCCVk4fy7atnRbswTGJNmvJ5dkmEC3o
yntUtKR0OSzo54ZWXbwiFJvAfJcO+OwdtWlfJdi0YKBrNaBBOz6E7jhkp1vB
wKk0O2Yi9ZVKhsqSKsKvuecrqP+NDub8tmka7cWyuXdngXRM/VYvQ2u6ymQM
JbQE3EmKEoEDeCyFihCCAa+EJs3KI7CD36qaLttDzRCKC1oGaq3ZpfQFyhAz
ZdhTBUqCs3KkDcowXhNrU2lsHPpbvbxZ99ofHpbNUqlm2ZB0+9Gb5WiB+FUW
hFcXcrNaNQ66jk5AzFxGU4ImSNBn0wvFYmWLiMy0ab1NuQ1cCv3P0mh9k829
FwmyWdp49fuiEL6vfdiKAthKJhRi2K5Ect8JIYNCfCOErCgBir/4UJzI4VJ2
NM7OCUqTrQ9JvKkTHA3oNjgZNq0kXjzJXr2Gzmx8uUymN5tUL9ylDZM2tWyT
NOfJBT0WCx9hk0wacd5im9qjYoZB9trSwjYBhqkGQ6jIQgy0FZ92ckwDgRTa
EWVzK60C6Uw0Wy/D5RtP2QV4FPFMFewRt5KSQ6LOsECM9O0YFuw1RIThBC5l
hWcANy9sJJab2WfqcjkVK3vlvKALvJVgoTA87pJ/5PWt/cysiqkuC0z7qksH
4nEBhxek3DiycTBxHDHlkjj1pyj1v4hRP5HyXg9NpXsadE+hk1sWd4QqkKZu
c/UyNL5rGiozDwUMkMJgIkzM3uQhgHzEexVLA/6LSMPxXNcIl7uzd1IU2UI7
yB00G9I97kNqSrC/9ecjhJPeo+72OE8SpnsKaY6nkJD9h0LiMUxvahQKmRrE
KDQChbnRWO3OsdKxH/vXCnGY7g2ejWBQFA4cnsMaiWhN9P+hWTjQcB6g+RHQ
zMfDjwzNPG1+ahDNSoCG/L9iuhH4/dtJUSGdiapZs/7oWDJqN6A5hnevZuEt
gRcoqEujjYTMyj/mzxGJTcN62wsEm4gE852HSK0uHK95vuMV9CaWxNlaCx1h
i/GhhBi2jJFJWTvHaWhhUgUWPQmWEBIWC5cOJ4fOawaEfmyWRofjbG6Cl9Z+
cXKlGJhckZYAEhnIg57TxfTlO1VXkTtiQoJ0zsdxJLIiJsNZbDCwGjDegb7y
MuqwFHde5vdQk2YHD6vxthACD0rqXqBTE+oE4+R8a4FkGrajcTfLjHYQ99GZ
6kiaYVwZ4nfoM7qRgNgyVsfMTdAwQUVA+Doqqp/Chq0mEz/KeLE0MEij/yJ3
4UxxJ8ba0p1wftMQGlNgBgk5AGX0dSWkuDALHHyy5f0ADsQSxsbhyI7AYQKy
d9SOwIojLhckvi6O2g7oLL8l4yPaD5iHV9kkC3WkrMrBhGO8JxwzEnaUXLH0
io1IJsEYYUlMyYRsIsu9iYeqNpGZueipTHiUEB5lGY6TZzNMV1WIRVMby5kK
kKiBvsMp7oyaL+0xf9JhRz9kwoF296WqrHaRV4XyGsMCtQzjQywKAwueCp4l
YGBeVJDNuDTaEvM+7Sn4YMyOm+3wRyyiUUfQdNiTCRtIzrvC4VIezcrp1VA5
sedEq9kyKho+2/KpjD3FYNudRP+Sz6X5fwb9v0mgfwbtm4ZDyxeC/IuaZaHl
cwqdOtPc/Lm2tIFeqNd8w0Lbls5WLCAW9M0lmKJM28atHzQ2GFAFMCmEoUlA
/HQyDMcLDIFq0mRhoJY8CDTCiRB1xE6oIwvVZGIgMxakyAP7iRlqI9h0D4/u
JVa+3ojVErc8fk/y+HBet2lKYdunMh9+O0GwnRzXnXDpv0hwm+J2IYn9Q/Iz
oVMgehrkT6E/bBZ6K6f0n4RGnqDxUwVIfMfjdVzpl+LXeigguPVZiMJpCYx/
XlTxMNNrY9T724Tx5Ec8YxBRPLeJ4uE9t6bwsOf+XENZ7Cw9LWX78S0DlA62
C8FMtg8lGb5DEzhwDzFrdKdSG8O6S77yqJ1khf1Z7ar049TW7uZMavhOv2g/
eLnSaOmc5n/Vlma9i5uFA2ENg3mKwRyl/9ckCaSRSon+20YG9Edx81dV0t9X
Ojj3ZgrfmsI8ogkZmROarHRGeuEo4/bpMW6HwkH50nJVOKtt1/y+FJqgWkXC
hk3crnGSaEG4EGoWjkgx0b4kTnszvKbo/anayXS3uaJM6D20n/rS5tD7PAi0
eah7fGrP1b3fzKa8h8AUI0SJjdSoaZquEQ4XI3WoXHpc6FUhmFK5OjwqY3Xg
UQc03CH7k6ImaGiJI7ZD5Yi0RfzC/UAjGcs6wlMqH8qOGPU+JepwSnSvkBvy
YxAyRlqX7Q6Zk0nMdE2BxFnoxpyF0Thp7stcWzo0L9U27kz05qHhne8RHO7o
dCX4qMZN1LlByBanSmeGNDeiy+iH45jgiOUFiWPVKdJkJiS2RYee7BzVK2/p
hvhjbzLRFxbHe1JO/PEGzPfy3xRDGuiUUaJTUFgViQBNiYUdfAPqE9s0tzkt
ifzcPJyyE1J5BT+0QGWmDQq0y4beLvH43Uj/g9pWJXv55MJCJfnlTko2v6uY
5PDtb42kmawaIz/S+WGwd46Pp9FpDGJEZES0hk4Hhvw91zZWL8npLNQhmy/P
amSkFr2NEf7myoqJOkzhM8+HnxYnd1H1edtm21qL8V9hK1fgYWVz+BcrdQzU
Kp4kvQpTwFe2YECQZFiqtF+sAzUXxej+reiXctLkRvgrnYwjmF0V4f3WVEL4
h73qRP98UIWK5SFxGhFsmKZBn9nqtON06hLm80aew96Y+XzLh+E4wGKfzyNE
93T3t9VUKD5/R4ke0JyJXANzIGQwRp70uV/ePJPYC1SZz1ZCI+M0MWBwpBeQ
Z/+hIjofH9C5lwZ0LOdtdDbF/aTfK0MDOxxp1rTbp2onmbmHSE8E3qyaj2Ie
4dta3UnMzQE1eISo7EL5kKZmqtQls/4DGmNAzarmxsxM4tX81IZp05WSqUYY
xJEnI6hsxq/p98Ue7eco7REKnRDQ3mpU5ldE+2OZ9j0vjhaMGO05f60nvLn7
YVfh7yC4qT7iaPXIZeioBTXlAMMC4u/FL4f+iWyIGrv1xN8oCNn8MW2AiL93
2ITlSQlKJYm/A3+waaZCidP9Vx2fpHRnqjJ9s5jk6XBC7xqDIT+cf5ZBe/22
H236QVPhEpJQIzwKSVAstCCT8Ncq4UF06+F6v+5CuW5SK68srcJd2Xp4VTr3
yDEXRAPCsYoaJkswnr5S4bo5YvbNo5tw8caOcTJEvjTC7EUxZo8bTc8JjBM8
qkiU4OGIXiYtUzuF0YDZTPd8bwi5N2N0WYzSMoeX+WJdkBvLDso9fq6c0nbC
xPb7j2grHj8Oxtl8bV7wpq9WNA5mm83vvBgYgpFL1SdcYzZTWXsjsfZmpPM+
1bILYu2SgLUTqOyrFNvm/A4qg31TRuQW2AzZMF650vyL2tHxrv4ceIPgF/Vi
zHHEvX5WaJEw5PtxJuCXiih/dAbl+yjlg2hX5zDZ65/rsY3nuECh1xNvxcu/
L1ZvBUqFz+K9K+dpNn8o/L2Z+HvrOGztC90uJFcRXfmqKKZQmsYUSrOoQ1gp
1SuieFqJvAGTXYnk+QlU9gZNG5VtmArujYyQkRmTVFBSsbwiMh8T+Ch2hKqP
Vys2uGOYU/ePzozQ6azQ3eP6Slci2E0JaJlvEgZ4oUb4SNR7cnRpCzH3VmXu
reNpF0HMbdGTsiQVEjB3s1CFGIkXe/o6YiOjJNbRdykeDJoOZ7tt4PGBG0Hu
DQG51yQwtjH1z/r9s8Udx8k+IzcqIV5w4RRQj9zXKVf7pLayPD7A0CkMo/gZ
WCP1GM9MTh0UuoHzvbgh4rbwvdeb7825PjGR25WbtxM37yRuLv6SNnAVcbNP
ZtYh6rAtiZO5RUVkZirzzPu0EneTPAOF/enQPqWTqKyzcZsqhVHNgOrIVRVT
+A49C9bbOg56Ned+5aqdJUCwxGziBA1UTVObOMc09UsWEmwY3UzqOHoJTklm
BlMGd35RJDPBAkb2dUWzqK5YpHs+o+6yKqiLwbYbbMKaTYbOxrg9GdJYCYVX
xCisY9GxITMKo/gAp0HXZFL4Cj+/55yWcEkxCPrFBFRvF1b6W73wc7F8qnki
YxM8EdhHaOklnuvHlW0WL0HF9ScSkkK0HxqaQ1LE08XELKUzlOIVqg6P4v4M
+hUtonPoPV7WiZkpZeRwCPSWVnq1lCmkeTpyO4aAUX+Zfu0iZYJvmzZTwqPS
AMdl11WP8FKgcxQHrR5oExLdirTDsfJapqaF96M0WDVJYyfmlHA8VodpymRn
OaIexAJJkfARCWJzBJVLpkBfE7GVzUu/bhoziT6bNw+VSGAOW1SH4OHUbZ6W
m40RpSmmeG2hvzeVlN+2rgKC84C1ZuALIzgKC9BOdePuERzRwiA1bQTXusDh
XuTkrRjBLQiLzWVktLOOMYcHyKO0LfA9Rs+jEIfzrFce71wkBjKDw5tVzOGB
xm6R4XckETtj9LPOhMWk+VYyrDhfZnsGZG8Zkt2mbS/VPeZ8tZSTmjijO6oG
0BNkc/XoLufOjgwqNSx4YrWYw7UcwCpmJNVTJ6B56JjUZ8cEVTI2TjsYHa+p
nZ06mrjMxpd/rhVC05L0eNNMPe4z+K8eg2dYx4zRqSkQm0fIZ+kI6G1M6PjU
YuPzOLFNodDdNVdCoygADU+37g6hj+KMQ5+kfFqs7sII/akSmrM76pb8OFz6
q8HJ/s2bW86aRMfyouSlPNixF4Wbx5meJvG3NIHX5zO2EjmRsTPnx9uMWiZ0
TZ5znB8d5Gs0Xtci3MQv1y/8SXUIcYPRGJl+zM3eXj0a5yozy5BRUR7hZr22
ethhQTiGFvj0hds3R90+bGJgHqGpuTr1/XAuPDR1qU/fL5W+M5S+vmm0CJRt
F31XryImroS2Hgvv0EnctcOhwHF+jtP5Z9ViuMHJTYzMGIKCOb47dofMh7Ce
7nutZOfBxrxT715b4yES3eZTS0rmKUpm3wtBAOpX9ayZzKaf1SBCPwfR7C9j
uuK7mK7wNy6B99EiUzeznmgZ0RMygrpGOFsYM7px7eCf2fyktvxqW8tMgm/Q
cefmaQPdhWo2pha2UEKjC8BE54KuAVUQWroGHREpgYgQ+c6C4GjYxxUQeYG6
ekZkVshomBAzgkzkzws9hRz3OFRPBHzcLFNP7B4fMzVTTNl0SGz51w5WHdtb
ZlJ7U4zav3rqg3a0LZXUOLqC5pDFu0Pqg9gG9tcdI+xfnNQjOf4RknqakvoH
JrU0YMNOcU1A6pi/Edg+L9IUVxk/eKRmXvayMMury8vpkNRE2mxVFztboTqR
mdpjcn+m+Eb9MDOBy9TZmSuxVKMvGpmgs2Zp9egr56AP4ykXVtQwvFuMtlzd
VoeTBULbehE2ll14o4C2W3za+n7FF0XJtPV9Cl9PLE3QE8zCLYW2FbKwkDAr
oC0zs/ByrvzZ1w/mxUFSbC7zzKJWSlBk1G2sdLUJeiAzrF8lkkTQcY+YXqgn
Ns5TvkzQt9E7qTE3wuL+CmPkIBMza5L/UJXirUgnGKNuCIgZ8YVVBYT0hMbd
0SqiG1hv+GZufUwXwL7OadpKSWZ5c7RHsR5JzoWFgqdUTOF8NXNwiTEqE3E6
7PeSqDu5X13uJSgeRP0gDIpiM7DrpveEuts1pLHLVwW+9+CbNd8zM42btL9b
XR1t67Fq2kjrkxXP456a7z0sUxU7o8hIa/nxb38vaffn4jJkVKTWtTbvMiKa
gLfSdXlnh10GTkOIc9YgcM6gCbYFefAYab+Ikfb7GGl9p8zfWUS0QItKmVbt
WLralN2kWsUUrPm/s5rKgboaQQLcuqwWV6kNpBPZftyGD5oA3i6CQfB0R94f
miw0KkUwaMaQerxl84mJnQRcMJxC2/lRmNsusZzrF4WZxDRzhSLH30dMVzk1
xT+oFbVTRkqzU6tVGkBGgvUPSkckuNFQZa4LT3xXTscC1arYOUCbIun0Vq8C
TXuENMTxw+mD63GR77zn6mfsxra+ryeixsiWt/S/TcNKzZLuC7KE/3YGV4SW
2yvwYE3g1ULtpbS0hPWPHrUqp6W0SPsrbw0wnBR6EyfPsB2QwGRdzUvX4yOc
c5+pzyGbZRo+QE4Duy60fygZo61DKqNjXLAXVqAzk+nIwUf4Sb6DquyYFW62
aoVeacS2Kyca5RAiovsx6lnW+adqU497+7s/8t7VSoVwCNbO7H2mybeZQ+sF
FueXfzfgYBfCuThNyYdcR8tBMG64kkQ5c44swOUn2PzkmlAuxcusIb6RMaAx
4ZaWIsXpyBZK6JanBI3RbqPSbq3Sbql6m7Ob/lFJ195JJ7VFu0m6fXg2HfKX
JsCjH4wWbH6tShB5eShBbJHWvtWQz0ft0PPBpWO118HkSnz2uQmkWxIjXWRr
xKqLEzhguE1KD6PJVg5/b2tpNNvaMtM0r4/RbDHT7E9KM0sAL6k2zaTDyZ85
JAUXUvI2dSLnEpFBYIX3rMT5lr0qB3g3viMHd7nv4hg5Rx0UQ32phSIzvWTj
7JjbuKhZZn7Gz82sBa3WM62QmjF9F9qPkOeUVmJTcsLXbYjRbFlAMxnXSURD
OhdtgpZVm2jSsGRPbjLAlZO9pYwvOJYzVLxB27z4Wg2Ni0q1LLU0STbjKcP5
zaIVTH5qZWULqZwB36xRiVrHgWfOYbl0xEikVVLpVzVDbrLdiVEH3zWn6d5K
HEu+/lpt4jRUjkKkHpyEDCD6Nn+lvhzOK/34rO8mN+TzGHCT0dmpbKyofNTq
iuTFOGl2TPIyXORYzinYLcMFgSLbwKlqU16ycbZEak1VSy3DfIeJmlQD7KOE
Qc4Uo7FWVZswjVSzgzCmkoJQwhNy8jrgmNe1lbFGd2EHra4WFcKBeJk299MV
kW1us8xURTQ3JCUpNb0MaAvN4bcIsxjrWgYGwHwuy3iCLF8V/UXJgkQnGhyv
rjZZeC4DGUy4rDiTa3nLGV5GB82AkV1Y86Y0+0UEACWCCHizgdNMTqilPV75
IYFXkjI4Hr9Ea3UsAcZXS6kMrBEWoS310r5fFsoJ5qwg8bhWlpryV64bpZMr
JkoT1TAgCrQLarKRcvkmYTOEWmy0ydr+oUSpd8B0BRshrwg4Ev2vQIBsB28R
6kDDpCMRPuGGnDAHbrtwqxOzUmsS1H2VIsgMov/1ht9FEakGacElG9gamtTM
UalZqj7QGk1p7+BTFpp4sni9n3SKU8PXs37gTWpsg9JnFCiuYnlZ6S3ZckUL
NV80s2g/XTXycuj8vel3rVrqB/7GfDCZVj09ITS2ila9/h2J7mIzjK4wZeO9
YvCvvKP+SateoPibQJgi9c3y8oAS0UUvaRYuXKuND9CVxxJlu7ny5rqXwI7B
4lfYKVg2HeUL0JDmgJSZwxbkZgq1Lxnpgpzw1OoP6n+Yr7ZcHYLlXIS6tLkc
V6opf7RjST83C6P6chTsIF0kMlXoDrftdy2ypUZFsK1EBtu25ogms0OvW0q0
RSkdo801VLTT2oWNkK3JHeIxOQzzbzDlDe2ig2rwhXIUN8ULzxLMsRKQY2rh
IboSJIMw62PH71rJnmr7sbGDkgKD2qZu9VuSptw+Stv0jpGurMGpHFpRmTJr
0kJSuNWUtkGYw+fw7TweBHlq4WG6BKRZJjjta7TbS/ijLgFlSihrRCHp8iCO
F2ZZUZOOaCnSVAADGddE+kPutAuQtDtJiwaaLJWyR+hdxzIWu3nX+2gcCPKB
DQ2SEJAL7AMt8oj8JcJjCXeZ4ttJc9cK7H3wYa31xhDqR6/ykt91YyIh2Ymk
OV6/AR3+MCev7L/+Dcfp6xEHxnAFjCdN/Y++AwFR9Lz75n/2HXI2BsNAvtf3
lbn/yddY5GyOvm/X/+ZrcJoNRco2kmj9f/drhIH34EPqaCSJToKoSfpavxY1
MpEewP+dr0PbtXudhMvecuEEyK3/m6/r4qRFJtqf2pTqH//7qzua/1aDuzmC
NTDZwEbrbfuffJPNfUO7ZugfbMx37NY3HX/s09X6Jtg8DExCNTc6S8z/Xd90
oAKCyY+Y14AGwRiJi6796Ac9YMCAYBbTzcqS6Kg4RalYHB3hYN9aQR4F37if
+g2YF4BBITZDGe2JbSCvffvAgQPdkCFD3BNPPME/j1S6gFMRX5ukFC510clB
1bgN8ewLeGgF+thjBKY/StHGF6B/PVrq+rcyePBg7m9/hN4OznAjUgqPUWeb
BLfDN1D928FUR4zLQZ/uc889N9Ja324HXX4ff/zx4HZwa+AMM8o2Vmm8yLCP
j93Nqf6dZEW4nO5mX4UIs1wwYhI9/m12D24EEOFGABFuBPTAjYBOR+pHwrnE
Qb3Rjg8b/N6byOX5pBjcDDnAzD3IQrdu3QJq9OvXDzeQckOHDqUvsKFRuI5Q
QiMvBR26wHCpUl9nR+5G74j2MkKXo48+mic3okc+5txgDKABhEbqeksBr4Cd
j9KvhACNVLaVDGRWZPhJnC7JdyLEqcWs4g9vxbQdHx2whrFIa70D6F2o+BXV
pkZUDWqXFLqNv+pdYF4ABr9AlDHzB/OaQQvMCvD5A/+2u+ipSvJno0N69+6C
p46lcRd7612AUcCtGEICWvh3ATVm4gKE7C6g0p53EiL8PXfBxe65uIvmehcQ
YKg2yAx0SZcuXYK76N+/P3Mp7gRN94/WlaAZ+G/2qbt9D5w6aMFskcOqDJKC
Eefo7w9mgKoyfQHWbIrX7qmf1M+Fh4GyKv5ivqfL+C/poNQD/+3PjznMA1Dn
UFi2Zigqwx7PW+KlzT1B+K3qLz4joHBuwtplv57DWhwqExMrYMbs2wcNGhR8
+zEe522s+ot5pGQWvrhGwheb3QTDQfiglYzWYDbAbD72Fu/DK8H24kCusir5
QuidCy64gOfXY5XQuQAWX2pf6GuLpBWeJF94idp1cI79KTBXTp2QPdgKYEYt
lohvBAtheeE3ZkW+kcnmgsF/1fwW6FToU8wbgTHDuoAcJuEeF3xmEvl0NZeq
uvS/xwh4sP4NLILJF7YMfMFp/9lHQtahbfCR4DbweyUfeZkSzD5SP84+DbSG
pQUFoLMhtrv/aYfoOzDoA/eFTzr9d38K3BB8CjD//Z8C0mNVIPnv/xRoGZso
X8mnXG4vP/bpALBD9Xcc3tCXV0Layj4Cc3D+w4+AS/A7P+Ku3Xv55P9//In1
Vw3867GKX3RQwtKSvJNHKv6IgxNe3q/ilx+S8PJKbvDQhJc/WvHLD0t4ed//
/fKZzJV8z/8K9yTvZNL/+9P/+1Plf7pS/+Q7EROr/BP/Y8///Ln7v/8PHEaz
JQ==\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{288, 340},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[26]=",
 CellID->385205503]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "TutorialMoreAboutSection",
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell["MORE ABOUT", "TutorialMoreAboutSection"], 
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "More About"}], "TutorialMoreAboutSection"]], 
    None}, {None, None}},
 CellFrameLabelMargins->0,
 "WholeCellGroupOpener" -> True,
 CellID->23220180],

Cell["", "SectionHeaderSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["AtomicDensityMatrix Package",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]], \
"TutorialMoreAbout",
 CellID->1567025153],

Cell["", "SectionFooterSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"NMOR in an RF Field - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2013, 7, 19, 15, 4, 38.6152423}", "context" -> 
    "AtomicDensityMatrix`", "keywords" -> {"Atomic Density Matrix", "ADM"}, 
    "index" -> True, "label" -> "Atomic Density Matrix Tutorial", "language" -> 
    "en", "paclet" -> "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "In this example we study atoms subject to linearly polaried light, a \
static bias magnetic field and a transverse oscillating (rf) magnetic field. \
The atoms are initially polarized by the resonant light. If the Larmor \
frequency associated with the bias field and the oscillation frequency of the \
rf field satisfy a resonance condition, the atoms are put into a polarization \
state that precesses about the bias field direction. The atoms then induce \
oscillating polarization rotation in the light field, which can be detected \
with a lock-in amplifier. Load the package. We first make a diagram of the \
experimental geometry.", "synonyms" -> {}, "title" -> "NMOR in an RF Field", 
    "type" -> "Tutorial", "uri" -> 
    "AtomicDensityMatrix/tutorial/NMORInAnRFField"}, "SearchTextTranslated" -> 
  "", "SearchText" -> ""},
FrontEndVersion->"6.0 for Microsoft Windows (64-bit) (May 21, 2008)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "6.0 for Microsoft Windows (64-bit) (May 21, 2008)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 78, 1, 3, "TutorialColorBar"],
Cell[649, 24, 220, 5, 70, "LinkTrail"],
Cell[872, 31, 7929, 162, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[8826, 197, 56, 1, 70, "Title",
 CellID->509267359],
Cell[8885, 200, 608, 10, 70, "Text",
 CellID->1534169418],
Cell[9496, 212, 60, 1, 70, "MathCaption",
 CellID->836781195],
Cell[9559, 215, 108, 3, 70, "Input",
 CellID->2058623809],
Cell[9670, 220, 88, 1, 70, "Text",
 CellID->15600200],
Cell[9761, 223, 67, 1, 70, "MathCaption",
 CellID->210471022],
Cell[9831, 226, 104, 3, 70, "Input",
 CellID->399354204],
Cell[9938, 231, 69, 1, 70, "MathCaption",
 CellID->606009605],
Cell[10010, 234, 1479, 40, 70, "Input",
 CellID->287183751],
Cell[11492, 276, 73, 1, 70, "MathCaption",
 CellID->435355331],
Cell[CellGroupData[{
Cell[11590, 281, 4764, 135, 70, "Input",
 CellID->162359029],
Cell[16357, 418, 7915, 134, 70, "Output",
 Evaluatable->False,
 CellID->138947816]
}, Open  ]],
Cell[24287, 555, 214, 5, 70, "Text",
 CellID->612747630],
Cell[24504, 562, 117, 3, 70, "MathCaption",
 CellID->108772237],
Cell[24624, 567, 280, 8, 70, "Input",
 CellID->19801112],
Cell[24907, 577, 78, 1, 70, "MathCaption",
 CellID->627164436],
Cell[CellGroupData[{
Cell[25010, 582, 885, 23, 70, "Input",
 CellID->4674794],
Cell[25898, 607, 1642, 42, 70, "Output",
 CellID->40279893]
}, Open  ]],
Cell[27555, 652, 489, 15, 70, "MathCaption",
 CellID->531992379],
Cell[28047, 669, 390, 11, 70, "Input",
 CellID->313420400],
Cell[28440, 682, 180, 4, 70, "MathCaption",
 CellID->201724876],
Cell[CellGroupData[{
Cell[28645, 690, 871, 24, 70, "Input",
 CellID->262558261],
Cell[29519, 716, 1877, 57, 70, "Output",
 CellID->709394457]
}, Open  ]],
Cell[31411, 776, 164, 4, 70, "MathCaption",
 CellID->46602588],
Cell[CellGroupData[{
Cell[31600, 784, 370, 11, 70, "Input",
 CellID->367378843],
Cell[31973, 797, 3217, 98, 70, "Output",
 CellID->151833558]
}, Open  ]],
Cell[35205, 898, 79, 1, 70, "MathCaption",
 CellID->279260831],
Cell[CellGroupData[{
Cell[35309, 903, 383, 11, 70, "Input",
 CellID->240274671],
Cell[35695, 916, 1514, 29, 70, "Output",
 Evaluatable->False,
 CellID->325743924]
}, Open  ]],
Cell[37224, 948, 267, 5, 70, "Text",
 CellID->419861567],
Cell[37494, 955, 127, 3, 70, "MathCaption",
 CellID->232477107],
Cell[CellGroupData[{
Cell[37646, 962, 428, 13, 70, "Input",
 CellID->530451512],
Cell[38077, 977, 1036, 30, 70, "Output",
 CellID->776459134]
}, Open  ]],
Cell[39128, 1010, 171, 4, 70, "MathCaption",
 CellID->250696079],
Cell[CellGroupData[{
Cell[39324, 1018, 447, 12, 70, "Input",
 CellID->872908440],
Cell[39774, 1032, 1464, 46, 70, "Output",
 CellID->220658746]
}, Open  ]],
Cell[41253, 1081, 119, 3, 70, "MathCaption",
 CellID->26724115],
Cell[CellGroupData[{
Cell[41397, 1088, 315, 10, 70, "Input",
 CellID->431704731],
Cell[41715, 1100, 875, 25, 70, "Output",
 CellID->73950923]
}, Open  ]],
Cell[42605, 1128, 125, 3, 70, "MathCaption",
 CellID->403563780],
Cell[CellGroupData[{
Cell[42755, 1135, 317, 10, 70, "Input",
 CellID->661359577],
Cell[43075, 1147, 1822, 54, 70, "Output",
 CellID->69128610]
}, Open  ]],
Cell[44912, 1204, 163, 4, 70, "MathCaption",
 CellID->44892595],
Cell[CellGroupData[{
Cell[45100, 1212, 330, 10, 70, "Input",
 CellID->135215867],
Cell[45433, 1224, 17316, 288, 70, "Output",
 Evaluatable->False,
 CellID->54720361]
}, Open  ]],
Cell[62764, 1515, 244, 7, 70, "MathCaption",
 CellID->97985673],
Cell[63011, 1524, 1003, 29, 70, "Input",
 CellID->1937353],
Cell[CellGroupData[{
Cell[64039, 1557, 629, 20, 70, "Input",
 CellID->24895147],
Cell[64671, 1579, 796, 26, 70, "Output",
 CellID->255987138]
}, Open  ]],
Cell[CellGroupData[{
Cell[65504, 1610, 779, 23, 70, "Input",
 CellID->945266666],
Cell[66286, 1635, 834, 27, 70, "Output",
 CellID->134300382]
}, Open  ]],
Cell[CellGroupData[{
Cell[67157, 1667, 451, 14, 70, "Input",
 CellID->215859820],
Cell[67611, 1683, 3786, 100, 70, "Output",
 CellID->566888926]
}, Open  ]],
Cell[CellGroupData[{
Cell[71434, 1788, 270, 9, 70, "Input",
 CellID->79059378],
Cell[71707, 1799, 2282, 64, 70, "Output",
 CellID->254382841]
}, Open  ]],
Cell[74004, 1866, 241, 7, 70, "Input",
 CellID->110448346],
Cell[CellGroupData[{
Cell[74270, 1877, 696, 19, 70, "Input",
 CellID->231252382],
Cell[74969, 1898, 4199, 73, 70, "Output",
 Evaluatable->False,
 CellID->158340335]
}, Open  ]],
Cell[CellGroupData[{
Cell[79205, 1976, 699, 19, 70, "Input",
 CellID->334428964],
Cell[79907, 1997, 3703, 65, 70, "Output",
 Evaluatable->False,
 CellID->577930429]
}, Open  ]],
Cell[83625, 2065, 341, 9, 70, "Input",
 CellID->31523307],
Cell[83969, 2076, 7400, 193, 70, "Input",
 CellID->181111389],
Cell[CellGroupData[{
Cell[91394, 2273, 647, 18, 70, "Input",
 CellID->306014737],
Cell[92044, 2293, 34744, 574, 70, "Output",
 Evaluatable->False,
 CellID->385205503]
}, Open  ]],
Cell[CellGroupData[{
Cell[126825, 2872, 747, 21, 70, "TutorialMoreAboutSection",
 CellID->23220180],
Cell[127575, 2895, 861, 21, 70, "SectionHeaderSpacer"],
Cell[128439, 2918, 192, 5, 70, "TutorialMoreAbout",
 CellID->1567025153],
Cell[128634, 2925, 861, 21, 70, "SectionFooterSpacer"]
}, Open  ]]
}, Open  ]],
Cell[129522, 2950, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

