(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     44125,       1222]
NotebookOptionsPosition[     39429,       1078]
NotebookOutlinePosition[     41671,       1137]
CellTagsIndexPosition[     41601,       1132]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "TutorialColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["AtomicDensityMatrix Package",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {
    StyleBox[
     GraphicsBox[RasterBox[CompressedData["
1:eJy9lulTk1cUxp+Zfu+Xfu5MO9O/oF90povj0A6dVtupdRsBqwRCg+DCqCxF
LLIIoUAIyGLayqJCFZRYVJaAaDBsQkBCEhaVoCjEBAiLTSLJ7bmX0nEBhZZ6
5mbmTebN/d3nnOec930/cN+mwLcAvEefD+jDr9nrwul0DvabbdaxuwNm++Ox
197/r8PQrY/bLwnyxYFvEL0F8TtwOiNq9IHFYDC4XK5VBGmvaXasg/QLRH6H
xABkBiFXhvw9fCVJP7LZbKsFemwdC1gP2ZdcjnwXCvag9BAuxOByHC4dQUU0
dBfzV4vV0aoL+4orOv49ckNRHo3qeDQehy4NzWnQpvCv/W2aRf+70vSeK8o/
+C0vkDIEZYdx5SfclKM9Az05MOai9wQ6FahLwJT9ObeQkaqrq3t7e1fESo+W
/LgV8t1QhfPU1Seh5WfczoY5D4Mn0V/AoSSwNkfidjnpfofDUVVVpVKpFArF
5OTkiliZMZJ4PyiCceYg/ohDUyq6stCXhzsqziIicXVyXriyVMnQoHnt2rV+
fn5paWkmk2lFIAptrfqYHzceJZBy1ZaObiUGCjirL5/nsDWdl+yXvfw8R3e8
EyYLIVBhYSEJfMW25F6HCKeI+R+npxzJOzmLEtiQhFuZvEzEouzps9CQzN1C
5s8IQroE4VvWJB2NLsqKP3U8vCI7ytypm0/syzExMaFWqxMTE2NjY0NDQ6VS
aVNTk8vpVMVLToZxq9cnclZvLsd1KDiFtFA1Y7aAtKfuflsRFXA+YSMdifzT
ks7PdjXV1/7IspS69vZ2uVyeLYKqbLFYGmursqUoO8RzRSwqUJcSJRGcsssH
gZ/zYULaC/fzapJVhn7F47MYPw/b77CVYlCFe83qpXDUFw0NDSUlJZRPo9FY
U1OTk5kWfzjsVOQ6qg7t1piMw5uw/VPs/gx7N/JhQiBy42gJZi/iaS3YdTAd
WBtYEzwaTJbj0a0lcez5TrxvGcpOOFCsiCOxOTEBcdu5HN7jm3k7kG2ou20X
4KqDpxXsNlgPmAmsD6xfXLdh5jK8Txev3cthHbHkhWLfRq6FRhY1OMmZ92db
BkbPYk4LZgS7BzYMZhHr/sIaBNPDZX6VtGeDJvDWT3iBwjZwM5yQ8ZLdSMGA
CvZyeBrE+Qn0QLCGwO6KixGwh+JHwg0vi3X6t/xtArTvayT4o/gAauLRmYVH
xXBWgmnAOsEMYunBugSXEnhHqBsRi9Cji4/NZ6MgK3Xrx7xAVB3qIz7b0/jQ
mD4PTzXYNbBWjrBW4mExZtXw1nNLcKhRyLEIgXThMC8ndTvXI3Yb0gNx+Sjv
rNHT+FMN1igo3VzIXD0myjB5DtMV8F5ZOECXcMggF2hvW+OcedUkoYcXGTvY
lzucZi+BqLlmKjB3FV6dOLlZ7Ebb3oRXAzeZrUak9IYwPN3QK264jYfmG0ql
UqfTud3uRVl1V9TkOrKcUoq6YzDlwVEBz3V42xfyc0eUhjbsAGsB04qlE/QO
oYv8b5Iw19+KZmdnl9JVVX7m0CZkSXmNqP2fXIS3UezQt+DqAZFDk/BGm8A1
i9Uivhqj2IiGzS2rrcI30OjGuUgYcmAthUcr0jK44K57mGp511r1ITdDI7xa
Pi68VKkWibs5io3pl0mZj+wjkuwf+AgdL8VcrUiLSfTmiOigHlSejLTb7XNP
HJ6pMc+4hdFkWPZweCGMHbriCJjzMX1B2NggCjQkerYLTlufv79/T0/PUuVe
UdDTpzLJl56Jzkui3D0LxuuVOMctPj4+MpksOTlZr9f/dxbFU5dztFtjPcPN
7CUnd0cxq34+URERESEhISkpKTMzM6vC+ic8bucLg3p4eDgoKIjel1YXtGjQ
e0JwcDA94N4Ai6KoqGh8fPzNsFbFgf9r/AWVRIUY
       "], {{0, 0}, {36, 32}}, {0, 255},
       ColorFunction->RGBColor],
      ImageSize->{36, 32},
      PlotRange->{{0, 36}, {0, 32}}],
     Deployed->True,
     StripOnInput->False], Cell[
    "ATOMIC DENSITY MATRIX TUTORIAL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix Package", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"AtomicDensityMatrix Package\"\>"}, 
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"More About \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicState", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/AtomicState", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "AtomicSystemQ", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/AtomicSystemQ", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "BranchingRatio", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/BranchingRatio", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "Energy", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/Energy", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "Even", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/Even", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "F", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/F", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "GFactor", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/GFactor", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "HyperfineA", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/HyperfineA", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "HyperfineB", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/HyperfineB", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "HyperfineSublevels", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/HyperfineSublevels", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "J", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/J", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "L", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/L", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "M", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/M", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "NaturalWidth", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/NaturalWidth", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "NuclearSpin", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/NuclearSpin", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "Odd", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/Odd", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "Parity", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/Parity", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "Polarizability", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/Polarizability", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "S", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/S", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "Sublevels", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/Sublevels", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "TransitionPolarizability", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/TransitionPolarizability", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "ZeemanSublevels", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/ZeemanSublevels", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"AtomicState\"\>", 2->"\<\"AtomicSystemQ\"\>", 
       3->"\<\"BranchingRatio\"\>", 4->"\<\"Energy\"\>", 5->"\<\"Even\"\>", 
       6->"\<\"F\"\>", 7->"\<\"GFactor\"\>", 8->"\<\"HyperfineA\"\>", 
       9->"\<\"HyperfineB\"\>", 10->"\<\"HyperfineSublevels\"\>", 
       11->"\<\"J\"\>", 12->"\<\"L\"\>", 13->"\<\"M\"\>", 
       14->"\<\"NaturalWidth\"\>", 15->"\<\"NuclearSpin\"\>", 
       16->"\<\"Odd\"\>", 17->"\<\"Parity\"\>", 18->"\<\"Polarizability\"\>", 
       19->"\<\"S\"\>", 20->"\<\"Sublevels\"\>", 
       21->"\<\"TransitionPolarizability\"\>", 22->"\<\"ZeemanSublevels\"\>"},
        
       FrameBox["\<\"Functions \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"Functions \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix/tutorial/SpecifyingTheAtomicSystem", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> None, 
          StringReplace[
           "Copy Mathematica url", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  StringReplace[
                  "AtomicDensityMatrix/tutorial/SpecifyingTheAtomicSystem", 
                   "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], Delimiter, 
          StringReplace[
           "Copy web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  BoxData[
                   MakeBoxes[
                    Hyperlink[
                    StringReplace[
                    "http://reference.wolfram.com/mathematica/\
AtomicDensityMatrix/tutorial/SpecifyingTheAtomicSystem.html", 
                    "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]], StandardForm]], 
                  StringReplace[
                  "Input", "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"], TextClipboardType -> 
                  StringReplace[
                   "PlainText", "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], 
          StringReplace[
           "Go to web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> FrontEndExecute[{
             NotebookLocate[{
               URL[
                StringJoin[
                 StringReplace[
                 "http://reference.wolfram.com/mathematica/", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 "AtomicDensityMatrix/tutorial/SpecifyingTheAtomicSystem", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 ".html", "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"]]], None}]}]}, #, 2]& , 
        Evaluator -> Automatic], {
       1->"\<\"AtomicDensityMatrix/tutorial/SpecifyingTheAtomicSystem\"\>", 
       2->"\<\"Copy Mathematica url\"\>", Delimiter, 
       4->"\<\"Copy web url\"\>", 5->"\<\"Go to web url\"\>"}, 
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"URL \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxAlignment->{"Columns" -> {{Left, Left, Right}}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.05], 
     Scaled[0.3], {
      Scaled[0.64]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Specifying the Atomic System", "Title",
 CellID->471728094],

Cell[TextData[{
 "In order to find explict forms for the density matrix, Hamiltonian, and \
other operators, the parameters of the atomic states must be specified. This \
is done using the ",
 Cell[BoxData[
  ButtonBox["AtomicState",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/AtomicState"]], "TR"],
 " expression. A list of atomic states is known as an ",
 StyleBox["atomic system",
  FontSlant->"Italic"],
 ", and is the first argument to many of the functions in the ",
 ButtonBox["Atomic Density Matrix",
  BaseStyle->"Link",
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 " package."
}], "Text",
 CellID->97203088],

Cell[TextData[Cell[BoxData[GridBox[{
   {
    RowBox[{
     ButtonBox["AtomicState",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/AtomicState"], "[", 
     StyleBox["label", "TI"], "]"}], 
    StyleBox[
     RowBox[{"a", " ", "labeled", " ", "atomic", " ", "state"}], 
     "TableText"]},
   {
    RowBox[{
     ButtonBox["AtomicState",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/AtomicState"], "[", 
     RowBox[{
      StyleBox["label", "TI"], ",", 
      RowBox[{
       SubscriptBox[
        StyleBox["par", "TI"], 
        StyleBox["1", "TR"]], "\[Rule]", 
       SubscriptBox[
        StyleBox["val", "TI"], 
        StyleBox["1", "TR"]]}], ",", 
      RowBox[{
       SubscriptBox[
        StyleBox["par", "TI"], 
        StyleBox["2", "TR"]], "\[Rule]", 
       SubscriptBox[
        StyleBox["val", "TI"], 
        StyleBox["2", "TR"]]}], ",", 
      StyleBox["\[Ellipsis]", "TR"]}], "]"}], 
    StyleBox[
     RowBox[{
     "an", " ", "atomic", " ", "state", " ", "with", " ", "one", " ", "or", 
      " ", "more", " ", "specified", " ", "atomic", " ", "parameters"}], 
     "TableText"]},
   {
    RowBox[{
     ButtonBox["AtomicSystemQ",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/AtomicSystemQ"], "[", 
     StyleBox["expr", "TI"], "]"}], 
    StyleBox[
     RowBox[{
     "tests", " ", "whether", " ", "an", " ", "expression", " ", "is", " ", 
      "a", " ", "list", " ", "of", " ", "atomic", " ", "states"}], 
     "TableText"]}
  }]]]], "DefinitionBox",
 CellID->50998985],

Cell["Specifying an atomic state.", "Caption",
 CellID->218865873],

Cell["This loads the package.", "MathCaption",
 CellID->314617643],

Cell[BoxData[
 RowBox[{"<<", "AtomicDensityMatrix`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->609886833],

Cell[TextData[{
 "The first argument to ",
 Cell[BoxData[
  StyleBox[
   ButtonBox[
    StyleBox["AtomicState", "InlineFormula"],
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/"], "InlineFormula"]]],
 " is a label, which can be any expression. This can be followed by one or \
more rules specifying the values of various atomic parameters."
}], "Text",
 CellID->753327094],

Cell["An atomic state", "MathCaption",
 CellID->207601131],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"state", "=", 
  RowBox[{"AtomicState", "[", 
   RowBox[{"1", ",", 
    RowBox[{"L", "\[Rule]", "1"}], ",", 
    RowBox[{"S", "\[Rule]", 
     RowBox[{"1", "/", "2"}]}], ",", 
    RowBox[{"J", "\[Rule]", 
     RowBox[{"3", "/", "2"}]}]}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->505500221],

Cell[BoxData[
 RowBox[{"AtomicState", "[", 
  RowBox[{"1", ",", 
   RowBox[{"L", "\[Rule]", "1"}], ",", 
   RowBox[{"S", "\[Rule]", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{"J", "\[Rule]", 
    FractionBox["3", "2"]}]}], "]"}]], "Output",
 ImageSize->{234, 30},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->425649877]
}, Open  ]],

Cell[TextData[Cell[BoxData[GridBox[{
   {
    ButtonBox["L",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/L"], 
    StyleBox[
     RowBox[{
     "electronic", " ", "orbital", " ", "angular", " ", "momentum", " ", 
      "quantum", " ", "number"}], "TableText"]},
   {
    ButtonBox["S",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/S"], 
    StyleBox[
     RowBox[{"electronic", " ", "spin", " ", "angular", " ", "momentum"}], 
     "TableText"]},
   {
    ButtonBox["J",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/J"], 
    StyleBox[
     RowBox[{
     "total", " ", "electronic", " ", "orbital", " ", "angular", " ", 
      "momentum"}], "TableText"]},
   {
    ButtonBox["NuclearSpin",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/NuclearSpin"], 
    StyleBox[
     RowBox[{"nuclear", " ", "spin", " ", "angular", " ", "momentum"}], 
     "TableText"]},
   {
    ButtonBox["F",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/F"], 
    StyleBox[
     RowBox[{"total", " ", "angular", " ", "momentum"}], "TableText"]},
   {
    ButtonBox["M",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/M"], 
    RowBox[{
     StyleBox["z", "TI",
      FontSlant->"Italic"], 
     StyleBox["-", "TableText"], 
     StyleBox[
      RowBox[{
      "projection", " ", "of", " ", "total", " ", "orbital", " ", "angular", 
       " ", "momentum"}], "TableText"]}]},
   {
    ButtonBox["Parity",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Parity"], 
    StyleBox[
     RowBox[{"parity", ";", " ", 
      RowBox[{"either", " ", 
       ButtonBox["Even",
        BaseStyle->"Link",
        ButtonData->"paclet:AtomicDensityMatrix/ref/Even"], " ", "or", " ", 
       ButtonBox["Odd",
        BaseStyle->"Link",
        ButtonData->"paclet:AtomicDensityMatrix/ref/Odd"]}]}], "TableText"]},
   {
    ButtonBox["Energy",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"], 
    StyleBox[
     RowBox[{"unperturbed", " ", "energy", " ", 
      RowBox[{"(", 
       RowBox[{
       "not", " ", "including", " ", "hyperfine", " ", "shift", " ", "in", 
        " ", "a", " ", "hyperfine", " ", "system"}], ")"}]}], "TableText"]},
   {
    ButtonBox["GFactor",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/GFactor"], 
    RowBox[{
     StyleBox["g", "TI"], 
     StyleBox["-", "TableText"], 
     StyleBox["factor", "TableText"]}]},
   {
    ButtonBox["NaturalWidth",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/NaturalWidth"], 
    StyleBox[
     RowBox[{"natural", " ", "linewidth"}], "TableText"]},
   {
    RowBox[{
     ButtonBox["Polarizability",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/Polarizability"], "[", 
     StyleBox["rank", "TI"], "]"}], 
    StyleBox[
     RowBox[{"electric", " ", "polarizability", " ", 
      RowBox[{"(", 
       RowBox[{"scalar", ",", " ", 
        RowBox[{"vector", " ", "or", " ", "tensor"}]}], ")"}]}], 
     "TableText"]},
   {
    ButtonBox["HyperfineA",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/HyperfineA"], 
    RowBox[{
     StyleBox["hyperfine", "TableText"], 
     StyleBox[" ", "TableText"], 
     StyleBox["A", "TI",
      FontSlant->"Italic"], 
     StyleBox[" ", "TableText"], 
     StyleBox["coefficient", "TableText"]}]},
   {
    ButtonBox["HyperfineB",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/HyperfineB"], 
    RowBox[{
     StyleBox["hyperfine", "TableText"], 
     StyleBox[" ", "TableText"], 
     StyleBox["B", "TI",
      FontSlant->"Italic"], 
     StyleBox[" ", "TableText"], 
     StyleBox["coefficient", "TableText"]}]},
   {
    RowBox[{
     RowBox[{
      ButtonBox["TransitionPolarizability",
       BaseStyle->"Link",
       ButtonData->"paclet:AtomicDensityMatrix/ref/TransitionPolarizability"],
       "[", 
      StyleBox["rank", "TI"], "]"}], "[", 
     StyleBox["lab", "TI"], "]"}], 
    RowBox[{
     StyleBox["electric", "TableText"], 
     StyleBox[" ", "TableText"], 
     StyleBox["transition", "TableText"], 
     StyleBox[" ", "TableText"], 
     StyleBox["polarizability", "TableText"], 
     StyleBox[" ", "TableText"], 
     StyleBox[
      RowBox[{"(", 
       RowBox[{"scalar", ",", " ", 
        RowBox[{"vector", " ", "or", " ", "tensor"}]}], ")"}], "TableText"], 
     StyleBox[" ", "TableText"], 
     StyleBox["to", "TableText"], 
     StyleBox[" ", "TableText"], 
     StyleBox["level", "TableText"], 
     StyleBox[" ", "TableText"], 
     StyleBox["with", "TableText"], 
     StyleBox[" ", "TableText"], 
     StyleBox["label", "TableText"], 
     StyleBox[" ", "TableText"], 
     StyleBox["lab", "TI",
      FontSlant->"Italic"]}]},
   {
    RowBox[{
     ButtonBox["BranchingRatio",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/BranchingRatio"], "[", 
     StyleBox["lab", "TI"], "]"}], 
    RowBox[{
     StyleBox["branching", "TableText"], 
     StyleBox[" ", "TableText"], 
     StyleBox["ratio", "TableText"], 
     StyleBox[" ", "TableText"], 
     StyleBox["to", "TableText"], 
     StyleBox[" ", "TableText"], 
     StyleBox["level", "TableText"], 
     StyleBox[" ", "TableText"], 
     StyleBox["with", "TableText"], 
     StyleBox[" ", "TableText"], 
     StyleBox["label", "TableText"], 
     StyleBox[" ", "TableText"], 
     StyleBox["lab", "TI"]}]}
  }]]]], "DefinitionBox",
 CellID->38109372],

Cell["Possible atomic parameters. ", "Caption",
 CellTags->"S2.2.3",
 CellID->110030987],

Cell[TextData[{
 Cell[BoxData[
  RowBox[{
   ButtonBox["StateLabel",
    BaseStyle->"Link",
    ButtonData->"paclet:ref/StateLabel"], "[", 
   StyleBox["state", "TI"], "]"}]], "InlineFormula"],
 " returns the label for that state."
}], "MathCaption",
 CellID->4535504],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StateLabel", "[", "state", "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->44081926],

Cell[BoxData["1"], "Output",
 ImageSize->{11, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->930463381]
}, Open  ]],

Cell[TextData[{
 StyleBox["param", "TI"],
 StyleBox["[", "MR"],
 StyleBox["state", "TI"],
 StyleBox["]", "MR"],
 " can be used to get the value of ",
 StyleBox["param", "TI"],
 " if it has been defined."
}], "MathCaption",
 CellID->266303124],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"J", "[", "state", "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->105761791],

Cell[BoxData[
 FractionBox["3", "2"]], "Output",
 ImageSize->{16, 30},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->559977088]
}, Open  ]],

Cell[TextData[{
 "If it hasn't been defined, ",
 StyleBox["param", "TI"],
 "[",
 StyleBox["state", "TI"],
 "] returns ",
 StyleBox["param", "TI"],
 StyleBox["[", "MR"],
 StyleBox[ButtonBox["StateLabel",
  BaseStyle->"Link",
  ButtonData->"paclet:AtomicDensityMatrix/ref/Label"], "MR"],
 StyleBox["[", "MR"],
 StyleBox["state", "TI"],
 StyleBox["]].", "MR"]
}], "MathCaption",
 CellID->412726313],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Energy", "[", "state", "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->483426200],

Cell[BoxData[
 RowBox[{"Energy", "[", "1", "]"}]], "Output",
 ImageSize->{67, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->13731945]
}, Open  ]],

Cell[TextData[Cell[BoxData[GridBox[{
   {
    RowBox[{
     ButtonBox["ZeemanSublevels",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/ZeemanSublevels"], "[", 
     StyleBox["syst", "TI"], "]"}], 
    StyleBox[
     RowBox[{
     "the", " ", "Zeeman", " ", "sublevels", " ", "of", " ", "a", " ", 
      "state", " ", "or", " ", "list", " ", "of", " ", "states"}], 
     "TableText"]},
   {
    RowBox[{
     ButtonBox["HyperfineSublevels",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/HyperfineSublevels"], "[", 
     StyleBox["syst", "TI"], "]"}], 
    StyleBox[
     RowBox[{
     "the", " ", "hyperfine", " ", "sublevels", " ", "of", " ", "a", " ", 
      "state", " ", "or", " ", "list", " ", "of", " ", "states"}], 
     "TableText"]},
   {
    RowBox[{
     ButtonBox["Sublevels",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/Sublevels"], "[", 
     StyleBox["syst", "TI"], "]"}], 
    StyleBox[
     RowBox[{
     "all", " ", "Zeeman", " ", "and", " ", "hyperfine", " ", "sublevels", 
      " "}], "TableText"]}
  }]]]], "DefinitionBox",
 CellID->193329274],

Cell["Generating sublevels of atomic states.", "Caption",
 CellID->802126245],

Cell["\<\
Zeeman and hyperfine sublevels of states with angular momentum can be \
generated automatically.\
\>", "Text",
 CellID->220687935],

Cell["Zeeman sublevels.", "MathCaption",
 CellID->423356995],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Sublevels", "[", "state", "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->552544953],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"M", "\[Rule]", 
      FractionBox["3", "2"]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"M", "\[Rule]", 
      FractionBox["1", "2"]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", 
       FractionBox["1", "2"]}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", 
       FractionBox["3", "2"]}]}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{588, 90},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->404418136]
}, Open  ]],

Cell["Hyperfine and Zeeman sublevels of a state with nuclear spin.", \
"MathCaption",
 CellID->130162118],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Sublevels", "[", 
  RowBox[{"AtomicState", "[", 
   RowBox[{"1", ",", 
    RowBox[{"L", "\[Rule]", "0"}], ",", 
    RowBox[{"S", "\[Rule]", 
     RowBox[{"1", "/", "2"}]}], ",", 
    RowBox[{"J", "\[Rule]", 
     RowBox[{"3", "/", "2"}]}], ",", 
    RowBox[{"NuclearSpin", "\[Rule]", 
     RowBox[{"1", "/", "2"}]}]}], "]"}], "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->372744504],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"L", "\[Rule]", "0"}], ",", 
     RowBox[{"S", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", "2"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"L", "\[Rule]", "0"}], ",", 
     RowBox[{"S", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"L", "\[Rule]", "0"}], ",", 
     RowBox[{"S", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"L", "\[Rule]", "0"}], ",", 
     RowBox[{"S", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"L", "\[Rule]", "0"}], ",", 
     RowBox[{"S", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "2"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"L", "\[Rule]", "0"}], ",", 
     RowBox[{"S", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"L", "\[Rule]", "0"}], ",", 
     RowBox[{"S", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"L", "\[Rule]", "0"}], ",", 
     RowBox[{"S", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{454, 240},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]=",
 CellID->24789816]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "TutorialMoreAboutSection",
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell["MORE ABOUT", "TutorialMoreAboutSection"], 
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "More About"}], "TutorialMoreAboutSection"]], 
    None}, {None, None}},
 CellFrameLabelMargins->0,
 "WholeCellGroupOpener" -> True,
 CellID->23220180],

Cell["", "SectionHeaderSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["AtomicDensityMatrix Package",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]], \
"TutorialMoreAbout",
 CellID->1567025153],

Cell["", "SectionFooterSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Specifying the Atomic System - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2013, 7, 19, 15, 4, 48.7238204}", "context" -> 
    "AtomicDensityMatrix`", "keywords" -> {"Atomic Density Matrix", "ADM"}, 
    "index" -> True, "label" -> "Atomic Density Matrix Tutorial", "language" -> 
    "en", "paclet" -> "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "In order to find explict forms for the density matrix, Hamiltonian, and \
other operators, the parameters of the atomic states must be specified. This \
is done using the AtomicState expression. A list of atomic states is known as \
an atomic system, and is the first argument to many of the functions in the \
Atomic Density Matrix package. Specifying an atomic state. This loads the \
package.", "synonyms" -> {}, "title" -> "Specifying the Atomic System", 
    "type" -> "Tutorial", "uri" -> 
    "AtomicDensityMatrix/tutorial/SpecifyingTheAtomicSystem"}, 
  "SearchTextTranslated" -> "", "SearchText" -> ""},
FrontEndVersion->"6.0 for Microsoft Windows (64-bit) (May 21, 2008)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "6.0 for Microsoft Windows (64-bit) (May 21, 2008)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "S2.2.3"->{
  Cell[27653, 682, 88, 2, 70, "Caption",
   CellTags->"S2.2.3",
   CellID->110030987]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"S2.2.3", 41490, 1125}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 78, 1, 3, "TutorialColorBar"],
Cell[649, 24, 220, 5, 70, "LinkTrail"],
Cell[872, 31, 17388, 344, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[18285, 379, 65, 1, 70, "Title",
 CellID->471728094],
Cell[18353, 382, 670, 17, 70, "Text",
 CellID->97203088],
Cell[19026, 401, 1583, 49, 70, "DefinitionBox",
 CellID->50998985],
Cell[20612, 452, 66, 1, 70, "Caption",
 CellID->218865873],
Cell[20681, 455, 66, 1, 70, "MathCaption",
 CellID->314617643],
Cell[20750, 458, 107, 3, 70, "Input",
 CellID->609886833],
Cell[20860, 463, 397, 11, 70, "Text",
 CellID->753327094],
Cell[21260, 476, 58, 1, 70, "MathCaption",
 CellID->207601131],
Cell[CellGroupData[{
Cell[21343, 481, 323, 10, 70, "Input",
 CellID->505500221],
Cell[21669, 493, 375, 12, 70, "Output",
 CellID->425649877]
}, Open  ]],
Cell[22059, 508, 5591, 172, 70, "DefinitionBox",
 CellID->38109372],
Cell[27653, 682, 88, 2, 70, "Caption",
 CellTags->"S2.2.3",
 CellID->110030987],
Cell[27744, 686, 268, 9, 70, "MathCaption",
 CellID->4535504],
Cell[CellGroupData[{
Cell[28037, 699, 109, 3, 70, "Input",
 CellID->44081926],
Cell[28149, 704, 158, 5, 70, "Output",
 CellID->930463381]
}, Open  ]],
Cell[28322, 712, 242, 9, 70, "MathCaption",
 CellID->266303124],
Cell[CellGroupData[{
Cell[28589, 725, 101, 3, 70, "Input",
 CellID->105761791],
Cell[28693, 730, 178, 6, 70, "Output",
 CellID->559977088]
}, Open  ]],
Cell[28886, 739, 395, 15, 70, "MathCaption",
 CellID->412726313],
Cell[CellGroupData[{
Cell[29306, 758, 106, 3, 70, "Input",
 CellID->483426200],
Cell[29415, 763, 189, 6, 70, "Output",
 CellID->13731945]
}, Open  ]],
Cell[29619, 772, 1153, 34, 70, "DefinitionBox",
 CellID->193329274],
Cell[30775, 808, 77, 1, 70, "Caption",
 CellID->802126245],
Cell[30855, 811, 140, 4, 70, "Text",
 CellID->220687935],
Cell[30998, 817, 60, 1, 70, "MathCaption",
 CellID->423356995],
Cell[CellGroupData[{
Cell[31083, 822, 109, 3, 70, "Input",
 CellID->552544953],
Cell[31195, 827, 1458, 45, 70, "Output",
 CellID->404418136]
}, Open  ]],
Cell[32668, 875, 105, 2, 70, "MathCaption",
 CellID->130162118],
Cell[CellGroupData[{
Cell[32798, 881, 409, 12, 70, "Input",
 CellID->372744504],
Cell[33210, 895, 3458, 98, 70, "Output",
 CellID->24789816]
}, Open  ]],
Cell[CellGroupData[{
Cell[36705, 998, 747, 21, 70, "TutorialMoreAboutSection",
 CellID->23220180],
Cell[37455, 1021, 861, 21, 70, "SectionHeaderSpacer"],
Cell[38319, 1044, 192, 5, 70, "TutorialMoreAbout",
 CellID->1567025153],
Cell[38514, 1051, 861, 21, 70, "SectionFooterSpacer"]
}, Open  ]]
}, Open  ]],
Cell[39402, 1076, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

