(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     56694,       1609]
NotebookOptionsPosition[     51527,       1449]
NotebookOutlinePosition[     53566,       1500]
CellTagsIndexPosition[     53523,       1497]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "TutorialColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["AtomicDensityMatrix Package",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {
    StyleBox[
     GraphicsBox[RasterBox[CompressedData["
1:eJy9lulTk1cUxp+Zfu+Xfu5MO9O/oF90povj0A6dVtupdRsBqwRCg+DCqCxF
LLIIoUAIyGLayqJCFZRYVJaAaDBsQkBCEhaVoCjEBAiLTSLJ7bmX0nEBhZZ6
5mbmTebN/d3nnOec930/cN+mwLcAvEefD+jDr9nrwul0DvabbdaxuwNm++Ox
197/r8PQrY/bLwnyxYFvEL0F8TtwOiNq9IHFYDC4XK5VBGmvaXasg/QLRH6H
xABkBiFXhvw9fCVJP7LZbKsFemwdC1gP2ZdcjnwXCvag9BAuxOByHC4dQUU0
dBfzV4vV0aoL+4orOv49ckNRHo3qeDQehy4NzWnQpvCv/W2aRf+70vSeK8o/
+C0vkDIEZYdx5SfclKM9Az05MOai9wQ6FahLwJT9ObeQkaqrq3t7e1fESo+W
/LgV8t1QhfPU1Seh5WfczoY5D4Mn0V/AoSSwNkfidjnpfofDUVVVpVKpFArF
5OTkiliZMZJ4PyiCceYg/ohDUyq6stCXhzsqziIicXVyXriyVMnQoHnt2rV+
fn5paWkmk2lFIAptrfqYHzceJZBy1ZaObiUGCjirL5/nsDWdl+yXvfw8R3e8
EyYLIVBhYSEJfMW25F6HCKeI+R+npxzJOzmLEtiQhFuZvEzEouzps9CQzN1C
5s8IQroE4VvWJB2NLsqKP3U8vCI7ytypm0/syzExMaFWqxMTE2NjY0NDQ6VS
aVNTk8vpVMVLToZxq9cnclZvLsd1KDiFtFA1Y7aAtKfuflsRFXA+YSMdifzT
ks7PdjXV1/7IspS69vZ2uVyeLYKqbLFYGmursqUoO8RzRSwqUJcSJRGcsssH
gZ/zYULaC/fzapJVhn7F47MYPw/b77CVYlCFe83qpXDUFw0NDSUlJZRPo9FY
U1OTk5kWfzjsVOQ6qg7t1piMw5uw/VPs/gx7N/JhQiBy42gJZi/iaS3YdTAd
WBtYEzwaTJbj0a0lcez5TrxvGcpOOFCsiCOxOTEBcdu5HN7jm3k7kG2ou20X
4KqDpxXsNlgPmAmsD6xfXLdh5jK8Txev3cthHbHkhWLfRq6FRhY1OMmZ92db
BkbPYk4LZgS7BzYMZhHr/sIaBNPDZX6VtGeDJvDWT3iBwjZwM5yQ8ZLdSMGA
CvZyeBrE+Qn0QLCGwO6KixGwh+JHwg0vi3X6t/xtArTvayT4o/gAauLRmYVH
xXBWgmnAOsEMYunBugSXEnhHqBsRi9Cji4/NZ6MgK3Xrx7xAVB3qIz7b0/jQ
mD4PTzXYNbBWjrBW4mExZtXw1nNLcKhRyLEIgXThMC8ndTvXI3Yb0gNx+Sjv
rNHT+FMN1igo3VzIXD0myjB5DtMV8F5ZOECXcMggF2hvW+OcedUkoYcXGTvY
lzucZi+BqLlmKjB3FV6dOLlZ7Ebb3oRXAzeZrUak9IYwPN3QK264jYfmG0ql
UqfTud3uRVl1V9TkOrKcUoq6YzDlwVEBz3V42xfyc0eUhjbsAGsB04qlE/QO
oYv8b5Iw19+KZmdnl9JVVX7m0CZkSXmNqP2fXIS3UezQt+DqAZFDk/BGm8A1
i9Uivhqj2IiGzS2rrcI30OjGuUgYcmAthUcr0jK44K57mGp511r1ITdDI7xa
Pi68VKkWibs5io3pl0mZj+wjkuwf+AgdL8VcrUiLSfTmiOigHlSejLTb7XNP
HJ6pMc+4hdFkWPZweCGMHbriCJjzMX1B2NggCjQkerYLTlufv79/T0/PUuVe
UdDTpzLJl56Jzkui3D0LxuuVOMctPj4+MpksOTlZr9f/dxbFU5dztFtjPcPN
7CUnd0cxq34+URERESEhISkpKTMzM6vC+ic8bucLg3p4eDgoKIjel1YXtGjQ
e0JwcDA94N4Ai6KoqGh8fPzNsFbFgf9r/AWVRIUY
       "], {{0, 0}, {36, 32}}, {0, 255},
       ColorFunction->RGBColor],
      ImageSize->{36, 32},
      PlotRange->{{0, 36}, {0, 32}}],
     Deployed->True,
     StripOnInput->False], Cell[
    "ATOMIC DENSITY MATRIX TUTORIAL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "Hyperfine Structure: Breit-Rabi Diagram", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/tutorial/\
HyperfineStructureBreitRabiDiagram", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"Hyperfine Structure: Breit-Rabi Diagram\"\>"}, 
       FrameBox["\<\"Related Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"Related Tutorials \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix Package", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"AtomicDensityMatrix Package\"\>"}, 
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"More About \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix/tutorial/StarkMixing", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> None, 
          StringReplace[
           "Copy Mathematica url", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  StringReplace[
                  "AtomicDensityMatrix/tutorial/StarkMixing", 
                   "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], Delimiter, 
          StringReplace[
           "Copy web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  BoxData[
                   MakeBoxes[
                    Hyperlink[
                    StringReplace[
                    "http://reference.wolfram.com/mathematica/\
AtomicDensityMatrix/tutorial/StarkMixing.html", 
                    "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]], StandardForm]], 
                  StringReplace[
                  "Input", "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"], TextClipboardType -> 
                  StringReplace[
                   "PlainText", "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], 
          StringReplace[
           "Go to web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> FrontEndExecute[{
             NotebookLocate[{
               URL[
                StringJoin[
                 StringReplace[
                 "http://reference.wolfram.com/mathematica/", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 "AtomicDensityMatrix/tutorial/StarkMixing", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 ".html", "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"]]], None}]}]}, #, 2]& , 
        Evaluator -> Automatic], {
       1->"\<\"AtomicDensityMatrix/tutorial/StarkMixing\"\>", 
       2->"\<\"Copy Mathematica url\"\>", Delimiter, 
       4->"\<\"Copy web url\"\>", 5->"\<\"Go to web url\"\>"}, 
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"URL \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxAlignment->{"Columns" -> {{Left, Left, Right}}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.05], 
     Scaled[0.3], {
      Scaled[0.64]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Stark Mixing", "Title",
 CellID->122350],

Cell["\<\
Electric fields cause mixing of opposite-parity atomic states, and consequent \
energy shifts. If all relevant atomic states are included in the system, the \
mixing and splitting can be found by finding the eigenvalues and eigenvectors \
of the Hamiltonian. \
\>", "Text",
 CellID->217979270],

Cell[TextData[{
 "Here we analyze a ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"J", "=", "2"}], "InlineMath"]]],
 " state mixed with a ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"J", "=", "1"}], "InlineMath"]]],
 " state by a ",
 Cell[BoxData[
  StyleBox["z", "InlineMath"]]],
 "-directed electric field."
}], "Text",
 CellID->14981418],

Cell["This loads the package.", "MathCaption",
 CellID->159403208],

Cell[BoxData[
 RowBox[{"<<", "AtomicDensityMatrix`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->75905070],

Cell["Define the atomic system.", "MathCaption",
 CellID->210450481],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"system", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", 
       RowBox[{"J", "\[Rule]", "2"}], ",", 
       RowBox[{"L", "\[Rule]", "2"}], ",", 
       RowBox[{"S", "\[Rule]", "0"}], ",", 
       RowBox[{"Energy", "\[Rule]", "0"}]}], "]"}], ",", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"2", ",", 
       RowBox[{"J", "\[Rule]", "1"}], ",", 
       RowBox[{"L", "\[Rule]", "1"}], ",", 
       RowBox[{"S", "\[Rule]", "0"}], ",", 
       RowBox[{"Energy", "\[Rule]", "\[CapitalDelta]"}]}], "]"}]}], "}"}], 
   "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->877256330],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{"L", "\[Rule]", "2"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "2"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{"L", "\[Rule]", "2"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{"L", "\[Rule]", "2"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{"L", "\[Rule]", "2"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{"L", "\[Rule]", "2"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "2"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "\[CapitalDelta]"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "\[CapitalDelta]"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "\[CapitalDelta]"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{365, 135},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->58050191]
}, Open  ]],

Cell[TextData[{
 "The Hamiltonian for the system subject to a ",
 Cell[BoxData[
  StyleBox["z", "InlineMath"]]],
 "-directed electric field, in terms of the \"reduced Rabi frequency\"."
}], "MathCaption",
 CellID->198653609],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", 
  RowBox[{"h", "=", 
   RowBox[{"Hamiltonian", "[", 
    RowBox[{"system", ",", 
     RowBox[{"ElectricField", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", 
        RowBox[{"\[CapitalOmega]R", "/", 
         RowBox[{"ReducedME", "[", 
          RowBox[{"1", ",", 
           RowBox[{"{", 
            RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}]}], 
       "}"}]}]}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->528282370],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        SqrtBox["10"]]}], "0", "0"},
     {"0", "0", "0", "0", "0", "0", 
      RowBox[{
       RowBox[{"-", 
        SqrtBox[
         FractionBox["2", "15"]]}], " ", "\[CapitalOmega]R"}], "0"},
     {"0", "0", "0", "0", "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        SqrtBox["10"]]}]},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        SqrtBox["10"]]}], "0", "0", "0", "\[CapitalDelta]", "0", "0"},
     {"0", "0", 
      RowBox[{
       RowBox[{"-", 
        SqrtBox[
         FractionBox["2", "15"]]}], " ", "\[CapitalOmega]R"}], "0", "0", "0", 
      "\[CapitalDelta]", "0"},
     {"0", "0", "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        SqrtBox["10"]]}], "0", "0", "0", "\[CapitalDelta]"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{358, 235},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//MatrixForm=",
 CellID->155114448]
}, Open  ]],

Cell["\<\
The level diagram for the system, showing the mixing induced by the electric \
field..\
\>", "MathCaption",
 CellID->18473580],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LevelDiagram", "[", 
  RowBox[{"system", ",", 
   RowBox[{"h", "/.", 
    RowBox[{"\[CapitalDelta]", "\[Rule]", "1"}]}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->359462651],

Cell[GraphicsData["CompressedBitmap", "\<\
eJztV71rwkAcPYm1GTM6OBy4FKyQodgulUxNWihkzBqkoENpsIL9D+yWP6Nj
xoyhk3TK6JihQ8csQnBK/d0H7UlKYorgcMPdxffevct9RN7du7Pxw6M7m4xc
bE5dbzwZPeObp+kWUhoIofW2XGMEz/n2kVVrlOc5kH83p6RRAtu2I8MwoKAu
qZXQsiwtTVOiKNJpVPc+HA53saPtWzS3prAUehzHRhRFUFCX1MrVcrkk7C9b
QadR3et8Pt/FjrZv0dzYUtxReYIxVrMsI7/6FTGTWtz+jAiH0QrDkMtLMUuw
8HzfB8r3PI/LSzHRAjYdqFjXdS4vxZgFbU5gfpmqqjn7usjp6dXkTMH6bLVa
vSwWi02r1YJJkB3p1eRMYQfp/wDb3H5FTFpIC2khLaSFtJAW0uJAFiz9QCCC
kMQlOEkSnnD25kRrgFJN0z47nc5Xu90mgbdXkxNybRMSIowM0Q7e4nwvWMzI
EFiBJVeTfkVMDLh2EARAQQzk8lJMtID1hPeDJM7lpZglnIY3x3F2d74UY2tx
Samii97HYDCoe0k8aN8L4dVrXRz/o2PDV7jlswY1vgGlP9WL\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{244, 61},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->135432012]
}, Open  ]],

Cell["Find the eigenvalues and eigenvectors of the Hamiltonian.", \
"MathCaption",
 CellID->125276603],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "/@", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"energies", ",", "states"}], "}"}], "=", 
    RowBox[{"Eigensystem", "[", "h", "]"}]}], ")"}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->622964901],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", 
     TagBox[GridBox[{
        {"0"},
        {"0"},
        {
         RowBox[{
          FractionBox["1", "10"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"5", " ", "\[CapitalDelta]"}], "-", 
            RowBox[{
             SqrtBox["5"], " ", 
             SqrtBox[
              RowBox[{
               RowBox[{"5", " ", 
                SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "10"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"5", " ", "\[CapitalDelta]"}], "-", 
            RowBox[{
             SqrtBox["5"], " ", 
             SqrtBox[
              RowBox[{
               RowBox[{"5", " ", 
                SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "10"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"5", " ", "\[CapitalDelta]"}], "+", 
            RowBox[{
             SqrtBox["5"], " ", 
             SqrtBox[
              RowBox[{
               RowBox[{"5", " ", 
                SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "10"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"5", " ", "\[CapitalDelta]"}], "+", 
            RowBox[{
             SqrtBox["5"], " ", 
             SqrtBox[
              RowBox[{
               RowBox[{"5", " ", 
                SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "30"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"15", " ", "\[CapitalDelta]"}], "-", 
            RowBox[{
             SqrtBox["15"], " ", 
             SqrtBox[
              RowBox[{
               RowBox[{"15", " ", 
                SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
               RowBox[{"8", " ", 
                SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "30"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"15", " ", "\[CapitalDelta]"}], "+", 
            RowBox[{
             SqrtBox["15"], " ", 
             SqrtBox[
              RowBox[{
               RowBox[{"15", " ", 
                SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
               RowBox[{"8", " ", 
                SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], ")"}]}]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.5599999999999999]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      Column], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", "0", "0", "0", "1", "0", "0", "0"},
       {"1", "0", "0", "0", "0", "0", "0", "0"},
       {"0", "0", "0", 
        FractionBox[
         RowBox[{
          RowBox[{"5", " ", "\[CapitalDelta]"}], "+", 
          RowBox[{
           SqrtBox["5"], " ", 
           SqrtBox[
            RowBox[{
             RowBox[{"5", " ", 
              SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], 
         RowBox[{
          SqrtBox["10"], " ", "\[CapitalOmega]R"}]], "0", "0", "0", "1"},
       {"0", 
        FractionBox[
         RowBox[{
          RowBox[{"5", " ", "\[CapitalDelta]"}], "+", 
          RowBox[{
           SqrtBox["5"], " ", 
           SqrtBox[
            RowBox[{
             RowBox[{"5", " ", 
              SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], 
         RowBox[{
          SqrtBox["10"], " ", "\[CapitalOmega]R"}]], "0", "0", "0", "1", "0", 
        "0"},
       {"0", "0", "0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "5"}], " ", "\[CapitalDelta]"}], "+", 
           RowBox[{
            SqrtBox["5"], " ", 
            SqrtBox[
             RowBox[{
              RowBox[{"5", " ", 
               SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], 
          RowBox[{
           SqrtBox["10"], " ", "\[CapitalOmega]R"}]]}], "0", "0", "0", "1"},
       {"0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "5"}], " ", "\[CapitalDelta]"}], "+", 
           RowBox[{
            SqrtBox["5"], " ", 
            SqrtBox[
             RowBox[{
              RowBox[{"5", " ", 
               SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], 
          RowBox[{
           SqrtBox["10"], " ", "\[CapitalOmega]R"}]]}], "0", "0", "0", "1", 
        "0", "0"},
       {"0", "0", 
        FractionBox[
         RowBox[{
          RowBox[{"15", " ", "\[CapitalDelta]"}], "+", 
          RowBox[{
           SqrtBox["15"], " ", 
           SqrtBox[
            RowBox[{
             RowBox[{"15", " ", 
              SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
             RowBox[{"8", " ", 
              SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], 
         RowBox[{"2", " ", 
          SqrtBox["30"], " ", "\[CapitalOmega]R"}]], "0", "0", "0", "1", 
        "0"},
       {"0", "0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "15"}], " ", "\[CapitalDelta]"}], "+", 
           RowBox[{
            SqrtBox["15"], " ", 
            SqrtBox[
             RowBox[{
              RowBox[{"15", " ", 
               SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
              RowBox[{"8", " ", 
               SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], 
          RowBox[{"2", " ", 
           SqrtBox["30"], " ", "\[CapitalOmega]R"}]]}], "0", "0", "0", "1", 
        "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}], "}"}]], "Output",
 ImageSize->{489, 525},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->31603502]
}, Open  ]],

Cell["\<\
The eigenvalues are the new energies. Here is a plot of them as a function of \
electric field.\
\>", "MathCaption",
 CellID->499179070],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{"energies", "/.", 
     RowBox[{"\[CapitalDelta]", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[CapitalOmega]R", ",", "0", ",", "5"}], "}"}], ",", 
   RowBox[{"Frame", "\[Rule]", "True"}], ",", 
   RowBox[{"Axes", "\[Rule]", "False"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->83467549],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{180, 117},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->145273100]
}, Open  ]],

Cell["\<\
The eigenvectors are the eigenstates in the presence of the electric field, \
written as a linear combination of the original sublevels. However, they are \
not listed in the order corresponding to the original sublevels. Here we \
reorder the eigenvalues and eigenvectors so that they match the unperturbed \
quantities when the magnetic field approaches zero.\
\>", "Text",
 CellID->271683158],

Cell["\<\
Expand the eigenvectors in series for small \[CapitalOmega]R.\
\>", "MathCaption",
 CellID->468478964],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Normal", "@", 
  RowBox[{"PowerExpand", "@", 
   RowBox[{"Series", "[", 
    RowBox[{"states", ",", 
     RowBox[{"{", 
      RowBox[{"\[CapitalOmega]R", ",", "0", ",", "2"}], "}"}]}], 
    "]"}]}]}]], "Input",
 CellLabel->"In[7]:=",
 CellID->845762637],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", 
     RowBox[{
      FractionBox[
       RowBox[{
        SqrtBox["10"], " ", "\[CapitalDelta]"}], "\[CapitalOmega]R"], "+", 
      FractionBox["\[CapitalOmega]R", 
       RowBox[{
        SqrtBox["10"], " ", "\[CapitalDelta]"}]]}], ",", "0", ",", "0", ",", 
     "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{
      FractionBox[
       RowBox[{
        SqrtBox["10"], " ", "\[CapitalDelta]"}], "\[CapitalOmega]R"], "+", 
      FractionBox["\[CapitalOmega]R", 
       RowBox[{
        SqrtBox["10"], " ", "\[CapitalDelta]"}]]}], ",", "0", ",", "0", ",", 
     "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", 
     RowBox[{"-", 
      FractionBox["\[CapitalOmega]R", 
       RowBox[{
        SqrtBox["10"], " ", "\[CapitalDelta]"}]]}], ",", "0", ",", "0", ",", 
     "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", 
      FractionBox["\[CapitalOmega]R", 
       RowBox[{
        SqrtBox["10"], " ", "\[CapitalDelta]"}]]}], ",", "0", ",", "0", ",", 
     "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", 
     RowBox[{
      FractionBox[
       RowBox[{
        SqrtBox[
         FractionBox["15", "2"]], " ", "\[CapitalDelta]"}], 
       "\[CapitalOmega]R"], "+", 
      FractionBox[
       RowBox[{
        SqrtBox[
         FractionBox["2", "15"]], " ", "\[CapitalOmega]R"}], 
       "\[CapitalDelta]"]}], ",", "0", ",", "0", ",", "0", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{
        SqrtBox[
         FractionBox["2", "15"]], " ", "\[CapitalOmega]R"}], 
       "\[CapitalDelta]"]}], ",", "0", ",", "0", ",", "0", ",", "1", ",", 
     "0"}], "}"}]}], "}"}]], "Output",
 ImageSize->{518, 153},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]=",
 CellID->146166328]
}, Open  ]],

Cell["Normalize the eigenvectors, and then expand in series again.", \
"MathCaption",
 CellID->42403709],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Normal", "@", 
  RowBox[{"PowerExpand", "@", 
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"#", "/", 
        SqrtBox[
         RowBox[{"#", ".", "#"}]]}], "&"}], "/@", "%"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[CapitalOmega]R", ",", "0", ",", "0"}], "}"}]}], 
    "]"}]}]}]], "Input",
 CellLabel->"In[8]:=",
 CellID->188794102],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
     "0"}], "}"}]}], "}"}]], "Output",
 ImageSize->{486, 50},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[8]=",
 CellID->194511638]
}, Open  ]],

Cell["\<\
Reorder the eigenvalues and eigenvectors to match the unperturbed eigenvalues \
and eigenvectors.\
\>", "MathCaption",
 CellID->589835931],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "/@", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"energies1", ",", "states1"}], "}"}], "=", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
        "energies", "\[LeftDoubleBracket]", "#", "\[RightDoubleBracket]"}], 
        ",", 
        RowBox[{
        "states", "\[LeftDoubleBracket]", "#", "\[RightDoubleBracket]"}]}], 
       "}"}], "&"}], "@", 
     RowBox[{"Reverse", "@", 
      RowBox[{"Ordering", "[", "%", "]"}]}]}]}], ")"}]}]], "Input",
 CellLabel->"In[9]:=",
 CellID->429623164],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", 
     TagBox[GridBox[{
        {"0"},
        {
         RowBox[{
          FractionBox["1", "10"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"5", " ", "\[CapitalDelta]"}], "-", 
            RowBox[{
             SqrtBox["5"], " ", 
             SqrtBox[
              RowBox[{
               RowBox[{"5", " ", 
                SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "30"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"15", " ", "\[CapitalDelta]"}], "-", 
            RowBox[{
             SqrtBox["15"], " ", 
             SqrtBox[
              RowBox[{
               RowBox[{"15", " ", 
                SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
               RowBox[{"8", " ", 
                SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "10"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"5", " ", "\[CapitalDelta]"}], "-", 
            RowBox[{
             SqrtBox["5"], " ", 
             SqrtBox[
              RowBox[{
               RowBox[{"5", " ", 
                SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], ")"}]}]},
        {"0"},
        {
         RowBox[{
          FractionBox["1", "10"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"5", " ", "\[CapitalDelta]"}], "+", 
            RowBox[{
             SqrtBox["5"], " ", 
             SqrtBox[
              RowBox[{
               RowBox[{"5", " ", 
                SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "30"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"15", " ", "\[CapitalDelta]"}], "+", 
            RowBox[{
             SqrtBox["15"], " ", 
             SqrtBox[
              RowBox[{
               RowBox[{"15", " ", 
                SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
               RowBox[{"8", " ", 
                SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "10"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"5", " ", "\[CapitalDelta]"}], "+", 
            RowBox[{
             SqrtBox["5"], " ", 
             SqrtBox[
              RowBox[{
               RowBox[{"5", " ", 
                SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], ")"}]}]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.5599999999999999]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      Column], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1", "0", "0", "0", "0", "0", "0", "0"},
       {"0", 
        FractionBox[
         RowBox[{
          RowBox[{"5", " ", "\[CapitalDelta]"}], "+", 
          RowBox[{
           SqrtBox["5"], " ", 
           SqrtBox[
            RowBox[{
             RowBox[{"5", " ", 
              SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], 
         RowBox[{
          SqrtBox["10"], " ", "\[CapitalOmega]R"}]], "0", "0", "0", "1", "0", 
        "0"},
       {"0", "0", 
        FractionBox[
         RowBox[{
          RowBox[{"15", " ", "\[CapitalDelta]"}], "+", 
          RowBox[{
           SqrtBox["15"], " ", 
           SqrtBox[
            RowBox[{
             RowBox[{"15", " ", 
              SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
             RowBox[{"8", " ", 
              SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], 
         RowBox[{"2", " ", 
          SqrtBox["30"], " ", "\[CapitalOmega]R"}]], "0", "0", "0", "1", 
        "0"},
       {"0", "0", "0", 
        FractionBox[
         RowBox[{
          RowBox[{"5", " ", "\[CapitalDelta]"}], "+", 
          RowBox[{
           SqrtBox["5"], " ", 
           SqrtBox[
            RowBox[{
             RowBox[{"5", " ", 
              SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], 
         RowBox[{
          SqrtBox["10"], " ", "\[CapitalOmega]R"}]], "0", "0", "0", "1"},
       {"0", "0", "0", "0", "1", "0", "0", "0"},
       {"0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "5"}], " ", "\[CapitalDelta]"}], "+", 
           RowBox[{
            SqrtBox["5"], " ", 
            SqrtBox[
             RowBox[{
              RowBox[{"5", " ", 
               SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], 
          RowBox[{
           SqrtBox["10"], " ", "\[CapitalOmega]R"}]]}], "0", "0", "0", "1", 
        "0", "0"},
       {"0", "0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "15"}], " ", "\[CapitalDelta]"}], "+", 
           RowBox[{
            SqrtBox["15"], " ", 
            SqrtBox[
             RowBox[{
              RowBox[{"15", " ", 
               SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
              RowBox[{"8", " ", 
               SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], 
          RowBox[{"2", " ", 
           SqrtBox["30"], " ", "\[CapitalOmega]R"}]]}], "0", "0", "0", "1", 
        "0"},
       {"0", "0", "0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "5"}], " ", "\[CapitalDelta]"}], "+", 
           RowBox[{
            SqrtBox["5"], " ", 
            SqrtBox[
             RowBox[{
              RowBox[{"5", " ", 
               SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], 
          RowBox[{
           SqrtBox["10"], " ", "\[CapitalOmega]R"}]]}], "0", "0", "0", "1"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}], "}"}]], "Output",
 ImageSize->{489, 525},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[9]=",
 CellID->176991622]
}, Open  ]],

Cell["\<\
Here we use the correctly ordered energies to plot the level diagram for the \
energy eigenstates in the presence of the electric field.\
\>", "MathCaption",
 CellID->88210042],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LevelDiagram", "[", 
  RowBox[{"system", ",", 
   RowBox[{"energies1", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\[CapitalDelta]", "\[Rule]", "1"}], ",", 
      RowBox[{"\[CapitalOmega]R", "\[Rule]", "2"}]}], "}"}]}]}], 
  "]"}]], "Input",
 CellLabel->"In[10]:=",
 CellID->848886796],

Cell[GraphicsData["CompressedBitmap", "\<\
eJzzTSzJSM1NLMlMTlRwL0osyMhMLlZwyy8CCjEzMjAwfAHiJAUGEPs/kAkl
vjD8//8fJImbSgNTzBzfv39fHxAQsN/BwYFBBUwyg/ggcbCKFIjydIhyi+PH
jzvs378fhBmUwSRYDCyLpBzVLjOEXc8lJCTAblQBk8wgPtwuYtWZEPYehRQ7
xCUG58+fR/cuSAzu3elEqmOBGMuG8OB2Dw8P5EAH8eEenEakOhaaB8QoRV3K
HBKzBf39/Q319fUgzKAMJpkr2tvb4TFLrDoTmhqL6nZoGQArLsDpURmRKgXe
v3+PpcjAljcIFxn4KAZGADnKmnc=\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{244, 98},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[10]=",
 CellID->24484200]
}, Open  ]],

Cell[TextData[{
 "We can see that sublevels with the same ",
 Cell[BoxData[
  StyleBox["M", "InlineMath"]]],
 " are mixed by the electric field, causing them to repel. There are no ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"M", "=", 
    RowBox[{"\[PlusMinus]", "2"}]}], "InlineMath"]]],
 " sublevels of the upper state, so the ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"M", "=", 
    RowBox[{"\[PlusMinus]", "2"}]}], "InlineMath"]]],
 " sublevels of the lower state do not shift."
}], "Text",
 CellID->264880464],

Cell[CellGroupData[{

Cell["", "TutorialMoreAboutSection",
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell["MORE ABOUT", "TutorialMoreAboutSection"], 
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "More About"}], "TutorialMoreAboutSection"]], 
    None}, {None, None}},
 CellFrameLabelMargins->0,
 "WholeCellGroupOpener" -> True,
 CellID->23220180],

Cell["", "SectionHeaderSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["AtomicDensityMatrix Package",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]], \
"TutorialMoreAbout",
 CellID->1567025153],

Cell["", "SectionFooterSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "RelatedTutorialsSection",
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell["RELATED TUTORIALS", "RelatedTutorialsSection"], 
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "Related Tutorials"}], "RelatedTutorialsSection"]], 
    None}, {None, None}},
 CellFrameLabelMargins->0,
 "WholeCellGroupOpener" -> True,
 CellID->415694126],

Cell["", "SectionHeaderSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["Hyperfine Structure: Breit-Rabi Diagram",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/tutorial/HyperfineStructureBreitRabiDiagram"]], \
"RelatedTutorials",
 CellID->806871991],

Cell["", "SectionFooterSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Stark Mixing - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2013, 7, 19, 15, 4, 50.1909044}", "context" -> 
    "AtomicDensityMatrix`", "keywords" -> {"Atomic Density Matrix", "ADM"}, 
    "index" -> True, "label" -> "Atomic Density Matrix Tutorial", "language" -> 
    "en", "paclet" -> "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "Electric fields cause mixing of opposite-parity atomic states, and \
consequent energy shifts. If all relevant atomic states are included in the \
system, the mixing and splitting can be found by finding the eigenvalues and \
eigenvectors of the Hamiltonian. Here we analyze a J=2 state mixed with a J=1 \
state by a z-directed electric field. This loads the package.", 
    "synonyms" -> {}, "title" -> "Stark Mixing", "type" -> "Tutorial", "uri" -> 
    "AtomicDensityMatrix/tutorial/StarkMixing"}, "SearchTextTranslated" -> "",
   "SearchText" -> ""},
FrontEndVersion->"6.0 for Microsoft Windows (64-bit) (May 21, 2008)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "6.0 for Microsoft Windows (64-bit) (May 21, 2008)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 78, 1, 3, "TutorialColorBar"],
Cell[649, 24, 220, 5, 70, "LinkTrail"],
Cell[872, 31, 9106, 189, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[10003, 224, 46, 1, 70, "Title",
 CellID->122350],
Cell[10052, 227, 303, 6, 70, "Text",
 CellID->217979270],
Cell[10358, 235, 332, 14, 70, "Text",
 CellID->14981418],
Cell[10693, 251, 66, 1, 70, "MathCaption",
 CellID->159403208],
Cell[10762, 254, 106, 3, 70, "Input",
 CellID->75905070],
Cell[10871, 259, 68, 1, 70, "MathCaption",
 CellID->210450481],
Cell[CellGroupData[{
Cell[10964, 264, 678, 19, 70, "Input",
 CellID->877256330],
Cell[11645, 285, 2524, 66, 70, "Output",
 CellID->58050191]
}, Open  ]],
Cell[14184, 354, 224, 6, 70, "MathCaption",
 CellID->198653609],
Cell[CellGroupData[{
Cell[14433, 364, 513, 15, 70, "Input",
 CellID->528282370],
Cell[14949, 381, 1672, 49, 70, "Output",
 CellID->155114448]
}, Open  ]],
Cell[16636, 433, 136, 4, 70, "MathCaption",
 CellID->18473580],
Cell[CellGroupData[{
Cell[16797, 441, 206, 6, 70, "Input",
 CellID->359462651],
Cell[17006, 449, 809, 17, 70, "Output",
 Evaluatable->False,
 CellID->135432012]
}, Open  ]],
Cell[17830, 469, 102, 2, 70, "MathCaption",
 CellID->125276603],
Cell[CellGroupData[{
Cell[17957, 475, 252, 8, 70, "Input",
 CellID->622964901],
Cell[18212, 485, 7563, 221, 70, "Output",
 CellID->31603502]
}, Open  ]],
Cell[25790, 709, 146, 4, 70, "MathCaption",
 CellID->499179070],
Cell[CellGroupData[{
Cell[25961, 717, 455, 12, 70, "Input",
 CellID->83467549],
Cell[26419, 731, 4698, 81, 70, "Output",
 Evaluatable->False,
 CellID->145273100]
}, Open  ]],
Cell[31132, 815, 405, 7, 70, "Text",
 CellID->271683158],
Cell[31540, 824, 112, 3, 70, "MathCaption",
 CellID->468478964],
Cell[CellGroupData[{
Cell[31677, 831, 277, 9, 70, "Input",
 CellID->845762637],
Cell[31957, 842, 2353, 72, 70, "Output",
 CellID->146166328]
}, Open  ]],
Cell[34325, 917, 104, 2, 70, "MathCaption",
 CellID->42403709],
Cell[CellGroupData[{
Cell[34454, 923, 397, 14, 70, "Input",
 CellID->188794102],
Cell[34854, 939, 1224, 39, 70, "Output",
 CellID->194511638]
}, Open  ]],
Cell[36093, 981, 148, 4, 70, "MathCaption",
 CellID->589835931],
Cell[CellGroupData[{
Cell[36266, 989, 579, 19, 70, "Input",
 CellID->429623164],
Cell[36848, 1010, 7564, 221, 70, "Output",
 CellID->176991622]
}, Open  ]],
Cell[44427, 1234, 186, 4, 70, "MathCaption",
 CellID->88210042],
Cell[CellGroupData[{
Cell[44638, 1242, 319, 10, 70, "Input",
 CellID->848886796],
Cell[44960, 1254, 545, 13, 70, "Output",
 Evaluatable->False,
 CellID->24484200]
}, Open  ]],
Cell[45520, 1270, 511, 16, 70, "Text",
 CellID->264880464],
Cell[CellGroupData[{
Cell[46056, 1290, 747, 21, 70, "TutorialMoreAboutSection",
 CellID->23220180],
Cell[46806, 1313, 861, 21, 70, "SectionHeaderSpacer"],
Cell[47670, 1336, 192, 5, 70, "TutorialMoreAbout",
 CellID->1567025153],
Cell[47865, 1343, 861, 21, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[48763, 1369, 759, 21, 70, "RelatedTutorialsSection",
 CellID->415694126],
Cell[49525, 1392, 861, 21, 70, "SectionHeaderSpacer"],
Cell[50389, 1415, 220, 5, 70, "RelatedTutorials",
 CellID->806871991],
Cell[50612, 1422, 861, 21, 70, "SectionFooterSpacer"]
}, Open  ]]
}, Open  ]],
Cell[51500, 1447, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

