(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     58764,       1584]
NotebookOptionsPosition[     51800,       1382]
NotebookOutlinePosition[     54903,       1449]
CellTagsIndexPosition[     54860,       1446]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "TutorialColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["AtomicDensityMatrix Package",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {
    StyleBox[
     GraphicsBox[RasterBox[CompressedData["
1:eJy9lulTk1cUxp+Zfu+Xfu5MO9O/oF90povj0A6dVtupdRsBqwRCg+DCqCxF
LLIIoUAIyGLayqJCFZRYVJaAaDBsQkBCEhaVoCjEBAiLTSLJ7bmX0nEBhZZ6
5mbmTebN/d3nnOec930/cN+mwLcAvEefD+jDr9nrwul0DvabbdaxuwNm++Ox
197/r8PQrY/bLwnyxYFvEL0F8TtwOiNq9IHFYDC4XK5VBGmvaXasg/QLRH6H
xABkBiFXhvw9fCVJP7LZbKsFemwdC1gP2ZdcjnwXCvag9BAuxOByHC4dQUU0
dBfzV4vV0aoL+4orOv49ckNRHo3qeDQehy4NzWnQpvCv/W2aRf+70vSeK8o/
+C0vkDIEZYdx5SfclKM9Az05MOai9wQ6FahLwJT9ObeQkaqrq3t7e1fESo+W
/LgV8t1QhfPU1Seh5WfczoY5D4Mn0V/AoSSwNkfidjnpfofDUVVVpVKpFArF
5OTkiliZMZJ4PyiCceYg/ohDUyq6stCXhzsqziIicXVyXriyVMnQoHnt2rV+
fn5paWkmk2lFIAptrfqYHzceJZBy1ZaObiUGCjirL5/nsDWdl+yXvfw8R3e8
EyYLIVBhYSEJfMW25F6HCKeI+R+npxzJOzmLEtiQhFuZvEzEouzps9CQzN1C
5s8IQroE4VvWJB2NLsqKP3U8vCI7ytypm0/syzExMaFWqxMTE2NjY0NDQ6VS
aVNTk8vpVMVLToZxq9cnclZvLsd1KDiFtFA1Y7aAtKfuflsRFXA+YSMdifzT
ks7PdjXV1/7IspS69vZ2uVyeLYKqbLFYGmursqUoO8RzRSwqUJcSJRGcsssH
gZ/zYULaC/fzapJVhn7F47MYPw/b77CVYlCFe83qpXDUFw0NDSUlJZRPo9FY
U1OTk5kWfzjsVOQ6qg7t1piMw5uw/VPs/gx7N/JhQiBy42gJZi/iaS3YdTAd
WBtYEzwaTJbj0a0lcez5TrxvGcpOOFCsiCOxOTEBcdu5HN7jm3k7kG2ou20X
4KqDpxXsNlgPmAmsD6xfXLdh5jK8Txev3cthHbHkhWLfRq6FRhY1OMmZ92db
BkbPYk4LZgS7BzYMZhHr/sIaBNPDZX6VtGeDJvDWT3iBwjZwM5yQ8ZLdSMGA
CvZyeBrE+Qn0QLCGwO6KixGwh+JHwg0vi3X6t/xtArTvayT4o/gAauLRmYVH
xXBWgmnAOsEMYunBugSXEnhHqBsRi9Cji4/NZ6MgK3Xrx7xAVB3qIz7b0/jQ
mD4PTzXYNbBWjrBW4mExZtXw1nNLcKhRyLEIgXThMC8ndTvXI3Yb0gNx+Sjv
rNHT+FMN1igo3VzIXD0myjB5DtMV8F5ZOECXcMggF2hvW+OcedUkoYcXGTvY
lzucZi+BqLlmKjB3FV6dOLlZ7Ebb3oRXAzeZrUak9IYwPN3QK264jYfmG0ql
UqfTud3uRVl1V9TkOrKcUoq6YzDlwVEBz3V42xfyc0eUhjbsAGsB04qlE/QO
oYv8b5Iw19+KZmdnl9JVVX7m0CZkSXmNqP2fXIS3UezQt+DqAZFDk/BGm8A1
i9Uivhqj2IiGzS2rrcI30OjGuUgYcmAthUcr0jK44K57mGp511r1ITdDI7xa
Pi68VKkWibs5io3pl0mZj+wjkuwf+AgdL8VcrUiLSfTmiOigHlSejLTb7XNP
HJ6pMc+4hdFkWPZweCGMHbriCJjzMX1B2NggCjQkerYLTlufv79/T0/PUuVe
UdDTpzLJl56Jzkui3D0LxuuVOMctPj4+MpksOTlZr9f/dxbFU5dztFtjPcPN
7CUnd0cxq34+URERESEhISkpKTMzM6vC+ic8bucLg3p4eDgoKIjel1YXtGjQ
e0JwcDA94N4Ai6KoqGh8fPzNsFbFgf9r/AWVRIUY
       "], {{0, 0}, {36, 32}}, {0, 255},
       ColorFunction->RGBColor],
      ImageSize->{36, 32},
      PlotRange->{{0, 36}, {0, 32}}],
     Deployed->True,
     StripOnInput->False], Cell[
    "ATOMIC DENSITY MATRIX TUTORIAL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "Zeeman Structure: EIT and Atomic Polarization", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/tutorial/\
ZeemanStructureEITAndAtomicPolarization", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {
       1->"\<\"Zeeman Structure: EIT and Atomic Polarization\"\>"}, 
       FrameBox["\<\"Related Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"Related Tutorials \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix Package", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"AtomicDensityMatrix Package\"\>"}, 
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"More About \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix/tutorial/\
ThreeLevelSystemElectromagneticallyInducedTransparency", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> None, 
          StringReplace[
           "Copy Mathematica url", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  StringReplace[
                  "AtomicDensityMatrix/tutorial/\
ThreeLevelSystemElectromagneticallyInducedTransparency", 
                   "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], Delimiter, 
          StringReplace[
           "Copy web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  BoxData[
                   MakeBoxes[
                    Hyperlink[
                    StringReplace[
                    "http://reference.wolfram.com/mathematica/\
AtomicDensityMatrix/tutorial/\
ThreeLevelSystemElectromagneticallyInducedTransparency.html", 
                    "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]], StandardForm]], 
                  StringReplace[
                  "Input", "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"], TextClipboardType -> 
                  StringReplace[
                   "PlainText", "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], 
          StringReplace[
           "Go to web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> FrontEndExecute[{
             NotebookLocate[{
               URL[
                StringJoin[
                 StringReplace[
                 "http://reference.wolfram.com/mathematica/", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 "AtomicDensityMatrix/tutorial/\
ThreeLevelSystemElectromagneticallyInducedTransparency", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 ".html", "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"]]], None}]}]}, #, 2]& , 
        Evaluator -> Automatic], {
       1->"\<\"AtomicDensityMatrix/tutorial/\
ThreeLevelSystemElectromagneticallyInducedTransparency\"\>", 
       2->"\<\"Copy Mathematica url\"\>", Delimiter, 
       4->"\<\"Copy web url\"\>", 5->"\<\"Go to web url\"\>"}, 
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"URL \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxAlignment->{"Columns" -> {{Left, Left, Right}}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.05], 
     Scaled[0.3], {
      Scaled[0.64]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Three-level System: Electromagnetically Induced Transparency", "Title",
 CellID->509267359],

Cell[TextData[{
 "Consider an atomic \[CapitalLambda]-system: a three-level system with two \
same-parity lower states |1\[RightAngleBracket] and |2\[RightAngleBracket],  \
and an upper state |3\[RightAngleBracket] with opposite parity. A \
near-resonant light field consisting of two phase-coherent components of \
frequency ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    SubscriptBox["\[Omega]", "a"], "InlineMath"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    SubscriptBox["\[Omega]", "b"], "InlineMath"], TraditionalForm]]],
 " is applied. When the difference frequency ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{
     SubscriptBox[
      StyleBox["\[CapitalDelta]", "InlineMath"], 
      RowBox[{"a", "\[VeryThinSpace]", "b"}]], "=", 
     RowBox[{
      SubscriptBox["\[Omega]", "a"], "-", 
      SubscriptBox["\[Omega]", "b"]}]}], "InlineMath"], TraditionalForm]]],
 " is equal to the frequency splitting ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    SubscriptBox["\[CapitalDelta]", "12"], "InlineMath"], TraditionalForm]]],
 " of the two lower levels (the Raman resonance condition), the system is \
pumped into a coherent superposition of the two lower states which no longer \
absorbs the bichromatic field. When one frequency component of the light \
field is much stronger than the other, it is referred to as a \"coupling\" or \
\"drive\" field, and the reduction of the absorption of the weaker probe \
field is called \"electromagnetically induced transparency\". Other names \
used to refer to this situation are \"dark resonance\" and \"coherent \
population trapping\". "
}], "Text",
 CellID->1534169418],

Cell["This loads the package.", "MathCaption",
 CellID->836781195],

Cell[BoxData[
 RowBox[{"<<", "AtomicDensityMatrix`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->2058623809],

Cell[TextData[{
 "We define an atomic system consisting of two even-parity lower states and \
an odd-parity upper state. We apply a light field with components at \
frequencies ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    SubscriptBox["\[Omega]", "a"], "InlineMath"], TraditionalForm]]],
 " (near resonant with the ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"|", "1"}], "\[RightAngleBracket]"}], "\[Rule]", 
     RowBox[{"|", "3"}]}], "\[RightAngleBracket]"}], "InlineMath"]]],
 " transition) and ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    SubscriptBox["\[Omega]", "b"], "InlineMath"], TraditionalForm]]],
 " (near resonant with the ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"|", "2"}], "\[RightAngleBracket]"}], "\[Rule]", 
     RowBox[{"|", "3"}]}], "\[RightAngleBracket]"}], "InlineMath"]]],
 " transition)."
}], "Text",
 CellID->525777075],

Cell["Define the atomic system.", "MathCaption",
 CellID->429217524],

Cell[BoxData[
 RowBox[{
  RowBox[{"system", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", 
       RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
       RowBox[{"Parity", "\[Rule]", "Even"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"2", ",", 
       RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
       RowBox[{"Parity", "\[Rule]", "Even"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"3", ",", 
       RowBox[{"Energy", "\[Rule]", "0"}], ",", 
       RowBox[{
        RowBox[{"BranchingRatio", "[", "1", "]"}], "\[Rule]", 
        RowBox[{"1", "/", "2"}]}], ",", 
       RowBox[{
        RowBox[{"BranchingRatio", "[", "2", "]"}], "\[Rule]", 
        RowBox[{"1", "/", "2"}]}], ",", 
       RowBox[{"NaturalWidth", "\[Rule]", "\[CapitalGamma]"}], ",", 
       RowBox[{"Parity", "\[Rule]", "Odd"}]}], "]"}]}], "\[IndentingNewLine]",
     "}"}]}], ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->433132487],

Cell["Remove explict time dependence from the density matrix.", "MathCaption",
 CellID->690131918],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SetOptions", "[", 
  RowBox[{"DensityMatrix", ",", 
   RowBox[{"TimeDependence", "\[Rule]", "False"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->718931880],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"TimeDependence", "\[Rule]", "False"}], ",", 
   RowBox[{"Representation", "\[Rule]", "Zeeman"}], ",", 
   RowBox[{"DMSymbol", "\[Rule]", "\[Rho]"}], ",", 
   RowBox[{"DMLabel", "\[Rule]", "None"}], ",", 
   RowBox[{"ComplexExpandVariables", "\[Rule]", "False"}], ",", 
   RowBox[{"TimeVariable", "\[Rule]", "t"}]}], "}"}]], "Output",
 ImageSize->{446, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->30985269]
}, Open  ]],

Cell["Here is what the density matrix looks like.", "MathCaption",
 CellID->272609152],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DensityMatrix", "[", "system", "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->611420683],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      SubscriptBox["\[Rho]", 
       RowBox[{"1", ",", "1"}]], 
      SubscriptBox["\[Rho]", 
       RowBox[{"1", ",", "2"}]], 
      SubscriptBox["\[Rho]", 
       RowBox[{"1", ",", "3"}]]},
     {
      SubscriptBox["\[Rho]", 
       RowBox[{"2", ",", "1"}]], 
      SubscriptBox["\[Rho]", 
       RowBox[{"2", ",", "2"}]], 
      SubscriptBox["\[Rho]", 
       RowBox[{"2", ",", "3"}]]},
     {
      SubscriptBox["\[Rho]", 
       RowBox[{"3", ",", "1"}]], 
      SubscriptBox["\[Rho]", 
       RowBox[{"3", ",", "2"}]], 
      SubscriptBox["\[Rho]", 
       RowBox[{"3", ",", "3"}]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{109, 45},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]//MatrixForm=",
 CellID->63311256]
}, Open  ]],

Cell[TextData[{
 "Define the optical field with two frequencies, ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    SubscriptBox["\[Omega]", "a"], "InlineMath"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    SubscriptBox["\[Omega]", "b"], "InlineMath"], TraditionalForm]]],
 "."
}], "MathCaption",
 CellID->133602844],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"field", "=", 
  RowBox[{
   RowBox[{"OpticalField", "[", 
    RowBox[{"\[Omega]a", ",", 
     RowBox[{"\[CapitalOmega]Ra", "/", 
      RowBox[{"ReducedME", "[", 
       RowBox[{"1", ",", 
        RowBox[{"{", 
         RowBox[{"Dipole", ",", "1"}], "}"}], ",", "3"}], "]"}]}]}], "]"}], 
   "+", 
   RowBox[{"OpticalField", "[", 
    RowBox[{"\[Omega]b", ",", 
     RowBox[{"\[CapitalOmega]Rb", "/", 
      RowBox[{"ReducedME", "[", 
       RowBox[{"2", ",", 
        RowBox[{"{", 
         RowBox[{"Dipole", ",", "1"}], "}"}], ",", "3"}], "]"}]}]}], 
    "]"}]}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->534530029],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    FractionBox[
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]a"}]], " ", 
      "\[CapitalOmega]Ra"}], 
     RowBox[{"ReducedME", "[", 
      RowBox[{"1", ",", 
       RowBox[{"{", 
        RowBox[{"Dipole", ",", "1"}], "}"}], ",", "3"}], "]"}]], "+", 
    FractionBox[
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]b"}]], " ", 
      "\[CapitalOmega]Rb"}], 
     RowBox[{"ReducedME", "[", 
      RowBox[{"2", ",", 
       RowBox[{"{", 
        RowBox[{"Dipole", ",", "1"}], "}"}], ",", "3"}], "]"}]]}], ",", "0", 
   ",", "0"}], "}"}]], "Output",
 ImageSize->{451, 36},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->52954590]
}, Open  ]],

Cell["\<\
The Hamiltonian for the system subject to the optical field. Each field is \
assumed to interact with only one transition\[LongDash]the other terms are \
set to zero.\
\>", "MathCaption",
 CellID->462076121],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", 
  RowBox[{"H", "=", 
   RowBox[{
    RowBox[{"Expand", "@", 
     RowBox[{"Hamiltonian", "[", 
      RowBox[{"system", ",", 
       RowBox[{"ElectricField", "\[Rule]", "field"}]}], "]"}]}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", "\[Omega]a"}], "]"}], " ", 
        RowBox[{"ReducedME", "[", 
         RowBox[{"2", ",", 
          RowBox[{"{", 
           RowBox[{"Dipole", ",", "1"}], "}"}], ",", "3"}], "]"}]}], 
       "\[Rule]", "0"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", "\[Omega]b"}], "]"}], " ", 
        RowBox[{"ReducedME", "[", 
         RowBox[{"1", ",", 
          RowBox[{"{", 
           RowBox[{"Dipole", ",", "1"}], "}"}], ",", "3"}], "]"}]}], 
       "\[Rule]", "0"}]}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->494599775],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"Energy", "[", "1", "]"}], "0", 
      RowBox[{
       RowBox[{"-", "\[CapitalOmega]Ra"}], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]a"}], "]"}]}]},
     {"0", 
      RowBox[{"Energy", "[", "2", "]"}], 
      RowBox[{
       RowBox[{"-", "\[CapitalOmega]Rb"}], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]b"}], "]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "\[CapitalOmega]Ra"}], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]a"}], "]"}]}], 
      RowBox[{
       RowBox[{"-", "\[CapitalOmega]Rb"}], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]b"}], "]"}]}], "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{313, 43},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]//MatrixForm=",
 CellID->819487573]
}, Open  ]],

Cell["The level diagram for the system.", "MathCaption",
 CellID->358620443],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LevelDiagram", "[", 
  RowBox[{"system", ",", 
   RowBox[{"H", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"Energy", "[", "1", "]"}], "\[Rule]", 
       RowBox[{"-", "1"}]}], ",", 
      RowBox[{
       RowBox[{"Energy", "[", "2", "]"}], "\[Rule]", 
       RowBox[{"-", "1.5"}]}]}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->167259034],

Cell[BoxData[
 GraphicsBox[{{{{}, LineBox[{{-0.9, -1}, {-0.09999999999999998, -1}}]}, {{}, 
     LineBox[{{-0.9, -1.5}, {-0.09999999999999998, -1.5}}]}, {{}, 
     LineBox[{{0.09999999999999998, 0}, {0.9, 0}}]}}, {{}, {}, {}}, 
   {Arrowheads[{-0.07659574468085106, 0.07659574468085106}], 
    ArrowBox[{{-0.45999999999999996`, -1}, {0.45999999999999996`, 0.}}], 
    ArrowBox[{{-0.45999999999999996`, -1.5}, {0.45999999999999996`, 0.}}]}, 
   {PointSize[0.0225]}},
  ImagePadding->{{2, 2}, {2, 2}},
  ImageSize->94.]], "Output",
 ImageSize->{98, 79},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]=",
 CellID->479247961]
}, Open  ]],

Cell["Apply the rotating-wave approximation to the Hamiltonian.", \
"MathCaption",
 CellID->577766068],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"Hrwa", "=", 
    RowBox[{"RotatingWaveApproximation", "[", 
     RowBox[{"system", ",", "H", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Omega]a", ",", 
          RowBox[{"1", "\[Rule]", "3"}], ",", "\[CapitalDelta]a"}], "}"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"\[Omega]b", ",", 
          RowBox[{"2", "\[Rule]", "3"}], ",", "\[CapitalDelta]b"}], "}"}]}], 
       "}"}], ",", 
      RowBox[{"Method", "\[Rule]", "\"\<ShiftLowerState\>\""}]}], "]"}]}], 
   ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->353525722],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[Omega]a", ",", 
     RowBox[{"1", "\[Rule]", "3"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Omega]b", ",", 
     RowBox[{"2", "\[Rule]", "3"}]}], "}"}]}], "}"}]], "Print",
 CellLabel->"During evaluation of In[8]:=",
 CellID->608655604],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"\[CapitalDelta]a", "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]Ra", "2"]}]},
     {"0", "\[CapitalDelta]b", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]Rb", "2"]}]},
     {
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]Ra", "2"]}], 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]Rb", "2"]}], "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{121, 69},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[8]//MatrixForm=",
 CellID->382279471]
}, Open  ]],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["IntrinsicRelaxation",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/IntrinsicRelaxation"]], 
  "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["TransitRelaxation",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/TransitRelaxation"]], 
  "InlineFormula"],
 " supply the relaxation matrices."
}], "MathCaption",
 CellID->610306692],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", 
  RowBox[{"relax", "=", 
   RowBox[{
    RowBox[{"IntrinsicRelaxation", "[", "system", "]"}], "+", 
    RowBox[{"TransitRelaxation", "[", 
     RowBox[{"system", ",", "\[Gamma]"}], "]"}]}]}], "]"}]], "Input",
 CellLabel->"In[9]:=",
 CellID->645617687],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"\[Gamma]", "0", "0"},
     {"0", "\[Gamma]", "0"},
     {"0", "0", 
      RowBox[{"\[Gamma]", "+", "\[CapitalGamma]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{81, 43},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[9]//MatrixForm=",
 CellID->250605992]
}, Open  ]],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["OpticalRepopulation",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/OpticalRepopulation"]], 
  "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["TransitRepopulation",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/TransitRepopulation"]], 
  "InlineFormula"],
 " supply the repopulation matrices."
}], "MathCaption",
 CellID->854192725],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", 
  RowBox[{"repop", "=", 
   RowBox[{
    RowBox[{"OpticalRepopulation", "[", "system", "]"}], "+", 
    RowBox[{"TransitRepopulation", "[", 
     RowBox[{"system", ",", "\[Gamma]"}], "]"}]}]}], "]"}]], "Input",
 CellLabel->"In[10]:=",
 CellID->465762594],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       FractionBox["\[Gamma]", "2"], "+", 
       RowBox[{
        FractionBox["1", "2"], " ", "\[CapitalGamma]", " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"3", ",", "3"}]]}]}], "0", "0"},
     {"0", 
      RowBox[{
       FractionBox["\[Gamma]", "2"], "+", 
       RowBox[{
        FractionBox["1", "2"], " ", "\[CapitalGamma]", " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"3", ",", "3"}]]}]}], "0"},
     {"0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{185, 61},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[10]//MatrixForm=",
 CellID->714618470]
}, Open  ]],

Cell["Here are the evolution equations.", "MathCaption",
 CellID->314466782],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TableForm", "[", 
  RowBox[{"eqs", "=", 
   RowBox[{"LiouvilleEquation", "[", 
    RowBox[{"system", ",", "Hrwa", ",", "relax", ",", "repop"}], "]"}]}], 
  "]"}]], "Input",
 CellLabel->"In[11]:=",
 CellID->298399236],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{471, 213},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[11]//TableForm=",
 CellID->82183921]
}, Open  ]],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["Observables",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/Observables"]], 
  "InlineFormula"],
 " supplies the absorption and phase shift experienced by the light in terms \
of the density-matrix elements."
}], "MathCaption",
 CellID->33276359],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"obs", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Observables", "[", 
     RowBox[{"system", ",", 
      RowBox[{"Energy", "[", "1", "]"}], ",", 
      RowBox[{"\[CapitalOmega]Ra", "/", 
       RowBox[{"ReducedME", "[", 
        RowBox[{"1", ",", 
         RowBox[{"{", 
          RowBox[{"Dipole", ",", "1"}], "}"}], ",", "3"}], "]"}]}], ",", 
      RowBox[{"TransformMatrix", "\[Rule]", 
       RowBox[{"MatrixExp", "[", 
        RowBox[{
         RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", 
         RowBox[{"DiagonalMatrix", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Energy", "[", "1", "]"}], ",", "0", ",", "0"}], "}"}], 
          "]"}]}], "]"}]}]}], "]"}], "/.", 
    RowBox[{
     RowBox[{"Energy", "[", "1", "]"}], "\[Rule]", 
     RowBox[{"2", 
      RowBox[{"\[Pi]", "/", "\[Lambda]"}]}]}]}], "//", 
   "FullSimplify"}]}]], "Input",
 CellLabel->"In[12]:=",
 CellID->14642222],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     FractionBox[
      RowBox[{"3", " ", "\[CapitalGamma]", " ", 
       SuperscriptBox["\[Lambda]", "2"], " ", 
       RowBox[{"Im", "[", 
        SubscriptBox["\[Rho]", 
         RowBox[{"1", ",", "3"}]], "]"}]}], 
      RowBox[{"8", " ", "\[Pi]", " ", "\[CapitalOmega]Ra"}]], ",", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{"3", " ", "\[CapitalGamma]", " ", 
        SuperscriptBox["\[Lambda]", "2"], " ", 
        RowBox[{"Re", "[", 
         SubscriptBox["\[Rho]", 
          RowBox[{"1", ",", "3"}]], "]"}]}], 
       RowBox[{"8", " ", "\[Pi]", " ", "\[CapitalOmega]Ra"}]]}]}], "}"}], ",",
    
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}]}], "}"}]], "Output",
 ImageSize->{283, 34},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[12]=",
 CellID->269417159]
}, Open  ]],

Cell["\<\
Here is the probe absorption spectrum as a function of probe detuning.\
\>", "MathCaption",
 CellID->551099716],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"params", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\[CapitalGamma]", "\[Rule]", "1"}], ",", 
     RowBox[{"\[Gamma]", "\[Rule]", ".01"}], ",", 
     RowBox[{"\[CapitalOmega]Ra", "\[Rule]", ".1"}], ",", 
     RowBox[{"\[CapitalOmega]Rb", "\[Rule]", ".5"}], ",", 
     RowBox[{"\[CapitalDelta]b", "\[Rule]", ".5"}], ",", 
     RowBox[{"\[Lambda]", "\[Rule]", "1"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"obs", "\[LeftDoubleBracket]", 
      RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "/.", "params"}], "/.",
     
    RowBox[{"Chop", "@", 
     RowBox[{
      RowBox[{"NSolve", "[", 
       RowBox[{
        RowBox[{"eqs", "/.", "params"}], ",", 
        RowBox[{"DMVariables", "[", "system", "]"}]}], "]"}], 
      "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"\[CapitalDelta]a", ",", 
     RowBox[{"-", "8"}], ",", "8"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]}], "Input",
 CellLabel->"In[13]:=",
 CellID->889304850],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{180, 112},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[13]=",
 CellID->577640901]
}, Open  ]],

Cell["\<\
The increased transmission at the Raman resonance is associated with \
coherence induced between the |1\[RightAngleBracket] and |2\
\[RightAngleBracket] states. Here is a plot of the coherence as a function of \
probe frequency.\
\>", "MathCaption",
 CellID->517847783],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"params", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\[CapitalGamma]", "\[Rule]", "1"}], ",", 
     RowBox[{"\[Gamma]", "\[Rule]", ".01"}], ",", 
     RowBox[{"\[CapitalOmega]Ra", "\[Rule]", ".1"}], ",", 
     RowBox[{"\[CapitalOmega]Rb", "\[Rule]", ".5"}], ",", 
     RowBox[{"\[CapitalDelta]b", "\[Rule]", ".5"}], ",", 
     RowBox[{"\[Lambda]", "\[Rule]", "1"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Im", "[", 
     SubscriptBox["\[Rho]", 
      RowBox[{"1", ",", "2"}]], "]"}], "/.", 
    RowBox[{"Chop", "@", 
     RowBox[{
      RowBox[{"NSolve", "[", 
       RowBox[{
        RowBox[{"eqs", "/.", "params"}], ",", 
        RowBox[{"DMVariables", "[", "system", "]"}]}], "]"}], 
      "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"\[CapitalDelta]a", ",", 
     RowBox[{"-", "8"}], ",", "8"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]}], "Input",
 CellLabel->"In[14]:=",
 CellID->26195282],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{180, 109},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[14]=",
 CellID->1837291]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "TutorialMoreAboutSection",
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell["MORE ABOUT", "TutorialMoreAboutSection"], 
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "More About"}], "TutorialMoreAboutSection"]], 
    None}, {None, None}},
 CellFrameLabelMargins->0,
 "WholeCellGroupOpener" -> True,
 CellID->23220180],

Cell["", "SectionHeaderSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["AtomicDensityMatrix Package",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]], \
"TutorialMoreAbout",
 CellID->1567025153],

Cell["", "SectionFooterSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "RelatedTutorialsSection",
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell["RELATED TUTORIALS", "RelatedTutorialsSection"], 
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "Related Tutorials"}], "RelatedTutorialsSection"]], 
    None}, {None, None}},
 CellFrameLabelMargins->0,
 "WholeCellGroupOpener" -> True,
 CellID->415694126],

Cell["", "SectionHeaderSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["Zeeman Structure: EIT and Atomic Polarization",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/tutorial/\
ZeemanStructureEITAndAtomicPolarization"]], "RelatedTutorials",
 CellID->806871991],

Cell["", "SectionFooterSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Three-level System: Electromagnetically Induced Transparency - \
Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2013, 7, 19, 15, 5, 1.3785443}", "context" -> 
    "AtomicDensityMatrix`", "keywords" -> {"Atomic Density Matrix", "ADM"}, 
    "index" -> True, "label" -> "Atomic Density Matrix Tutorial", "language" -> 
    "en", "paclet" -> "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "Consider an atomic \\[CapitalLambda]-system: a three-level system with \
two same-parity lower states |1> and |2>, and an upper state |3> with \
opposite parity. A near-resonant light field consisting of two phase-coherent \
components of frequency \\[Omega]_a and \\[Omega]_b is applied. When the \
difference frequency \\[CapitalDelta]_a b=\\[Omega]_a-\\[Omega]_b is equal to \
the frequency splitting \\[CapitalDelta]_12 of the two lower levels (the \
Raman resonance condition), the system is pumped into a coherent \
superposition of the two lower states which no longer absorbs the bichromatic \
field. When one frequency component of the light field is much stronger than \
the other, it is referred to as a \"coupling\" or \"drive\" field, and the \
reduction of the absorption of the weaker probe field is called \
\"electromagnetically induced transparency\". Other names used to refer to \
this situation are \"dark resonance\" and \"coherent population trapping\". \
This loads the package. We define an atomic system consisting of two \
even-parity lower states and an odd-parity upper state. We apply a light \
field with components at frequencies \\[Omega]_a (near resonant with the \
|1>->|3> transition) and \\[Omega]_b (near resonant with the |2>->|3> \
transition).", "synonyms" -> {}, "title" -> 
    "Three-level System: Electromagnetically Induced Transparency", "type" -> 
    "Tutorial", "uri" -> 
    "AtomicDensityMatrix/tutorial/\
ThreeLevelSystemElectromagneticallyInducedTransparency"}, 
  "SearchTextTranslated" -> "", "SearchText" -> ""},
FrontEndVersion->"6.0 for Microsoft Windows (64-bit) (May 21, 2008)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "6.0 for Microsoft Windows (64-bit) (May 21, 2008)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 78, 1, 3, "TutorialColorBar"],
Cell[649, 24, 220, 5, 70, "LinkTrail"],
Cell[872, 31, 9356, 195, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[10253, 230, 97, 1, 70, "Title",
 CellID->509267359],
Cell[10353, 233, 1661, 40, 70, "Text",
 CellID->1534169418],
Cell[12017, 275, 66, 1, 70, "MathCaption",
 CellID->836781195],
Cell[12086, 278, 108, 3, 70, "Input",
 CellID->2058623809],
Cell[12197, 283, 928, 31, 70, "Text",
 CellID->525777075],
Cell[13128, 316, 68, 1, 70, "MathCaption",
 CellID->429217524],
Cell[13199, 319, 1080, 28, 70, "Input",
 CellID->433132487],
Cell[14282, 349, 98, 1, 70, "MathCaption",
 CellID->690131918],
Cell[CellGroupData[{
Cell[14405, 354, 188, 5, 70, "Input",
 CellID->718931880],
Cell[14596, 361, 515, 13, 70, "Output",
 CellID->30985269]
}, Open  ]],
Cell[15126, 377, 86, 1, 70, "MathCaption",
 CellID->272609152],
Cell[CellGroupData[{
Cell[15237, 382, 150, 5, 70, "Input",
 CellID->611420683],
Cell[15390, 389, 1290, 41, 70, "Output",
 CellID->63311256]
}, Open  ]],
Cell[16695, 433, 339, 13, 70, "MathCaption",
 CellID->133602844],
Cell[CellGroupData[{
Cell[17059, 450, 642, 20, 70, "Input",
 CellID->534530029],
Cell[17704, 472, 909, 29, 70, "Output",
 CellID->52954590]
}, Open  ]],
Cell[18628, 504, 217, 5, 70, "MathCaption",
 CellID->462076121],
Cell[CellGroupData[{
Cell[18870, 513, 944, 29, 70, "Input",
 CellID->494599775],
Cell[19817, 544, 1386, 41, 70, "Output",
 CellID->819487573]
}, Open  ]],
Cell[21218, 588, 76, 1, 70, "MathCaption",
 CellID->358620443],
Cell[CellGroupData[{
Cell[21319, 593, 402, 13, 70, "Input",
 CellID->167259034],
Cell[21724, 608, 659, 14, 70, "Output",
 CellID->479247961]
}, Open  ]],
Cell[22398, 625, 102, 2, 70, "MathCaption",
 CellID->577766068],
Cell[CellGroupData[{
Cell[22525, 631, 651, 19, 70, "Input",
 CellID->353525722],
Cell[23179, 652, 314, 10, 70, "Print",
 CellID->608655604],
Cell[23496, 664, 1046, 31, 70, "Output",
 CellID->382279471]
}, Open  ]],
Cell[24557, 698, 424, 14, 70, "MathCaption",
 CellID->610306692],
Cell[CellGroupData[{
Cell[25006, 716, 294, 8, 70, "Input",
 CellID->645617687],
Cell[25303, 726, 821, 24, 70, "Output",
 CellID->250605992]
}, Open  ]],
Cell[26139, 753, 430, 14, 70, "MathCaption",
 CellID->854192725],
Cell[CellGroupData[{
Cell[26594, 771, 297, 8, 70, "Input",
 CellID->465762594],
Cell[26894, 781, 1165, 35, 70, "Output",
 CellID->714618470]
}, Open  ]],
Cell[28074, 819, 76, 1, 70, "MathCaption",
 CellID->314466782],
Cell[CellGroupData[{
Cell[28175, 824, 240, 7, 70, "Input",
 CellID->298399236],
Cell[28418, 833, 7198, 122, 70, "Output",
 Evaluatable->False,
 CellID->82183921]
}, Open  ]],
Cell[35631, 958, 313, 9, 70, "MathCaption",
 CellID->33276359],
Cell[CellGroupData[{
Cell[35969, 971, 941, 27, 70, "Input",
 CellID->14642222],
Cell[36913, 1000, 887, 27, 70, "Output",
 CellID->269417159]
}, Open  ]],
Cell[37815, 1030, 121, 3, 70, "MathCaption",
 CellID->551099716],
Cell[CellGroupData[{
Cell[37961, 1037, 1172, 32, 70, "Input",
 CellID->889304850],
Cell[39136, 1071, 3369, 59, 70, "Output",
 Evaluatable->False,
 CellID->577640901]
}, Open  ]],
Cell[42520, 1133, 279, 6, 70, "MathCaption",
 CellID->517847783],
Cell[CellGroupData[{
Cell[42824, 1143, 1124, 31, 70, "Input",
 CellID->26195282],
Cell[43951, 1176, 2330, 42, 70, "Output",
 Evaluatable->False,
 CellID->1837291]
}, Open  ]],
Cell[CellGroupData[{
Cell[46318, 1223, 747, 21, 70, "TutorialMoreAboutSection",
 CellID->23220180],
Cell[47068, 1246, 861, 21, 70, "SectionHeaderSpacer"],
Cell[47932, 1269, 192, 5, 70, "TutorialMoreAbout",
 CellID->1567025153],
Cell[48127, 1276, 861, 21, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[49025, 1302, 759, 21, 70, "RelatedTutorialsSection",
 CellID->415694126],
Cell[49787, 1325, 861, 21, 70, "SectionHeaderSpacer"],
Cell[50651, 1348, 231, 5, 70, "RelatedTutorials",
 CellID->806871991],
Cell[50885, 1355, 861, 21, 70, "SectionFooterSpacer"]
}, Open  ]]
}, Open  ]],
Cell[51773, 1380, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

