(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     41190,       1227]
NotebookOptionsPosition[     34246,        999]
NotebookOutlinePosition[     34647,       1016]
CellTagsIndexPosition[     34604,       1013]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Usage Messages", "Title"],

Cell[CellGroupData[{

Cell["Reference", "Section"],

Cell["Title", "Subsection"],

Cell["Authors", "Subsection"],

Cell["Summary", "Subsection"],

Cell["Copyright", "Subsection"],

Cell["Notebook Version", "Subsection"],

Cell[TextData[{
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " version"
}], "Subsection"],

Cell["History", "Subsection"],

Cell["Keywords", "Subsection"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Interface", "Section"],

Cell["This part declares publicly visible symbols.", "Text"],

Cell[TextData[{
 "Fix for general ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " bug in Information[]. "
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"System`Dump`fixmessagestring", "[", "System`Dump`s_", "]"}], ":=", 
  
  RowBox[{"ToString", "@", 
   RowBox[{"InputForm", "@", "System`Dump`s"}]}]}]], "Input",
 InitializationCell->True],

Cell["Original Definition:", "Text"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"System`Dump`fixmessagestring", "[", "System`Dump`s_", "]"}], ":=",
    
   RowBox[{"\"\<\\\"\>\"", "<>", 
    RowBox[{"StringReplace", "[", 
     RowBox[{"System`Dump`s", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"\"\<\\n\>\"", "\[Rule]", "\"\<\\\\n\>\""}], ",", 
        RowBox[{"\"\<\\\\\>\"", "\[Rule]", "\"\<\\\\\\\\\>\""}], ",", 
        RowBox[{"\"\<\\\"\>\"", "\[Rule]", "\"\<\\\\\\\"\>\""}]}], "}"}]}], 
     "]"}], "<>", "\"\<\\\"\>\""}]}], "*)"}]], "Input",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Begin package context", "Subsection"],

Cell[BoxData[
 RowBox[{"BeginPackage", "[", "\"\<AtomicDensityMatrix`UsageMessages`\>\"", 
  RowBox[{"(*", 
   RowBox[{",", 
    RowBox[{"{", 
     RowBox[{"\"\<PhysicalConstants`\>\"", ",", "\"\<Units`\>\""}], "}"}]}], 
   "*)"}], "]"}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{"Unprotect", "[", 
  RowBox[{"Evaluate", "[", 
   RowBox[{"$Context", "<>", "\"\<*\>\""}], "]"}], "]"}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Usage messages for AtomicSystem.m", "Subsection",
 InitializationGroup -> True],

Cell[BoxData[
 RowBox[{
  RowBox[{"AtomicState", "::", "usage"}], "=", 
  "\"\<AtomicState[\\!\\(\\*\nStyleBox[\\\"label\\\", \\\"TI\\\"]\\)] \
represents an atomic state labeled by \\!\\(\\*\nStyleBox[\\\"label\\\", \
\\\"TI\\\"]\\).\nAtomicState[\\!\\(\\*\nStyleBox[\\\"label\\\", \
\\\"TI\\\"]\\),\\!\\(\\*SubscriptBox[\nStyleBox[\\\"param\\\", \\\"TI\\\"], \
\\\"1\\\"]\\)->\\!\\(\\*SubscriptBox[\nStyleBox[\\\"value\\\", \\\"TI\\\"], \
\\\"1\\\"]\\),\\!\\(\\*SubscriptBox[\nStyleBox[\\\"param\\\", \\\"TI\\\"], \\\
\"2\\\"]\\)->\\!\\(\\*SubscriptBox[\nStyleBox[\\\"value\\\", \\\"TI\\\"], \
\\\"2\\\"]\\),\[Ellipsis]] represents an atomic state with specified values \
for one or more state parameters.\nPossible state parameters are S, L, J, \
NuclearSpin, F, M, Parity, Energy, NaturalWidth, GFactor, BranchingRatio, \
HyperfineA, HyperfineB, and Polarizability.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"GroundStates", "::", "usage"}], "=", "\"\<GroundStates[\!\(\*
StyleBox[\"sys\", \"TI\"]\)] returns the list of AtomicState objects from \
atomic system \!\(\*
StyleBox[\"sys\", \"TI\"]\) for which GroundStateQ gives True.\>\""}]], \
"Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ExcitedStates", "::", "usage"}], "=", "\"\<ExcitedStates[\!\(\*
StyleBox[\"sys\", \"TI\"]\)] returns the list of AtomicState objects from \
atomic system \!\(\*
StyleBox[\"sys\", \"TI\"]\) for which GroundStateQ gives False.\>\""}]], \
"Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"StateMatchQ", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"StatePosition", "::", "usage"}], "=", "\"\<StatePosition[\!\(\*
StyleBox[\"sys\", \"TI\"]\),\!\(\*
StyleBox[\"crit\", \"TI\"]\)] returns the positions of the AtomicState \
objects in the atomic system \!\(\*
StyleBox[\"sys\", \"TI\"]\) whose parameters satisfy the boolean expression \
\!\(\*
StyleBox[\"crit\", \"TI\"]\). The parameter \!\(\*
StyleBox[\"crit\", \"TI\"]\) is specified in the form, e.g, \
StateLabel==2&&F==3. If all the states with a particular label are desired, \
the shorthand StatePosition[sys,label] can be used.\>\""}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"True", " ", "but", " ", 
    RowBox[{
    "deprecated", ":", " ", 
     "\"\<The criteria can also be specified using Rule in place of Equal, \
and if multiple criteria are specified they must all be satisfied. Thus, for \
example, StatePosition[sys,StateLabel==2&&F==3], \
StatePosition[sys,StateLabel->2&&F->3], and \
StatePosition[sys,StateLabel->2,F->3] are all equivalent.\>\""}]}], 
   "*)"}]}]}], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"SelectStates", "::", "usage"}], "=", "\"\<SelectStates[\!\(\*
StyleBox[\"sys\", \"TI\"]\),\!\(\*
StyleBox[\"crit\", \"TI\"]\)] returns the list of the AtomicState objects in \
the atomic system \!\(\*
StyleBox[\"sys\", \"TI\"]\) whose parameters satisfy the boolean expression \
\!\(\*
StyleBox[\"crit\", \"TI\"]\). The parameter \!\(\*
StyleBox[\"crit\", \"TI\"]\) is specified in the form, e.g, \
StateLabel==2&&F==3. If all the states with a particular label are desired, \
the shorthand StatePosition[sys,label] can be used.\n\nSelectStates[\!\(\*
StyleBox[\"sys\", \"TI\"]\),\!\(\*
StyleBox[\"crit\", \"TI\"]\),\!\(\*
StyleBox[\"n\", \"TI\"]\)] returns the first \!\(\*
StyleBox[\"n\", \"TI\"]\) AtomicStates whose parameters satisfy \!\(\*
StyleBox[\"crit\", \"TI\"]\).\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"SelectState", "::", "usage"}], "=", "\"\<SelectState[\!\(\*
StyleBox[\"sys\", \"TI\"]\),\!\(\*
StyleBox[\"crit\", \"TI\"]\)] is equivalent to SelectStates[\!\(\*
StyleBox[\"sys\", \"TI\"]\),\!\(\*
StyleBox[\"crit\", \"TI\"]\),1\!\(\*
StyleBox[\"]\", \"TI\"]\).\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"DeleteStates", "::", "usage"}], "=", "\"\<DeleteStates[\!\(\*
StyleBox[\"sys\", \"TI\"]\),\!\(\*
StyleBox[\"crit\", \"TI\"]\)] deletes the AtomicState objects from the atomic \
system \!\(\*
StyleBox[\"sys\", \"TI\"]\) whose parameters satisfy the boolean expression \
\!\(\*
StyleBox[\"crit\", \"TI\"]\). The parameter \!\(\*
StyleBox[\"crit\", \"TI\"]\) is specified in the form, e.g, \
StateLabel==2&&F==3. If all the states with a particular label are desired, \
the shorthand StatePosition[sys,label] can be used.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"SublevelMultiplicity", "::", "usage"}], "=", 
  "\"\<SublevelMultiplicity[\!\(\*
StyleBox[\"state\", \"TI\"]\)], where \!\(\*
StyleBox[\"state\", \"TI\"]\) is an AtomicState object, returns the number of \
magnetic sublevels corresponding to the F, J, and NuclearSpin quantum numbers \
of \!\(\*
StyleBox[\"state\", \"TI\"]\). If F is defined, (2F+1) is returned; otherwise \
(2J+1)(2NuclearSpin+1) is returned, where NuclearSpin is assumed to be zero \
if it is not defined.\n\nSublevelMultiplicity[\!\(\*
StyleBox[\"system\", \"TI\"]\)], where \!\(\*
StyleBox[\"system\", \"TI\"]\) is a list of AtomicState objects, returns the \
total number of unique magnetic sublevels of all of the states, as given by J \
and NuclearSpin of each AtomicState. Any F quantum numbers that may be \
defined are ignored, and only one AtomicState corresponding to each unique \
StateLabel is considered.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"F", "::", "usage"}], "=", 
  "\"\<F is a parameter specified in an AtomicState expression that specifies \
the total angular momentum (electronic plus nuclear) for the state. The value \
must be integer or half-integer.\nF[\\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\
\\\"]\\)] returns the value specified for F in AtomicState \\!\\(\\*\n\
StyleBox[\\\"state\\\", \\\"TI\\\"]\\), or J[\\!\\(\\*\n\
StyleBox[\\\"state\\\", \\\"TI\\\"]\\)] if it is not specified.\>\""}]], \
"Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"M", "::", "usage"}], "=", 
  "\"\<M is a parameter specified in an AtomicState expression that specifies \
the z-projection of the total angular momentum for the state. The value must \
be integer or half-integer.\nM[\\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\
\\)] returns the value specified for M in AtomicState \\!\\(\\*\n\
StyleBox[\\\"state\\\", \\\"TI\\\"]\\), or M[StateLabel[\\!\\(\\*\n\
StyleBox[\\\"state\\\", \\\"TI\\\"]\\)]] if it is not specified.\>\""}]], \
"Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"Polarizability", "::", "usage"}], "=", 
  "\"\<Polarizability[\\!\\(\\*\nStyleBox[\\\"k\\\", \\\"TI\\\"]\\)] is a \
parameter specified in an AtomicState expression that specifies the scalar \
(\\!\\(\\*\nStyleBox[\\\"k\\\", \\\"TI\\\"]\\)=0), vector (\\!\\(\\*\n\
StyleBox[\\\"k\\\", \\\"TI\\\"]\\)=1), or tensor (\\!\\(\\*\nStyleBox[\\\"k\\\
\", \\\"TI\\\"]\\)=2) polarizability for the state. The value can be numeric \
or symbolic. \nPolarizability[\\!\\(\\*\nStyleBox[\\\"k\\\", \\\"TI\\\"]\\)][\
\\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\\)] returns the corresponding \
specified value for the polarizability of AtomicState \\!\\(\\*\n\
StyleBox[\\\"state\\\", \\\"TI\\\"]\\), or Polarizability[\\!\\(\\*\n\
StyleBox[\\\"k\\\", \\\"TI\\\"]\\)][StateLabel[\\!\\(\\*\n\
StyleBox[\\\"state\\\", \\\"TI\\\"]\\)]] if it is not specified.\>\""}]], \
"Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"GFactor", "::", "usage"}], "=", 
  "\"\<GFactor is a parameter specified in an AtomicState expression that \
specifies the g-factor for the state.\nGFactor[\\!\\(\\*\n\
StyleBox[\\\"state\\\", \\\"TI\\\"]\\)] returns the value specified for F in \
AtomicState \\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\\), or \
GFactor[StateLabel[\\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\\)]] if it \
is not specified.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"TransitionPolarizability", "::", "usage"}], "=", 
  "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"BranchingRatio", "::", "usage"}], "=", 
  "\"\<BranchingRatio[\\!\\(\\*\nStyleBox[\\\"label\\\", \\\"TI\\\"]\\)] is a \
parameter specified in an AtomicState expression that specifies the branching \
ratio to another state with label \\!\\(\\*\nStyleBox[\\\"label\\\", \\\"TI\\\
\"]\\).\nBranchingRatio[\\!\\(\\*\nStyleBox[\\\"label\\\", \
\\\"TI\\\"]\\)][\\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\\)] returns \
the value specified for the branching ratio to the state with label \\!\\(\\*\
\nStyleBox[\\\"label\\\", \\\"TI\\\"]\\)\\!\\(\\*\nStyleBox[\\\" \\\", \\\"TI\
\\\"]\\)in AtomicState \\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\\), or \
BranchingRatio[\\!\\(\\*\nStyleBox[\\\"label\\\", \\\"TI\\\"]\\)][StateLabel[\
\\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\\)]] if it is not specified.\>\
\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"GroundStateQ", "::", "usage"}], "=", 
  "\"\<GroundStateQ[\\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\\)] \
returns True if NaturalWidth[\\!\\(\\*\nStyleBox[\\\"state\\\", \
\\\"TI\\\"]\\)] is zero, and False otherwise.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"LevelPosition", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"t", "::", "usage"}], "=", 
  "\"\<t is the default value for the option TimeVariable in DensityMatrix \
and other functions.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"StateLabel", "::", "usage"}], "=", 
  "\"\<StateLabel[\\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\\)] returns \
the label (the first argument) for the AtomicState \\!\\(\\*\n\
StyleBox[\\\"state\\\", \\\"TI\\\"]\\).\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"StateParameters", "::", "usage"}], "=", 
  "\"\<StateParameters[\\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\\)] \
returns the state parameters of the AtomicState \\!\\(\\*\nStyleBox[\\\"state\
\\\", \\\"TI\\\"]\\).\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"MapOnParameters", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"StateParameterPattern", "::", "usage"}], "=", 
  "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"StateParameterQ", "::", "usage"}], "=", 
  "\"\<StateParameterQ[\\!\\(\\*\nStyleBox[\\\"expr\\\", \\\"TI\\\"]\\)] \
returns True if \\!\\(\\*\nStyleBox[\\\"expr\\\", \\\"TI\\\"]\\) is a valid \
parameter for an AtomicState expression, and False otherwise.\>\""}]], "Input",\

 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"AtomicSystemQ", "::", "usage"}], "=", 
  "\"\<AtomicSystemQ[\\!\\(\\*\nStyleBox[\\\"expr\\\", \\\"TI\\\"]\\)] \
returns True if \\!\\(\\*\nStyleBox[\\\"expr\\\", \\\"TI\\\"]\\) is a list of \
AtomicState objects, and False otherwise.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefinedQ", "::", "usage"}], "=", 
  "\"\<DefinedQ[\\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\\),\\!\\(\\*\n\
StyleBox[\\\"param\\\", \\\"TI\\\"]\\)] returns True if state parameter \
\\!\\(\\*\nStyleBox[\\\"param\\\", \\\"TI\\\"]\\) is specified in AtomicState \
\\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\\), and False otherwise.\n\
DefinedQ[\\!\\(\\*\nStyleBox[\\\"state\\\", \
\\\"TI\\\"]\\),{\\!\\(\\*SubscriptBox[\nStyleBox[\\\"param\\\", \\\"TI\\\"], \
\\\"1\\\"]\\),\\!\\(\\*SubscriptBox[\nStyleBox[\\\"param\\\", \\\"TI\\\"], \\\
\"2\\\"]\\),\[Ellipsis]}] returns True if all of the \\!\\(\\*\n\
StyleBox[SubscriptBox[\\\"param\\\", \\\"i\\\"], \\\"TI\\\"]\\) are specified \
in \\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\\), and False otherwise.\n\
DefinedQ[{\\!\\(\\*SubscriptBox[\nStyleBox[\\\"state\\\", \\\"TI\\\"], \
\\\"1\\\"]\\),\\!\\(\\*SubscriptBox[\nStyleBox[\\\"state\\\", \\\"TI\\\"], \\\
\"2\\\"]\\),\[Ellipsis]},\\!\\(\\*\nStyleBox[\\\"param\\\", \\\"TI\\\"]\\)] \
checks if \\!\\(\\*\nStyleBox[\\\"param\\\", \\\"TI\\\"]\\) is specified in \
all of the states.\nDefinedQ behaves analogously with region parameters and \
regions in place of state parameters and states.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"DeleteParameter", "::", "usage"}], "=", 
  "\"\<DeleteParameter[\\!\\(\\*\nStyleBox[\\\"state\\\", \
\\\"TI\\\"]\\),\\!\\(\\*\nStyleBox[\\\"param\\\", \\\"TI\\\"]\\)] deletes any \
specification for state parameter \\!\\(\\*\nStyleBox[\\\"param\\\", \\\"TI\\\
\"]\\) from the AtomicState \\!\\(\\*\nStyleBox[\\\"state\\\", \
\\\"TI\\\"]\\).\nIf a list of states is supplied, the parameter is deleted \
from all of the states. If a list of parameters is supplied, all of the \
parameters are deleted.\nDeleteParameter behaves analogously with region \
parameters and regions in place of state parameters and states.\>\""}]], \
"Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"AddParameter", "::", "usage"}], "=", 
  "\"\<AddParameter[\\!\\(\\*\nStyleBox[\\\"state\\\", \
\\\"TI\\\"]\\),\\!\\(\\*\nStyleBox[\\\"param\\\", \\\"TI\\\"]\\)->\\!\\(\\*\n\
StyleBox[\\\"value\\\", \\\"TI\\\"]\\)] adds the supplied parameter \
specification to AtomicState \\!\\(\\*\nStyleBox[\\\"state\\\", \
\\\"TI\\\"]\\), or replaces the existing specification.\nAddParameter behaves \
analogously with region parameters and regions in place of state parameters \
and states.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ReplaceMatrixElement", "::", "usage"}], "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetSystemType", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"AtomicSystemType", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"Toy", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"Zeeman", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"HyperfineZeeman", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"LevelLabel", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"SublevelLabel", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"HyperfineSublevels", "::", "usage"}], "=", 
  "\"\<HyperfineSublevels[{\\!\\(\\*SubscriptBox[\nStyleBox[\\\"state\\\", \\\
\"TI\\\"], \\\"1\\\"]\\),\\!\\(\\*SubscriptBox[\nStyleBox[\\\"state\\\", \
\\\"TI\\\"], \\\"2\\\"]\\),\[Ellipsis]}] returns a list of AtomicState \
objects in which each \\!\\(\\*\nStyleBox[SubscriptBox[\\\"state\\\", \\\"i\\\
\"], \\\"TI\\\"]\\) that has a specified J and NuclearSpin parameter has been \
expanded into states representing each hyperfine sublevel of the \
state.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ZeemanSublevels", "::", "usage"}], "=", 
  "\"\<Sublevels[{\\!\\(\\*SubscriptBox[\nStyleBox[\\\"state\\\", \
\\\"TI\\\"], \\\"1\\\"]\\),\\!\\(\\*SubscriptBox[\nStyleBox[\\\"state\\\", \\\
\"TI\\\"], \\\"2\\\"]\\),\[Ellipsis]}] returns a list of AtomicState objects \
in which each \\!\\(\\*\nStyleBox[SubscriptBox[\\\"state\\\", \\\"i\\\"], \
\\\"TI\\\"]\\) that has a specified J or F parameter has been expanded into \
states representing each Zeeman sublevel of the state.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"Sublevels", "::", "usage"}], "=", 
  "\"\<Sublevels[{\\!\\(\\*SubscriptBox[\nStyleBox[\\\"state\\\", \
\\\"TI\\\"], \\\"1\\\"]\\),\\!\\(\\*SubscriptBox[\nStyleBox[\\\"state\\\", \\\
\"TI\\\"], \\\"2\\\"]\\),\[Ellipsis]}] returns a list of AtomicState objects \
in which each \\!\\(\\*\nStyleBox[SubscriptBox[\\\"state\\\", \\\"i\\\"], \
\\\"TI\\\"]\\) that has a specified J and NuclearSpin parameter has been \
expanded into states representing each hyperfine sublevel of the state, and \
each state that has a specified J or F parameter has been expanded into \
states representing each Zeeman sublevel of the state.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"RemoveZeemanSublevels", "::", "usage"}], "=", 
  "\"\<RemoveZeemanSublevels[\\!\\(\\*\nStyleBox[\\\"syst\\\", \
\\\"TI\\\"]\\)] replaces sublists of the atomic system (list of AtomicState \
objects) \\!\\(\\*\nStyleBox[\\\"syst\\\", \\\"TI\\\"]\\) that are identical \
apart from their M value with a single state with no M value \
specified.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ZeemanSystem", "::", "usage"}], "=", 
  "\"\<ZeemanSystem[\\!\\(\\*\nStyleBox[\\\"j\\\", \\\"TI\\\"]\\)] returns a \
list of AtomicState objects describing the Zeeman sublevels of an atomic \
system with angular momentum \\!\\(\\*\nStyleBox[\\\"j\\\", \\\"TI\\\"]\\).\n\
ZeemanSystem[\\!\\(\\*\nStyleBox[\\\"label\\\", \\\"TI\\\"]\\),\\!\\(\\*\n\
StyleBox[\\\"j\\\", \\\"TI\\\"]\\)] provides a specific label for the \
AtomicState objects.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ASTOpt", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ExpandASTOpt", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Usage messages for AtomicDensityMatrix.m", "Subsection",
 InitializationGroup -> True],

Cell[CellGroupData[{

Cell["Meta info", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$ADMVersion", "::", "usage"}], "=", 
  "\"\<$ADMVersion returns the version number of the AtomicDensityMatrix \
package.\>\""}]], "Input",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Tensor decomposition", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Decomposition", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 

 RowBox[{
  RowBox[{
   RowBox[{"Recomposition", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{"PolarizationMatrices", "::", "usage"}], "=", 
  "\"\<\>\""}]}], "Input",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Angular momentum probability distribution", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]JJ", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"MaxProjectionProbability", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{"AMPSPlot", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "Input",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Optical field", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeField", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OpticalField", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"PolarizationVector", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"PropagationVector", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OpticalPhase", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"CartesianCoordinates", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Parameterization", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{"ReparameterizeField", "::", "usage"}], "=", 
  "\"\<\>\""}], "\n"}], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Hamiltonians", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Energies", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"TransitionFrequencies", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Hamiltonian", "::", "usage"}], "=", "\"\<\>\""}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"ElectricField", "::", "usage"}], "=", 
    RowBox[{
    "\"\<\>\"", " ", "Declaration", " ", "moved", " ", "to", " ", 
     "Common`"}]}], "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"MagneticField", "::", "usage"}], "=", 
    RowBox[{
    "\"\<\>\"", " ", "Declaration", " ", "moved", " ", "to", " ", 
     "Common`"}]}], "*)"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Interaction", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Internal", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"E1", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Magnetic", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"InternalHamiltonian", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"E1Hamiltonian", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 

 RowBox[{
  RowBox[{
   RowBox[{"MagneticHamiltonian", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"PolarizabilityHamiltonian", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"TransitionPolarizabilityHamiltonian", "::", "usage"}], "=", 
   "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"AC", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"DC", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "Input",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Rotating wave approximation", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"EffectiveHamiltonian", "::", "usage"}], "=", 
  "\"\<EffectiveHamiltonian[h,u,t] returns the effective Hamiltonian \
corresponding to the Hamiltonian h under a (possibly time dependent) \
transformation u, assuming time variable t.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"DropFastTerms", "::", "usage"}], "=", 
  "\"\<DropFastTerms[expr,omega,t] sets terms in expr sinusoidally \
oscillating at twice the frequency omega (assuming time variable t) to zero.\n\
DropFastTerms[expr,{\!\(\*SubscriptBox[\(omega\), \
\(1\)]\),\!\(\*SubscriptBox[\(omega\), \(2\)]\),...},t] drops terms \
oscillating at twice any of the \!\(\*SubscriptBox[\(omega\), \
\(i\)]\).\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ReturnFrequencyReplacements", "::", "usage"}], 
  "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"RotatingWaveTransformMatrix", "::", "usage"}], "=", 
  "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"RotatingWaveTransform", "::", "usage"}], "=", 
  "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"TransformMatrix", "::", "usage"}], "=", 
  "\"\<TransformMatrix is an option for RotatingWaveApproximation and related \
functions that can be used to explicitly specify the unitary transformation \
to the rotating frame.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"DMFromRotatingDM", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"RotatingWaveApproximation", "::", "usage"}], "=", 
  "\"\<RotatingWaveApproximation[sys,h,{\[Omega],tr}] performs the \
rotating-wave approximation on a Hamiltonian h for an atomic system sys \
subject to an optical field with angular frequency \[Omega] acting on \
transitions tr. Transitions are specified by \!\(\*SubscriptBox[\(crit\), \
\(lower\)]\)\[Rule]\!\(\*SubscriptBox[\(crit\), \(upper\)]\), where \
\!\(\*SubscriptBox[\(crit\), \(lower\)]\) and \!\(\*SubscriptBox[\(crit\), \
\(upper\)]\) are state selection criteria for the lower and upper states in \
the optical transition, specified as in the documentation for StatePosition. \
Each transition specification also accepts a list of transitions.\n\
RotatingWaveApproximation[sys,h,{{\!\(\*SubscriptBox[\(\[Omega]\), \
\(1\)]\),\!\(\*SubscriptBox[\(tr\), \
\(1\)]\)},{\!\(\*SubscriptBox[\(\[Omega]\), \
\(2\)]\),\!\(\*SubscriptBox[\(tr\), \(2\)]\)},...}] performs the RWA assuming \
multiple optical fields with angular frequencies \
\!\(\*SubscriptBox[\(\[Omega]\), \(i\)]\), acting on transitions \
\!\(\*SubscriptBox[\(tr\), \(i\)]\).\n\
RotatingWaveApproximation[sys,h,{{\!\(\*SubscriptBox[\(\[Omega]\), \
\(1\)]\),\!\(\*SubscriptBox[\(tr\), \(1\)]\),\!\(\*SubscriptBox[\(\
\[CapitalDelta]\), \(1\)]\)},{\!\(\*SubscriptBox[\(\[Omega]\), \
\(2\)]\),\!\(\*SubscriptBox[\(tr\), \(2\)]\),\!\(\*SubscriptBox[\(\
\[CapitalDelta]\), \(2\)]\)},...}] writes optical frequencies in terms of \
their detunings \!\(\*SubscriptBox[\(\[CapitalDelta]\), \(i\)]\) from \
resonance after performing the RWA.\n\
RotatingWaveApproximation[sys,h,\[Omega]] performs the RWA using an \
automatically generated transformation appropriate for a single optical \
field.\nRotatingWaveApproximation[sys,h,{\!\(\*SubscriptBox[\(\[Omega]\), \(1\
\)]\),\!\(\*SubscriptBox[\(\[Omega]\), \(2\)]\),...},TransformMatrix->u] \
performs the RWA using an explicity specified unitary transformation \
matrix.\>\""}]], "Input",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Relaxation and repopulation", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"IntrinsicRelaxation", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"TransitRelaxation", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Relaxation", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"TransitRepopulation", "::", "usage"}], "=", 
   "\"\<TransitRepopulation[\\!\\(\\*\nStyleBox[\\\"sys\\\", \
\\\"TI\\\"]\\),\\!\\(\\*\nStyleBox[\\\"gamma\\\", \\\"TI\\\"]\\)] returns a \
matrix describing the appearence of unpolarized atoms in the ground state of \
atomic system \\!\\(\\*\nStyleBox[\\\"sys\\\", \\\"TI\\\"]\\) due to transit \
into the experimental volume at rate \\!\\(\\*\nStyleBox[\\\"gamma\\\", \
\\\"TI\\\"]\\). The ground states of sys are assumed to be those that have \
NaturalWidth->0. This matrix is suitable for use as an argument in the \
function LiouvileEquation.\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OpticalRepopulationOperator", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OpticalRepopulation", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OpticalRepopulationPM", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OpticalRepopulationZ", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"HyperfineCoherenceTransfer", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{"Repopulation", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "Input",\

 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["FluorescenceOperator", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FluorescenceOperator", "::", "\"\<usage\>\""}], "\n"}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Density matrix evolution equation", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"LiouvilleRHS", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"LiouvilleEquation", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{"InitialConditions", "::", "usage"}], "=", 
  "\"\<\>\""}], "\n"}], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Solution of wave equation", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"WaveEqnSolution", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Find dipole polarization", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Observables", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"PolarizationComponents", "::", "usage"}], "=", 
  "\"\<\>\""}], "\n"}], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["LinearAbsorption", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Voigt", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"InternalEnergy", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{"LinearAbsorption", "::", "usage"}], "=", 
  "\"\<\>\""}], "\n"}], "Input",
 InitializationCell->True]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Usage messages for ExperimentalSystem.m", "Subsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Region", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TransitRate", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Void", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Density", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"OpticalParameters", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RegionParameters", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RegionParameterPattern", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RegionParameterQ", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ExperimentalSystemQ", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SelectRegions", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"RegionLabel", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"SelectRegion", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"DeleteRegions", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"RegionPosition", "::", "usage"}], "=", "\"\<\>\""}]}], "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Epilog", "Section"],

Cell["This section protects exported symbols and ends the package.", "Text"],

Cell[CellGroupData[{

Cell["Protect exported symbols", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"Protect", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{"$Context", "<>", "\"\<*\>\""}], "]"}], "]"}], "*)"}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["End the package context", "Subsection"],

Cell[BoxData[
 RowBox[{"EndPackage", "[", "]"}]], "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{815, 814},
WindowMargins->{{74, Automatic}, {Automatic, 3}},
TrackCellChangeTimes->False,
FrontEndVersion->"6.0 for Microsoft Windows (64-bit) (May 21, 2008)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 31, 0, 83, "Title"],
Cell[CellGroupData[{
Cell[646, 27, 28, 0, 71, "Section"],
Cell[677, 29, 27, 0, 36, "Subsection"],
Cell[707, 31, 29, 0, 28, "Subsection"],
Cell[739, 33, 29, 0, 28, "Subsection"],
Cell[771, 35, 31, 0, 28, "Subsection"],
Cell[805, 37, 38, 0, 28, "Subsection"],
Cell[846, 39, 94, 4, 28, "Subsection"],
Cell[943, 45, 29, 0, 28, "Subsection"],
Cell[975, 47, 30, 0, 28, "Subsection"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1042, 52, 28, 0, 71, "Section"],
Cell[1073, 54, 60, 0, 29, "Text"],
Cell[1136, 56, 124, 5, 29, "Text"],
Cell[1263, 63, 222, 6, 31, "Input",
 InitializationCell->True],
Cell[1488, 71, 36, 0, 29, "Text"],
Cell[1527, 73, 563, 14, 52, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[2115, 91, 43, 0, 36, "Subsection"],
Cell[2161, 93, 275, 7, 31, "Input",
 InitializationCell->True],
Cell[2439, 102, 164, 4, 31, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[2640, 111, 85, 1, 36, "Subsection"],
Cell[2728, 114, 914, 14, 252, "Input",
 InitializationCell->True],
Cell[3645, 130, 303, 7, 72, "Input",
 InitializationCell->True],
Cell[3951, 139, 306, 7, 72, "Input",
 InitializationCell->True],
Cell[4260, 148, 121, 3, 31, "Input",
 InitializationCell->True],
Cell[4384, 153, 1109, 25, 252, "Input",
 InitializationCell->True],
Cell[5496, 180, 855, 17, 152, "Input",
 InitializationCell->True],
Cell[6354, 199, 340, 8, 31, "Input",
 InitializationCell->True],
Cell[6697, 209, 598, 12, 112, "Input",
 InitializationCell->True],
Cell[7298, 223, 967, 17, 232, "Input",
 InitializationCell->True],
Cell[8268, 242, 541, 10, 172, "Input",
 InitializationCell->True],
Cell[8812, 254, 547, 10, 172, "Input",
 InitializationCell->True],
Cell[9362, 266, 925, 15, 292, "Input",
 InitializationCell->True],
Cell[10290, 283, 492, 9, 152, "Input",
 InitializationCell->True],
Cell[10785, 294, 137, 4, 31, "Input",
 InitializationCell->True],
Cell[10925, 300, 890, 14, 272, "Input",
 InitializationCell->True],
Cell[11818, 316, 302, 6, 72, "Input",
 InitializationCell->True],
Cell[12123, 324, 123, 3, 31, "Input",
 InitializationCell->True],
Cell[12249, 329, 204, 5, 52, "Input",
 InitializationCell->True],
Cell[12456, 336, 298, 6, 72, "Input",
 InitializationCell->True],
Cell[12757, 344, 297, 6, 72, "Input",
 InitializationCell->True],
Cell[13057, 352, 125, 3, 31, "Input",
 InitializationCell->True],
Cell[13185, 357, 134, 4, 31, "Input",
 InitializationCell->True],
Cell[13322, 363, 337, 7, 92, "Input",
 InitializationCell->True],
Cell[13662, 372, 313, 6, 72, "Input",
 InitializationCell->True],
Cell[13978, 380, 1284, 19, 372, "Input",
 InitializationCell->True],
Cell[15265, 401, 696, 12, 192, "Input",
 InitializationCell->True],
Cell[15964, 415, 559, 10, 172, "Input",
 InitializationCell->True],
Cell[16526, 427, 125, 3, 31, "Input",
 InitializationCell->True],
Cell[16654, 432, 123, 3, 31, "Input",
 InitializationCell->True],
Cell[16780, 437, 126, 3, 31, "Input",
 InitializationCell->True],
Cell[16909, 442, 113, 3, 31, "Input",
 InitializationCell->True],
Cell[17025, 447, 116, 3, 31, "Input",
 InitializationCell->True],
Cell[17144, 452, 125, 3, 31, "Input",
 InitializationCell->True],
Cell[17272, 457, 120, 3, 31, "Input",
 InitializationCell->True],
Cell[17395, 462, 123, 3, 31, "Input",
 InitializationCell->True],
Cell[17521, 467, 583, 10, 152, "Input",
 InitializationCell->True],
Cell[18107, 479, 555, 9, 132, "Input",
 InitializationCell->True],
Cell[18665, 490, 698, 11, 172, "Input",
 InitializationCell->True],
Cell[19366, 503, 422, 8, 112, "Input",
 InitializationCell->True],
Cell[19791, 513, 519, 9, 152, "Input",
 InitializationCell->True],
Cell[20313, 524, 116, 3, 31, "Input",
 InitializationCell->True],
Cell[20432, 529, 122, 3, 31, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[20591, 537, 92, 1, 28, "Subsection"],
Cell[CellGroupData[{
Cell[20708, 542, 34, 0, 28, "Subsubsection"],
Cell[20745, 544, 200, 5, 31, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[20982, 554, 45, 0, 22, "Subsubsection"],
Cell[21030, 556, 339, 12, 112, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[21406, 573, 66, 0, 22, "Subsubsection"],
Cell[21475, 575, 335, 10, 132, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[21847, 590, 38, 0, 22, "Subsubsection"],
Cell[21888, 592, 875, 30, 332, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[22800, 627, 37, 0, 28, "Subsubsection"],
Cell[22840, 629, 1854, 60, 652, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[24731, 694, 52, 0, 22, "Subsubsection"],
Cell[24786, 696, 311, 6, 92, "Input",
 InitializationCell->True],
Cell[25100, 704, 463, 9, 92, "Input",
 InitializationCell->True],
Cell[25566, 715, 135, 4, 31, "Input",
 InitializationCell->True],
Cell[25704, 721, 140, 4, 31, "Input",
 InitializationCell->True],
Cell[25847, 727, 134, 4, 31, "Input",
 InitializationCell->True],
Cell[25984, 733, 301, 6, 72, "Input",
 InitializationCell->True],
Cell[26288, 741, 126, 3, 31, "Input",
 InitializationCell->True],
Cell[26417, 746, 2019, 32, 332, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[28473, 783, 52, 0, 22, "Subsubsection"],
Cell[28528, 785, 1659, 46, 552, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[30224, 836, 45, 0, 28, "Subsubsection"],
Cell[30272, 838, 127, 3, 52, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[30436, 846, 58, 0, 28, "Subsubsection"],
Cell[30497, 848, 344, 11, 132, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[30878, 864, 50, 0, 28, "Subsubsection"],
Cell[30931, 866, 148, 5, 52, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[31116, 876, 49, 0, 28, "Subsubsection"],
Cell[31168, 878, 241, 7, 92, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[31446, 890, 41, 0, 28, "Subsubsection"],
Cell[31490, 892, 333, 11, 132, "Input",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[31872, 909, 61, 0, 28, "Subsection"],
Cell[31936, 911, 1684, 55, 552, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[33669, 972, 25, 0, 71, "Section"],
Cell[33697, 974, 76, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[33798, 978, 46, 0, 36, "Subsection"],
Cell[33847, 980, 189, 5, 31, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[34073, 990, 45, 0, 36, "Subsection"],
Cell[34121, 992, 85, 2, 31, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
